Imports System.Data
Imports System.Data.OleDb

Partial Class ActualInvestment
    Inherits System.Web.UI.Page

    Dim adp As New OleDbDataAdapter
    Dim objCon As OleDbConnection
    Dim dsInv As New DataSet
    Dim strRComponents() As String
    Dim strDComponents() As String
    Dim strOComponents() As String
    Dim strHRAComponents() As String
    Dim strILHPComponents() As String
    Dim hCity As New Hashtable, hMonth As New Hashtable, hYear As New Hashtable

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If

            '--lblToday.Text = Today
            If Session("Actconnection") = Nothing Then
                lblMessage.Text = "The database missing or corrupted."
                Exit Sub
            End If
            objCon = New OleDbConnection(Session("Actconnection"))

            lblEmpCode.Text = UCase(Session("EmpId"))
            lblEmpName.Text = Session("EmpName")
            lblFY.Text = Session("Period")

            lblInvDeclFormFY.Text = "Please Enter the Amount of Actual Proof Submitted for the Financial Year " & Session("Period")

            Call FillInvActual80C()

            If Page.IsPostBack = False Then
                hCity.Add(1, "Non-Metro")
                hCity.Add(2, "Kolkata")
                hCity.Add(3, "Delhi")
                hCity.Add(4, "Mumbai")
                hCity.Add(5, "Chennai")
                hCity.Add(6, "--select--")

                lblToday.Text = Format(Today, "dd/MM/yyyy")
                '--txtPAN.Text = GetPAN()
                Call FillInvActualUS6A()

                tblInv1.Rows.Item(0).CssClass = "GrdHeader"
                tblInv2.Rows.Item(0).CssClass = "GrdHeader"
                tblOthers.Rows.Item(0).CssClass = "GrdHeader"

            End If

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub FillInvActualUS6A()
        Try
            dsInv.Tables("InvDetails").Clear()

            adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11005,D11009," & _
                "O11001,HRAAmt1 from [Details]  where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")

            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80CD11001.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11001")) = True, "", .Rows(.Rows.Count - 1).Item("D11001"))
                    txt80CD11002.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11002")) = True, "", .Rows(.Rows.Count - 1).Item("D11002"))
                    txt80CD11003.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11003")) = True, "", .Rows(.Rows.Count - 1).Item("D11003"))
                    txt80CD11005.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11005")) = True, "", .Rows(.Rows.Count - 1).Item("D11005"))
                    txt80CD11009.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11009")) = True, "", .Rows(.Rows.Count - 1).Item("D11009"))
                    txtO11001.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("O11001")) = True, "", .Rows(.Rows.Count - 1).Item("O11001"))
                    txtHRAAmount.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRAAmt1")) = True, "", .Rows(.Rows.Count - 1).Item("HRAAmt1"))
                Else
                    txt80CD11001.Text = "0"
                    txt80CD11002.Text = "0"
                    txt80CD11003.Text = "0"
                    txt80CD11005.Text = "0"
                    txt80CD11009.Text = "0"
                    txtO11001.Text = "0"
                    txtHRAAmount.Text = "0"
                End If
            End With

            adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11005,D11009," & _
                "O11001,HRAAmt1 from [Remarks]  where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails1")

            With dsInv.Tables("InvDetails1")
                If .Rows.Count > 0 Then
                    txtD11001Remarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11001")) = True, "", .Rows(.Rows.Count - 1).Item("D11001"))
                    txtD11002Remarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11002")) = True, "", .Rows(.Rows.Count - 1).Item("D11002"))
                    txtD11003Remarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11003")) = True, "", .Rows(.Rows.Count - 1).Item("D11003"))
                    txtD11005Remarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11005")) = True, "", .Rows(.Rows.Count - 1).Item("D11005"))
                    txtD11009Remarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11009")) = True, "", .Rows(.Rows.Count - 1).Item("D11009"))
                    txtO11001Remarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("O11001")) = True, "", .Rows(.Rows.Count - 1).Item("O11001"))
                    txtHRARemarks.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRAAmt1")) = True, "", .Rows(.Rows.Count - 1).Item("HRAAmt1"))

                    txtD11001Remarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11001")) = True, "", .Rows(.Rows.Count - 1).Item("D11001"))
                    txtD11002Remarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11002")) = True, "", .Rows(.Rows.Count - 1).Item("D11002"))
                    txtD11003Remarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11003")) = True, "", .Rows(.Rows.Count - 1).Item("D11003"))
                    txtD11005Remarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11005")) = True, "", .Rows(.Rows.Count - 1).Item("D11005"))
                    txtD11009Remarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11009")) = True, "", .Rows(.Rows.Count - 1).Item("D11009"))
                    txtO11001Remarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("O11001")) = True, "", .Rows(.Rows.Count - 1).Item("O11001"))
                    txtHRARemarks.ToolTip = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRAAmt1")) = True, "", .Rows(.Rows.Count - 1).Item("HRAAmt1"))
                Else
                    txtD11001Remarks.Text = ""
                    txtD11002Remarks.Text = ""
                    txtD11003Remarks.Text = ""
                    txtD11005Remarks.Text = ""
                    txtD11009Remarks.Text = ""
                    txtO11001Remarks.Text = ""
                    txtHRARemarks.Text = ""
                End If
            End With
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub FillInvActual80C()
        Try
            Dim intI As Integer, intJ As Integer '--For Loop Variables
            Dim tblRow As TableRow '--Row to add in the table dynamically
            Dim tblCell As TableCell '--Cells to add in each row dynamically
            tblRow = New TableHeaderRow
            tblInv1.Rows.Add(tblRow)
            tblCell = New TableHeaderCell
            tblCell.Text = "S.No."
            tblRow.Cells.Add(tblCell)
            tblCell = New TableHeaderCell
            tblCell.Text = "Type of Investment"
            tblRow.Cells.Add(tblCell)
            tblCell = New TableHeaderCell
            tblCell.Text = "Amount (Rs.)"
            tblRow.Cells.Add(tblCell)
            tblCell = New TableHeaderCell
            tblCell.Text = "Remarks"
            tblRow.Cells.Add(tblCell)

            adp = New OleDbDataAdapter("select SalTdsCode,Description,'' from Masters where mid(SalTdsCode,1,1)='R' and Active=True order by SalTdsCode", objCon)
            adp.Fill(dsInv, "InvDecl")
            
            adp = New OleDbDataAdapter("select * from [Details] where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")

            adp = New OleDbDataAdapter("select * from [Remarks] where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails1")

            With dsInv.Tables("InvDecl")
                If .Rows.Count > 0 Then
                    For intI = 0 To .Rows.Count - 1
                        tblRow = New TableRow
                        tblInv1.Rows.Add(tblRow)
                        For intJ = 0 To .Columns.Count
                            tblCell = New TableCell
                            If intJ = 0 Then
                                tblCell.Text = intI + 1
                            ElseIf intJ = 1 Then
                                tblCell.Text = .Rows(intI).Item(intJ).ToString
                            ElseIf intJ = 2 Then
                                Dim txt80C1 As New TextBox
                                txt80C1.ID = "txt80C" & .Rows(intI).Item(0)
                                txt80C1.CssClass = "AlignForNum"
                                txt80C1.MaxLength = 10
                                txt80C1.Width = 50

                                txt80C1.Attributes.Add("onkeyup", "javascript:ValidateNums('ctl00_ContentPlaceHolder1_txt80C" & .Rows(intI).Item(0) & "')")
                                With dsInv.Tables("InvDetails")
                                    If .Rows.Count > 0 Then
                                        txt80C1.Text = .Rows(.Rows.Count - 1).Item(dsInv.Tables("InvDecl").Rows(intI).Item(0))
                                    Else
                                        txt80C1.Text = "0"
                                    End If
                                End With
                                tblCell.Controls.Add(txt80C1)
                            Else
                                Dim txt80C As New TextBox
                                txt80C.ID = "txt" & .Rows(intI).Item(0) & "Remarks"
                                '--txt80C.CssClass = "AlignForNum"
                                txt80C.MaxLength = 100
                                txt80C.Width = 250
                                With dsInv.Tables("InvDetails1")
                                    If .Rows.Count > 0 Then
                                        txt80C.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item(dsInv.Tables("InvDecl").Rows(intI).Item(0))) = True, "", .Rows(.Rows.Count - 1).Item(dsInv.Tables("InvDecl").Rows(intI).Item(0)))
                                    Else
                                        txt80C.Text = "0"
                                    End If
                                End With
                                tblCell.Controls.Add(txt80C)
                            End If
                            tblRow.Cells.Add(tblCell)
                        Next
                    Next
                End If
            End With
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Try
            Dim htmlctrl As Control
            Dim intRecordsAffected As Integer

            '--For intCount As Integer = 0 To Me.Controls.Count - 1
            For Each htmlctrl In Me.Controls
                Call GetControlID(Table1, htmlctrl)
            Next

            '--Declaration goes here
            Dim strR11050 As String, strR11051 As String, strO11001 As String
            Dim strR11(25) As String, strD11(8) As String

            lblMessage.Text = ""
            '--Inserting the Primary Column ECode
            adp = New OleDbDataAdapter("select ECode from [Details] where ECode='" & Session("EmpID") & "'", objCon)
            adp.Fill(dsInv, "Inv")
            If dsInv.Tables("Inv").Rows.Count = 0 Then
                adp = New OleDbDataAdapter("insert into [Details](ECode) values('" & Session("EmpId") & "')", objCon)
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery()
            End If

            adp = New OleDbDataAdapter("select ECode from [Remarks] where ECode='" & Session("EmpID") & "'", objCon)
            adp.Fill(dsInv, "Inv1")
            If dsInv.Tables("Inv1").Rows.Count = 0 Then
                adp = New OleDbDataAdapter("insert into [Remarks](ECode) values('" & Session("EmpId") & "')", objCon)
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery()
                objCon.Close()
            End If

            dsInv.Tables.Clear()

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt1=" & Val(txtHRAAmount.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"

            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Remarks] set HRAAmt1='" & txtHRARemarks.Text.Trim & "'" & _
                                " where ECode='" & Session("EmpId") & "'"

            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            For intK As Integer = 1 To 26
                strR11(intK - 1) = Val(SearchValue("txt80CR110" & Format(intK, "00")))
                adp.SelectCommand.CommandText = "update [Details] set R110" & Format(intK, "00") & "=" & Val(strR11(intK - 1)) & "" & _
                    " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                strR11(intK - 1) = Trim(SearchValue("txtR110" & Format(intK, "00") & "Remarks"))
                adp.SelectCommand.CommandText = "update [Remarks] set R110" & Format(intK, "00") & "='" & Trim(strR11(intK - 1)) & "'" & _
                    " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()
            Next intK

            strR11050 = Val(SearchValue("txt80CR11050"))
            adp.SelectCommand.CommandText = "update [Details] set R11050=" & Val(strR11050) & "" & _
                                   " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            strR11050 = SearchValue("txtR11050Remarks")
            adp.SelectCommand.CommandText = "update [Remarks] set R11050='" & Trim(strR11050) & "'" & _
                                   " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            strR11051 = Val(SearchValue("txt80CR11051"))
            adp.SelectCommand.CommandText = "update [Details] set R11051=" & Val(strR11051) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            strR11051 = SearchValue("txtR11051Remarks")
            adp.SelectCommand.CommandText = "update [Remarks] set R11051='" & Trim(strR11051) & "'" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            adp.SelectCommand.CommandText = "update [Details] set O11001=" & Val(txtO11001.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Remarks] set O11001='" & txtO11001Remarks.Text.Trim & "'" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            objCon.Open()
            adp.SelectCommand.CommandText = "update [Details] set D11001=" & Val(txt80CD11001.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11002=" & Val(txt80CD11002.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11003=" & Val(txt80CD11003.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11005=" & Val(txt80CD11005.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11009=" & Val(txt80CD11009.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Remarks] set D11001='" & Trim(txtD11001Remarks.Text) & "'" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Remarks] set D11002='" & Trim(txtD11002Remarks.Text) & "'" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Remarks] set D11003='" & Trim(txtD11003Remarks.Text) & "'" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Remarks] set D11005='" & Trim(txtD11005Remarks.Text) & "'" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Remarks] set D11009='" & Trim(txtD11009Remarks.Text) & "'" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            lblMessage.Text = "Record Submitted Successfully."
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub

    Private Function SearchValue(ByVal pStrCode As String) As String
        SearchValue = "0"
        With Table1
            For intI As Integer = 0 To .Rows.Count - 1
                If .Rows(intI).Cells(0).Text = pStrCode Then
                    Return .Rows(intI).Cells(1).Text
                End If
            Next
        End With
    End Function

    Private Sub GetControlID(ByVal tbl As Table, ByVal oControl As Control)
        Dim frmControl As Control
        Dim OArrayList As New ArrayList
        Dim tblRow As TableRow
        Dim tblCell As TableCell
        Dim txt1 As TextBox, opt1 As RadioButtonList, drp1 As DropDownList
        Try
            For Each frmControl In oControl.Controls
                If TypeOf frmControl Is TextBox Then
                    tblRow = New TableRow
                    Table1.Rows.Add(tblRow)
                    tblCell = New TableCell
                    tblCell.Text = frmControl.ID
                    tblRow.Cells.Add(tblCell)
                    tblCell = New TableCell
                    txt1 = New TextBox
                    txt1 = frmControl
                    tblCell.Text = txt1.Text
                    tblRow.Cells.Add(tblCell)
                ElseIf TypeOf frmControl Is RadioButtonList Then
                    tblRow = New TableRow
                    Table1.Rows.Add(tblRow)
                    tblCell = New TableCell
                    tblCell.Text = frmControl.ID
                    tblRow.Cells.Add(tblCell)
                    tblCell = New TableCell
                    opt1 = New RadioButtonList
                    opt1 = frmControl
                    tblCell.Text = opt1.Text
                    tblRow.Cells.Add(tblCell)
                ElseIf TypeOf frmControl Is DropDownList Then
                    tblRow = New TableRow
                    Table1.Rows.Add(tblRow)
                    tblCell = New TableCell
                    tblCell.Text = frmControl.ID
                    tblRow.Cells.Add(tblCell)
                    tblCell = New TableCell
                    drp1 = New DropDownList
                    drp1 = frmControl
                    tblCell.Text = drp1.Text
                    tblRow.Cells.Add(tblCell)
                End If
                Dim strid As String = TypeName(frmControl.GetType)
                If frmControl.HasControls Then
                    GetControlID(tbl, frmControl)
                End If
            Next
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        If Page.IsPostBack = True Then
            ReDim strRComponents(tblInv1.Rows.Count)
            Dim htmlCtrl As Control
            For Each htmlCtrl In Me.Controls
                Call GetControlValue(strRComponents, htmlCtrl)
            Next

        End If
    End Sub

    Private Sub GetControlValue(ByVal strArray() As String, ByVal oControl As Control)
        Dim frmControl As Control
        Dim OArrayList As New ArrayList
        Dim txt1 As TextBox
        Dim intI As Integer
        Try
            For Each frmControl In oControl.Controls
                If TypeOf frmControl Is TextBox Then
                    txt1 = New TextBox
                    txt1 = frmControl
                    strArray(intI) = txt1.Text
                    intI += 1
                End If
                Dim strid As String = TypeName(frmControl.GetType)
                If frmControl.HasControls Then
                    GetControlValue(strArray, frmControl)
                End If
            Next
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

End Class
