Imports System.Data
Imports System.Data.OleDb
Imports MigraDoc.Rendering
Imports System.Diagnostics

Partial Class _AnnualSalRpt
    Inherits System.Web.UI.Page

    Dim dsProfile As DataSet
    Dim sqlCon As OleDbConnection
    Dim sqlCmd As OleDbCommand
    Dim adpAnnualRpt As New OleDbDataAdapter

    Dim AdapEarning As New OleDbDataAdapter
    Dim AdapDeduction As New OleDbDataAdapter

    Dim DsGrossEarning As New DataSet
    Dim DsDeduction As New DataSet
    Dim DsEarning As New DataSet


    Dim dsAnnualRpt As New DataSet
    Dim DataTempTable As New DataTable
    Dim DataTempTbl As DataTable
    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        AddHandler Master.Print_PDF, AddressOf PrintPDF
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            sqlCon = New OleDbConnection(Session("myconnection"))
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If
            Call FillHeadings()
            Call FillGrid()
            gvAnnualRpt.Rows(gvAnnualRpt.Rows.Count - 1).Cells(0).Text = "Net <sub><img src='" & Session("img") & "' /><sub>"
        Catch ex As Exception

        End Try
    End Sub

    Private Sub FillHeadings()
        lblPeriod.Text = "Annual Salary Report for the period " & Session("Period")
        lblEmpCode.Text = Session("EmpId")
        lblName.Text = Session("EmpName")
        lblFY.Text = Session("Period")
    End Sub

    Private Sub FillGrid()
        Dim intI As Integer
        Dim intECnt As Integer

        Try
            adpAnnualRpt = New OleDbDataAdapter("SELECT descp AS PaymentHead, iif( amt04 is null , 0 , amt04) AS APR," & _
                                                " iif(amt05 is null,0,amt05) AS MAY, iif(amt06 is null,0,amt06) AS JUN, iif(amt07 is null,0,amt07) AS JUL," & _
                                                " iif(amt08 is null,0,amt08) AS AUG, iif(amt09 is null,0,amt09) AS SEP, iif(amt10 is null,0,amt10) AS OCT," & _
                                                " iif(amt11 is null,0,amt11) AS NOV, iif(amt12 is null,0,amt12) AS [DEC]," & _
                                                " iif(amt01 is null,0,amt01) AS JAN, iif(amt02 is null,0,amt02) AS FEB, iif(amt03 is null,0,amt03) AS MAR," & _
                                                "[JAN] + [FEB] + [MAR] + [APR] + [MAY] + [JUN] + [JUL] + [AUG] + [SEP] + [OCT] + [NOV] + [DEC] as Amount FROM AnnualReport" & _
                                                " WHERE ecode='" & Session("EmpId") & "'" & _
                                                " and mType='E'", sqlCon)
            adpAnnualRpt.Fill(dsAnnualRpt, "AnnualRpt")
            intECnt = Val(dsAnnualRpt.Tables("AnnualRpt").Rows.Count)

            adpAnnualRpt = New OleDbDataAdapter("SELECT 'Gross Earning' as PaymentHead, iif( sum(amt04) is null , 0 ,sum(amt04))  AS [APR], " & _
                                                " iif( sum(amt05) is null , 0 ,sum(amt05)) AS [MAY], " & _
                                                " iif( sum(amt06) is null , 0 ,sum(amt06)) AS [JUN], " & _
                                                " iif( sum(amt07) is null , 0 ,sum(amt07)) AS [JUL], " & _
                                                " iif( sum(amt08) is null , 0 ,sum(amt08)) AS [AUG], " & _
                                                " iif( sum(amt09) is null , 0 ,sum(amt09)) AS [SEP], " & _
                                                " iif( sum(amt10) is null , 0 ,sum(amt10)) AS [OCT], " & _
                                                " iif( sum(amt11) is null , 0 ,sum(amt11)) AS [NOV], " & _
                                                " iif( sum(amt12) is null , 0 ,sum(amt12)) AS [DEC], " & _
                                                " iif( sum(amt01) is null , 0 ,sum(amt01)) AS [JAN], " & _
                                                " iif( sum(amt02) is null , 0 ,sum(amt02))AS [FEB], " & _
                                                " iif( sum(amt03) is null , 0 ,sum(amt03)) AS [MAR] , " & _
                                                " [JAN] + [FEB] + [MAR] + [APR] + [MAY] + [JUN] + [JUL] + [AUG] + [SEP] + [OCT] + [NOV] + [DEC] as Amount  FROM AnnualReport " & _
                                                " WHERE ecode='" & Session("EmpId") & "' and mType='E' GROUP BY mType", sqlCon)
            adpAnnualRpt.Fill(dsAnnualRpt, "AnnualRpt")

            dsAnnualRpt.Tables("AnnualRpt").Rows.Add()

            adpAnnualRpt = New OleDbDataAdapter("SELECT descp AS PaymentHead , iif(amt04 is null,0,amt04) AS APR, iif(amt05 is null,0,amt05) AS MAY," & _
                                                " iif(amt07 is null,0,amt07) AS JUL, iif(amt08 is null,0,amt08) AS AUG, iif(amt09 is null,0,amt09) AS SEP, iif(amt10 is null,0,amt10) AS OCT," & _
                                                " iif(amt11 is null,0,amt11) AS NOV, iif(amt12 is null,0,amt12) AS [DEC], iif(amt06 is null,0,amt06) AS JUN, " & _
                                                " iif(amt01 is null,0,amt01) AS JAN, iif(amt02 is null,0,amt02) AS FEB, iif(amt03 is null,0,amt03) AS MAR," & _
                                                " [JAN] + [FEB] + [MAR] + [APR] + [MAY] + [JUN] + [JUL] + [AUG] + [SEP] + [OCT] + [NOV] + [DEC] as Amount  FROM AnnualReport " & _
                                                " WHERE ecode='" & Session("EmpId") & "' and mType='D' ", sqlCon)
            adpAnnualRpt.Fill(dsAnnualRpt, "AnnualRpt")

            adpAnnualRpt = New OleDbDataAdapter("SELECT 'Gross Deduction' as PaymentHead, iif( sum(amt01) is null , 0 ,sum(amt01))  AS [JAN], iif( sum(amt02) is null , 0 ,sum(amt02)) AS [FEB], iif( sum(amt03) is null , 0 ,sum(amt03)) AS [MAR], iif( sum(amt04) is null , 0 ,sum(amt04)) AS [APR], iif( sum(amt05) is null , 0 ,sum(amt05)) AS [MAY], iif( sum(amt06) is null , 0 ,sum(amt06)) AS [JUN], iif( sum(amt07) is null , 0 ,sum(amt07)) AS [JUL], iif( sum(amt08) is null , 0 ,sum(amt08)) AS [AUG], iif( sum(amt09) is null , 0 ,sum(amt09)) AS [SEP], iif( sum(amt10) is null , 0 ,sum(amt10)) AS [OCT], iif( sum(amt11) is null , 0 ,sum(amt11))AS [NOV], iif( sum(amt12) is null , 0 ,sum(amt12)) AS [DEC] , [JAN] + [FEB] + [MAR] + [APR] + [MAY] + [JUN] + [JUL] + [AUG] + [SEP] + [OCT] + [NOV] + [DEC] as Amount  FROM(AnnualReport) WHERE ecode='" & Session("EmpId") & "' and mType='D' GROUP BY mType", sqlCon)
            adpAnnualRpt.Fill(dsAnnualRpt, "AnnualRpt")

            Dim DataAns As DataRow = dsAnnualRpt.Tables("AnnualRpt").NewRow

            DataAns("PaymentHead") = "Net Amount"

            DataAns("JAN") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("JAN")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("JAN"))
            DataAns("FEB") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("FEB")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("FEB"))
            DataAns("MAR") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("MAR")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("MAR"))
            DataAns("APR") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("APR")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("APR"))
            DataAns("MAY") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("MAY")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("MAY"))
            DataAns("JUN") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("JUN")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("JUN"))
            DataAns("JUL") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("JUL")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("JUL"))
            DataAns("AUG") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("AUG")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("AUG"))
            DataAns("SEP") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("SEP")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("SEP"))
            DataAns("OCT") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("OCT")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("OCT"))
            DataAns("NOV") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("NOV")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("NOV"))
            DataAns("DEC") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("DEC")) - _
                             Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("DEC"))
            DataAns("Amount") = Val(dsAnnualRpt.Tables("AnnualRpt").Rows(intECnt).Item("Amount")) - _
                                Val(dsAnnualRpt.Tables("AnnualRpt").Rows(dsAnnualRpt.Tables("AnnualRpt").Rows.Count - 1).Item("Amount"))
            dsAnnualRpt.Tables("AnnualRpt").Rows.Add()
            dsAnnualRpt.Tables("AnnualRpt").Rows.Add(DataAns)


            If dsAnnualRpt.Tables("AnnualRpt").Rows.Count > 0 Then

                gvAnnualRpt.DataSource = dsAnnualRpt.Tables("AnnualRpt")
                gvAnnualRpt.DataBind()
                gvAnnualRpt.HeaderRow.Cells(13).Text = "Total<sub><img src='" & Session("img") & "'/></sub>"
                gvAnnualRpt.HeaderRow.Cells(0).HorizontalAlign = HorizontalAlign.Left
                For intI = 0 To gvAnnualRpt.Rows.Count - 1
                    gvAnnualRpt.Rows(intI).Cells(0).HorizontalAlign = HorizontalAlign.Left
                Next

                For intI = 0 To 13
                    gvAnnualRpt.Rows(intECnt).Cells(intI).Font.Bold = True
                    gvAnnualRpt.Rows(gvAnnualRpt.Rows.Count - 1).Cells(intI).Font.Bold = True
                    gvAnnualRpt.Rows(gvAnnualRpt.Rows.Count - 3).Cells(intI).Font.Bold = True
                    For intJ As Integer = 0 To gvAnnualRpt.Rows.Count - 1
                        If Not gvAnnualRpt.Rows(intJ).Cells(0).Text = "&nbsp;" Then
                            gvAnnualRpt.Rows(intJ).Cells(intI + 1).Text = IIf(Val(gvAnnualRpt.Rows(intJ).Cells(intI + 1).Text) = 0, "-", gvAnnualRpt.Rows(intJ).Cells(intI + 1).Text)
                        End If
                    Next
                Next

                gvAnnualRpt.Visible = True
            End If
        Catch ex As Exception
            '            MsgBox(ex.Message.ToString)
        End Try
    End Sub
    Private Sub PrintPDF()

        Try

       
            Dim pdfForm As New PDFform(dsAnnualRpt, "0", "14in")
        Dim document As MigraDoc.DocumentObjectModel.Document = pdfForm.CreateDocument()

        document.UseCmykColor = True
        Dim pdfRenderer As New PdfDocumentRenderer(True)
        pdfRenderer.Document = document
        pdfRenderer.RenderDocument()
        Dim ms As New System.IO.MemoryStream()
        pdfRenderer.Save(ms, True)
        Dim byteArray() As Byte = ms.ToArray()
        HttpContext.Current.Response.ContentType = "Application/pdf"
        HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=AnnualSalaryReport.pdf")
        HttpContext.Current.Response.AddHeader("Content-Length", byteArray.Length.ToString())
        HttpContext.Current.Response.ContentType = "application/octet-stream"
        HttpContext.Current.Response.BinaryWrite(byteArray)
            HttpContext.Current.Response.End()
        Catch ex As Exception
            Alert.Show("No data found")
        End Try
    End Sub
End Class
