Imports System.Data
Imports System.Data.OleDb
Imports System.IO

Partial Class ChangePassword
    Inherits System.Web.UI.Page

    Private dsProfile As New DataSet
    Private dr As DataRow
    Private mycon As OleDbConnection
    Private pwdcon As OleDbConnection
    Private strQuery As String
    Private sqlcmd As New OleDb.OleDbCommand(strQuery, pwdcon)
    Private adp As New OleDb.OleDbDataAdapter
    Dim blnDone As Boolean

    Protected Sub btnProceed_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnProceed.Click
        Dim strPass As String
        Try
            Dim intRowsAffected As Integer
            If txtOldPass.Text = "" Then
                lblMsg.Text = "Please Enter Old Password"
                Exit Sub
            ElseIf txtNewPass.Text = "" Then
                lblMsg.Text = "Please Enter New Password"
                Exit Sub
            ElseIf txtRePass.Text = "" Then
                lblMsg.Text = "Please Enter Re-Password"
                Exit Sub
            ElseIf txtNewPass.Text.Length < 6 Then
                lblMsg.Text = "Password should be atleast 6 character"
                Exit Sub
            ElseIf StrComp(txtNewPass.Text, txtRePass.Text, CompareMethod.Binary) <> 0 Then
                lblMsg.Text = "New Password is not matching with Re-Password"
                Exit Sub
            End If
            adp = New OleDbDataAdapter("select Pwd from Employee where EmpCode='" & Session("EmpId") & "' ", pwdcon)
            adp.Fill(dsProfile, "PwdChange")

            If dsProfile.Tables("PwdChange").Rows.Count > 0 Then
                strPass = IIf(IsDBNull(dsProfile.Tables("PwdChange").Rows(0).Item("Pwd")), "", dsProfile.Tables("PwdChange").Rows(0).Item("Pwd"))
                If StrComp(strPass, txtOldPass.Text, CompareMethod.Binary) = 0 Then

                    'Ver 4.1 QC1148 start
                    'adp.SelectCommand.CommandText = "update Employee " & _
                    '            "set Pwd='" & txtNewPass.Text & "'" & _
                    '            " where EmpCode='" & Session("EmpId") & "' " & _
                    '            " and Pwd='" & txtOldPass.Text & "'"

                    adp.SelectCommand.CommandText = "update Employee set Pwd=@NewPassword where EmpCode ='" & Session("EmpId") & "'and Pwd=@OldPassword "
                    adp.SelectCommand.Parameters.AddWithValue("@NewPassword", txtNewPass.Text)
                    adp.SelectCommand.Parameters.AddWithValue("@OldPassword", txtOldPass.Text)
                    'Ver 4.1 QC1148 end 
                    pwdcon.Open()
                    intRowsAffected = adp.SelectCommand.ExecuteNonQuery()
                    pwdcon.Close()
                    lblMsg.Text = "Password Changed Successfully"
                    Exit Sub
                End If
            End If
            adp.SelectCommand.Connection = mycon
            adp.SelectCommand.CommandText = "select [Password] from EmpMaster " & _
                                              " where EmpCode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "PwdChange")
            If dsProfile.Tables("PwdChange").Rows.Count > 0 Then
                strPass = IIf(IsDBNull(dsProfile.Tables("PwdChange").Rows(0).Item("Password")), "", dsProfile.Tables("PwdChange").Rows(0).Item("Password"))
                If StrComp(strPass, txtOldPass.Text, CompareMethod.Binary) = 0 Then
                    adp.SelectCommand.Connection = pwdcon
                    'Ver 4.1 QC1148 start
                    'adp.SelectCommand.CommandText = "insert into Employee(EmpCode,Pwd) " & _
                    '                    "values('" & Session("EmpId") & "','" & txtNewPass.Text & "')"


                    adp.SelectCommand.CommandText = "insert into Employee(EmpCode,Pwd)values('" & Session("EmpId") & "',@NewPassword)"
                    adp.SelectCommand.Parameters.AddWithValue("@NewPassword", txtNewPass.Text)

                    'Ver 4.1 QC1148 end 
                    pwdcon.Open()
                    intRowsAffected = adp.SelectCommand.ExecuteNonQuery
                    pwdcon.Close()
                    lblMsg.Text = ("Password Changed Successfully.")
                    Exit Sub
                End If
            End If
            lblMsg.Text = "Old Password not matching."
        Catch ex As Exception
            'Ver 4.1 QC1148 start
            'lblMsg.Text = ex.Message.ToString
            lblMsg.Text = "Some technical issues has occurred"
            'Ver 4.1 QC1148 end 
        End Try
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If
            'Ver 3.2-E398 Start
            Master.FindControl("imgPDF").Visible = False
            'Ver 3.2-E398 end
            mycon = New OleDbConnection(Session("myconnection"))
            pwdcon = New OleDbConnection(Session("pwdconnection"))

            If blnDone = True Then
                lblMsg.Text = "Password Changed Successfully"
                blnDone = False
            End If

            lblEmpCode.Text = Session("EmpId")
            lblName.Text = Session("EmpName")
            lblFY.Text = Session("Period")

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
End Class
