﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing
Imports System.IO
Imports Ionic.Zip

Partial Class DownloadCSV
    Inherits System.Web.UI.Page
    Dim ds As DataSet
    Dim strconn As String
    Dim strSortCondition As String

    Protected Sub lnkhra_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkhra.Click
        CreateCSV(Data("SELECT HRA.EmployeeCode, format(HRA.PeriodFrom,'dd/MM/yyyy') as PeriodFrom, format(HRA.PeriodTo,'dd/MM/yyyy') as PeriodTo, HRA.TotalRentForYear, iif(HRA.AgreementProof=true,'Yes','No') as AgreementProof, iif( HRA.Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(HRA.isproofreject=true,'Yes','No') as isproofreject, HRA.Reason FROM HRA where type='Agreement' order by HRA.EmployeeCode " + hdQry.Value))
    End Sub
    Protected Sub lnkMediclaim_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkMediclaim.Click
        CreateCSV(Data("SELECT Mediclaim.EmployeeCode, Mediclaim.NameofPolicyHolder, Mediclaim.Relationship,format(Mediclaim.DateofPayment,'dd/MM/yyyy') as DateofPayment, Mediclaim.Amount,iif(Mediclaim.IsProofAttach=true,'Yes','No') as IsProofAttach ,iif(Mediclaim.Isproofapproved=true,'Yes','No') as Isproofapproved ,iif( Mediclaim.isproofreject=true,'Yes','No') as isproofreject, Mediclaim.Reason FROM Mediclaim order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkEducationLoan_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkEducationLoan.Click
        CreateCSV(Data("SELECT EducationLoan.EmployeeCode, EducationLoan.NameofBank, EducationLoan.Relationship, format(EducationLoan.DateofCertificate,'dd/MM/yyyy') as DateofCertificate, EducationLoan.InterestAmount, iif(EducationLoan.CertificatefromBank,'Yes','No') as CertificatefromBank, iif(EducationLoan.StatementspecifyingInterestFigures,'Yes','No') as StatementspecifyingInterestFigures , iif(EducationLoan.Isproofapproved,'Yes','No') as Isproofapproved,iif(EducationLoan.isproofreject,'Yes','No') as isproofreject, EducationLoan.Reason   FROM(EducationLoan) order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkLIP_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkLIP.Click
        CreateCSV(Data("SELECT LIP.EmployeeCode, LIP.PolicyHolder, LIP.Relationship, LIP.PolicyNumber, LIP.Frequency, LIP.PremiumAmount, LIP.TotalPremium,format(LIP.FirstPayment,'dd/MM/yyyy') as FirstPayment , format(LIP.lastPayment,'dd/MM/yyyy') as lastPayment, iif(LIP.LIPReceipts=true,'Yes','No') as LIPReceipts, iif( LIP.Certificate=true,'Yes','No') as Certificate, iif( LIP.IsNewPolicy=true,'Yes','No') as IsNewPolicy, iif( LIP.Isproofapproved=true,'Yes','No') as Isproofapproved, iif( LIP.isproofreject=true,'Yes','No') as isproofreject, LIP.Reason FROM LIP order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkppf_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkppf.Click
        CreateCSV(Data("SELECT PPF.EmployeeCode, PPF.BankName, PPF.Relationship, format(PPF.DateofPayment,'dd/MM/yyyy') as DateofPayment, PPF.Amount, iif(PPF.CopyofPassBook=true,'Yes','No') as CopyofPassBook,iif( PPF.CopyofChallan=true,'Yes','No') as CopyofChallan, iif(PPF.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(PPF.isproofreject=true,'Yes','No') as isproofreject, PPF.Reason FROM PPF order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkElss_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkElss.Click
        CreateCSV(Data("SELECT ELSS.EmployeeCode, ELSS.SchemeName, ELSS.Relationship, format(ELSS.DateofPayment,'dd/MM/yyyy') as DateofPayment, ELSS.Amount, iif(ELSS.Receipt_Statement=true,'Yes','No') as Receipt_Statement,iif( ELSS.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(ELSS.isproofreject=true,'Yes','No') as isproofreject, ELSS.Reason FROM ELSS order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkTermdeposit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkTermdeposit.Click
        CreateCSV(Data("SELECT TermDeposit.EmployeeCode, TermDeposit.BankName, format(TermDeposit.DateofPayment,'dd/MM/yyyy') as DateofPayment, TermDeposit.Amount, iif(TermDeposit.DepositReceipt=true,'Yes','No') as DepositReceipt, iif(TermDeposit.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(TermDeposit.isproofreject=true,'Yes','No') as isproofreject, TermDeposit.Reason FROM TermDeposit  order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkTutionfees_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkTutionfees.Click
        CreateCSV(Data("SELECT TutionFees.EmployeeCode, TutionFees.SchoolName, TutionFees.Relationship, TutionFees.Frequency, TutionFees.AmountofTutionFees, TutionFees.TotalTutionFees, format(TutionFees.FirstPayment,'dd/MM/yyyy') as FirstPayment, format(TutionFees.lastPayment,'dd/MM/yyyy') as lastPayment, iif(TutionFees.FirstnLastReceipt=true,'Yes','No') as FirstnLastReceipt, iif(TutionFees.Isproofapproved=true,'Yes','No') as Isproofapproved,iif( TutionFees.isproofreject=true,'Yes','No') as isproofreject, TutionFees.Reason FROM TutionFees order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkHousingLoan_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkHousingLoan.Click
        CreateCSV(Data("SELECT HousingLoan.EmployeeCode, HousingLoan.BankName, HousingLoan.Owned_Letout, format(HousingLoan.DateofCertificate,'dd/MM/yyyy') as DateofCertificate, HousingLoan.PrincipalAmount, HousingLoan.InterestAmount, iif(HousingLoan.CertificatefromBank=true,'Yes','No') as CertificatefromBank,iif( HousingLoan.Isproofapproved=true,'Yes','No') as Isproofapproved,iif( HousingLoan.isproofreject=true,'Yes','No') as isproofreject, HousingLoan.Reason FROM HousingLoan  order by employeecode" + hdQry.Value))
    End Sub
    Protected Sub lnkRentRecipt_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkRentRecipt.Click
        CreateCSV(Data("SELECT HraMonthlyValues.EmployeeCode, HraMonthlyValues.MonthCode, HraMonthlyValues.Amount,iif(HraMonthlyValues.HasProof=true,'Yes','No') as HasProof, iif(HraMonthlyValues.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(HraMonthlyValues.isproofreject =true,'Yes','No') as isproofreject, HraMonthlyValues.Reason FROM HRA INNER JOIN HraMonthlyValues ON HRA.EmployeeCode = HraMonthlyValues.EmployeeCode where HRA.Type='Rent Receipts' order by HRA.EmployeeCode" + ff(hdQry.Value)))
    End Sub
    Protected Sub lnkNSC_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkNSC.Click
        CreateCSV(Data("SELECT NSC.NameofNSCHolder, NSC.Relationship,format(NSC.DateofPayment,'dd/MM/yyyy') as DateofPayment, NSC.Amount, iif(NSC.IsProofAttach=true,'Yes','No') as IsProofAttach, NSC.EmployeeCode,  iif(NSC.Isproofapproved=true,'Yes','No') as Isproofapproved, NSC.Reason,  iif(NSC.isproofreject=true,'Yes','No') as isproofreject FROM NSC order by NSC.EmployeeCode" + hdQry.Value))
    End Sub

    Sub CreateCSV(ByVal dds As DataSet)
        Dim sb As StringBuilder = New StringBuilder()
        Dim ds As DataSet = dds
        Dim rc As Integer = ds.Tables(0).Columns.Count
        Dim rr As Integer = ds.Tables(0).Rows.Count
        For cc = 0 To rc - 1
            sb.Append(ds.Tables(0).Columns(cc).ColumnName + ",")
        Next
        sb.AppendLine("")
        For j = 0 To rr - 1
            For i = 0 To rc - 1
                sb.Append(ds.Tables(0).Rows(j)(i).ToString() + ",")
            Next
            sb.AppendLine("")
        Next
        Response.ContentType = "text/Plain"
        Response.AddHeader("content-disposition", "attachment; filename=download.csv")
        Response.Write(sb.ToString())
        Response.End()
    End Sub
    Function Data(ByVal strQuery As String) As DataSet
        Dim ds As DataSet = New DataSet()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strQuery, strconn)
        da.Fill(ds)
        Return ds
    End Function
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'Ver 3.5-REQ305 start
        'If Session("Period") = "2013-2014" Then
        'Ver 4.0-QC972 start
        ' If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Then
        'Ver 4.01-REQ723 start
        'If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") = "2016-2017" Then
        If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") >= "2016-2017" Then
            'Ver 4.01-REQ723 end
            'Ver 4.0-QC972 end 
            'Ver 3.5-REQ305 end
            lnk80TTA.Visible = True
            lnk80EE.Visible = True
            lbl80TTA.Visible = True
            'Ver 3.07-REQ??? start
            'Ver 3.8-REQ580 start
            'ElseIf Session("Period") = "2015-2016" Then
        ElseIf Session("Period") >= "2015-2016" Then
            'Ver 3.8-REQ580 end 
            'Ver 3.07-REQ??? end
            lnk80TTA.Visible = True
            lbl80TTA.Visible = True
        Else
            lnk80TTA.Visible = False
            lnk80EE.Visible = False
            lbl80TTA.Visible = False
        End If
        If Session("EmpId") = String.Empty Then
            Response.Redirect("EmpLogin.aspx")
        End If
        strconn = Session("invConnection").ToString()
        Try
            ds = Data("select category,format(Lastmodify,'dd-MM-yyyy') as Lastmodify  from categoryLOG")
            lblHRA.Text = ds.Tables(0).Rows(0)("Lastmodify").ToString()
            lblMediclaim.Text = ds.Tables(0).Rows(1)("Lastmodify").ToString()
            lblEducationLoan.Text = ds.Tables(0).Rows(2)("Lastmodify").ToString()
            lblLIP.Text = ds.Tables(0).Rows(3)("Lastmodify").ToString()
            lblPpf.Text = ds.Tables(0).Rows(4)("Lastmodify").ToString()
            lblElss.Text = ds.Tables(0).Rows(5)("Lastmodify").ToString()
            lblTermDeposit.Text = ds.Tables(0).Rows(6)("Lastmodify").ToString()
            lblTutionfees.Text = ds.Tables(0).Rows(7)("Lastmodify").ToString()
            lblHousingLoan.Text = ds.Tables(0).Rows(8)("Lastmodify").ToString()
            lblRentRecipt.Text = ds.Tables(0).Rows(9)("Lastmodify").ToString()
            lblNSC.Text = ds.Tables(0).Rows(10)("Lastmodify").ToString()
            lbl80ccg.Text = ds.Tables(0).Rows(11)("Lastmodify").ToString()

            If ds.Tables(0).Select("Category = 'Landlorddetails'").Length > 0 Then
                lbllandlord.Text = ds.Tables(0).Select("Category = 'Landlorddetails'").CopyToDataTable.Rows(0)("Lastmodify").ToString()
            End If

            'Ver 3.3-E588 start 
            'Ver 3.5-REQ305 start
            'If Session("Period") = "2013-2014" Then
            'Ver 4.0-QC972 start
            'If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Then
            'Ver 4.01-REQ723 start
            'If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") = "2016-2017" Then
            If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") >= "2016-2017" Then
                'Ver 4.01-REQ723 end
                'Ver 4.0-QC972 end 
                'Ver 3.5-REQ305 end
                lbl80TTA.Text = ds.Tables(0).Rows(12)("Lastmodify").ToString()
                lbl80EE.Text = ds.Tables(0).Rows(13)("Lastmodify").ToString()
            End If
            'Ver 3.3-E588 end
            'Ver 3.07-REQ511 start
            'Ver 3.8-REQ580 start
            'If Session("Period") = "2015-2016" Then
            If Session("Period") >= "2015-2016" Then
                'Ver 3.8-REQ580 end 
                lbl80TTA.Text = ds.Tables(0).Rows(12)("Lastmodify").ToString()
                lbl80CCD.Text = ds.Tables(0).Rows(14)("Lastmodify").ToString()
            End If
            'Ver 3.07-REQ511 end

            'ver 4.2 REQ806 Start
            If Session("Period") >= "2018-2019" Then
                lbl80TTB.Text = ds.Tables(0).Rows(15)("Lastmodify").ToString()
                lblNPS.Text = ds.Tables(0).Rows(16)("Lastmodify").ToString()
            End If
            'ver 4.2 REQ806 end
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table or query 'categoryLOG'") Or ex.Message.Contains("There is no row at position 0") Then
                General.ExecuteDML(strconn, "create table categoryLOG ( category Text,Lastmodify DateTime) ")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('hra')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('mediclaim')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('educationloan')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('lip')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('ppf')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('ELSS')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('TermDeposit')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('TutionFees')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('HousingLoan')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('RentRecipt')")
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('NSC')")
                'Ver 3.2-E450 Start
                General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80CCG')")
                'Ver 3.2-E450 End
                'Ver 3.3-E588 start 
                'Ver 3.5-REQ305 start
                'If Session("Period") = "2013-2014" Then
                'Ver 4.0-QC972 start
                ' If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Then
                'Ver 4.01-REQ723 start
                'If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") = "2016-2017" Then
                If Session("Period") >= "2013-2014" Then
                    General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80TTA')")
                End If
                If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") >= "2016-2017" Then
                    'Ver 4.01-REQ723 end
                    'Ver 4.0-QC972 end 
                    'Ver 3.5-REQ305 end
                    ' General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80TTA')")
                    General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80EE')")
                End If
                'Ver 3.3-E588 end 
                'Ver 3.07-REQ511 start
                'Ver 3.8-REQ580 start
                If Session("Period") >= "2015-2016" Then
                    'Ver 3.8-REQ580 end 
                    ' General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80TTA')")
                    General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80CCD')")
                End If
                'Ver 3.07-REQ511 end
                'ver 4.2 REQ806 Start
                If Session("Period") >= "2018-2019" Then
                    General.ExecuteDML(strconn, "insert into categoryLOG(category) values('80TTB')")
                End If
                'ver 4.2 REQ806 end
                'FascFacts 721 Start
                If Session("Period") >= "2018-2019" Then
                    General.ExecuteDML(strconn, "insert into categoryLOG(category) values('NPS')")
                End If
                'FascFacts 721 end end

            End If

        End Try
        If Page.IsPostBack <> True Then
            strSortCondition = ""
        End If
    End Sub
    Protected Sub ddlDate_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlDate.SelectedIndexChanged
        If ddlcategory.SelectedItem.Value.Equals("None") Then
            hdQry.Value = " " + ddlDate.SelectedItem.Value
        End If
        If ddlcategory.SelectedItem.Value.Equals("EmpInsert") Then
            hdQry.Value = ",EmpInsert " + ddlDate.SelectedItem.Value
        End If
        If ddlcategory.SelectedItem.Value.Equals("EmpUpdate") Then
            hdQry.Value = ",EmpUpdate " + ddlDate.SelectedItem.Value
        End If
        If ddlcategory.SelectedItem.Value.Equals("AdminUpdate") Then
            hdQry.Value = ",AdminUpdate " + ddlDate.SelectedItem.Value
        End If
    End Sub
    Protected Sub ddlcategory_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlcategory.SelectedIndexChanged
        If ddlcategory.SelectedItem.Value.Equals("None") Then
            hdQry.Value = " " + ddlDate.SelectedItem.Value
        End If
        If ddlcategory.SelectedItem.Value.Equals("EmpInsert") Then
            hdQry.Value = ",EmpInsert " + ddlDate.SelectedItem.Value
        End If
        If ddlcategory.SelectedItem.Value.Equals("EmpUpdate") Then
            hdQry.Value = ",EmpUpdate " + ddlDate.SelectedItem.Value
        End If
        If ddlcategory.SelectedItem.Value.Equals("AdminUpdate") Then
            hdQry.Value = ",AdminUpdate " + ddlDate.SelectedItem.Value
        End If
    End Sub

    Protected Sub lnkDownLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDownLoad.Click
        Dim strFPath As String = ""
        Dim strWinDir = Environment.GetEnvironmentVariable("WINDIR").Substring(0, 2)

        'Ver 3.3-E456 Start
        'strFPath = strWinDir & "\\SSM\Downloads\InvestmentProofs"
        strFPath = strWinDir & "\SSM\Downloads\InvestmentProofs"
        'Ver 3.3-E456 End

        If Directory.Exists(strFPath) <> True Then
            Directory.CreateDirectory(strFPath)
        End If


        WriteCSV(Data("SELECT HRA.EmployeeCode, HRA.Type, format(HRA.PeriodFrom,'dd/MM/yyyy') as PeriodFrom,format(HRA.PeriodTo,'dd/MM/yyyy') as PeriodTo, HRA.AgreementRentAmount, HRA.TotalRentForYear, HRA.TotalRentReceiptsAmount, HRA.AgreementProof, HRA.Isproofapproved, HRA.Reason, HRA.isproofreject, HRA.isproofreject, HraMonthlyValues.MonthCode, HraMonthlyValues.Amount, HraMonthlyValues.HasProof, HraMonthlyValues.Isproofapproved, HraMonthlyValues.Reason, HraMonthlyValues.isproofreject FROM HRA INNER JOIN HraMonthlyValues ON HRA.EmployeeCode = HraMonthlyValues.EmployeeCode order by HRA.EmployeeCode" + ff(hdQry.Value)), strFPath, "\Hra-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("select EmpCode as EmployeeCode, Name as LandLordName, Address as LandLordAddress, PANNumber as LandLordPAN from LandLordDetails order by EmpCode" + ff(hdQry.Value)), strFPath, "\LandLord-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT Mediclaim.EmployeeCode, Mediclaim.NameofPolicyHolder, Mediclaim.Relationship,format(Mediclaim.DateofPayment,'dd/MM/yyyy') as DateofPayment, Mediclaim.Amount,iif(Mediclaim.IsProofAttach=true,'Yes','No') as IsProofAttach ,iif(Mediclaim.Isproofapproved=true,'Yes','No') as Isproofapproved ,iif( Mediclaim.isproofreject=true,'Yes','No') as isproofreject, Mediclaim.Reason FROM Mediclaim order by employeecode" + hdQry.Value), strFPath, "\Mediclaim-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT EducationLoan.EmployeeCode, EducationLoan.NameofBank, EducationLoan.Relationship, format(EducationLoan.DateofCertificate,'dd/MM/yyyy') as DateofCertificate, EducationLoan.InterestAmount, iif(EducationLoan.CertificatefromBank,'Yes','No') as CertificatefromBank, iif(EducationLoan.StatementspecifyingInterestFigures,'Yes','No') as StatementspecifyingInterestFigures , iif(EducationLoan.Isproofapproved,'Yes','No') as Isproofapproved,iif(EducationLoan.isproofreject,'Yes','No') as isproofreject, EducationLoan.Reason   FROM(EducationLoan) order by employeecode" + hdQry.Value), strFPath, "\educationloan-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT LIP.EmployeeCode, LIP.PolicyHolder, LIP.Relationship, LIP.PolicyNumber, LIP.Frequency, LIP.PremiumAmount, LIP.TotalPremium,format(LIP.FirstPayment,'dd/MM/yyyy') as FirstPayment , format(LIP.lastPayment,'dd/MM/yyyy') as lastPayment, iif(LIP.LIPReceipts=true,'Yes','No') as LIPReceipts, iif( LIP.Certificate=true,'Yes','No') as Certificate, iif( LIP.IsNewPolicy=true,'Yes','No') as IsNewPolicy, iif( LIP.Isproofapproved=true,'Yes','No') as Isproofapproved, iif( LIP.isproofreject=true,'Yes','No') as isproofreject, LIP.Reason FROM LIP order by employeecode" + hdQry.Value), strFPath, "\LIP-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT PPF.EmployeeCode, PPF.BankName, PPF.Relationship, format(PPF.DateofPayment,'dd/MM/yyyy') as DateofPayment, PPF.Amount, iif(PPF.CopyofPassBook=true,'Yes','No') as CopyofPassBook,iif( PPF.CopyofChallan=true,'Yes','No') as CopyofChallan, iif(PPF.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(PPF.isproofreject=true,'Yes','No') as isproofreject, PPF.Reason FROM PPF order by employeecode" + hdQry.Value), strFPath, "\PPF-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT ELSS.EmployeeCode, ELSS.SchemeName, ELSS.Relationship, format(ELSS.DateofPayment,'dd/MM/yyyy') as DateofPayment, ELSS.Amount, iif(ELSS.Receipt_Statement=true,'Yes','No') as Receipt_Statement,iif( ELSS.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(ELSS.isproofreject=true,'Yes','No') as isproofreject, ELSS.Reason FROM ELSS order by employeecode" + hdQry.Value), strFPath, "\ELSS-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT TermDeposit.EmployeeCode, TermDeposit.BankName, format(TermDeposit.DateofPayment,'dd/MM/yyyy') as DateofPayment, TermDeposit.Amount, iif(TermDeposit.DepositReceipt=true,'Yes','No') as DepositReceipt, iif(TermDeposit.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(TermDeposit.isproofreject=true,'Yes','No') as isproofreject, TermDeposit.Reason FROM TermDeposit  order by employeecode" + hdQry.Value), strFPath, "\TermDeposit-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT TutionFees.EmployeeCode, TutionFees.SchoolName, TutionFees.Relationship, TutionFees.Frequency, TutionFees.AmountofTutionFees, TutionFees.TotalTutionFees, format(TutionFees.FirstPayment,'dd/MM/yyyy') as FirstPayment, format(TutionFees.lastPayment,'dd/MM/yyyy') as lastPayment, iif(TutionFees.FirstnLastReceipt=true,'Yes','No') as FirstnLastReceipt, iif(TutionFees.Isproofapproved=true,'Yes','No') as Isproofapproved,iif( TutionFees.isproofreject=true,'Yes','No') as isproofreject, TutionFees.Reason FROM TutionFees order by employeecode" + hdQry.Value), strFPath, "\Tutionfees-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT HousingLoan.EmployeeCode, HousingLoan.BankName, HousingLoan.Owned_Letout, format(HousingLoan.DateofCertificate,'dd/MM/yyyy') as DateofCertificate, HousingLoan.PrincipalAmount, HousingLoan.InterestAmount, iif(HousingLoan.CertificatefromBank=true,'Yes','No') as CertificatefromBank,iif( HousingLoan.Isproofapproved=true,'Yes','No') as Isproofapproved,iif( HousingLoan.isproofreject=true,'Yes','No') as isproofreject, HousingLoan.Reason FROM HousingLoan  order by employeecode" + hdQry.Value), strFPath, "\HousingLoan-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        WriteCSV(Data("SELECT NSC.NameofNSCHolder, NSC.Relationship, format(NSC.DateofPayment,'dd/MM/yyyy') as DateofPayment, NSC.Amount, iif(NSC.IsProofAttach=true,'Yes','No') as IsProofAttach, NSC.EmployeeCode,  iif(NSC.Isproofapproved=true,'Yes','No') as Isproofapproved, NSC.Reason,  iif(NSC.isproofreject=true,'Yes','No') as isproofreject, NSC.EmpInsert, NSC.EmpUpdate, NSC.AdminUpdate FROM NSC order by NSC.EmployeeCode" + hdQry.Value), strFPath, "\NSC-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
        'Ver 3.2-E450 Start
        Try
            WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80ccg   order by EmployeeCode " + hdQry.Value), strFPath, "\80CCG-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
            'Ver 3.3-E588 start 
            'Ver 3.5-REQ305 start
            'If Session("Period") = "2013-2014" Then
            If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Then
                'Ver 3.5-REQ305 end
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80TTA   order by EmployeeCode " + hdQry.Value), strFPath, "\80TTA-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
            End If
            'Ver 3.3-E588 end

            'Ver 4.2 REQ806 start
            If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") >= "2016-2017" Then
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80EE   order by EmployeeCode " + hdQry.Value), strFPath, "\80EE-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
            End If
            'Ver 4.2 REQ806 End

            'Ver 3.07-REQ511 start
            'Ver 3.8-REQ580 start
            'If Session("Period") = "2015-2016" Then
            If Session("Period") >= "2015-2016" Then
                'Ver 3.8-REQ580 end 
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80TTA   order by EmployeeCode " + hdQry.Value), strFPath, "\80TTA-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80CCD order by EmployeeCode " + hdQry.Value), strFPath, "\80CCD-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")

            End If

            'Ver 3.07-REQ511 end
            'Ver 4.2 REQ806 start
            If Session("Period") >= "2018-2019" Then
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80TTB   order by EmployeeCode " + hdQry.Value), strFPath, "\80TTB-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM NPS order by EmployeeCode " + hdQry.Value), strFPath, "\NPS-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")

                ''added by kishor - 18-12-2019
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80EEA order by EmployeeCode " + hdQry.Value), strFPath, "\80EEA-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80EEB order by EmployeeCode " + hdQry.Value), strFPath, "\80EEB-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                ''added by kishor - 18-12-2019

                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80DDB order by EmployeeCode " + hdQry.Value), strFPath, "\80DDB-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80DD order by EmployeeCode " + hdQry.Value), strFPath, "\80DD-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80G order by EmployeeCode " + hdQry.Value), strFPath, "\80G-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80GG order by EmployeeCode " + hdQry.Value), strFPath, "\80GG-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80GGA order by EmployeeCode " + hdQry.Value), strFPath, "\80GGA-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80U order by EmployeeCode " + hdQry.Value), strFPath, "\80U-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
                WriteCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM OtherInvestment order by EmployeeCode " + hdQry.Value), strFPath, "\OtherInvestment-" + DateTime.Now.ToShortDateString().Replace("/", ".") + ".csv")
            End If
            'Ver 4.2 REQ806 end

            'Ver4.2 REQ795 Start
            Dim fileEntries As String() = Directory.GetFiles(strFPath)
            Dim zip As New ZipFile()
            For Each fileName In fileEntries
                Dim filePath As String = fileName
                zip.AddFile(filePath, "Files")
            Next fileName
            Response.Clear()
            Response.BufferOutput = False
            Dim zipName As String = [String].Format("Zip_{0}.zip", DateTime.Now.ToString("yyyy-MMM-dd-HHmmss"))
            Response.ContentType = "application/zip"
            Response.AddHeader("content-disposition", "attachment; filename=" + zipName)
            zip.Save(Response.OutputStream)
            Response.End()
            'Ver4.2 REQ795 End
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
        'Ver 3.2-E450 End

        lblMessage.Text = "Files save Successfully in " & strFPath

    End Sub

    Function ff(ByVal s As String) As String
        s = s.Replace("EmpInsert", "HraMonthlyValues.EmpInsert")
        s = s.Replace("EmpUpdate", "HraMonthlyValues.EmpUpdate")
        s = s.Replace("AdminUpdate", "HraMonthlyValues.AdminUpdate")
        Return s
    End Function
    Sub WriteCSV(ByVal dds As DataSet, ByVal strPath As String, ByVal strFileName As String)
        Dim sb As StringBuilder = New StringBuilder()
        Dim ds As DataSet = dds
        Dim rc As Integer = ds.Tables(0).Columns.Count
        Dim rr As Integer = ds.Tables(0).Rows.Count
        For cc = 0 To rc - 1
            sb.Append(ds.Tables(0).Columns(cc).ColumnName + ",")
        Next
        sb.AppendLine("")
        For j = 0 To rr - 1
            For i = 0 To rc - 1
                sb.Append(ds.Tables(0).Rows(j)(i).ToString() + ",")
            Next
            sb.AppendLine("")
        Next
        Dim fs As FileStream = New FileStream(strPath & strFileName, FileMode.Create)
        Dim sw As StreamWriter = New StreamWriter(fs)
        sw.Write(sb)
        sw.Flush()
        sw.Close()
        fs.Close()
    End Sub
    'Ver 3.2-E450 Start
    Protected Sub lnk80ccg_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80ccg.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80ccg   order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    'Ver 3.2-E450 End
    'Ver 3.3-E588 start
    Protected Sub lnk80TTA_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80TTA.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80TTA   order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub

    Protected Sub lnk80EE_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80EE.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80EE   order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    'Ver 3.3-E588 end

    'Ver4.2 REQ794 Start
    Protected Sub lnk80CCD_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80CCD.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80CCD order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    'Ver4.2 REQ794 End

    'Ver4.2 REQ806 Start
    Protected Sub lnk80TTB_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80TTB.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80TTB order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    'Ver4.2 REQ806 End

    'FascFacts 721 start
    Protected Sub lnkNPS_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkNPS.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM NPS order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    'FascFacts 721 end

    ''kishor added -18-12-2019
    Protected Sub lnk80EEA_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80EEA.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80EEA order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub


    Protected Sub lnk80EEB_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnk80EEB.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80EEB order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    ''kishor added -18-12-2019

    Private Sub lnk80DDB_Click(sender As Object, e As EventArgs) Handles lnk80DDB.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80DDB order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Private Sub lnk80DD_Click(sender As Object, e As EventArgs) Handles lnk80DD.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80DD order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Private Sub lnk80G_Click(sender As Object, e As EventArgs) Handles lnk80G.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80G order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Private Sub lnk80GG_Click(sender As Object, e As EventArgs) Handles lnk80GG.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80GG order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Private Sub lnk80GGA_Click(sender As Object, e As EventArgs) Handles lnk80GGA.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80GGA order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Private Sub lnk80U_Click(sender As Object, e As EventArgs) Handles lnk80U.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM 80U order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Private Sub lnkothinvst_Click(sender As Object, e As EventArgs) Handles lnkothinvst.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode, Amount,  iif(IsProofAttach=true,'Yes','No') as IsProofAttach, iif( Isproofapproved=true,'Yes','No') as Isproofapproved,  iif(isproofreject=true,'Yes','No') as isproofreject, Reason FROM OtherInvestment order by EmployeeCode " + hdQry.Value))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub

    Protected Sub lnklandlord_Click(sender As Object, e As EventArgs) Handles lnklandlord.Click
        'CreateCSV(Data("SELECT HraMonthlyValues.EmployeeCode, HraMonthlyValues.MonthCode, HraMonthlyValues.Amount,iif(HraMonthlyValues.HasProof=true,'Yes','No') as HasProof, iif(HraMonthlyValues.Isproofapproved=true,'Yes','No') as Isproofapproved, iif(HraMonthlyValues.isproofreject =true,'Yes','No') as isproofreject, HraMonthlyValues.Reason FROM HRA INNER JOIN HraMonthlyValues ON HRA.EmployeeCode = HraMonthlyValues.EmployeeCode where HRA.Type='Rent Receipts' order by HRA.EmployeeCode" + ff(hdQry.Value)))
        CreateCSV(Data("select EmpCode as EmployeeCode, Name as LandLordName, Address as LandLordAddress, PANNumber as LandLordPAN from LandLordDetails order by EmpCode" + ff(hdQry.Value)))
    End Sub
End Class
