﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Xml
Partial Class DownloadNewTaxRegime
    Inherits System.Web.UI.Page

    Dim adpDownLoad As New OleDbDataAdapter
    Dim dsDownLoad As New DataSet
    Dim dtReader As OleDbDataReader
    Dim objCon As New OleDbConnection
    Dim strconn As String

    Protected Sub btnDownLoad_Click(sender As Object, e As EventArgs) Handles btnDownLoad.Click
        Try
            CreateCSV(Data("SELECT EmployeeCode ,format(EmpInsert,'dd-MMM-yyyy') as DateInserted from TaxNewRegime order by EmployeeCode "))
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
            End If
        End Try
    End Sub
    Sub CreateCSV(ByVal dds As DataSet)
        Dim sb As StringBuilder = New StringBuilder()
        Dim ds As DataSet = dds
        Dim rc As Integer = ds.Tables(0).Columns.Count
        Dim rr As Integer = ds.Tables(0).Rows.Count
        For cc = 0 To rc - 1
            sb.Append(ds.Tables(0).Columns(cc).ColumnName + ",")
        Next
        sb.AppendLine("")
        For j = 0 To rr - 1
            For i = 0 To rc - 1
                sb.Append(ds.Tables(0).Rows(j)(i).ToString() + ",")
            Next
            sb.AppendLine("")
        Next
        Response.ContentType = "text/Plain"
        Response.AddHeader("content-disposition", "attachment; filename=download.csv")
        Response.Write(sb.ToString())
        Response.End()
    End Sub

    Function Data(ByVal strQuery As String) As DataSet
        strconn = Session("invConnection").ToString()
        Dim ds As DataSet = New DataSet()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strQuery, strconn)
        da.Fill(ds)
        Return ds
    End Function

End Class
