Imports System.Data
Imports System.Data.OleDb
Imports System.IO

Partial Class DownloadList
    Inherits System.Web.UI.Page

    Dim adpList As New OleDbDataAdapter
    Dim objCon As New OleDbConnection

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("EmpId") = String.Empty Then
            Response.Redirect("EmpLogin.aspx")
        End If
        'Ver 3.2-E398 Start
        Master.FindControl("imgPDF").Visible = False
        'Ver 3.2-E398 end
        Try
            lblEmpCode.Text = Session("EmpId")
            lblName.Text = Session("EmpName")
            lblFY.Text = Session("Period")

            objCon.ConnectionString = Session("myconnection")

            If Request.QueryString("Fold") <> String.Empty Then
                Call GetDownloadLinks(Request.QueryString("Fold") & "/")
            Else
                Call GetDownloadLinks(Server.MapPath("App_Data/") & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/" & UCase(Session("EmpId")) & "/" & "Download/")
            End If
            ColorRow()
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub GetDownloadLinks(ByVal strPath As String)
        Try
            '--Dim strPath As String
            Dim tblRow As TableRow
            Dim tblCol As TableCell
            Dim lnkDownload As HyperLink

            '--strPath = Server.MapPath("App_Data/") & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/" & UCase(Session("EmpId")) & "/" & "Download/"

            Dim MainDirectory As DirectoryInfo = New DirectoryInfo(strPath)

            Dim strFile As FileInfo
            Dim strDir As DirectoryInfo

            If MainDirectory.Exists = False Then
                MainDirectory.Create()
                'lblMsg.Text = "The Directory not Exist"
                Exit Sub
            Else
                For Each strDir In MainDirectory.GetDirectories()
                    tblRow = New TableRow
                    tblDownloadLinks.Rows.Add(tblRow)
                    tblCol = New TableCell

                    lnkDownload = New HyperLink
                    lnkDownload.NavigateUrl = "DownlodList.aspx?Fold=" & strDir.FullName
                    lnkDownload.Text = strDir.Name
                    tblCol.Controls.Add(lnkDownload)
                    tblRow.Cells.Add(tblCol)
                    'AddHandler lnkDownload.CheckedChanged, AddressOf optDedCol0_SelectionChanged
                Next

                For Each strFile In MainDirectory.GetFiles()
                    tblRow = New TableRow
                    tblDownloadLinks.Rows.Add(tblRow)
                    tblCol = New TableCell

                    lnkDownload = New HyperLink
                    lnkDownload.NavigateUrl = "DownloadFile.aspx?File=" & strFile.FullName
                    lnkDownload.Text = strFile.Name
                    tblCol.Controls.Add(lnkDownload)
                    tblRow.Cells.Add(tblCol)
                Next
            End If
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
    Private Sub ColorRow()
        Try

            For i = 0 To tblDownloadLinks.Rows.Count
                If (i Mod 2 = 0) Then
                    tblDownloadLinks.Rows(i).CssClass = "tblAlternetRow"
                End If
            Next
        Catch ex As Exception
        End Try

    End Sub
End Class
