﻿Imports System.Data
Imports System.Data.OleDb
Imports System.IO
Imports General
Imports System.Net.Mail
Imports System.Web.Configuration
Imports System.Net.Configuration
Imports SendMail

Partial Class NewEmpLogin
    Inherits System.Web.UI.Page
    Private dsProfile As New DataSet
    Dim adp As New OleDbDataAdapter
    Private objCon As New OleDbConnection
    Private objPwdCon As New OleDbConnection

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("CoCode") = String.Empty Then
                Response.Redirect("Login.aspx")
            End If
            If Not File.Exists(Server.MapPath("App_Data") & "/" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/UDF.mdb") Then
                File.Copy(Server.MapPath("App_Data") & "/UDF.mdb", Server.MapPath("App_Data") & "/" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/UDF.mdb")
            End If

            imgPayLogo.ImageUrl = "~/Images/" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/Paypac.bmp"
            imgPayLogo.AlternateText = Session("CoName")

            lblCompanyName.Text = Session("CoName")
            objCon = New OleDb.OleDbConnection(Session("myConnection"))
            objPwdCon = New OleDb.OleDbConnection(Session("PwdConnection"))

            '--This line is for Default Password in WEBSITE
            '--txtUserName.Text = "ffcs01"
            '--txtPassword.Attributes.Add("Value", "01042006")
            'Try
            '    CreateTable()
            'Catch ex As Exception
            'End Try
            'If General.GetData(Session("pwdConnection"), "select count(*) from pagerights where pagename='UDFFields'") = "0" Then
            '    lblMsg.Text = "0"
            '    General.ExecuteDML(Session("pwdConnection"), "insert into pagerights values('UDFFields',-1)")
            'End If

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try

    End Sub
    Private Sub CreateTable()
        ExcDML("create table pagerights( pagename text,allowtouser yesno)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Payslip',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Estimation slip',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Leave Details',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Company Loan Details',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Annual salary Report',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Reimbursement Details',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Investment Declaration',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Post Query',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('My Query Status',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Tax Estimator',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Proof Submission',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Organisation Chart',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('Team Members',-1)")
        ExcDML("insert into pagerights(pagename,allowtouser) values ('UDFFields',-1)")
    End Sub
    Private Sub ExcDML(ByVal qry As String)
        'ver 3.2-CRK Start
        'Dim con As New OleDbConnection(Session("pwdConnection").ToString())
        'con.Open()
        'Dim i As Integer = 0
        'Dim cmd As New OleDbCommand(qry, con)
        'cmd.ExecuteNonQuery()
        'con.Close()
        General.ExecuteDML(Session("pwdConnection").ToString(), qry)
        'ver 3.2-CRK End
    End Sub
    Protected Sub btnLogin_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnLogin.Click
        If btnLogin.Text = "Reset" Then
            btnLogin.ValidationGroup = "L"
            RequiredFieldValidator2.ValidationGroup = "L"
            'Ver 3.2-E427 Start
            forgotPassword()
            'Ver 3.2-E427 End
            btnLogin.Text = "Login"
            LinkButton1.Enabled = True
            btnCancel.Visible = False
        Else
            Dim strPass As String
            Try
                If InStr(txtUserName.Text, "'", CompareMethod.Binary) > 0 Then
                    lblMsg.Text = "The Employee Code does not exists"
                    Exit Sub
                End If
                'Ver 3.2-E428 Start
                If IsDeActive() Then
                    Alert.Show("Your login is deactivated, please contact administrator")
                    Exit Sub
                End If
                'Ver 3.2-E428 end
                'ver 3.3-E625 Start
                Try
                    Session("PAN") = General.GetData(Session("myConnection"), "select pan from  EmpMaster where EmpCode='" & txtUserName.Text & "'")

                Catch ex As Exception
                    Session("PAN") = ""

                End Try
                'ver 3.3-E625 End
                adp = New OleDbDataAdapter("select EmpCode,Pwd from Employee where EmpCode='" & txtUserName.Text & "'", objPwdCon)
                'Alert.Show("Enter2-ConnectionString" + objPwdCon.ConnectionString) 'Jk
                adp.Fill(dsProfile, "Login")
                With dsProfile.Tables("Login")
                    If .Rows.Count > 0 Then
                        strPass = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("Pwd")), "", .Rows(.Rows.Count - 1).Item("Pwd"))
                        If (StrComp(strPass, txtPassword.Text, CompareMethod.Binary) = 0) Or IsAdminPassword(txtPassword.Text) Then
                            If StrComp(.Rows(.Rows.Count - 1).Item("EmpCode"), "Admin", CompareMethod.Binary) = 0 Then
                                Session.Add("EmpId", "Admin")
                                Session("PageName") = "Create Area Admin"
                                Response.Redirect("CreateAdmin.aspx")
                            Else
                                Session.Add("EmpId", .Rows(.Rows.Count - 1).Item("EmpCode"))
                                Call GetEmpName()
                                Session.Add("AreaAdmin", GetAreaAdmin(objPwdCon.ConnectionString, Session("EmpId")))
                                '--Call GetAreaAdmin()
                                Session("PageName") = "Home"
                                Response.Redirect("Home.aspx")
                                Session("SelectedEmpId") = String.Empty
                            End If
                        Else
                            'ver 3.5-???? start
                            lblMsg.Text = "The username or password you entered is incorrect."
                            'ver 3.5-???? end
                            Exit Sub
                        End If
                    End If
                End With

                adp = New OleDbDataAdapter("select EmpCode,[Password] from EmpMaster where EmpCode='" & txtUserName.Text & "'", objCon)
                adp.Fill(dsProfile, "Login")

                With dsProfile.Tables("Login")
                    If .Rows.Count > 0 Then
                        strPass = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("Password")), "", .Rows(.Rows.Count - 1).Item("Password"))
                        If (StrComp(strPass, txtPassword.Text, CompareMethod.Binary) = 0 Or IsAdminPassword(txtPassword.Text)) Then
                            adp.SelectCommand.Connection = objPwdCon
                            Session.Add("EmpId", .Rows(.Rows.Count - 1).Item("EmpCode"))
                            Call GetEmpName()
                            Session.Add("AreaAdmin", GetAreaAdmin(objPwdCon.ConnectionString, Session("EmpId")))
                            '--Call GetAreaAdmin()
                            Session("PageName") = "Home"
                            Response.Redirect("Home.aspx")
                        Else
                            'ver 3.5-???? start
                            lblMsg.Text = "The username or password you entered is incorrect."
                            'ver 3.5-???? start
                        End If
                    Else
                        'ver 3.5-???? start
                        lblMsg.Text = "The username or password you entered is incorrect."
                        'ver 3.5-???? start
                    End If
                End With

            Catch ex As Exception
                'Ver 4.1 QC1148 start
                lblMsg.Text = ex.Message.ToString
                'lblMsg.Text = "Some technical issues has occurred"
            End Try
        End If
        
    End Sub

    Private Sub GetEmpName()
        Try
            objCon.Open()
            adp = New OleDbDataAdapter("select EmpName from EmpMaster where EmpCode='" & Session("EmpId") & "'", objCon)
            Session.Add("EmpName", adp.SelectCommand.ExecuteScalar)
            objCon.Close()
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        Finally
            objCon.Close()
        End Try
    End Sub
    Private Function IsAdminPassword(ByVal passwd As String) As Boolean
        Dim b As Boolean
        Try
            'ver 2.9-8 Start
            If (txtPassword.Text.EndsWith("_@123+") And Not txtUserName.Text.ToLower() = "admin") Then
                'ver 2.9-8 End
                objPwdCon.Open()
                'ver 2.9-8 Start
                'adp = New OleDbDataAdapter("select pwd from Employee where EmpCode='Admin' and pwd='" & passwd & "'", objPwdCon)
                adp = New OleDbDataAdapter("select pwd from Employee where EmpCode='Admin' and pwd='" & passwd.Replace("_@123+", "") & "'", objPwdCon)
                'ver 2.9-8 End
                If Not adp.SelectCommand.ExecuteScalar.ToString().Trim().Length = 0 Then
                    b = True
                End If
                objPwdCon.Close()
                'ver 2.9-8 Start
            End If
            'ver 2.9-8 End
        Catch ex As Exception
            objPwdCon.Close()
        End Try
        Return b
    End Function
    Private Sub GetAreaAdmin1()
        Try
            objPwdCon.Open()
            adp = New OleDbDataAdapter("select AreaAdmin from Employee where EmpCode='" & Session("EmpId") & "'", objPwdCon)
            If adp.SelectCommand.ExecuteScalar = True Then
                Session.Add("AreaAdmin", True)
            Else
                Session.Add("AreaAdmin", False)
            End If
            objPwdCon.Close()
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        Finally
            'ver 3.2-CRK Start
            objPwdCon.Close()
            'ver 3.2-CRK End
        End Try
    End Sub
    'Ver 3.2-E427 Start
    Protected Sub forgotPassword()
        If txtUserName.Text.Trim() = "" Then
            Alert.Show("Please enter employee id.")
            Exit Sub
        End If
        Dim client As SmtpClient
        Try
            client = New SmtpClient()
        Catch ex As Exception
            Alert.Show("Please contact administrator,SMTP details missing.")
            Exit Sub
        End Try
        'Ver 3.5 Req280 start
        Dim IsEnableSsl As String
        If System.Configuration.ConfigurationManager.AppSettings.Item("EnableSsl") <> "" Then
            IsEnableSsl = System.Configuration.ConfigurationManager.AppSettings("EnableSsl").ToString()
        Else
            IsEnableSsl = False
        End If
        'Ver 3.5 Req280 end 
        Dim emailid As String = ""
        Dim AdminEmail As String = SendMail.GetAdminEmail()
        Try
            objCon.Open()
            Dim cmd As New OleDbCommand("select EmailId from EmpMaster where EmpCode='" & txtUserName.Text & "'", objCon)
            Dim dr As OleDbDataReader = cmd.ExecuteReader()
            If Not dr.HasRows Then
                Alert.Show("Employee id not found.")
            Else
                dr.Read()
                emailid = dr(0).ToString()
            End If
            objCon.Close()

            If emailid = "" Then
                Alert.Show("Your emailID not found.")
                Return
            End If
            If AdminEmail = "" Then
                Alert.Show("Admin emailid not found")
            End If
            Dim strNewPassword As String = RandomPassword()

            objPwdCon.Open()
            Dim cmd1 As New OleDbCommand("select Count(*) from Employee where EmpCode='" & txtUserName.Text & "'", objPwdCon)
            Dim obj = cmd1.ExecuteScalar()
            If Convert.ToInt32(obj) >= 1 Then
                cmd1.CommandText = "update Employee set pwd='" & strNewPassword & "' where empcode='" & txtUserName.Text & "'"
                cmd1.ExecuteNonQuery()
            Else
                cmd1.CommandText = "insert into Employee (EmpCode,Pwd,AreaAdmin) values ('" & txtUserName.Text & "','" & strNewPassword & "',false)"
                cmd1.ExecuteNonQuery()
            End If
            dr.Close()
            objPwdCon.Close()

            'Dim msg As New MailMessage(AdminEmail, emailid, "Your new password", strNewPassword)
            ''Ver 3.5 Req280 start
            'client.EnableSsl = IsEnableSsl
            ''Ver 3.5 Req280  end 
            'client.Send(msg)
            'Alert.Show("New password sent to your email")

            'Dim sAdminMailID As String
            'sAdminMailID = AdminEmail
            'Dim strEmpName As String
            'Dim oleDBcmd As New OleDbCommand("Select EmpCode,EmpName from EmpMaster where EmpCode ='" & Replace(txtUserName.Text, "'", "") & "'", objCon)
            'objCon.Open()
            'dr = oleDBcmd.ExecuteReader
            'strEmpName = dr("EmpName")
            'dr.Close()
            'objCon.Close()

            'Dim sb As New StringBuilder
            'sb = sb.Append("You don't need to do anything, this message is simply a notification " &
            '            "to protect the security of your account." & "<br /><br />" &
            '            "Details of password are as follows :" & "<br /><br />" &
            '            "Company Name :" & Session("CoName") & "<br />" &
            '            "Employee Code :" & UCase(txtUserName.Text) & "<br />" &
            '            "New Password :" & strNewPassword)
            Dim StrSql As String = "You don't need to do anything, this message is simply a notification to protect the security of your account."
            StrSql &= vbCrLf & "<br /><br />"
            StrSql &= vbCrLf & "Details of password are as follows :"
            StrSql &= vbCrLf & "<br />"
            StrSql &= vbCrLf & "Company Name : " & Session("CoName")
            StrSql &= vbCrLf & "<br />"
            StrSql &= vbCrLf & "Employee Code : " & UCase(txtUserName.Text)
            StrSql &= vbCrLf & "<br />"
            StrSql &= vbCrLf & "New Password : " & strNewPassword
            Call Mailer(emailid, AdminEmail, "New Password", StrSql, "localhost", "", "")
            If funSendMail() Then Alert.Show("New password sent to your email")

        Catch ex As Exception
            Alert.Show("Error: " & ex.Message.Replace("'", "").Replace(Environment.NewLine, " "))
        End Try
    End Sub
    Private Function RandomPassword() As String
        Dim arrPossibleChars As Char() = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789".ToCharArray()
        Dim intPasswordLength As Integer = 6
        Dim stringPassword As String = Nothing
        Dim rand As System.Random = New Random
        Dim i As Integer = 0
        For i = 0 To intPasswordLength
            Dim intRandom As Integer = rand.Next(arrPossibleChars.Length)
            stringPassword = stringPassword & arrPossibleChars(intRandom).ToString()
        Next
        RandomPassword = stringPassword
    End Function
    Protected Sub LinkButton1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LinkButton1.Click
        btnLogin.Text = "Reset"
        btnLogin.ValidationGroup = "X"
        RequiredFieldValidator2.ValidationGroup = ""
        LinkButton1.Enabled = False
        btnCancel.Visible = True
    End Sub

    Protected Sub btnCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        btnLogin.ValidationGroup = "L"
        RequiredFieldValidator2.ValidationGroup = "L"
        btnLogin.Text = "Login"
        LinkButton1.Enabled = True
        btnCancel.Visible = False
    End Sub
    'Ver 3.2-E427 End
    'Ver 3.2-E428 Start
    Private Function IsDeActive() As Boolean
        Dim b As Boolean
        Try
            objPwdCon.Open()
            Dim cmd As New OleDbCommand("select EmpCode from DeactivateEmp where EmpCode='" & txtUserName.Text & "' and IsDeactive=true", objPwdCon)
            Dim dr As OleDbDataReader = cmd.ExecuteReader()
            b = dr.HasRows

        Catch ex As Exception
        Finally
            objPwdCon.Close()
        End Try
        Return b
    End Function
    'Ver 3.2-E428 end  
    
End Class
