Imports System.Data.OleDb

Partial Class EstDetails
    Inherits System.Web.UI.Page

    Dim objCon As OleDbConnection
    Dim strCCode As String
    Dim strEmpCode As String
    Dim strEmpName As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        objCon = New OleDbConnection(Session("myConnection"))
        Try
            If Page.IsPostBack = False Then
                objCon.Open()
                strCCode = Request.QueryString("Code")
                strEmpCode = Session("EmpId")
                strEmpName = Session("EmpName")

                Call FillDtls()
                Call ColorRow()
                objCon.Close()
            End If
        Catch ex As Exception
            'ver 3.2-CRK Start
            objCon.Close()
            'ver 3.2-CRK end
        End Try
    End Sub
    'Ver 3.3-???? Start (Not found in list)
    Public Shared Function WriteCss() As String
        Dim css As String = General.DefaultCSS
        Try
            css = HttpContext.Current.Session("CurCss").ToString()
        Catch ex As Exception
        End Try
        Return css
    End Function
    'Ver 3.3-???? End
    Private Sub FillDtls()
        Try
            Dim oleDbCMD As New OleDbCommand
            Dim oleDbDR As OleDbDataReader

            Dim oleDbCMD1 As New OleDbCommand
            Dim oleDbDR1 As OleDbDataReader

            oleDbCMD.Connection = objCon
            oleDbCMD1.Connection = objCon

            Dim TblRow As New TableRow
            Dim TblCell As New TableCell

            Dim strDesc As String

            If strCCode <> "Tax" Then
                Dim objCmd As New OleDbCommand("Select [Desc] From Trans where Code = '" & strCCode & "' and ECode ='" & strEmpCode & "'", objCon)
                strDesc = objCmd.ExecuteScalar
                TblHead.Rows.Add(New TableRow)
                TblHead.Rows(0).Cells.Add(New TableCell)
                If strCCode = "TaxDedMade" Then
                    strDesc = "Tax Deduction already made "
                End If
                TblHead.Rows(0).Cells.Item(0).Text = "<b>" & strDesc & "</b>"
                TblHead.Rows(0).Cells.Item(0).HorizontalAlign = HorizontalAlign.Center
                TblHead.Rows(0).CssClass = "GrdHeader"
                objCmd.Dispose()
            Else
                TblHead.Rows.Add(New TableRow)
                TblHead.Rows(0).Cells.Add(New TableCell)
                TblHead.Rows(0).Cells.Item(0).Text = "<b>Details of Deduction Entries</b>"
                TblHead.Rows(0).Cells.Item(0).HorizontalAlign = HorizontalAlign.Center
                TblHead.Rows(0).CssClass = "GrdHeader"
            End If
            Select Case (Mid(strCCode, 1, 3))
                'Ver 4.82-2343 start
                'Case "S11", "S12"
                Case "S11", "S12", "S13"
                    'Ver 4.82-2343 end
                    oleDbCMD.CommandText = "Select * From Variable where Code = '" & strCCode & "' and ECode ='" & strEmpCode & "'"
                    oleDbDR = oleDbCMD.ExecuteReader

                    If oleDbDR.HasRows = True Then
                        oleDbDR.Read()

                        Dim lngSumAmt As Double = 0
                        Dim lngSumTaxfreeAmt As Double = 0
                        Dim lngSumRentAmt As Double = 0
                        Dim lngSumTaxableAmt As Double = 0

                        If strCCode = "S12001" Then
                            SetTblHeader(TblDtls, "Month", "Amount<sub><img src='" & Session("img") & "'/></sub>", "Rent Paid<sub><img src='" & Session("img") & "'/></sub>", "Tax Free Amount<sub><img src='" & Session("img") & "'/></sub>", "Taxable Amount<sub><img src='" & Session("img") & "'/></sub>")

                            oleDbCMD1.CommandText = "Select * From Variable where Code = '" & strCCode & "E1" & "' and ECode ='" & strEmpCode & "'"
                            oleDbDR1 = oleDbCMD1.ExecuteReader

                            If oleDbDR1.HasRows Then oleDbDR1.Read()

                            For intI As Integer = 1 To 12
                                TblRow = New TableRow
                                TblDtls.Rows.Add(New TableRow)
                                TblDtls.Rows.Add(TblRow)
                                TblRow.Cells.Add(New TableCell())
                                If intI <= 9 Then
                                    TblRow.Cells.Item(0).Text = MonthName(intI + 3)
                                Else
                                    TblRow.Cells.Item(0).Text = MonthName(intI - 9)
                                End If
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(1).Text = oleDbDR("AMT" & intI)
                                TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                                lngSumAmt += oleDbDR("AMT" & intI)
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(2).Text = oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Item(2).HorizontalAlign = HorizontalAlign.Right
                                lngSumRentAmt += oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Add(New TableCell())
                                If oleDbDR1.HasRows Then
                                    TblRow.Cells.Item(3).Text = oleDbDR1("AMTTAXFREE" & intI)
                                    TblRow.Cells.Item(3).HorizontalAlign = HorizontalAlign.Right
                                    lngSumTaxfreeAmt += oleDbDR1("AMTTAXFREE" & intI)
                                    TblRow.Cells.Add(New TableCell())
                                    TblRow.Cells.Item(4).Text = oleDbDR("AMT" & intI) - oleDbDR1("AMTTAXFREE" & intI)
                                    TblRow.Cells.Item(4).HorizontalAlign = HorizontalAlign.Right
                                    lngSumTaxableAmt += oleDbDR("AMT" & intI) - (oleDbDR1("AMTTAXFREE" & intI))
                                Else
                                    TblRow.Cells.Add(New TableCell())
                                End If
                            Next
                            TblRow = New TableRow
                            TblDtls.Rows.Add(New TableRow)
                            TblDtls.Rows.Add(TblRow)
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(0).Text = "<u><b>Total</b></u>"
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(1).Text = Math.Round(lngSumAmt, 0)
                            TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(2).Text = Math.Round(lngSumRentAmt, 0)
                            TblRow.Cells.Item(2).HorizontalAlign = HorizontalAlign.Right
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(3).Text = Math.Round(lngSumTaxfreeAmt, 0)
                            TblRow.Cells.Item(3).HorizontalAlign = HorizontalAlign.Right
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(4).Text = Math.Round(lngSumTaxableAmt, 0)
                            TblRow.Cells.Item(4).HorizontalAlign = HorizontalAlign.Right
                        Else
                            SetTblHeader(TblDtls, "Month", "<span>Amount<sub><img src='" & Session("img") & "'/></sub>", "TaxFree Amount<sub><img src='" & Session("img") & "'/></sub>", "Taxable Amount<sub><img src='" & Session("img") & "'/></sub><span>")
                            For intI As Integer = 1 To 12
                                TblRow = New TableRow
                                TblDtls.Rows.Add(New TableRow)
                                TblDtls.Rows.Add(TblRow)
                                TblRow.Cells.Add(New TableCell())
                                If intI <= 9 Then
                                    TblRow.Cells.Item(0).Text = MonthName(intI + 3)
                                Else
                                    TblRow.Cells.Item(0).Text = MonthName(intI - 9)
                                End If
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(1).Text = oleDbDR("AMT" & intI) '+ oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                                lngSumAmt += oleDbDR("AMT" & intI) '+ oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(2).Text = oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Item(2).HorizontalAlign = HorizontalAlign.Right
                                lngSumTaxfreeAmt += oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(3).Text = oleDbDR("AMT" & intI) - oleDbDR("AMTTAXFREE" & intI)
                                TblRow.Cells.Item(3).HorizontalAlign = HorizontalAlign.Right
                                lngSumTaxableAmt += oleDbDR("AMT" & intI) - oleDbDR("AMTTAXFREE" & intI)
                            Next
                            TblRow = New TableRow
                            TblDtls.Rows.Add(New TableRow)
                            TblDtls.Rows.Add(TblRow)
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(0).Text = "<u><b>Total</b></u>"
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(1).Text = lngSumAmt
                            TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(2).Text = lngSumTaxfreeAmt
                            TblRow.Cells.Item(2).HorizontalAlign = HorizontalAlign.Right
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(3).Text = lngSumTaxableAmt
                            TblRow.Cells.Item(3).HorizontalAlign = HorizontalAlign.Right
                        End If
                    End If
                Case "S17", "R11"
                    SetTblHeader(TblDtls, "Month", "Amount<sub><img src='" & Session("img") & "'/></sub>")
                    oleDbCMD.CommandText = "Select * From Variable where Code = '" & strCCode & "' and ECode ='" & strEmpCode & "'"
                    oleDbDR = oleDbCMD.ExecuteReader
                    If oleDbDR.HasRows = True Then
                        oleDbDR.Read()
                        Dim lngSumAmt As Long = 0
                        For intI As Integer = 1 To 12
                            TblRow = New TableRow
                            TblDtls.Rows.Add(New TableRow)
                            TblDtls.Rows.Add(TblRow)
                            TblRow.Cells.Add(New TableCell())
                            If intI <= 9 Then
                                TblRow.Cells.Item(0).Text = MonthName(intI + 3)
                            Else
                                TblRow.Cells.Item(0).Text = MonthName(intI - 9)
                            End If
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(1).Text = oleDbDR("AMT" & intI)
                            TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                            lngSumAmt += oleDbDR("AMT" & intI)
                        Next
                        TblRow = New TableRow
                        TblDtls.Rows.Add(New TableRow)
                        TblDtls.Rows.Add(TblRow)
                        TblRow.Cells.Add(New TableCell())
                        TblRow.Cells.Item(0).Text = "<u><b>Total</b></u>"
                        TblRow.Cells.Add(New TableCell())
                        TblRow.Cells.Item(1).Text = lngSumAmt
                        TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                    End If
                Case "Tax"
                    SetTblHeader(TblDtls, "Month", "TDS Amount<sub><img src='" & Session("img") & "'/></sub>", "Date of Deduction")
                    oleDbCMD.CommandText = "Select Month,TdsAmt,DeductDate From Deduction where ECode ='" & strEmpCode & "' order by DeductDate"
                    oleDbDR = oleDbCMD.ExecuteReader
                    'ver 3.3-Improve UI of Estimation slip popup window Start
                    Dim totalamt As Decimal = 0
                    'ver 3.3-Improve UI of Estimation slip popup window End
                    If oleDbDR.HasRows = True Then
                        While oleDbDR.Read
                            TblRow = New TableRow
                            TblDtls.Rows.Add(New TableRow)
                            TblDtls.Rows.Add(TblRow)
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(0).Text = oleDbDR("Month")
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(1).Text = oleDbDR("TdsAmt")
                            totalamt = totalamt + Convert.ToDecimal(oleDbDR("TdsAmt"))
                            TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(2).Text = Format(CDate(oleDbDR("DeductDate")), "dd/MM/yyyy")
                            TblRow.Cells.Item(2).HorizontalAlign = HorizontalAlign.Right
                        End While
                        'ver 3.3-Improve UI of Estimation slip popup window Start
                        TblRow = New TableRow
                        TblDtls.Rows.Add(New TableRow)
                        TblDtls.Rows.Add(TblRow)
                        TblRow.Cells.Add(New TableCell())
                        TblRow.Cells.Item(0).Text = "<u><b>Total</b></u>"
                        TblRow.Cells.Add(New TableCell())
                        TblRow.Cells.Item(1).Text = totalamt
                        TblRow.Cells.Item(1).HorizontalAlign = HorizontalAlign.Right
                        'ver 3.3-Improve UI of Estimation slip popup window End
                    End If
            End Select
        Catch ex As Exception
        End Try
    End Sub

    Private Sub SetTblHeader(ByVal TblName As Table, _
                            ByVal Col1 As String, _
                            ByVal Col2 As String)

        Dim TblHRow As New TableHeaderRow
        Dim TblHCell As New TableHeaderCell
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col1
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col2
        TblHRow.Cells.Add(TblHCell)
        TblName.Rows.Add(TblHRow)
        TblName.Rows.Item(0).CssClass = "GrdHeader"
    End Sub

    Private Sub SetTblHeader(ByVal TblName As Table, _
                            ByVal Col1 As String, _
                            ByVal Col2 As String, _
                            ByVal Col3 As String)

        Dim TblHRow As New TableHeaderRow
        Dim TblHCell As New TableHeaderCell
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col1
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col2
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col3
        TblHRow.Cells.Add(TblHCell)
        TblName.Rows.Add(TblHRow)
        TblName.Rows.Item(0).CssClass = "GrdHeader"
    End Sub

    Private Sub SetTblHeader(ByVal TblName As Table, _
                            ByVal Col1 As String, _
                            ByVal Col2 As String, _
                            ByVal Col3 As String, _
                            ByVal Col4 As String)

        Dim TblHRow As New TableHeaderRow
        Dim TblHCell As New TableHeaderCell
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col1
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col2
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col3
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col4
        TblHRow.Cells.Add(TblHCell)
        TblName.Rows.Add(TblHRow)
        TblName.Rows.Item(0).CssClass = "GrdHeader"
    End Sub

    Private Sub SetTblHeader(ByVal TblName As Table, _
                            ByVal Col1 As String, _
                            ByVal Col2 As String, _
                            ByVal Col3 As String, _
                            ByVal Col4 As String, _
                            ByVal Col5 As String)

        Dim TblHRow As New TableHeaderRow
        Dim TblHCell As New TableHeaderCell
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col1
        'TblHCell.Width = Unit.Pixel(200)
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col2
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col3
        TblHRow.Cells.Add(TblHCell)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col4
        TblHRow.Cells.Add(TblHCell)
        TblName.Rows.Add(TblHRow)
        TblHCell = New TableHeaderCell
        TblHCell.Text = Col5
        TblHRow.Cells.Add(TblHCell)
        TblName.Rows.Add(TblHRow)
        TblName.Rows.Item(0).CssClass = "GrdHeader"
    End Sub
    Private Sub ColorRow()
        For i = 0 To TblDtls.Rows.Count
            If (i Mod 4 = 0) Then
                TblDtls.Rows(i).CssClass = "tblAlternetRow"
            End If
        Next
        For i = 0 To TblDtls.Rows(0).Cells.Count - 1
            TblDtls.Rows(0).Cells(i).Width = Unit.Pixel(400)
        Next
    End Sub

End Class
