﻿'ver 3.3-E501 Start -New Page
Imports System.Data
Imports System.Data.OleDb
Partial Class FAQ
    Inherits System.Web.UI.Page

    Protected Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        Try
            If Not Session("EmpId").ToString().Equals("Admin") Then
                Me.MasterPageFile = "MasterPage.master"
                gvFAQ.Visible = False
                divAdmin.Visible = False
            Else
                gvFAQ.Visible = True
                divAdmin.Visible = True
            End If
        Catch ex As Exception

        End Try
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        End If
        If Session("EmpId").ToString().Equals("Admin") Then
            divAdmin.Visible = True
        End If
        Session("PageName") = "Frequently Ask Questions"
        If Not Page.IsPostBack Then
            BindData()
        End If
        EnableControl(False)
        'Ver 3.3-E588 Start
        Master.FindControl("imgPDF").Visible = False
        'Ver 3.3-E588 end 
    End Sub
    Protected Sub BindData()
        Dim dt As DataTable = General.GetDataTable(Session("pwdConnection").ToString(), "select * from FAQ where isenable=true  order by priority")
        repFAQ.DataSource = dt
        repFAQ.DataBind()
        dt = General.GetDataTable(Session("pwdConnection").ToString(), "select * from FAQ order by priority ")
        gvFAQ.DataSource = dt
        gvFAQ.DataBind()
        ddlFAQ.DataSource = System.Linq.Enumerable.Range(1, 50)
        ddlFAQ.DataBind()
        ddlFAQ.Items.Insert(0, New ListItem("", ""))
    End Sub
   
    Protected Sub gvFAQ_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles gvFAQ.RowCommand
        If e.CommandName = "Select" Then
            Dim RowIndex As Integer = DirectCast(DirectCast(e.CommandSource, LinkButton).NamingContainer, GridViewRow).RowIndex
            txtQuation.Text = DirectCast(gvFAQ.Rows(RowIndex).FindControl("lblQA"), Literal).Text.Replace("''", "'")
            txtAnswer.Text = DirectCast(gvFAQ.Rows(RowIndex).FindControl("lblAns"), Literal).Text.Replace("''", "'")
            hidSrNo.Value = DirectCast(gvFAQ.Rows(RowIndex).FindControl("ltrDBSrNo"), Literal).Text
            chkEnable.Checked = DirectCast(gvFAQ.Rows(RowIndex).FindControl("chkEnable"), CheckBox).Checked
            ddlFAQ.Text = DirectCast(gvFAQ.Rows(RowIndex).FindControl("lblPriority"), Literal).Text
            hidupdate.Value = "True"
            btnModify.Enabled = True
            btnDelete.Enabled = True
            lblMSG.Text = ""
        End If
    End Sub

    Protected Sub btnAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim i As Integer = 0
        If btnAdd.Text = "Save" Then
            If hidupdate.Value = "True" Then
                i = General.ExecuteDML(Session("pwdConnection").ToString(), "update FAQ set Quation='" & txtQuation.Text.Replace("'", "''") & "',Answer='" & txtAnswer.Text.Replace("'", "''") & "',IsEnable=" & chkEnable.Checked & ",priority='" & ddlFAQ.Text & "' where SrNo=" & hidSrNo.Value & " ")
                lblMSG.Text = "Record successfully updated."
            Else
                i = General.ExecuteDML(Session("pwdConnection").ToString(), "insert into FAQ(Quation,Answer,IsEnable,priority) values('" & txtQuation.Text.Replace("'", "''") & "','" & txtAnswer.Text.Replace("'", "''") & "'," & chkEnable.Checked & ",'" & ddlFAQ.Text & "')")
                lblMSG.Text = "Record successfully added."
            End If

            EnableControl(False)

            BindData()
            btnAdd.Text = "Add"
            btnAdd.ValidationGroup = "x"
            btnModify.Text = "Modify"
            btnModify.Enabled = False
        Else
            btnAdd.Text = "Save"
            btnAdd.ValidationGroup = "qa"
            btnModify.Text = "Cancel"
            btnModify.ValidationGroup = "x"
            btnDelete.Enabled = False
            EnableControl(True)
            btnDelete.Enabled = False
            btnModify.Enabled = True
            lblMSG.Text = ""
        End If
        ClearControl()
        hidupdate.Value = "False"
    End Sub

    Protected Sub btnModify_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnModify.Click
        If btnModify.Text = "Cancel" Then
            btnAdd.Text = "Add"
            btnAdd.ValidationGroup = "x"
            btnModify.Text = "Modify"
            btnDelete.Enabled = True
            hidupdate.Value = "False"
            EnableControl(False)
            lblMSG.Text = ""
            ClearControl()
            btnModify.Enabled = False
        Else
            btnAdd.Text = "Save"
            btnAdd.ValidationGroup = "qa"
            btnModify.Text = "Cancel"
            btnModify.ValidationGroup = "x"
            EnableControl(True)
            btnModify.Enabled = True
        End If
        btnDelete.Enabled = False

    End Sub

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        General.ExecuteDML(Session("pwdConnection").ToString(), "delete from FAQ where SrNo=" & hidSrNo.Value & " ")
        BindData()
        ClearControl()
        btnModify.Enabled = False
        btnDelete.Enabled = False
        lblMSG.Text = "Record deleted successfully."
    End Sub

  
    Protected Sub repFAQ_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles repFAQ.ItemDataBound
        DirectCast(e.Item.FindControl("tr1"), HtmlTableRow).Attributes.Add("onclick", "ShowANS('" + DirectCast(e.Item.FindControl("pnlAns"), Panel).ClientID + "','Cimg" & e.Item.ItemIndex & "')")
    End Sub
    Private Sub EnableControl(ByVal b As Boolean)
        txtAnswer.Enabled = b
        ddlFAQ.Enabled = b
        txtQuation.Enabled = b
        chkEnable.Enabled = b
        gvFAQ.Enabled = Not b
    End Sub
    Private Sub ClearControl()
        txtAnswer.Text = ""
        ddlFAQ.SelectedIndex = -1
        txtQuation.Text = ""
        chkEnable.Checked = False
        gvFAQ.SelectedIndex = -1

    End Sub
End Class
'ver 3.3-E501 End -New Page