Imports System.Data
Imports System.Data.OleDb
Imports MigraDoc.Rendering
Imports System.IO ' Jitendra 12BB
Partial Class InvestmentDeclaration
    Inherits System.Web.UI.Page

    Dim adp As New OleDbDataAdapter
    Dim objCon As OleDbConnection
    Dim dsInv As New DataSet
    Dim strRComponents() As String
    Dim strDComponents() As String
    Dim strOComponents() As String
    Dim strHRAComponents() As String
    Dim strILHPComponents() As String
    Dim hCity As New Hashtable, hMonth As New Hashtable, hYear As New Hashtable
    'Ver 3.2-E398 Start
    'Private adp As New OleDb.OleDbDataAdapter
    Dim dspdf As New DataSet()
    'Ver 4.1-REQ623 start
    Dim empCode As String
    Dim fYear As String
    'Ver 4.1-REQ623 end 
    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        AddHandler Master.Print_PDF, AddressOf PrintPDF
    End Sub
    'Ver 3.2-E398 End
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If
            'Ver 3.2-E398 Start
            Master.FindControl("imgPDF").Visible = True
            'Ver 3.2-E398 end
            If (Convert.ToInt32(Left(Session("Period"), 4)) >= 2013) Then
                tblrow80CCG.Visible = True

            End If
            '--lblToday.Text = Today
            If Session("invconnection") = Nothing Then
                lblMessage.Text = "The database missing or corrupted."
            End If

            objCon = New OleDbConnection(Session("invconnection"))
            txtEmpId.Text = UCase(Session("EmpId"))
            txtEName.Text = Session("EmpName")

            ''kishor added - 21-03-2020
            'If Session("period") = "2020-2021" Then
            If Integer.Parse(Session("period").ToString().Substring(0, 4)) >= 2020 Then
                rdbOldTaxRegime.Visible = True
                btnSubmitNewTax.Visible = True
                rdbNewTaxRegime.Visible = True
                '' varalakshmi - 15jun20 - start - Even the NewTaxRegime selected, that is now showing - issue fix
                ''rdbOldTaxRegime.Checked = True
                'objCon.Open()
                'Dim cmd1 As New OleDbCommand("select * from TaxNewRegime where employeecode = '" & Session("EmpId") & "'", objCon)
                'Dim drNewTax As OleDbDataReader = cmd1.ExecuteReader()
                'If drNewTax.HasRows Then
                '    drNewTax.Read()
                '    rdbOldTaxRegime.Checked = False
                '    rdbNewTaxRegime.Checked = True
                '    'Else
                '    '    rdbOldTaxRegime.Checked = True
                '    '    rdbNewTaxRegime.Checked = False
                'End If
                'objCon.Close()
                '' varalakshmi - 15jun20 - end 
                btnSubmitNewTax.Enabled = False
            Else
                rdbOldTaxRegime.Visible = False
                btnSubmitNewTax.Visible = False
                rdbNewTaxRegime.Visible = False
            End If
            ''kishor added - 21-03-2020

            'Ver 4.1-REQ623 start
            If Session("EmpId") <> String.Empty Then
                empCode = Session("EmpId").ToString()
            End If
            If Session("FY") <> String.Empty Then
                fYear = Session("FY").ToString()
            End If
            'Ver 4.1-REQ623 end 

            lblInvDeclFormFY.Text = "INVESTMENT DECLARATION FORM FOR THE FY " & Session("Period")
            lblAmount.Text = "Amount paid / payable during the year April " & Left(Session("Period"), 4) & " - March " & Right(Session("Period"), 4) & " should be shown under 'Amount' column."
            Call FillInvDecl80C()
            btnSave.Attributes.Add("onclick", "javascript:chkRel()")
            If Page.IsPostBack = False Then
                ScriptManager.RegisterStartupScript(Me, Page.GetType, "Script", "DisableIncmFromHP();", True)
                hCity.Add(1, "Non-Metro")
                hCity.Add(2, "Kolkata")
                hCity.Add(3, "Delhi")
                hCity.Add(4, "Mumbai")
                hCity.Add(5, "Chennai")
                hCity.Add(6, "--select--")

                drpP1LoanMonth.Items.Clear()
                drpP1LoanYear.Items.Clear()
                drpP1PossessMonth.Items.Clear()
                drpP1PossessYear.Items.Clear()
                drpP2LoanMonth.Items.Clear()
                drpP2LoanYear.Items.Clear()
                drpP2PossessMonth.Items.Clear()
                drpP2PossessYear.Items.Clear()

                drpP1LoanMonth.Items.Add("--MM--")
                drpP1LoanYear.Items.Add("--YYYY--")
                drpP2LoanMonth.Items.Add("--MM--")
                drpP2LoanYear.Items.Add("--YYYY--")
                drpP1PossessMonth.Items.Add("--MM--")
                drpP1PossessYear.Items.Add("--YYYY--")
                drpP2PossessMonth.Items.Add("--MM--")
                drpP2PossessYear.Items.Add("--YYYY--")

                For intI As Integer = 1 To 12
                    drpP1LoanMonth.Items.Add(CStr(intI))
                    drpP1PossessMonth.Items.Add(CStr(intI))
                    drpP2LoanMonth.Items.Add(CStr(intI))
                    drpP2PossessMonth.Items.Add(CStr(intI))
                Next intI

                For intI As Integer = 1990 To Year(Today.Date)
                    drpP1LoanYear.Items.Add(CStr(intI))
                    drpP1PossessYear.Items.Add(CStr(intI))
                    drpP2LoanYear.Items.Add(CStr(intI))
                    drpP2PossessYear.Items.Add(CStr(intI))
                Next

                drpApril.DataSource = hCity.Values
                drpApril.DataBind()

                drpMay.DataSource = hCity.Values
                drpMay.DataBind()

                drpJune.DataSource = hCity.Values
                drpJune.DataBind()

                drpJuly.DataSource = hCity.Values
                drpJuly.DataBind()

                drpAugust.DataSource = hCity.Values
                drpAugust.DataBind()

                drpSeptember.DataSource = hCity.Values
                drpSeptember.DataBind()

                drpOctober.DataSource = hCity.Values
                drpOctober.DataBind()

                drpNovember.DataSource = hCity.Values
                drpNovember.DataBind()

                drpDecember.DataSource = hCity.Values
                drpDecember.DataBind()

                drpJanuary.DataSource = hCity.Values
                drpJanuary.DataBind()

                drpFebruary.DataSource = hCity.Values
                drpFebruary.DataBind()

                drpMarch.DataSource = hCity.Values
                drpMarch.DataBind()

                lblToday.Text = Format(Today, "dd/MM/yyyy")
                txtPAN.Text = GetPAN()
                Call AlterTable()
                Call FillInvDeclUS6A()
                Call FillIncLossHP()
                Call FillHRA()

                btnSave.Enabled = IsSaveLocked()
                tblHRA.Enabled = btnSave.Enabled
                tblIncLoss.Enabled = btnSave.Enabled
                tblInv1.Enabled = btnSave.Enabled
                tblInv2.Enabled = btnSave.Enabled

                tblInv1.Rows.Item(0).CssClass = "GrdHeader"
                tblInv2.Rows.Item(0).CssClass = "GrdHeader"
                tblHRA.Rows.Item(0).CssClass = "GrdHeader"
                tblIncLoss.Rows.Item(0).CssClass = "GrdHeader"
            End If
            If (Val(Left(Session("Period"), 4)) >= 2010) Then
                tblInv2.FindControl("rwD11011").Visible = True
                tblInv2.FindControl("rwPrevEmp1").Visible = False
                tblInv2.FindControl("rwPrevEmp2").Visible = False
                tblInv2.FindControl("rwPrevEmp3").Visible = False
                tblInv2.FindControl("rwPrevEmp4").Visible = False
                tblInv2.FindControl("lblP1SelfOrOccupied").Visible = False
                tblInv2.FindControl("RdP1SelfOrOccupied").Visible = False
                tblInv2.FindControl("RdP1SelfOrOccupied").Visible = False
                tblInv2.FindControl("rwP1Footer").Visible = False
                tblInv2.FindControl("rwProp2").Visible = False
                tblInv2.FindControl("rwP2Header").Visible = False
                tblInv2.FindControl("rwP2Footer").Visible = False
                tblInv2.FindControl("pnlRent1").Visible = False
                tblInv2.FindControl("pnlMun1").Visible = False
            Else
                tblInv2.FindControl("rwD11011").Visible = False
                tblInv2.FindControl("rwPrevEmp1").Visible = True
                tblInv2.FindControl("rwPrevEmp2").Visible = True
                tblInv2.FindControl("rwPrevEmp3").Visible = True
                tblInv2.FindControl("rwPrevEmp4").Visible = True
                tblInv2.FindControl("lblP1SelfOrOccupied").Visible = True
                tblInv2.FindControl("RdP1SelfOrOccupied").Visible = True
                tblInv2.FindControl("RdP1SelfOrOccupied").Visible = True
                tblInv2.FindControl("rwP1Footer").Visible = True
                tblInv2.FindControl("rwProp2").Visible = True
                tblInv2.FindControl("rwP2Header").Visible = True
                tblInv2.FindControl("rwP2Footer").Visible = True
            End If
            'ver 3.0 Start
            'ver 3.3-E456 Start
            'If Session("Period") = "2012-2013"  Then
            'Ver 3.5-REQ305 start
            'If Session("Period") = "2012-2013" Or Session("Period") = "2013-2014" Then
            'Ver 3.07-REQ511 start
            'If Session("Period") = "2012-2013" Or Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Then
            'Ver 3.8-REQ580 start
            ' If Session("Period") = "2012-2013" Or Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") = "2015-2016" Then
            If Session("Period") = "2012-2013" Or Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Or Session("Period") >= "2015-2016" Then
                'Ver 3.8-REQ580 end 
                'Ver 3.07-REQ511 end
                'Ver 3.5-REQ305 end
                'ver 3.3-E456 End
                rwD11011.Visible = False
                txtD11011.Text = "0"
                lblSrNo8.Text = "6"
                lblSrNo9.Text = "7"
                lblSrNo10.Text = "8"
                lblsrno11.Text = "9"
            End If

            'Ver 3.5-REQ305 start
            'If Session("Period") = "2013-2014" Then
            If Session("Period") = "2013-2014" Or Session("Period") = "2014-2015" Then
                'Ver 3.5-REQ305 end
                rwD11014.Visible = True
                rwD11015.Visible = True
                'Ver 3.07-REQ511 start
                'Ver 3.8-REQ580 start
                'ElseIf Session("Period") = "2015-2016" Then
            ElseIf Session("Period") >= "2015-2016" Then
                'Ver 3.8-REQ580 end 
                rwD11015.Visible = False
                rwD11014.Visible = True
                'Ver 3.07-REQ511 end
            Else
                rwD11014.Visible = False
                rwD11015.Visible = False
            End If
            'ver 3.0 End
            '==>Jitendra
            'If Session("Period") >= "2015-2016"  and Then
            If Session("Period") >= "2015-2016" And Page.IsPostBack = False Then
                Call Fill80CCD()
            End If
            '<==Jitendra

            '==>Jitendra 80EE on 25/04/2016
            'Ver 4.0-REQ579 start
            If Session("Period") >= "2016-2017" And Page.IsPostBack = False Then
                Call Fill80EE()
            End If
            If Session("Period") >= "2016-2017" Then
                rw80EE.Visible = True
                rwD11007.Visible = False
                rwD11007_1.Visible = True
            Else
                rw80EE.Visible = False
                rwD11007.Visible = True
                rwD11007_1.Visible = False
            End If
            'Ver 4.0-REQ579 end 

            'Ver 4.1-REQ623 start
            If Session("Period") >= "2016-2017" Then
                'ver 4.01-QC?? start
                'txtTotValue.Text = Convert.ToInt32(txtApril.Text) + Convert.ToInt32(txtMay.Text) + Convert.ToInt32(txtJune.Text) + Convert.ToInt32(txtJuly.Text) + Convert.ToInt32(txtAugust.Text) + Convert.ToInt32(txtSeptember.Text) + Convert.ToInt32(txtOctober.Text) + Convert.ToInt32(txtNovember.Text) + Convert.ToInt32(txtDecember.Text) + Convert.ToInt32(txtJanuary.Text) + Convert.ToInt32(txtFebruary.Text) + Convert.ToInt32(txtMarch.Text)
                txtTotValue.Text = Val(txtApril.Text) + Val(txtMay.Text) + Val(txtJune.Text) + Val(txtJuly.Text) + Val(txtAugust.Text) + Val(txtSeptember.Text) + Val(txtOctober.Text) + Val(txtNovember.Text) + Val(txtDecember.Text) + Val(txtJanuary.Text) + Val(txtFebruary.Text) + Val(txtMarch.Text)
                'ver 4.01-QC?? end
            End If
            'Ver 4.1-REQ623 end 
            '==>Jitendra 12BB
            If Directory.Exists(Session("strPath").ToString() & "\12BBDeclaration" & "_" & Session("CoCode") & "_" & (Session("Period")).ToString()) Then
                If File.Exists(Session("strPath").ToString() & "\12BBDeclaration" & "_" & Session("CoCode") & "_" & (Session("Period")) & "\" & Session("EmpId") & "_" & Session("EmpName") & ".xls") Then
                    btnGenerate12BB.Visible = True
                Else
                    btnGenerate12BB.Visible = False
                End If
            Else
                btnGenerate12BB.Visible = False
            End If

            '<==Jitendra 12BB 

            ''Kishor - 06-12-2019 - start to check 80EEA And 80EEB exist or not 

            'Call CreateTable_80EEA_800EEB("80EEA", objCon.ConnectionString.ToString.Trim)
            'Call CreateTable_80EEA_800EEB("80EEB", objCon.ConnectionString.ToString.Trim)

            'Call Check_80EEA_800EEB("Details", "80EEA", objCon.ConnectionString.ToString.Trim)
            ' Call Check_80EEA_800EEB("Details", "80EEB", objCon.ConnectionString.ToString.Trim)

            ''Kishor - 06-12-2019 - to check 80EEA And 80EEB exist or not


            'Ver4.2 REQ806 start
            If Session("Period") >= "2018-2019" And Page.IsPostBack = False Then
                Call Fill80TTB()
            End If
            If Session("Period") >= "2019-2020" And Page.IsPostBack = False Then
                Call Fill80EEA()
            End If
            If Session("Period") >= "2019-2020" And Page.IsPostBack = False Then
                Call Fill80EEB()
            End If
            If Session("Period") >= "2018-2019" Then

                Dim IsSenior As String
                Dim IsSeniorAbove As String
                IsSenior = General.GetData(Session("myConnection"), "select senior from  EmpMaster where EmpCode='" & Session("EmpId").ToString() & "'")
                IsSeniorAbove = General.GetData(Session("myConnection"), "select seniorabove80 from  EmpMaster where EmpCode='" & Session("EmpId").ToString() & "'")

                '  isSeniorcitizen = General.IsseniorCitizen(dob)
                If IsSenior = True Or IsSeniorAbove = True Then
                    rw80TTB.Visible = True
                    rwD11014.Visible = False
                Else
                    rw80TTB.Visible = False
                    rwD11014.Visible = True
                End If
            End If
            If Session("Period") >= "2019-2020" Then

                Dim IsSenior As String
                Dim IsSeniorAbove As String
                IsSenior = General.GetData(Session("myConnection"), "select senior from  EmpMaster where EmpCode='" & Session("EmpId").ToString() & "'")
                IsSeniorAbove = General.GetData(Session("myConnection"), "select seniorabove80 from  EmpMaster where EmpCode='" & Session("EmpId").ToString() & "'")

                rw80EEA.Visible = True  '===kishor added 16-12-2019===='

                '  isSeniorcitizen = General.IsseniorCitizen(dob)
                If IsSenior = True Or IsSeniorAbove = True Then
                    ' rw80EEA.Visible = True
                    rwD11014.Visible = False
                Else
                    ' rw80EEA.Visible = False
                    rwD11014.Visible = True
                End If
            End If
            If Session("Period") >= "2019-2020" Then

                Dim IsSenior As String
                Dim IsSeniorAbove As String
                IsSenior = General.GetData(Session("myConnection"), "select senior from  EmpMaster where EmpCode='" & Session("EmpId").ToString() & "'")
                IsSeniorAbove = General.GetData(Session("myConnection"), "select seniorabove80 from  EmpMaster where EmpCode='" & Session("EmpId").ToString() & "'")

                rw80EEB.Visible = True '===kishor added 16-12-2019===='

                '  isSeniorcitizen = General.IsseniorCitizen(dob)
                If IsSenior = True Or IsSeniorAbove = True Then
                    'rw80EEB.Visible = True
                    rwD11014.Visible = False
                Else
                    ' rw80EEB.Visible = False
                    rwD11014.Visible = True
                End If
            End If
            'Ver4.2 REQ806 end
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
    Private Function AlterTable() As Boolean
        Dim StrSql As String = String.Empty
        Dim dt As New DataTable
        Try
            adp = New OleDbDataAdapter("select * from [Details] where 1=2", objCon)
            adp.Fill(dt)
            If Not dt.Columns.Contains("LandLord2Name") Then
                StrSql = "ALTER TABLE Details ADD COLUMN LandLord2Name varchar (50),COLUMN LandLord2Add1 varchar(100),COLUMN LandLord2Add2 varchar(100),COLUMN LandLord2Add3 varchar(100),COLUMN LandLord2PAN varchar(10)"
                StrSql &= vbCrLf & ",COLUMN LandLord3Name varchar (50),COLUMN LandLord3Add1 varchar(100),COLUMN LandLord3Add2 varchar(100),COLUMN LandLord3Add3 varchar(100),COLUMN LandLord3PAN varchar(10)"
                StrSql &= vbCrLf & ",COLUMN LandLord4Name varchar (50),COLUMN LandLord4Add1 varchar(100),COLUMN LandLord4Add2 varchar(100),COLUMN LandLord4Add3 varchar(100),COLUMN LandLord4PAN varchar(10)"
                adp = New OleDbDataAdapter(StrSql, objCon)
                If objCon.State = ConnectionState.Closed Then objCon.Open()
                adp.SelectCommand.ExecuteNonQuery()
                objCon.Close()
            End If

            adp = New OleDbDataAdapter("select * from [IncomeFromHouseProperty] where 1=2", objCon)
            dt = New DataTable
            adp.Fill(dt)
            If Not dt.Columns.Contains("Lender2Name") Then
                StrSql = "ALTER TABLE IncomeFromHouseProperty ADD COLUMN Lender2Name varchar (50),COLUMN Lender2Add1 varchar(100),COLUMN Lender2Add2 varchar(100),COLUMN Lender2Add3 varchar(100),COLUMN Lender2PAN varchar(10)"
                StrSql &= vbCrLf & ",COLUMN Lender3Name varchar (50),COLUMN Lender3Add1 varchar(100),COLUMN Lender3Add2 varchar(100),COLUMN Lender3Add3 varchar(100),COLUMN Lender3PAN varchar(10)"
                StrSql &= vbCrLf & ",COLUMN Lender4Name varchar (50),COLUMN Lender4Add1 varchar(100),COLUMN Lender4Add2 varchar(100),COLUMN Lender4Add3 varchar(100),COLUMN Lender4PAN varchar(10)"
                adp = New OleDbDataAdapter(StrSql, objCon)
                If objCon.State = ConnectionState.Closed Then objCon.Open()
                adp.SelectCommand.ExecuteNonQuery()
                objCon.Close()
            End If

            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function
    Private Function IsSaveLocked() As Boolean
        Try
            objCon.Open()
            adp = New OleDbDataAdapter("select SaveLock from [Parameters]", objCon)
            'If adp.SelectCommand.ExecuteScalar = False Then
            '    Return True
            'Else
            '    Return False
            'End If
            Return Not adp.SelectCommand.ExecuteScalar
            objCon.Close()
        Catch ex As Exception
            'ver 3.2-CRK Start
            objCon.Close()
            Return False
            'ver 3.2-CRK End
        End Try
    End Function

    Private Function GetPAN() As String
        GetPAN = ""
        Try
            'adp = New OleDbDataAdapter("select [PAN] from [Details] where ECode='" & Session("EmpId") & "'", objCon)
            'adp.Fill(dsInv, "PAN")
            'With dsInv.Tables("PAN")
            '    If .Rows.Count > 0 Then
            '        If IsDBNull(.Rows(.Rows.Count - 1).Item("PAN")) = True Then
            '            GetPAN = ""
            '        Else
            '            GetPAN = "" & .Rows(.Rows.Count - 1).Item("PAN").ToString()
            '        End If
            '    End If
            'End With
            Dim con As OleDbConnection = New OleDbConnection(Session("myConnection").ToString())
            adp = New OleDbDataAdapter("Select pan from [EmpMaster]  where EmpCode='" & Session("EmpId") & "'", con)
            adp.Fill(dsInv, "PAN")
            With dsInv.Tables("PAN")
                If .Rows.Count > 0 Then
                    If IsDBNull(.Rows(.Rows.Count - 1).Item("PAN")) = True Then
                        GetPAN = ""
                    Else
                        GetPAN = "" & .Rows(.Rows.Count - 1).Item("PAN").ToString()
                    End If
                End If
            End With
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Function


    Private Sub FillInvDecl80C()
        Try
            Dim intI As Integer, intJ As Integer '--For Loop Variables
            Dim tblRow As TableRow '--Row to add in the table dynamically
            Dim tblCell As TableCell '--Cells to add in each row dynamically
            Dim blnChild As Boolean
            tblRow = New TableHeaderRow
            tblInv1.Rows.Add(tblRow)
            tblCell = New TableHeaderCell
            tblCell.Text = "S.No."
            tblRow.Cells.Add(tblCell)
            tblCell = New TableHeaderCell
            tblCell.Text = "Type of Investment"
            tblRow.Cells.Add(tblCell)
            tblCell = New TableHeaderCell
            tblCell.Text = "Amount<img src='" & Session("img") & "'/>"
            tblCell.Width = Unit.Pixel(105)
            tblRow.Cells.Add(tblCell)
            tblCell = New TableHeaderCell
            tblCell.Text = "Proof Required Later"
            tblRow.Cells.Add(tblCell)

            adp = New OleDbDataAdapter("select SalTdsCode,Description,'', Remarks from Masters where mid(SalTdsCode,1,1)='R' and Active=True order by SalTdsCode", objCon)
            adp.Fill(dsInv, "InvDecl")
            adp = New OleDbDataAdapter("select * from [Details] where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDecl")
                If .Rows.Count > 0 Then
                    For intI = 0 To .Rows.Count - 1
                        tblRow = New TableRow
                        tblRow.CssClass = "txtvalign"
                        tblInv1.Rows.Add(tblRow)
                        For intJ = 0 To .Columns.Count - 1
                            tblCell = New TableCell
                            If intJ = 0 Then
                                tblCell.Text = intI + 1
                            ElseIf intJ = 1 Then
                                '--If the Description is Education Expense for children going to school/college 
                                If .Rows(intI).Item(0).ToString = "R11050" Then
                                    Dim lblText As New Label
                                    '--Education expense for children
                                    lblText.Text = "" & .Rows(intI).Item(intJ).ToString & "<br>"
                                    tblCell.Controls.Add(lblText)
                                    '--No. of children going for school selection
                                    Dim lblDedUS As New Label
                                    lblDedUS.ID = "lblDedUS" & intI
                                    lblDedUS.Text = "No. of Children going to school - College"
                                    tblCell.Controls.Add(lblDedUS)
                                    Dim grp80C As New RadioButtonList

                                    grp80C.ID = "RdDedUS" & .Rows(intI).Item(0).ToString
                                    grp80C.Attributes.Add("onclick", "javascript:onNoChldClick(this.id);")
                                    tblCell.Controls.Add(grp80C)
                                    Dim optDedUS0 As New RadioButton
                                    optDedUS0.Text = "0"

                                    grp80C.Items.Add(optDedUS0.Text)
                                    Dim optDedUS1 As New RadioButton
                                    optDedUS1.Text = "1"
                                    optDedUS1.Attributes.Add("onclick", "onNoChldClick(false)")
                                    grp80C.Items.Add(optDedUS1.Text)
                                    Dim optDedUS2 As New RadioButton
                                    optDedUS2.Text = "2"
                                    grp80C.Items.Add(optDedUS2.Text)
                                    Dim optDedUS3 As New RadioButton
                                    optDedUS3.Text = "3"
                                    grp80C.Items.Add(optDedUS3.Text)
                                    Dim optDedUS4 As New RadioButton
                                    optDedUS4.Text = "More"
                                    grp80C.Items.Add(optDedUS4.Text)
                                    grp80C.SelectedValue = "0"
                                    '--Getting Number of Childrens going to school
                                    With dsInv.Tables("InvDetails")
                                        If .Rows.Count > 0 Then
                                            grp80C.SelectedValue = "" & .Rows(.Rows.Count - 1).Item("NoOfChildrenSchool").ToString()
                                        End If
                                    End With
                                    '--AddHandler optDedUS0.CheckedChanged, AddressOf optDedCol0_SelectionChanged
                                    '--No. of children going for college selection
                                    Dim lblDedCol As New Label
                                    lblDedCol.ID = "lblDedCol" & intI
                                    lblDedCol.Text = "<br>No. of Children staying in hostel"
                                    tblCell.Controls.Add(lblDedCol)
                                    Dim grp80C1 As New RadioButtonList
                                    grp80C1.ID = "RdDedCol" & .Rows(intI).Item(0).ToString
                                    tblCell.Controls.Add(grp80C1)
                                    grp80C.RepeatDirection = RepeatDirection.Horizontal
                                    Dim optDedCol0 As New RadioButton
                                    optDedCol0.Text = "0"
                                    optDedCol0.ID = "RdDedUSR11050_0"
                                    grp80C1.Items.Add(optDedCol0.Text)
                                    Dim optDedCol1 As New RadioButton
                                    optDedCol1.Text = "1"
                                    ' grp80C.Attributes.Add("onclick", "javascript:onNoChldClick('ctl00_ContentPlaceHolder1_RdDedUS" & .Rows(intI).Item(0) & "_0','ctl00_ContentPlaceHolder1_RdDedCol" & .Rows(intI).Item(0) & "_0','ctl00_ContentPlaceHolder1_txt80C" & .Rows(intI).Item(0) & "')")
                                    '  grp80C1.Attributes.Add("onclick", "javascript:onNoChldClick('ctl00_ContentPlaceHolder1_RdDedUS" & .Rows(intI).Item(0) & "_0','ctl00_ContentPlaceHolder1_RdDedCol" & .Rows(intI).Item(0) & "_0','ctl00_ContentPlaceHolder1_txt80C" & .Rows(intI).Item(0) & "')")
                                    '  Dim g = "javascript:onNoChldClick('ctl00_ContentPlaceHolder1_RdDedUSR11050" & .Rows(intI).Item(0) & "_0','ctl00_ContentPlaceHolder1_RdDedColR11050" & .Rows(intI).Item(0) & "_0','ctl00_ContentPlaceHolder1_txt80CR11050" & .Rows(intI).Item(0) & "')"
                                    grp80C1.Items.Add(optDedCol1.Text)
                                    Dim optDedCol2 As New RadioButton
                                    optDedCol2.Text = "2"
                                    grp80C1.Items.Add(optDedCol2.Text)
                                    Dim optDedCol3 As New RadioButton
                                    optDedCol3.Text = "3"
                                    grp80C1.Items.Add(optDedCol3.Text)
                                    Dim optDedCol4 As New RadioButton
                                    optDedCol4.Text = "More"
                                    grp80C1.Items.Add(optDedCol4.Text)
                                    grp80C1.RepeatDirection = RepeatDirection.Horizontal
                                    grp80C1.SelectedValue = "0"
                                    '--Getting Number of Childrens going to college
                                    With dsInv.Tables("InvDetails")
                                        If .Rows.Count > 0 Then
                                            grp80C1.SelectedValue = "" & .Rows(.Rows.Count - 1).Item("NoOfChildrenCollege")
                                        End If
                                    End With
                                    If (grp80C.SelectedItem.Text = "0" And grp80C1.SelectedItem.Text = "0") Then
                                        blnChild = False
                                    Else
                                        blnChild = True
                                    End If
                                    'ver 3.0 start
                                    grp80C1.Visible = False
                                    lblDedCol.Visible = False
                                    'ver 3.0 End
                                Else
                                    tblCell.Text = "" & .Rows(intI).Item(intJ).ToString
                                End If
                            ElseIf intJ = 2 Then
                                Dim txt80C As New TextBox
                                txt80C.ID = "txt80C" & .Rows(intI).Item(0)
                                txt80C.CssClass = "txtNumbox"
                                txt80C.Width = Unit.Pixel(100)
                                txt80C.MaxLength = 10
                                txt80C.Attributes.Add("onkeyup", "javascript:ValidateNums('ctl00_ContentPlaceHolder1_txt80C" & .Rows(intI).Item(0) & "')")
                                With dsInv.Tables("InvDetails")
                                    If .Rows.Count > 0 Then
                                        '' varalakshmi - 25jun20 - start
                                        'objCon.Open()
                                        'Dim cmd1 As New OleDbCommand("select * from TaxNewRegime where employeecode = '" & Session("EmpId") & "'", objCon)
                                        'Dim drNewTax As OleDbDataReader = cmd1.ExecuteReader()
                                        'If drNewTax.HasRows Then
                                        '    drNewTax.Read()
                                        '    txt80C.Text = 0
                                        'Else
                                        '    txt80C.Text = "" & .Rows(.Rows.Count - 1).Item(dsInv.Tables("InvDecl").Rows(intI).Item(0))
                                        'End If
                                        'objCon.Close()
                                        'txt80C.Text = "" & .Rows(.Rows.Count - 1).Item(dsInv.Tables("InvDecl").Rows(intI).Item(0))
                                        If rdbNewTaxRegime.Checked = True Then
                                            txt80C.Text = 0
                                        Else
                                            txt80C.Text = "" & .Rows(.Rows.Count - 1).Item(dsInv.Tables("InvDecl").Rows(intI).Item(0))
                                        End If
                                        '' varalakshmi - 25jun20 - end
                                    End If
                                End With
                                If .Rows(intI).Item(0).ToString = "R11050" Then
                                    If blnChild = False Then txt80C.Text = "0"
                                    txt80C.Enabled = blnChild
                                Else
                                    txt80C.Enabled = True
                                End If
                                tblCell.Controls.Add(txt80C)
                            Else
                                tblCell.Text = "" & .Rows(intI).Item(intJ).ToString
                            End If
                            tblRow.Cells.Add(tblCell)
                        Next
                    Next
                End If
            End With

        Catch ex As Exception
            lblMsg.Text = ex.StackTrace.ToString
        End Try
    End Sub
    Private Sub FillIncLossHP()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select IncmFromHP,Prop1SelfOrLetout,Prop1AmtIntPaid,Prop1AmtRentRecd,Prop1AmtMuncipalTax,Prop1LoanTakenMonth,Prop1LoanTakenYear,Prop1LoanPossessionMonth,Prop1LoanPossessionYear," & _
                                        "Prop2SelfOrLetout,Prop2AmtIntPaid,Prop2AmtRentRecd,Prop2AmtMuncipalTax,Prop2LoanTakenMonth,Prop2LoanTakenYear,Prop2LoanPossessionMonth,Prop2LoanPossessionYear from [Details] " & _
                                        " where ECode='" & Session("EmpId") & "'", objCon)
                                            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    If (Val(Left(Session("Period"), 4)) >= 2010) Then
                        RdP1SelfOrOccupied.SelectedValue = "" & .Rows(.Rows.Count - 1).Item("IncmFromHP")
                        txtIntPaidAmt1.Text = "" & .Rows(.Rows.Count - 1).Item("IncmFromHP")
                    Else

                        If IsDBNull(.Rows(.Rows.Count - 1).Item("Prop1SelfOrLetout")) = False Then
                            RdP1SelfOrOccupied.SelectedValue = "" & .Rows(.Rows.Count - 1).Item("IncmFromHP")
                            txtIntPaidAmt1.Text = "" & .Rows(.Rows.Count - 1).Item("IncmFromHP")
                            If .Rows(.Rows.Count - 1).Item("Prop1SelfOrLetout") = "Let out" Then
                                txtRentPaidAmt1.Text = "" & .Rows(.Rows.Count - 1).Item("Prop1AmtRentRecd")
                                txtMunTaxAmt1.Text = "" & .Rows(.Rows.Count - 1).Item("Prop1AmtMuncipalTax")
                                pnlRent1.CssClass = "visible"
                                pnlMun1.CssClass = "visible"
                            Else
                                pnlRent1.CssClass = "hidden"
                                pnlMun1.CssClass = "hidden"
                                txtRentPaidAmt1.Text = "0"
                                txtMunTaxAmt1.Text = "0"
                            End If
                        End If
                        Call setComboIndex(drpP1LoanMonth, "" & .Rows(.Rows.Count - 1).Item("Prop1LoanTakenMonth"))
                        Call setComboIndex(drpP1LoanYear, "" & .Rows(.Rows.Count - 1).Item("Prop1LoanTakenYear"))
                        Call setComboIndex(drpP1PossessMonth, "" & .Rows(.Rows.Count - 1).Item("Prop1LoanPossessionMonth"))
                        Call setComboIndex(drpP1PossessYear, "" & .Rows(.Rows.Count - 1).Item("Prop1LoanPossessionYear"))
                        If IsDBNull(.Rows(.Rows.Count - 1).Item("Prop2SelfOrLetout")) = False Then
                            RdP2SelfOrOccupied.SelectedValue = "" & .Rows(.Rows.Count - 1).Item("Prop2SelfOrLetout")
                            txtIntPaidAmt2.Text = .Rows(.Rows.Count - 1).Item("Prop2AmtIntPaid")
                            If .Rows(.Rows.Count - 1).Item("Prop2SelfOrLetout") = "Let out" Then
                                txtRentPaidAmt2.Text = "" & .Rows(.Rows.Count - 1).Item("Prop2AmtRentRecd")
                                txtMunTaxAmt2.Text = "" & .Rows(.Rows.Count - 1).Item("Prop2AmtMuncipalTax")
                                pnlRent2.CssClass = "visible"
                                pnlMun2.CssClass = "visible"
                            Else
                                pnlRent2.CssClass = "hidden"
                                pnlMun2.CssClass = "hidden"
                                txtRentPaidAmt2.Text = "0"
                                txtMunTaxAmt2.Text = "0"
                            End If
                        End If
                        Call setComboIndex(drpP2LoanMonth, "" & .Rows(.Rows.Count - 1).Item("Prop2LoanTakenMonth"))
                        Call setComboIndex(drpP2LoanYear, "" & .Rows(.Rows.Count - 1).Item("Prop2LoanTakenYear"))
                        Call setComboIndex(drpP2PossessMonth, "" & .Rows(.Rows.Count - 1).Item("Prop2LoanPossessionMonth"))
                        Call setComboIndex(drpP2PossessYear, "" & .Rows(.Rows.Count - 1).Item("Prop2LoanPossessionYear"))
                    End If
                Else
                    RdP1SelfOrOccupied.SelectedValue = 0
                    txtIntPaidAmt1.Text = "0"
                    txtRentPaidAmt1.Text = "0"
                    txtMunTaxAmt1.Text = "0"
                    drpP1LoanMonth.SelectedIndex = -1
                    drpP1LoanYear.SelectedIndex = -1
                    drpP1PossessMonth.SelectedIndex = -1
                    drpP1PossessYear.SelectedIndex = -1
                    RdP2SelfOrOccupied.SelectedValue = 0
                    txtIntPaidAmt2.Text = "0"
                    txtRentPaidAmt2.Text = "0"
                    txtMunTaxAmt2.Text = "0"
                    drpP2LoanMonth.SelectedIndex = -1
                    drpP2LoanYear.SelectedIndex = -1
                    drpP2PossessMonth.SelectedIndex = -1
                    drpP2PossessYear.SelectedIndex = -1
                End If
            End With
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub FillHRA()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select [HRAAmt1],[HRAAmt2],[HRAAmt3],[HRAAmt4],[HRAAmt5],[HRAAmt6],[HRAAmt7],[HRAAmt8],[HRAAmt9],[HRAAmt10],[HRAAmt11],[HRAAmt12],[HRACity1],[HRACity2],[HRACity3],[HRACity4],[HRACity5],[HRACity6],[HRACity7],[HRACity8],[HRACity9],[HRACity10],[HRACity11],[HRACity12] from [Details] " & _
                                        " where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txtApril.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt1")
                    txtMay.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt2")
                    txtJune.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt3")
                    txtJuly.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt4")
                    txtAugust.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt5")
                    txtSeptember.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt6")
                    txtOctober.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt7")
                    txtNovember.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt8")
                    txtDecember.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt9")
                    txtJanuary.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt10")
                    txtFebruary.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt11")
                    txtMarch.Text = "" & .Rows(.Rows.Count - 1).Item("HRAAmt12")
                    drpApril.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity1")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity1"))
                    drpMay.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity2")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity2"))
                    drpJune.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity3")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity3"))
                    drpJuly.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity4")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity4"))
                    drpAugust.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity5")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity5"))
                    drpSeptember.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity6")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity6"))
                    drpOctober.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity7")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity7"))
                    drpNovember.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity8")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity8"))
                    drpDecember.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity9")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity9"))
                    drpJanuary.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity10")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity10"))
                    drpFebruary.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity11")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity11"))
                    drpMarch.SelectedValue = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("HRACity12")) = True, "--select--", "" & .Rows(.Rows.Count - 1).Item("HRACity12"))
                End If
            End With
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
    '>Jitendra Pension
    Private Sub Fill80CCD()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select [80CCD_1B] from [Details] " & _
                                        " where ECode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80CCD.Text = "" & .Rows(.Rows.Count - 1).Item("80CCD_1B")

                End If
            End With
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
    '<==Jitendra
    'Ver 4.0-REQ579 start
    '==>Jitendra 80EE started for Housing loan on 25/04/2016
    Private Sub Fill80EE()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select [80EE] from [Details] " & _
                                      " where Ecode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80EE.Text = "" & .Rows(.Rows.Count - 1).Item("80EE")
                End If
            End With
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub
    '<==Jitendra 
    ' Ver 4.0-REQ579 end 
    'Ver4.2 REQ806 start
    Private Sub Fill80TTB()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select [80TTB] from [Details] " & " where Ecode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80TTB.Text = "" & .Rows(.Rows.Count - 1).Item("80TTB")
                End If
            End With
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub

    '===kishor===='
    ' Private Sub Check_80EEA_800EEB(ByVal tblName As String, ByVal fldName As String, ByVal cnnStr As String)
    ' Try
    ' Open connection to the database
    'Dim dbConn As New OleDbConnection(cnnStr)
    ' dbConn.Open()
    'Dim d'bTbl As New DataTable
    Dim DoesFieldExist As Boolean

    ' Get the table definition loaded in a table adapter
    '   Dim strSql As String = "Select TOP 1 * from " & tblName
    'Dim dbAdapater As New OleDbDataAdapter(strSql, dbConn)
    '  dbAdapater.Fill(dbTbl)

    ' Get the index of the field name
    'Dim i As Integer = dbTbl.Columns.IndexOf(fldName)

    'If i = -1 Then
    'Field is missing
    '  DoesFieldExist = False

    'to add missing field
    'ordsAffected As Integer
    '  adp = New OleDbDataAdapter("ALTER TABLE Details ADD COLUMN " & fldName & " TEXT(255)", objCon)
    'If objCon.State = ConnectionState.Closed Then
    '    objCon.Open()
    'End If
    '  intRecordsAffected = adp.SelectCommand.ExecuteNonQuery()
    '  objCon.Close()

    '
    'Field is there
    ' DoesFieldExist = True
    'Exit Sub
    'End If
    'Catch ex As Exception
    '    lblMessage.Text = ex.Message.ToString
    'End Try
    ' End Sub

    ' Private Sub CreateTable_80EEA_800EEB(ByVal tblName As String, ByVal cnnStr As String)
    'Dim con As New OleDb.OleDbConnection(cnnStr)
    '  con.Open()

    'Get database schema
    'Dim dbSchema As DataTable = con.GetOleDbSchemaTable(OleDb.OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, tblName, "TABLE"})

    ' con.Close()

    ' If the table exists, the count = 1
    'If dbSchema.Rows.Count = 0 Then
    ' e.g. create a table
    ' Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] ([Field1] TEXT(10), [Field2] TEXT(10))", con)
    'Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] (SrNo AUTOINCREMENT,[EmployeeCode] TEXT(20),[Amount] TEXT(100),[IsProofAttach] YesNo,[Isproofapproved] YesNo,[Reason] TEXT(150),[isproofreject] YesNo,[EmpInsert] datetime,[EmpUpdate] datetime,[AdminUpdate] DateTime)", con)
    'Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] ([EmployeeCode] TEXT(20),[Amount] TEXT(100),[IsProofAttach] YesNo)", con)
    '  con.Open()
    ' cmd.ExecuteNonQuery()
    ' con.Close()
    'End If
    '  End Sub
    '====kishor==='

    '===== Vijayan ===='
    Private Sub Fill80EEA()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select [80EEA] from [Details] " & " where Ecode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80EEA.Text = "" & .Rows(.Rows.Count - 1).Item("80EEA")
                End If
            End With
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub
    Private Sub Fill80EEB()
        Try
            dsInv.Tables("InvDetails").Clear()
            adp = New OleDbDataAdapter("select [80EEB] from [Details] " & " where Ecode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80EEB.Text = "" & .Rows(.Rows.Count - 1).Item("80EEB")
                End If
            End With
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub
    'Ver4.2 REQ806 end

    Private Sub FillInvDeclUS6A()
        Try
            dsInv.Tables("InvDetails").Clear()
            If (Val(Left(Session("Period"), 4)) >= 2010) Then

                'adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                'Ver 3.07-REQ511 start
                'adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF,O11007,D11015 from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                'Ver 4.1-REQ623 start
                'adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF,O11007 from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                If (Val(Left(Session("Period"), 4)) >= 2016) Then
                    If (Val(Left(Session("Period"), 4)) >= 2020) Then
                        adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF,O11007,LandLordName,LandLordAddress1,LandLordAddress2,LandLordAddress3,LandLordPAN,LandLord2Name,LandLord2Add1,LandLord2Add2,LandLord2Add3,LandLord2PAN,LandLord3Name,LandLord3Add1,LandLord3Add2,LandLord3Add3,LandLord3PAN,LandLord4Name,LandLord4Add1,LandLord4Add2,LandLord4Add3,LandLord4PAN from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                    Else
                        adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF,O11007,LandLordName,LandLordAddress1,LandLordAddress2,LandLordAddress3,LandLordPAN from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                    End If
                Else
                    adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF,O11007 from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                End If
                'Ver 4.1-REQ623 end 
                'Ver 3.07-REQ511 end
                'ElseIf Session("Period") = "2013-2014" Then 'Ver 3.3-E588 start 
                '    adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009,D11011,D11013,[80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF,O11007,D11015 from [Details] where ECode='" & Session("EmpId") & "'", objCon)
                'Ver 3.3-E588 end
            Else
                adp = New OleDbDataAdapter("select D11001,D11002,D11003,D11004,D11005,D11006,D11007,D11008,D11009, [80D-DisabilityLevel],[80D-Relation],[80U-DisabilityLevel],PrevSal,PrevTds,PrevPT,PrevPF from [Details] where ECode='" & Session("EmpId") & "'", objCon)
            End If

            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txt80CD11001.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11001")) = True, "", .Rows(.Rows.Count - 1).Item("D11001"))
                    txt80CD11002.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11002")) = True, "", .Rows(.Rows.Count - 1).Item("D11002"))
                    txt80CD11003.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11003")) = True, "", .Rows(.Rows.Count - 1).Item("D11003"))
                    txt80CD11005.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11005")) = True, "", .Rows(.Rows.Count - 1).Item("D11005"))
                    txt80CD11009.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11009")) = True, "", .Rows(.Rows.Count - 1).Item("D11009"))
                    If (Val(Left(Session("Period"), 4)) >= 2010) Then
                        txtD11011.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11011")) = True, "", .Rows(.Rows.Count - 1).Item("D11011"))
                    End If
                    'Ver 2.5.2-........... start
                    txtD11006.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11006")) = True, "", .Rows(.Rows.Count - 1).Item("D11006"))
                    If (Val(Left(Session("Period"), 4)) >= 2016) Then
                        txtD11007_1.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11007")) = True, "", .Rows(.Rows.Count - 1).Item("D11007"))
                    Else
                        txtD11007.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11007")) = True, "", .Rows(.Rows.Count - 1).Item("D11007"))
                    End If

                    txtD11008.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11008")) = True, "", .Rows(.Rows.Count - 1).Item("D11008"))
                    txtD11004.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11004")) = True, "", .Rows(.Rows.Count - 1).Item("D11004"))
                    'ver 3.3 Start
                    txtD11013.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11013")) = True, "", .Rows(.Rows.Count - 1).Item("D11013"))
                    'ver 3.3 end
                    'Ver 2.5.2-........... end
                    txtSalIncUS10.Text = "" & .Rows(.Rows.Count - 1).Item("PrevSal")
                    txtPrevPF.Text = "" & .Rows(.Rows.Count - 1).Item("PrevPF")
                    txtPrevPT.Text = "" & .Rows(.Rows.Count - 1).Item("PrevPT")
                    txtPrevTax.Text = "" & .Rows(.Rows.Count - 1).Item("PrevTds")

                    txtIntPaidAmt1.Text = "" & .Rows(.Rows.Count - 1).Item("IncmFromHP")

                    If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), "Not Applicable", CompareMethod.Binary) = 0 Then
                        txtRelD11003.Text = ""
                        txt80CD11003.Text = "0"
                    Else
                        txtRelD11003.Text = "" & .Rows(.Rows.Count - 1).Item("80D-Relation")
                        '==>Budget changes 2015-16
                        'If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), _
                        '            "Normal Disability", _
                        '            CompareMethod.Binary) = 0 Then _
                        '                txt80CD11003.Text = "50000"
                        'If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), _
                        '            "Severe Disability (80% & Above)", _
                        '            CompareMethod.Binary) = 0 Then _
                        '                txt80CD11003.Text = "75000"
                        If Session("Period") >= "2015-2016" Then
                            If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), _
                                        "Normal Disability", _
                                        CompareMethod.Binary) = 0 Then _
                                            txt80CD11003.Text = "75000"
                            If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), _
                                        "Severe Disability (80% & Above)", _
                                        CompareMethod.Binary) = 0 Then _
                                            txt80CD11003.Text = "125000"
                        Else
                            If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), _
                                        "Normal Disability", _
                                        CompareMethod.Binary) = 0 Then _
                                            txt80CD11003.Text = "50000"
                            If StrComp("" & .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel"), _
                                        "Severe Disability (80% & Above)", _
                                        CompareMethod.Binary) = 0 Then _
                                            txt80CD11003.Text = "75000"
                        End If
                        If StrComp("" & .Rows("" & .Rows.Count - 1).Item("80U-DisabilityLevel"), _
                                    "Not Applicable", _
                                    CompareMethod.Binary) = 0 Then
                            txt80CD11009.Text = "0"
                        Else
                            '==>Budget changes 2015-16
                            'If StrComp("" & .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel"), _
                            '            "Normal Disability", _
                            '            CompareMethod.Binary) = 0 Then _
                            '                txt80CD11009.Text = "50000"
                            'If StrComp("" & .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel"), _
                            '            "Severe Disability (80% & Above)", _
                            '            CompareMethod.Binary) = 0 Then _
                            '                txt80CD11009.Text = "75000"

                            If Session("Period") >= "2015-2016" Then
                                If StrComp("" & .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel"), _
                                            "Normal Disability", _
                                            CompareMethod.Binary) = 0 Then _
                                                txt80CD11009.Text = "75000"
                                If StrComp("" & .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel"), _
                                            "Severe Disability (80% & Above)", _
                                            CompareMethod.Binary) = 0 Then _
                                                txt80CD11009.Text = "125000"

                            Else
                                If StrComp("" & .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel"), _
                                            "Normal Disability", _
                                            CompareMethod.Binary) = 0 Then _
                                                txt80CD11009.Text = "50000"
                                If StrComp("" & .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel"), _
                                            "Severe Disability (80% & Above)", _
                                            CompareMethod.Binary) = 0 Then _
                                                txt80CD11009.Text = "75000"
                            End If
                            '<== End Budget changes 2015-16
                        End If

                    End If
                    'Ver 4.1-REQ623 start
                    If Session("Period") >= "2015-2016" Then
                        txtLandlord.Text = "" & .Rows(.Rows.Count - 1).Item("LandLordName")
                        txtLLordAdd1.Text = "" & .Rows(.Rows.Count - 1).Item("LandLordAddress1")
                        txtLLordAdd2.Text = "" & .Rows(.Rows.Count - 1).Item("LandLordAddress2")
                        txtLLordAdd3.Text = "" & .Rows(.Rows.Count - 1).Item("LandLordAddress3")
                        txtPANnumber.Text = "" & .Rows(.Rows.Count - 1).Item("LandLordPAN")
                    End If

                    If Session("Period") >= "2020-2021" Then
                        TxtNameLL2.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord2Name")
                        txtadd1LL2.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord2Add1")
                        txtadd2LL2.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord2Add2")
                        txtadd3LL2.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord2Add3")
                        txtpanLL2.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord2PAN")

                        TxtNameLL3.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord3Name")
                        txtadd1LL3.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord3Add1")
                        txtadd2LL3.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord3Add2")
                        txtadd3LL3.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord3Add3")
                        txtpanLL3.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord3PAN")

                        TxtNameLL4.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord4Name")
                        txtadd1LL4.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord4Add1")
                        txtadd2LL4.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord4Add2")
                        txtadd3LL4.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord4Add3")
                        txtpanLL4.Text = "" & .Rows(.Rows.Count - 1).Item("LandLord4PAN")
                    End If
                    'Ver 4.1-REQ623 end 
                    Call setComboIndex(drpDedUSD11003, IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("80D-DisabilityLevel")) = True, "", .Rows(.Rows.Count - 1).Item("80D-DisabilityLevel")))
                    Call setComboIndex(drpDed80UD11009, IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("80U-DisabilityLevel")) = True, "", .Rows(.Rows.Count - 1).Item("80U-DisabilityLevel")))
                    'Ver 3.3-E588 start 
                    txtD11014.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("O11007")) = True, "", .Rows(.Rows.Count - 1).Item("O11007"))
                    'Ver 3.07-REQ511 start
                    'txtD11015.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("D11015")) = True, "", .Rows(.Rows.Count - 1).Item("D11015"))
                    'Ver 3.07-REQ511 end
                    'Ver 3.3-E588 end 
                    'Ver4.2 REQ806 start
                    If Session("Period") > "2017-2018" Then
                        txt80TTB.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("80TTB")) = True, "", .Rows(.Rows.Count - 1).Item("80TTB"))
                    End If
                    If Session("Period") > "2019-2020" Then
                        txt80EEA.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("80EEA")) = True, "", .Rows(.Rows.Count - 1).Item("80EEA"))
                    End If
                    If Session("Period") > "2019-2020" Then
                        txt80EEB.Text = IIf(IsDBNull(.Rows(.Rows.Count - 1).Item("80EEB")) = True, "", .Rows(.Rows.Count - 1).Item("80EEB"))
                    End If
                    'Ver4.2 REQ806 end
                Else
                        txt80CD11001.Text = "0"
                    txt80CD11002.Text = "0"
                    txt80CD11003.Text = "0"
                    txt80CD11005.Text = "0"
                    txt80CD11009.Text = "0"
                    txtRelD11003.Text = ""
                    drpDedUSD11003.SelectedIndex = -1
                    drpDed80UD11009.SelectedIndex = -1
                    txt80TTB.Text = "0"
                    txt80EEA.Text = "0"
                    txt80EEB.Text = "0"
                    'txtNPS.Text = "0"
                End If


            End With
        Catch ex As Exception
            lblMsg.Text = ex.StackTrace.ToString
        End Try
    End Sub

    Private Sub setComboIndex(ByVal ctrlDropDown As DropDownList, ByVal strValue As String)
        Try
            For intI As Integer = 0 To ctrlDropDown.Items.Count - 1
                If strValue = "" Then ctrlDropDown.SelectedIndex = 0
                If ctrlDropDown.Items(intI).Text = strValue Then
                    ctrlDropDown.SelectedIndex = intI
                    Exit For
                End If
            Next
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Try
            Dim htmlctrl As Control
            Dim intRecordsAffected As Integer

            If Val(txtApril.Text) > 0 Then
                If drpApril.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for April Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpApril.SelectedIndex = 0 Then
                If Val(txtApril.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for April Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtMay.Text) > 0 Then
                If drpMay.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for May Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpMay.SelectedIndex = 0 Then
                If Val(txtMay.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for May Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtJune.Text) > 0 Then
                If drpJune.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for June Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpJune.SelectedIndex = 0 Then
                If Val(txtJune.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for June Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtJuly.Text) > 0 Then
                If drpJuly.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for July Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpJuly.SelectedIndex = 0 Then
                If Val(txtJuly.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for July Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtAugust.Text) > 0 Then
                If drpAugust.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for August Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpAugust.SelectedIndex = 0 Then
                If Val(txtAugust.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for August Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtSeptember.Text) > 0 Then
                If drpSeptember.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for September Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpSeptember.SelectedIndex = 0 Then
                If Val(txtSeptember.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for September Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtOctober.Text) > 0 Then
                If drpOctober.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for October Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpOctober.SelectedIndex = 0 Then
                If Val(txtOctober.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for October Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtNovember.Text) > 0 Then
                If drpNovember.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for November Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpNovember.SelectedIndex = 0 Then
                If Val(txtNovember.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for November Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtDecember.Text) > 0 Then
                If drpDecember.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for December Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpDecember.SelectedIndex = 0 Then
                If Val(txtDecember.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for December Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtJanuary.Text) > 0 Then
                If drpJanuary.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for January Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpJanuary.SelectedIndex = 0 Then
                If Val(txtJanuary.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for January Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtFebruary.Text) > 0 Then
                If drpFebruary.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for February Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpFebruary.SelectedIndex = 0 Then
                If Val(txtFebruary.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for February Month in HRA"
                    Exit Sub
                End If
            End If
            If Val(txtMarch.Text) > 0 Then
                If drpMarch.SelectedIndex = 0 Then
                    lblMessage.Text = "Please Enter City for March Month in HRA"
                    Exit Sub
                End If
            ElseIf Not drpMarch.SelectedIndex = 0 Then
                If Val(txtMarch.Text) = 0 Then
                    lblMessage.Text = "Please Enter Amount for March Month in HRA"
                    Exit Sub
                End If
            End If
            'Ver 4.1-REQ623 start 
            'Ver4.2 REQ796 Start
            ' if total Rented value is greater than 100000 then Landlord name and address are mandatory
            If Val(txtTotValue.Text) > 100000 Then
                If txtLandlord.Text = "" Or txtLLordAdd1.Text = "" Or txtLLordAdd2.Text = "" Or txtLLordAdd3.Text = "" Then
                    lblMessage.Text = "Please Enter Landlord Name and Address"
                    Exit Sub
                End If
            End If
            'Ver4.2 REQ796 End
            ' if total Rented value is greater than 1 lakh then PAN is mandatory
            If Val(txtTotValue.Text) > 100000 Then
                If (txtPANnumber.Text) = "" Then
                    lblMessage.Text = "PAN Number is Mandatory"
                    Exit Sub
                End If
            End If
            'Ver 4.1-REQ623 end 
            '--For intCount As Integer = 0 To Me.Controls.Count - 1
            For Each htmlctrl In Me.Controls
                Call GetControlID(Table1, htmlctrl)
            Next

            '--Declaration goes here
            Dim strPAN As String
            Dim strChScrool As String, strChCollege As String, Str80DDisLevel As String, strRelation As String
            Dim Str80UDisLevel As String
            Dim strP1SelfOrLet As String, strP2SelfOrLet As String
            Dim StrP1LoanMonth As String, StrP2LoanMonth As String, strP1LoanYear As String
            Dim strP1PossessMonth As String, strP1PossessYear As String, strP2PossessMonth As String, strP2PossessYear As String
            Dim strP2LoanYear As String, strHRA(11) As String, strCity(11) As String
            Dim strR11050 As Long, strR11051 As Long, strR11052 As Long
            Dim strHCity1 As String, strHCity2 As String, strHCity3 As String, strHCity4 As String
            Dim strHCity5 As String, strHCity6 As String, strHCity7 As String, strHCity8 As String
            Dim strHCity9 As String, strHCity10 As String, strHCity11 As String, strHCity12 As String
            Dim strR11(24) As Long, strD11(8) As String, strD11011 As Long
            'Ver 3.7-REQ519start
            Dim strR11053 As Long
            'Ver 3.7-REQ519 end 
            '--Assignment goes here
            strPAN = "" & txtPAN.Text.ToUpper
            strChScrool = SearchValue("RdDedUSR11050")
            strChCollege = SearchValue("RdDedColR11050")
            Str80DDisLevel = drpDedUSD11003.SelectedItem.Text

            If Str80DDisLevel = "Not Applicable" Then
                strRelation = ""
            Else
                strRelation = txtRelD11003.Text
            End If
            Str80UDisLevel = drpDed80UD11009.SelectedItem.Text
            StrP1LoanMonth = drpP1LoanMonth.SelectedItem.Text
            strP1LoanYear = drpP1LoanYear.SelectedItem.Text
            StrP2LoanMonth = drpP2LoanMonth.SelectedItem.Text
            strP2LoanYear = drpP2LoanYear.SelectedItem.Text
            strP1PossessMonth = drpP1PossessMonth.SelectedItem.Text
            strP1PossessYear = drpP1PossessYear.SelectedItem.Text
            strP2PossessMonth = drpP2PossessMonth.SelectedItem.Text
            strP2PossessYear = drpP2PossessYear.SelectedItem.Text
            strP1SelfOrLet = RdP1SelfOrOccupied.SelectedValue.ToString
            strP2SelfOrLet = RdP2SelfOrOccupied.SelectedValue.ToString
            strR11050 = Val(SearchValue("txt80CR11050"))
            strR11051 = Val(SearchValue("txt80CR11051"))
            strR11052 = Val(SearchValue("txt80CR11052"))
            'Ver 3.7-REQ519 start
            If (Val(Left(Session("Period"), 4)) >= 2015) Then
                strR11053 = Val(SearchValue("txt80CR11053"))
            End If

            'Ver 3.7-REQ519 end 
            If strChCollege = "" Then
                strChCollege = "0"
            End If
            If strChScrool = "" Then
                strChScrool = "0"
            End If
            If StrComp(Str80DDisLevel, "Not Applicable", CompareMethod.Text) <> 0 Then
                If strRelation = "" Then
                    lblMessage.Text = "Please Enter Relationship"
                    Exit Sub
                End If
                If StrComp(Str80DDisLevel, "Normal Disability", CompareMethod.Text) = 0 Then
                    'Ver 3.07-REQ511 start
                    If (Val(Left(Session("Period"), 4)) < 2015) Then
                        'Ver 3.07-REQ511 end
                        txt80CD11003.Text = "50000"
                        'Ver 3.07-REQ511 start
                    Else
                        txt80CD11003.Text = "75000"
                    End If
                    'Ver 3.07-REQ511 end
                ElseIf StrComp(Str80DDisLevel, "Severe Disability (80% & Above)", CompareMethod.Text) = 0 Then
                    'Ver 3.07-REQ511 start
                    If (Val(Left(Session("Period"), 4)) < 2015) Then
                        'Ver 3.07-REQ511 end
                        txt80CD11003.Text = "75000"
                        'Ver 3.07-REQ511 start
                    Else
                        txt80CD11003.Text = "125000"
                    End If
                    'Ver 3.07-REQ511 end
                End If
            End If
            If StrComp(Str80UDisLevel, "Not Applicable", CompareMethod.Text) = 0 Then
                txt80CD11009.Text = "0"
            End If
            If StrComp(Str80DDisLevel, "Not Applicable", CompareMethod.Text) = 0 Then
                txt80CD11003.Text = "0"
            End If
            If StrP1LoanMonth = "--MM--" Then
                '--lblMessage.Text = "Please Select Property1 Loan Month"
                StrP1LoanMonth = ""
            End If
            If strP1LoanYear = "--YYYY--" Then
                '--lblMessage.Text = "Please Select Property1 Loan Year"
                strP1LoanYear = ""
            End If
            If StrP2LoanMonth = "--MM--" Then
                '--lblMessage.Text = "Please Select Property2 Loan Month"
                StrP2LoanMonth = ""
            End If
            If strP2LoanYear = "--YYYY--" Then
                '--lblMessage.Text = "Please Select Property2 Loan Year"
                strP2LoanYear = ""
            End If
            If strP1PossessMonth = "--MM--" Then
                '--lblMessage.Text = "Please Select Property1 Prossess Month"
                strP1PossessMonth = ""
            End If
            If strP1PossessYear = "--YYYY--" Then
                '--lblMessage.Text = "Please Select Property1 Possess Year"
                strP1PossessYear = ""
            End If
            If strP2PossessMonth = "--MM--" Then
                '--lblMessage.Text = "Please Select Property2 Possess Month"
                strP2PossessMonth = ""
            End If
            If strP2PossessYear = "--YYYY--" Then
                '--lblMessage.Text = "Please Select Property2 Possess Year"
                strP2PossessYear = ""
            End If
            If drpApril.SelectedItem.Text = "--select--" Then
                strHCity1 = ""
            Else
                strHCity1 = drpApril.SelectedItem.Text
            End If

            If drpMay.SelectedItem.Text = "--select--" Then
                strHCity2 = ""
            Else
                strHCity2 = drpMay.SelectedItem.Text
            End If
            If drpJune.SelectedItem.Text = "--select--" Then
                strHCity3 = ""
            Else
                strHCity3 = drpJune.SelectedItem.Text
            End If
            If drpJuly.SelectedItem.Text = "--select--" Then
                strHCity4 = ""
            Else
                strHCity4 = drpJuly.SelectedItem.Text
            End If
            If drpAugust.SelectedItem.Text = "--select--" Then
                strHCity5 = ""
            Else
                strHCity5 = drpAugust.SelectedItem.Text
            End If
            If drpSeptember.SelectedItem.Text = "--select--" Then
                strHCity6 = ""
            Else
                strHCity6 = drpSeptember.SelectedItem.Text
            End If
            If drpOctober.SelectedItem.Text = "--select--" Then
                strHCity7 = ""
            Else
                strHCity7 = drpOctober.SelectedItem.Text
            End If
            If drpNovember.SelectedItem.Text = "--select--" Then
                strHCity8 = ""
            Else
                strHCity8 = drpNovember.SelectedItem.Text
            End If
            If drpDecember.SelectedItem.Text = "--select--" Then
                strHCity9 = ""
            Else
                strHCity9 = drpDecember.SelectedItem.Text
            End If
            If drpJanuary.SelectedItem.Text = "--select--" Then
                strHCity10 = ""
            Else
                strHCity10 = drpJanuary.SelectedItem.Text
            End If
            If drpFebruary.SelectedItem.Text = "--select--" Then
                strHCity11 = ""
            Else
                strHCity11 = drpFebruary.SelectedItem.Text
            End If
            If drpMarch.SelectedItem.Text = "--select--" Then
                strHCity12 = ""
            Else
                strHCity12 = drpMarch.SelectedItem.Text
            End If
            lblMessage.Text = ""
            '--Inserting the Primary Column ECode
            Dim tblRow As New TableRow
            adp = New OleDbDataAdapter("select ECode from [Details] where ECode='" & Session("EmpID") & "'", objCon)
            adp.Fill(dsInv, "Inv")
            If dsInv.Tables("Inv").Rows.Count = 0 Then
                adp = New OleDbDataAdapter("insert into [Details](ECode) values('" & Session("EmpId") & "')", objCon)
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery()
                objCon.Close()
            End If
            '--Updating the PAN Number here
            adp.SelectCommand.CommandText = "update [Details] set PAN='" & strPAN & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            adp.SelectCommand.CommandText = "update [Details] set NoOfChildrenSchool='" & strChScrool & "'" & _
                                        " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            adp.SelectCommand.CommandText = "update [Details] set NoOfChildrenCollege='" & strChCollege & "'" & _
                                        " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            adp.SelectCommand.CommandText = "update [Details] set [80D-DisabilityLevel]='" & drpDedUSD11003.SelectedItem.Text & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            adp.SelectCommand.CommandText = "update [Details] set [80D-Relation]='" & strRelation & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            adp.SelectCommand.CommandText = "update [Details] set [80U-DisabilityLevel]='" & drpDed80UD11009.SelectedItem.Text & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()

            If (Val(Left(Session("Period"), 4)) < 2010) Then
                adp.SelectCommand.CommandText = "update [Details] set PrevSal=" & Val(txtSalIncUS10.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()

                adp.SelectCommand.CommandText = "update [Details] set PrevTds=" & Val(txtPrevTax.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()

                adp.SelectCommand.CommandText = "update [Details] set PrevPT=" & Val(txtPrevPT.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()

                adp.SelectCommand.CommandText = "update [Details] set PrevPF=" & Val(txtPrevPF.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()

                adp.SelectCommand.CommandText = "update [Details] set Prop1SelfOrLetout='" & strP1SelfOrLet & "'" & _
                                                " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()
            End If

            adp.SelectCommand.CommandText = "update [Details] set Prop1AmtIntPaid=" & Val(txtIntPaidAmt1.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            If (Val(Left(Session("Period"), 4)) < 2010) Then
                If RdP1SelfOrOccupied.SelectedValue = "Let out" Then

                    adp.SelectCommand.CommandText = "update [Details] set Prop1AmtRentRecd=" & Val(txtRentPaidAmt1.Text) & "" & _
                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                    adp.SelectCommand.CommandText = "update [Details] set Prop1AmtMuncipalTax=" & Val(txtMunTaxAmt1.Text) & "" & _
                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                Else
                    adp.SelectCommand.CommandText = "update [Details] set Prop1AmtRentRecd=0" & _
                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                    adp.SelectCommand.CommandText = "update [Details] set Prop1AmtMuncipalTax=0" & _
                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                End If

                adp.SelectCommand.CommandText = "update [Details] set Prop1LoanTakenMonth=" & Val(StrP1LoanMonth) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop1LoanTakenYear=" & Val(strP1LoanYear) & "" & _
                        " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop1LoanPossessionMonth=" & Val(strP1PossessMonth) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"

                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop1LoanPossessionYear=" & Val(strP1PossessYear) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop2SelfOrLetout='" & strP2SelfOrLet & "'" & _
                                                " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop2AmtIntPaid=" & Val(txtIntPaidAmt2.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                If RdP2SelfOrOccupied.SelectedValue = "Let out" Then
                    adp.SelectCommand.CommandText = "update [Details] set Prop2AmtRentRecd=" & Val(txtRentPaidAmt2.Text) & "" & _
                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                    adp.SelectCommand.CommandText = "update [Details] set Prop2AmtMuncipalTax=" & Val(txtMunTaxAmt2.Text) & "" & _
                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                Else
                    adp.SelectCommand.CommandText = "update [Details] set Prop2AmtRentRecd=0" & _
                                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                    adp.SelectCommand.CommandText = "update [Details] set Prop2AmtMuncipalTax=0" & _
                                                        " where ECode='" & Session("EmpId") & "'"
                    intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                End If

                adp.SelectCommand.CommandText = "update [Details] set Prop2LoanTakenMonth=" & Val(StrP2LoanMonth) & "" & _
                                    " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop2LoanTakenYear=" & Val(strP2LoanYear) & "" & _
                                    " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop2LoanPossessionMonth=" & Val(strP2PossessMonth) & "" & _
                                    " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

                adp.SelectCommand.CommandText = "update [Details] set Prop2LoanPossessionYear=" & Val(strP2PossessYear) & "" & _
                                    " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt1=" & Val(txtApril.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt2=" & Val(txtMay.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt3=" & Val(txtJune.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt4=" & Val(txtJuly.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt5=" & Val(txtAugust.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt6=" & Val(txtSeptember.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt7=" & Val(txtOctober.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt8=" & Val(txtNovember.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt9=" & Val(txtDecember.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt10=" & Val(txtJanuary.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt11=" & Val(txtFebruary.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRAAmt12=" & Val(txtMarch.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity1='" & strHCity1 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRACity2='" & strHCity2 & "'" & _
                                           " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set HRACity3='" & strHCity3 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity4='" & strHCity4 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity5='" & strHCity5 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity6='" & strHCity6 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity7='" & strHCity7 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity8='" & strHCity8 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity9='" & strHCity9 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity10='" & strHCity10 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity11='" & strHCity11 & "'" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set HRACity12='" & strHCity12 & "'" & _
                                               " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            For intK As Integer = 1 To 25
                strR11(intK - 1) = Val(SearchValue("txt80CR110" & Format(intK, "00")))
                adp.SelectCommand.CommandText = "update [Details] set R110" & Format(intK, "00") & "=" & Val(strR11(intK - 1)) & "" & _
                    " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()
            Next intK
            adp.SelectCommand.CommandText = "update [Details] set R11050=" & Val(strR11050) & "" & _
                                   " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            adp.SelectCommand.CommandText = "update [Details] set R11051=" & Val(strR11051) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            adp.SelectCommand.CommandText = "update [Details] set R11052=" & Val(strR11052) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            objCon.Open()
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            objCon.Close()
            'Ver 3.7-REQ519 start
            If (Val(Left(Session("Period"), 4)) >= 2015) Then
                adp.SelectCommand.CommandText = "update [Details] set R11053=" & Val(strR11053) & "" & _
                                  " where ECode='" & Session("EmpId") & "'"
                objCon.Open()
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                objCon.Close()
            End If

            'Ver 3.7-REQ519 end 
            objCon.Open()
            adp.SelectCommand.CommandText = "update [Details] set D11001=" & Val(txt80CD11001.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11002=" & Val(txt80CD11002.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11003=" & Val(txt80CD11003.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11004=" & Val(txtD11004.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"



            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11005=" & Val(txt80CD11005.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11006=" & Val(txtD11006.Text) & "" & _
                                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            '==>Jitendra
            'adp.SelectCommand.CommandText = "update [Details] set D11007=" & Val(txtD11007_1.Text) & "" & _
            '                                        " where ECode='" & Session("EmpId") & "'"
            If (Val(Left(Session("Period"), 4)) >= 2016) Then
                adp.SelectCommand.CommandText = "update [Details] set D11007=" & Val(txtD11007_1.Text) & "" & _
                                                    " where ECode='" & Session("EmpId") & "'"
            Else
                adp.SelectCommand.CommandText = "update [Details] set D11007=" & Val(txtD11007.Text) & "" & _
                                                  " where ECode='" & Session("EmpId") & "'"
            End If
            'end 
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            adp.SelectCommand.CommandText = "update [Details] set D11008=" & Val(txtD11008.Text) & "" & _
                                             " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            If drpDed80UD11009.SelectedIndex = 0 Then
                txt80CD11009.Text = "0"
                txt80CD11009.CssClass = "hidden"
            ElseIf drpDed80UD11009.SelectedIndex = 1 Then
                'Ver 3.07-REQ511 start
                If (Val(Left(Session("Period"), 4)) < 2015) Then
                    'Ver 3.07-REQ511 end
                    txt80CD11009.Text = "50000"
                    'Ver 3.07-REQ511 start
                Else
                    txt80CD11009.Text = "75000"
                End If

            Else
                'Ver 3.07-REQ511 start
                If (Val(Left(Session("Period"), 4)) < 2015) Then
                    'Ver 3.07-REQ511 end
                    txt80CD11009.Text = "75000"
                    'Ver 3.07-REQ511 start
                Else
                    txt80CD11009.Text = "125000"
                End If
                'Ver 3.07-REQ511 end
            End If

            adp.SelectCommand.CommandText = "update [Details] set D11009=" & Val(txt80CD11009.Text) & "" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            'adp.SelectCommand.CommandText = "update [Details] set DateOfEntry=#" & Month(Today) & "/" & Day(Today) & "/" & Year(Today) & " " & Today.ToLongTimeString & "#" & _
            '                    " where ECode='" & Session("EmpId") & "'"
            'intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            adp.SelectCommand.CommandText = "update [Details] set DateOfEntry=#" & DateTime.Now.ToString() & "#" & _
                                " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery

            If (Val(Left(Session("Period"), 4)) >= 2010) Then
                adp.SelectCommand.CommandText = "update [Details] set D11011=" & Val(txtD11011.Text) & "" & _
                                       " where ECode='" & Session("EmpId") & "'"

                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If

            'Ver 3.3-E456 Start
            adp.SelectCommand.CommandText = "update [Details] set D11013=" & Val(txtD11013.Text) & "" & _
                                            " where ECode='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            'Ver 3.3-E456 End
            'Ver 3.3-E588 start 
            adp.SelectCommand.CommandText = "update [details] set O11007=" & Val(txtD11014.Text) & "  where ECode ='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            'Ver 3.07-REQ511 start
            'If (Val(Left(Session("Period"), 4)) < 2010) Then
            If (Val(Left(Session("Period"), 4)) < 2015) Then
                'Ver 3.07-REQ511 end
                adp.SelectCommand.CommandText = "update [details] set D11015=" & Val(txtD11015.Text) & "  where ECode  ='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
                'Ver 3.3-E588 end 
                'Ver 3.07-REQ511 start
            End If
            'Ver 3.07-REQ511 end


            '==>Jitendra for 80CCD New Pension Scheme.
            If (Val(Left(Session("Period"), 4)) >= 2015) Then
                adp.SelectCommand.CommandText = "update [Details] set 80CCD_1B=" & Val(txt80CCD.Text) & "" & _
                                             " where ECode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If
            '<== New Pension Scheme
            '==> Jayant for Income form House Property
            adp = New OleDbDataAdapter("select [IncmFromHP] from [Details] " & " where Ecode='" & Session("EmpId") & "'", objCon)
            adp.Fill(dsInv, "InvDetails")
            With dsInv.Tables("InvDetails")
                If .Rows.Count > 0 Then
                    txtIntPaidAmt1.Text = "" & .Rows(.Rows.Count - 1).Item("IncmFromHP")
                End If
            End With
            adp.SelectCommand.CommandText = "update [details] set IncmFromHP=" & Val(txtIntPaidAmt1.Text) & "  where ECode ='" & Session("EmpId") & "'"
            intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            '<==

            '==>Jitendra Started 80EE housing loan on 25/04/2016
            'Ver 4.0-REQ579 start
            If (Val(Left(Session("Period"), 4)) >= 2016) Then
                adp.SelectCommand.CommandText = "update [Details] set 80EE=" & Val(txt80EE.Text) & "" & _
                                                "  where Ecode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If
            'Ver 4.0-REQ579 end 
            'Ver 4.1-REQ623 start 
            If (Val(Left(Session("Period"), 4)) >= 2016) Then
                Dim strsql As String = String.Empty
                strsql = "update [Details] set LandLordName='" & (txtLandlord.Text) & "',LandLordAddress1='" & (txtLLordAdd1.Text) & "',LandLordAddress2='" & (txtLLordAdd2.Text) & "',LandLordAddress3='" & (txtLLordAdd3.Text) & "',LandLordPAN='" & (txtPANnumber.Text) & "'"
                strsql &= vbCrLf & ",LandLord2Name = '" & (TxtNameLL2.Text) & "' ,LandLord2Add1 = '" & (txtadd1LL2.Text) & "',LandLord2Add2 = '" & (txtadd2LL2.Text) & "' ,LandLord2Add3 = '" & (txtadd3LL2.Text) & "' ,LandLord2PAN = '" & (txtpanLL2.Text) & "'"
                strsql &= vbCrLf & ",LandLord3Name = '" & (TxtNameLL3.Text) & "' ,LandLord3Add1 = '" & (txtadd1LL3.Text) & "',LandLord3Add2 = '" & (txtadd2LL3.Text) & "' ,LandLord3Add3 = '" & (txtadd3LL3.Text) & "' ,LandLord3PAN = '" & (txtpanLL3.Text) & "'"
                strsql &= vbCrLf & ",LandLord4Name = '" & (TxtNameLL4.Text) & "' ,LandLord4Add1 = '" & (txtadd1LL4.Text) & "',LandLord4Add2 = '" & (txtadd2LL4.Text) & "' ,LandLord4Add3 = '" & (txtadd3LL4.Text) & "' ,LandLord4PAN = '" & (txtpanLL4.Text) & "'"
                strsql &= vbCrLf & " where Ecode='" & Session("EmpId") & "'"
                adp.SelectCommand.CommandText = strsql
                ' &
                ' &
                ' &
                '" where Ecode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If
            'Ver 4.1-REQ623 end 
            'Ver4.2 REQ806 start
            If (Val(Left(Session("Period"), 4)) >= 2018) Then
                adp.SelectCommand.CommandText = "update [Details] set 80TTB=" & Val(txt80TTB.Text) & "" & "  where Ecode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If

            If (Val(Left(Session("Period"), 4)) >= 2019) Then
                adp.SelectCommand.CommandText = "update [Details] set 80EEA=" & Val(txt80EEA.Text) & "" & "  where Ecode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If
            If (Val(Left(Session("Period"), 4)) >= 2019) Then
                adp.SelectCommand.CommandText = "update [Details] set 80EEB=" & Val(txt80EEB.Text) & "" & "  where Ecode='" & Session("EmpId") & "'"
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
            End If
            'Ver4.2 REQ806 end
            objCon.Close()
            lblMessage.Text = "Record Submitted Successfully."
            ScriptManager.RegisterStartupScript(Me, Page.GetType, "Script", "DisableIncmFromHP();", True)
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        Finally
            'ver 3.2-CRK Start
            objCon.Close()
            'ver 3.2-CRK End
        End Try
    End Sub

    Private Function SearchValue(ByVal pStrCode As String) As String
        SearchValue = "0"
        With Table1
            For intI As Integer = 0 To .Rows.Count - 1
                If .Rows(intI).Cells(0).Text = pStrCode Then
                    Return .Rows(intI).Cells(1).Text
                End If
            Next
        End With
    End Function

    Private Sub GetControlID(ByVal tbl As Table, ByVal oControl As Control)
        Dim frmControl As Control
        Dim OArrayList As New ArrayList
        Dim tblRow As TableRow
        Dim tblCell As TableCell
        Dim txt1 As TextBox, opt1 As RadioButtonList, drp1 As DropDownList
        Try
            For Each frmControl In oControl.Controls
                If TypeOf frmControl Is TextBox Then
                    tblRow = New TableRow
                    Table1.Rows.Add(tblRow)
                    tblCell = New TableCell
                    tblCell.Text = frmControl.ID
                    tblRow.Cells.Add(tblCell)
                    tblCell = New TableCell
                    txt1 = New TextBox
                    txt1 = frmControl
                    tblCell.Text = txt1.Text
                    tblRow.Cells.Add(tblCell)
                ElseIf TypeOf frmControl Is RadioButtonList Then
                    tblRow = New TableRow
                    Table1.Rows.Add(tblRow)
                    tblCell = New TableCell
                    tblCell.Text = frmControl.ID
                    tblRow.Cells.Add(tblCell)
                    tblCell = New TableCell
                    opt1 = New RadioButtonList
                    opt1 = frmControl
                    tblCell.Text = opt1.Text
                    tblRow.Cells.Add(tblCell)
                ElseIf TypeOf frmControl Is DropDownList Then
                    tblRow = New TableRow
                    Table1.Rows.Add(tblRow)
                    tblCell = New TableCell
                    tblCell.Text = frmControl.ID
                    tblRow.Cells.Add(tblCell)
                    tblCell = New TableCell
                    drp1 = New DropDownList
                    drp1 = frmControl
                    tblCell.Text = drp1.Text
                    tblRow.Cells.Add(tblCell)
                End If
                Dim strid As String = TypeName(frmControl.GetType)
                If frmControl.HasControls Then
                    GetControlID(tbl, frmControl)
                End If
            Next
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    'Private Sub GetExpChild(ByVal oControl As Control)
    '    Dim frmControl As Control
    '    Dim OArrayList As New ArrayList
    '    Dim tblRow As TableRow
    '    Dim tblCell As TableCell
    '    Dim txt1 As TextBox, opt1 As RadioButtonList, drp1 As DropDownList
    '    Try
    '        For Each frmControl In oControl.Controls
    '            If TypeOf frmControl Is DropDownList Then
    '                tblCell.Text = frmControl.
    '                tblRow.Cells.Add(tblCell)
    '                tblCell = New TableCell
    '                drp1 = New DropDownList
    '                drp1 = frmControl
    '                tblCell.Text = drp1.Text
    '                tblRow.Cells.Add(tblCell)
    '            End If
    '            Dim strid As String = TypeName(frmControl.GetType)
    '            If frmControl.HasControls Then
    '                GetControlID(tbl, frmControl)
    '            End If
    '        Next
    '    Catch ex As Exception
    '        lblMsg.Text = ex.Message.ToString
    '    End Try
    'End Sub

    Protected Sub Page_LoadComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LoadComplete
        If (Val(Left(Session("Period"), 4)) >= 2010) Then
            If RdP1SelfOrOccupied.SelectedIndex = 0 Then
                pnlRent1.CssClass = "hidden"
                pnlMun1.CssClass = "hidden"
            Else
                pnlRent1.CssClass = "visible"
                pnlMun1.CssClass = "visible"
            End If
            If RdP2SelfOrOccupied.SelectedIndex = 0 Then
                pnlRent2.CssClass = "hidden"
                pnlMun2.CssClass = "hidden"
            Else
                pnlRent2.CssClass = "visible"
                pnlMun2.CssClass = "visible"
            End If
        End If

        If drpDedUSD11003.SelectedIndex = 0 Then
            txt80CD11003.Text = "0"
            txtRelD11003.CssClass = "hidden"
        ElseIf drpDedUSD11003.SelectedIndex = 1 Then
            txt80CD11003.Text = "75000"
            txtRelD11003.CssClass = "visible"
        Else
            txt80CD11003.Text = "125000"
            txtRelD11003.CssClass = "visible"
        End If

    End Sub

    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        If Page.IsPostBack = True Then
            ReDim strRComponents(tblInv1.Rows.Count + 1)
            Dim htmlCtrl As Control
            For Each htmlCtrl In Me.Controls
                Call GetControlValue(strRComponents, htmlCtrl)
            Next

        End If
    End Sub

    Private Sub GetControlValue(ByVal strArray() As String, ByVal oControl As Control)
        Dim frmControl As Control
        Dim OArrayList As New ArrayList
        Dim txt1 As TextBox
        Dim intI As Integer
        Try
            For Each frmControl In oControl.Controls
                If TypeOf frmControl Is TextBox Then
                    txt1 = New TextBox
                    txt1 = frmControl
                    strArray(intI) = txt1.Text
                    intI += 1
                End If
                Dim strid As String = TypeName(frmControl.GetType)
                If frmControl.HasControls Then
                    GetControlValue(strArray, frmControl)
                End If
            Next
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub drpDedUS_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Try
            Dim htmlctrl As New Control
            For Each htmlctrl In Me.Controls
                Call GetControlID(Table1, htmlctrl)
            Next
            Dim strChangedValue As String = SearchValue("drpDedUSD11003")
            For Each htmlctrl In Me.Controls
                If StrComp(strChangedValue, "Normal Disability") = 0 Then
                    GetControlValue("txt80CD11003", "75000", htmlctrl)

                ElseIf StrComp(strChangedValue, "Severe Disability (80% & Above)") = 0 Then
                    GetControlValue("txt80CD11003", "125000", htmlctrl)
                Else
                    GetControlValue("txt80CD11003", "0", htmlctrl)
                End If
            Next htmlctrl

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub GetControlValue(ByVal strId As String, ByVal strValue As String, ByVal oControl As Control)
        Dim frmControl As Control
        Dim OArrayList As New ArrayList
        '--Dim tblRow As TableRow
        '--Dim tblCell As TableCell
        Dim txt1 As TextBox '--, opt1 As RadioButtonList, drp1 As DropDownList
        Try
            For Each frmControl In oControl.Controls
                If TypeOf frmControl Is TextBox Then

                    If frmControl.ID = strId Then
                        txt1 = New TextBox
                        txt1 = frmControl
                        txt1.Text = strValue
                        frmControl = txt1
                        Exit For
                    End If
                End If
                Dim strid1 As String = TypeName(frmControl.GetType)
                If frmControl.HasControls Then
                    GetControlValue(strId, strValue, frmControl)
                End If
            Next
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub drpDed80U_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Try
            Dim htmlctrl As New Control
            For Each htmlctrl In Me.Controls
                Call GetControlID(Table1, htmlctrl)
            Next
            Dim strChangedValue As String = SearchValue("drpDed80UD11009")
            For Each htmlctrl In Me.Controls
                If StrComp(strChangedValue, "Normal Disability") = 0 Then
                    GetControlValue("txt80CD11009", "75000", htmlctrl)
                ElseIf StrComp(strChangedValue, "Severe Disability (80% & Above)") = 0 Then
                    GetControlValue("txt80CD11009", "125000", htmlctrl)
                Else
                    GetControlValue("txt80CD11009", "0", htmlctrl)
                End If
            Next htmlctrl
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
    Private Sub ColorRow()
        Try
            For i = 1 To tblInv1.Rows.Count
                If (i Mod 2 = 0) Then
                    tblInv1.Rows(i).BackColor = Drawing.Color.FromName("#E0E0E0")
                End If
            Next
        Catch ex As Exception
        End Try
    End Sub
    'Ver 3.2-E398 Start
    Private Sub PrintPDF()
        'Ver 3.2-E398 Start
        Dim rcnt As Integer = 0
        Dim dttxtValue As New DataTable()
        dttxtValue.Columns.Add("S.No.")
        dttxtValue.Columns.Add("Type of Investment")
        dttxtValue.Columns.Add("Amount")
        dttxtValue.Columns.Add("Proof Required Later")
        For rcnt = 1 To tblInv1.Rows.Count - 1
            If Not tblInv1.Rows(rcnt).Cells(1).HasControls() Then
                dttxtValue.Rows.Add(tblInv1.Rows(rcnt).Cells(0).Text, tblInv1.Rows(rcnt).Cells(1).Text, CType(tblInv1.Rows(rcnt).Cells(2).Controls(0), TextBox).Text, tblInv1.Rows(rcnt).Cells(3).Text)
            Else
                Dim str As String = ""
                str = getLabel(tblInv1.Rows(rcnt).Cells(1).Controls(0)) & "  " & getLabel(tblInv1.Rows(rcnt).Cells(1).Controls(1))
                str = str & ":" & CType(tblInv1.Rows(rcnt).Cells(1).Controls(2), RadioButtonList).SelectedValue
                dttxtValue.Rows.Add(tblInv1.Rows(rcnt).Cells(0).Text, str, CType(tblInv1.Rows(rcnt).Cells(2).Controls(0), TextBox).Text, tblInv1.Rows(rcnt).Cells(3).Text)
            End If
        Next
        dspdf.Tables.Add(dttxtValue)
        'Ver 3.2-E398 End
        'Ver 3.2-E398 Start
        rcnt = 0
        dttxtValue = New DataTable()
        dttxtValue.Columns.Add("S.No.")
        dttxtValue.Columns.Add("Section")
        dttxtValue.Columns.Add("Remarks")
        dttxtValue.Columns.Add("Amount")
        dttxtValue.Columns.Add("Proof Required Later")
        For rcnt = 1 To tblInv2.Rows.Count - 1
            If tblInv2.Rows(rcnt).Visible = True Then
                If tblInv2.Rows(rcnt).Cells(2).Controls.Count > 1 Then
                    Dim strdis As String = "Disability:" & DirectCast(tblInv2.Rows(rcnt).Cells(2).Controls(1), DropDownList).SelectedItem.Text
                    If strdis <> "Disability:Not Applicable" And txt80CD11009.Text <> "" And getLabel(tblInv2.Rows(rcnt).Cells(0).Controls(0)).Trim() = "4" Then
                        strdis = strdis & Environment.NewLine & " Relationship:" & txtRelD11003.Text
                    End If
                    dttxtValue.Rows.Add(getLabel(tblInv2.Rows(rcnt).Cells(0).Controls(0)), getLabel(tblInv2.Rows(rcnt).Cells(1).Controls(0)), strdis, CType(tblInv2.Rows(rcnt).Cells(3).Controls(0), TextBox).Text, getLabel(tblInv2.Rows(rcnt).Cells(4).Controls(0)))
                Else
                    dttxtValue.Rows.Add(getLabel(tblInv2.Rows(rcnt).Cells(0).Controls(0)), getLabel(tblInv2.Rows(rcnt).Cells(1).Controls(0)), getLabel(tblInv2.Rows(rcnt).Cells(2).Controls(0)), CType(tblInv2.Rows(rcnt).Cells(3).Controls(0), TextBox).Text, getLabel(tblInv2.Rows(rcnt).Cells(4).Controls(0)))

                End If
            End If
        Next
        dspdf.Tables.Add(dttxtValue)
        'Ver 3.2-E398 End
        rcnt = 0
        dttxtValue = New DataTable()
        dttxtValue.Columns.Add("Month")
        dttxtValue.Columns.Add("Amount")
        dttxtValue.Columns.Add("City Name")

        dttxtValue.Rows.Add("April", txtApril.Text, drpApril.Text)
        dttxtValue.Rows.Add("May", txtMay.Text, drpMay.Text)
        dttxtValue.Rows.Add("June", txtJune.Text, drpJune.Text)
        dttxtValue.Rows.Add("July", txtJuly.Text, drpJuly.Text)
        dttxtValue.Rows.Add("August", txtAugust.Text, drpAugust.Text)
        dttxtValue.Rows.Add("September", txtSeptember.Text, drpSeptember.Text)
        dttxtValue.Rows.Add("October", txtOctober.Text, drpOctober.Text)
        dttxtValue.Rows.Add("November", txtNovember.Text, drpNovember.Text)
        dttxtValue.Rows.Add("December", txtDecember.Text, drpDecember.Text)
        dttxtValue.Rows.Add("January", txtJanuary.Text, drpJanuary.Text)
        dttxtValue.Rows.Add("February", txtFebruary.Text, drpFebruary.Text)
        dttxtValue.Rows.Add("March", txtMarch.Text, drpMarch.Text)
        'Ver 4.1-REQ623 start
        dttxtValue.Rows.Add("Rent Paid to the Landlord", txtTotValue.Text, "")
        'Ver 4.1-REQ623 end 

        dspdf.Tables.Add(dttxtValue)
        rcnt = 0
        dttxtValue = New DataTable()
        dttxtValue.Columns.Add("tmp")
        dttxtValue.Rows.Add(txtEmpId.Text)
        dttxtValue.Rows.Add(txtEName.Text)
        dttxtValue.Rows.Add(txtPAN.Text)
        dttxtValue.Rows.Add(txtIntPaidAmt1.Text)
        dspdf.Tables.Add(dttxtValue)

        'Ver 4.1-REQ623 start
        rcnt = 0
        dttxtValue = New DataTable()
        dttxtValue.Columns.Add("")
        dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("Name of the landlord", txtLandlord.Text)
        dttxtValue.Rows.Add("Address of the landlord", txtLLordAdd1.Text)
        dttxtValue.Rows.Add("", txtLLordAdd2.Text)
        dttxtValue.Rows.Add("", txtLLordAdd3.Text)
        dttxtValue.Rows.Add("PAN of the landlord", txtPANnumber.Text)
        'dspdf.Tables.Add(dttxtValue)

        'rcnt = 0
        'dttxtValue = New DataTable()
        'dttxtValue.Columns.Add("")
        'dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("", "")
        dttxtValue.Rows.Add("Name of the landlord", TxtNameLL2.Text)
        dttxtValue.Rows.Add("Address of the landlord", txtadd1LL2.Text)
        dttxtValue.Rows.Add("", txtadd2LL2.Text)
        dttxtValue.Rows.Add("", txtadd3LL2.Text)
        dttxtValue.Rows.Add("PAN of the landlord", txtpanLL2.Text)
        'dspdf.Tables.Add(dttxtValue)

        'rcnt = 0
        'dttxtValue = New DataTable()
        'dttxtValue.Columns.Add("")
        'dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("", "")
        dttxtValue.Rows.Add("Name of the landlord", TxtNameLL3.Text)
        dttxtValue.Rows.Add("Address of the landlord", txtadd1LL3.Text)
        dttxtValue.Rows.Add("", txtadd2LL3.Text)
        dttxtValue.Rows.Add("", txtadd3LL3.Text)
        dttxtValue.Rows.Add("PAN of the landlord", txtpanLL3.Text)
        'dspdf.Tables.Add(dttxtValue)

        'rcnt = 0
        'dttxtValue = New DataTable()
        'dttxtValue.Columns.Add("")
        'dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("", "")
        dttxtValue.Rows.Add("Name of the landlord", TxtNameLL4.Text)
        dttxtValue.Rows.Add("Address of the landlord", txtadd1LL4.Text)
        dttxtValue.Rows.Add("", txtadd2LL4.Text)
        dttxtValue.Rows.Add("", txtadd3LL4.Text)
        dttxtValue.Rows.Add("PAN of the landlord", txtpanLL4.Text)
        dspdf.Tables.Add(dttxtValue)


        objCon.Open()
        Dim cmd1 As New OleDbCommand("select * from IncomeFromHouseProperty where FYear='" & fYear & "' AND EmpCode='" & empCode & "'", objCon)
        Dim drIncome As OleDbDataReader = cmd1.ExecuteReader()
        Dim InterestOnHousingLoan, IncomefromSelfoccupiedHouseProperty, AnnualLetableValueRentReceivedorReceivable, LessMunicipalTaxesPaidDuringtheYear, LessUnrealizedRent, NetAnnualValue, StandardDeduction30ofNetAnnualValue, iiInterestonHousingLoan, IncomefromLetoutHouseProperty, IncomeFromHouseProperty As Integer
        Dim LenderName, LenderAddress1, LenderAddress2, LenderAddress3, PanLender As String
        Dim Lender2Name, Lender2Address1, Lender2Address2, Lender2Address3, PanLender2 As String
        Dim Lender3Name, Lender3Address1, Lender3Address2, Lender3Address3, PanLender3 As String
        Dim Lender4Name, Lender4Address1, Lender4Address2, Lender4Address3, PanLender4 As String

        If drIncome.HasRows Then
            drIncome.Read()
            InterestOnHousingLoan = Convert.ToInt32(drIncome("InterestOnHLPaid")).ToString()
            IncomefromSelfoccupiedHouseProperty = Convert.ToInt32(drIncome("IncomeSelfOcc")).ToString()
            AnnualLetableValueRentReceivedorReceivable = Convert.ToInt32(drIncome("RentRecieved")).ToString()
            LessMunicipalTaxesPaidDuringtheYear = Convert.ToInt32(drIncome("MunicipalTaxes")).ToString()
            LessUnrealizedRent = Convert.ToInt32(drIncome("RentUnrealized")).ToString()
            NetAnnualValue = Convert.ToInt32(drIncome("NetAnnualValue")).ToString()
            StandardDeduction30ofNetAnnualValue = Convert.ToInt32(drIncome("StandardDeduction30")).ToString()
            iiInterestonHousingLoan = Convert.ToInt32(drIncome("IneterstOnHLLetout")).ToString()
            IncomefromLetoutHouseProperty = Convert.ToInt32(drIncome("IncomeLetOutHP")).ToString()
            IncomeFromHouseProperty = Decimal.Ceiling(Convert.ToDecimal(IncomefromLetoutHouseProperty)) + Decimal.Ceiling(Convert.ToDecimal(IncomefromSelfoccupiedHouseProperty))

            LenderName = drIncome("LenderName").ToString()
            LenderAddress1 = drIncome("LenderAddress1").ToString()
            LenderAddress2 = drIncome("LenderAddress2").ToString()
            LenderAddress3 = drIncome("LenderAddress3").ToString()
            PanLender = drIncome("LenderPAN").ToString()

            Lender2Name = drIncome("Lender2Name").ToString()
            Lender2Address1 = drIncome("Lender2Add1").ToString()
            Lender2Address2 = drIncome("Lender2Add2").ToString()
            Lender2Address3 = drIncome("Lender2Add3").ToString()
            PanLender2 = drIncome("Lender2PAN").ToString()

            Lender3Name = drIncome("Lender3Name").ToString()
            Lender3Address1 = drIncome("Lender3Add1").ToString()
            Lender3Address2 = drIncome("Lender3Add2").ToString()
            Lender3Address3 = drIncome("Lender3Add3").ToString()
            PanLender3 = drIncome("Lender3PAN").ToString()

            Lender4Name = drIncome("Lender4Name").ToString()
            Lender4Address1 = drIncome("Lender4Add1").ToString()
            Lender4Address2 = drIncome("Lender4Add2").ToString()
            Lender4Address3 = drIncome("Lender4Add3").ToString()
            PanLender4 = drIncome("Lender4PAN").ToString()

        Else
            LenderName = ""
            LenderAddress1 = ""
            LenderAddress2 = ""
            LenderAddress3 = ""
            PanLender = ""

            Lender2Name = ""
            Lender2Address1 = ""
            Lender2Address2 = ""
            Lender2Address3 = ""
            PanLender2 = ""

            Lender3Name = ""
            Lender3Address1 = ""
            Lender3Address2 = ""
            Lender3Address3 = ""
            PanLender3 = ""

            Lender4Name = ""
            Lender4Address1 = ""
            Lender4Address2 = ""
            Lender4Address3 = ""
            PanLender4 = ""
        End If
        rcnt = 0
        dttxtValue = New DataTable()

        dttxtValue.Columns.Add("")
        dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("1 Interest on Housing Loan", InterestOnHousingLoan)
        dttxtValue.Rows.Add("2 Income from Self- occupied House Property", IncomefromSelfoccupiedHouseProperty)
        dspdf.Tables.Add(dttxtValue)

        rcnt = 0
        dttxtValue = New DataTable()

        dttxtValue.Columns.Add("")
        dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("1.Annual Letable Value/Rent Received or Receivable ", AnnualLetableValueRentReceivedorReceivable)
        dttxtValue.Rows.Add("2.Less:Municiple Taxes Paid During the Year", LessMunicipalTaxesPaidDuringtheYear)
        dttxtValue.Rows.Add("3.Less:Unrealized Rent", LessUnrealizedRent)
        dttxtValue.Rows.Add("4.Net Annual Value(1-(2+3))", NetAnnualValue)
        dttxtValue.Rows.Add("5.Less : Deductions from Net Annual Value", "")
        dttxtValue.Rows.Add("   i.Standard Deduction @30% of Net Annual Value", StandardDeduction30ofNetAnnualValue)
        dttxtValue.Rows.Add("   ii.Interest on Housing Loan", iiInterestonHousingLoan)
        dttxtValue.Rows.Add("6:Income from Let-out House Property", IncomefromLetoutHouseProperty)
        dttxtValue.Rows.Add("C. Income From House Property", IncomeFromHouseProperty)
        dspdf.Tables.Add(dttxtValue)


        rcnt = 0
        dttxtValue = New DataTable()

        dttxtValue.Columns.Add("")
        dttxtValue.Columns.Add("")
        dttxtValue.Rows.Add("Name of the lender", LenderName)
        dttxtValue.Rows.Add("Address of the lender", LenderAddress1)
        dttxtValue.Rows.Add("", LenderAddress2)
        dttxtValue.Rows.Add("", LenderAddress3)
        dttxtValue.Rows.Add("Pan of the lender", PanLender)

        dttxtValue.Rows.Add("Name of the lender", Lender2Name)
        dttxtValue.Rows.Add("Address of the lender", Lender2Address1)
        dttxtValue.Rows.Add("", Lender2Address2)
        dttxtValue.Rows.Add("", Lender2Address3)
        dttxtValue.Rows.Add("Pan of the lender", PanLender2)

        dttxtValue.Rows.Add("Name of the lender", Lender3Name)
        dttxtValue.Rows.Add("Address of the lender", Lender3Address1)
        dttxtValue.Rows.Add("", Lender3Address2)
        dttxtValue.Rows.Add("", Lender3Address3)
        dttxtValue.Rows.Add("Pan of the lender", PanLender3)

        dttxtValue.Rows.Add("Name of the lender", Lender4Name)
        dttxtValue.Rows.Add("Address of the lender", Lender4Address1)
        dttxtValue.Rows.Add("", Lender4Address2)
        dttxtValue.Rows.Add("", Lender4Address3)
        dttxtValue.Rows.Add("Pan of the lender", PanLender4)
        dspdf.Tables.Add(dttxtValue)


        objCon.Close()
        drIncome.Close()
        'Ver 4.1-REQ623 end 




        Dim pdfForm As New PDFform(dspdf, "0", "8.0in")
        Dim document As MigraDoc.DocumentObjectModel.Document = pdfForm.CreateDocument()
        document.UseCmykColor = True
        Dim pdfRenderer As New PdfDocumentRenderer(True)
        pdfRenderer.Document = document
        pdfRenderer.RenderDocument()
        Dim ms As New System.IO.MemoryStream()
        pdfRenderer.Save(ms, True)
        Dim byteArray() As Byte = ms.ToArray()
        HttpContext.Current.Response.ContentType = "Application/pdf"
        HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=InvestmentDeclaration.pdf")
        HttpContext.Current.Response.AddHeader("Content-Length", byteArray.Length.ToString())
        HttpContext.Current.Response.ContentType = "application/octet-stream"
        HttpContext.Current.Response.BinaryWrite(byteArray)
        HttpContext.Current.Response.End()
    End Sub
    Private Function getLabel(ByVal exp As Control) As String
        Try
            Return CType(exp, Label).Text.Replace("<b>", "").Replace("</b>", "").Replace("<br>", Environment.NewLine)
        Catch ex As Exception
            Return ""
        End Try
    End Function
    'Ver 3.2-E398 End

    Protected Sub btnCalculate_Click(sender As Object, e As EventArgs) Handles btnCalculate.Click
        Try
            ScriptManager.RegisterStartupScript(Me, Page.GetType, "Script", "popup();", True)
            SetFocus(txtIntPaidAmt1)
        Catch ex As Exception

        End Try
    End Sub
    ''==>jitendra
    'Private Function SpecialCharacter(str As String) As String
    '    'Dim replaceStr = ""
    '    Try
    '        Dim replaceStr = Regex.Replace(str, "[^a-zA-Z0-9_]+", "")
    '        Return replaceStr
    '    Catch ex As Exception
    '        Return ""
    '    End Try
    'End Function
    ''<==Jitendra

    Protected Sub btnGenerate12BB_Click(sender As Object, e As EventArgs) Handles btnGenerate12BB.Click
        Dim strDownloadPath As String = ""
        Dim strFileName As String = ""
        Try

            If Directory.Exists(Session("strPath").ToString() & "\12BBDeclaration" & "_" & Session("CoCode") & "_" & (Session("Period")).ToString()) Then
                If File.Exists(Session("strPath").ToString() & "\12BBDeclaration" & "_" & Session("CoCode") & "_" & (Session("Period")) & "\" & Session("EmpId") & "_" & Session("EmpName") & ".xls") Then
                    strDownloadPath = Session("strPath").ToString() & "\12BBDeclaration" & "_" & Session("CoCode") & "_" & (Session("Period")) & "\" & Session("EmpId") & "_" & Session("EmpName") & ".xls"
                End If
            Else
                Exit Sub
            End If
            strFileName = Session("EmpId") & "_" & Session("EmpName") & ".xls"
            Dim byteArray() As Byte = File.ReadAllBytes(strDownloadPath)
            Response.ContentType = "text/Plain"
            Response.AddHeader("content-disposition", "attachment;filename=" & strFileName & "")
            Response.AddHeader("Content-Length", byteArray.Length.ToString())
            Response.ContentType = "application/octet-stream"
            ''Write the file directly to the HTTP output stream.
            Response.BinaryWrite(byteArray)
            MsgBox("DownLoad Completed Successfully.", MsgBoxStyle.Information, "12BB file Generation")
            HttpContext.Current.Response.End()

        Catch ex As Exception
            Alert.Show(ex.Message)
        End Try
    End Sub
    Protected Sub rdbOldTaxRegime_CheckedChanged(sender As Object, e As EventArgs) Handles rdbOldTaxRegime.CheckedChanged
        objCon.Open()
        Dim cmd1 As New OleDbCommand("Select * from [Parameters] ", objCon)
        Dim drNewTax As OleDbDataReader = cmd1.ExecuteReader()
        If drNewTax.HasRows Then
            drNewTax.Read()
            If drNewTax("Savelock") = True Then
                'rdbOldTaxRegime.Checked = False
                'btnSubmitNewTax.Enabled = True
                tblInv1.Enabled = False
                txtPAN.Enabled = False  ' txtPAN.Enabled = False varalakshmi - 23-Apr-20 - as per mail request from support
                tblInv2.Enabled = False
                tblHRA.Enabled = False
                tblLandLordAddress.Enabled = False
                tblIncLoss.Enabled = False
                btnSave.Enabled = False
                btnGenerate12BB.Enabled = False
                Exit Sub
            End If
            '    rdbOldTaxRegime.Checked = True
            '    rdbNewTaxRegime.Checked = False
        End If
        objCon.Close()
        If rdbOldTaxRegime.Checked = True Then
            rdbNewTaxRegime.Checked = False

            btnSubmitNewTax.Enabled = False
            tblInv1.Enabled = True
            txtPAN.Enabled = True
            tblInv2.Enabled = True
            tblHRA.Enabled = True
            tblLandLordAddress.Enabled = True
            tblIncLoss.Enabled = True
            btnSave.Enabled = True
            btnGenerate12BB.Enabled = True

        End If
    End Sub

    Protected Sub rdbNewTaxRegime_CheckedChanged(sender As Object, e As EventArgs) Handles rdbNewTaxRegime.CheckedChanged
        objCon.Open()
        Dim cmd1 As New OleDbCommand("Select * from [Parameters] ", objCon)
        Dim drNewTax As OleDbDataReader = cmd1.ExecuteReader()
        Dim intRecords As Integer
        If drNewTax.HasRows Then
            drNewTax.Read()
            If drNewTax("Savelock") = True Then
                'rdbOldTaxRegime.Checked = False
                'btnSubmitNewTax.Enabled = True
                tblInv1.Enabled = False
                txtPAN.Enabled = False  ' txtPAN.Enabled = False varalakshmi - 23-Apr-20 - as per mail request from support
                tblInv2.Enabled = False
                tblHRA.Enabled = False
                tblLandLordAddress.Enabled = False
                tblIncLoss.Enabled = False
                btnSave.Enabled = False
                btnGenerate12BB.Enabled = False
                Exit Sub
            End If
            '    rdbOldTaxRegime.Checked = True
            '    rdbNewTaxRegime.Checked = False
        End If
        objCon.Close()


        If rdbNewTaxRegime.Checked = True Then
            rdbOldTaxRegime.Checked = False
            btnSubmitNewTax.Enabled = True
            tblInv1.Enabled = False
            txtPAN.Enabled = True  ' txtPAN.Enabled = False varalakshmi - 23-Apr-20 - as per mail request from support
            tblInv2.Enabled = False
            tblHRA.Enabled = False
            tblLandLordAddress.Enabled = False
            ' varalakshmi - 22jun-20 - start
            'tblIncLoss.Enabled = False
            tblIncLoss.Enabled = True
            'btnSave.Enabled = False
            btnSave.Enabled = True
            ' varalakshmi - 22jun-20 - end

            btnGenerate12BB.Enabled = False

            ''DisableAll(False)
        End If
    End Sub

    'Protected Sub DisableAll(status As Boolean)
    'For Each ctrl As Control In Form.Controls
    ' If TypeOf ctrl Is Button Then
    ' TryCast(ctrl, Button).Enabled = status
    'End If
    'Next
    ' End Sub

    Protected Sub viewTaxEstimator_Click(sender As Object, e As EventArgs) Handles viewTaxEstimator.Click
        Session("PageName") = "Tax Esimators"
        Response.Redirect("TaxEsimators.aspx")
    End Sub
    Protected Sub btnSubmitNewTax_Click(sender As Object, e As EventArgs) Handles btnSubmitNewTax.Click
        Dim tblRow As New TableRow
        Dim intRecordsAffected As Integer
        adp = New OleDbDataAdapter("select * from TaxNewRegime where employeecode = '" & Session("EmpId") & "'", objCon)
        adp.Fill(dsInv, "Inv")
        If dsInv.Tables("Inv").Rows.Count > 0 Then
            Dim cmd As New OleDbCommand("delete * from taxnewregime where employeecode = '" & Session("EmpId") & "'", objCon)
            objCon.Open()
            cmd.ExecuteNonQuery()
            'objCon.Close()
            adp = New OleDbDataAdapter("insert into [TaxNewRegime](EmployeeCode,EmpInsert) values('" & Session("EmpId") & "'" & ",#" + Date.Now.ToString() + "#)", objCon)
        Else
            adp = New OleDbDataAdapter("insert into [TaxNewRegime](EmployeeCode,EmpInsert) values('" & Session("EmpId") & "'" & ",#" + Date.Now.ToString() + "#)", objCon)
            objCon.Open()
        End If
        intRecordsAffected = adp.SelectCommand.ExecuteNonQuery()
        objCon.Close()

        ' varalakshmi - To update the investment details with 0 while changing from old to new tax regime - 30jun20 - start
        objCon.Open()
        'adp = New OleDbDataAdapter("select ECode from [Details] where ECode='" & Session("EmpID") & "'", objCon)
        'adp.Fill(dsInv, "Inv")
        'adp.SelectCommand.CommandText = "update [Details] set R11001=0 " &
        '                                " where ECode='" & Session("EmpId") & "'"
        adp.SelectCommand.CommandText = "update [details] set R11001= 0,R11002=0,R11003=0,R11004=0,R11005=0,R11006=0,R11007=0,R11008=0,R11009=0,R11010=0,R11011=0,R11012=0,R11013=0,R11014=0,R11015=0,R11016=0,R11017=0,R11018=0,R11019=0,R11020=0,R11021=0,R11022=0,R11023=0,R11024=0,R11025=0, " & _
                                               " R11050=0,R11051=0,R11052=0,D11001=0,D11002=0,D11003=0,D11004=0,D11005=0,D11006=0,D11007=0,D11008=0,D11009=0,D11011=0,D11013=0,80EEA=0,80EEB=0,80CCD_1B=0 where ECode ='" & Session("EmpId") & "'"

        intRecordsAffected = adp.SelectCommand.ExecuteNonQuery
        objCon.Close()

        ' to refresh the values if newtax was submitted
        DirectCast(tblInv2.FindControl("txt80CR11001"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11005"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11007"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11008"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11009"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11015"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11021"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11050"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11051"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CR11053"), System.Web.UI.WebControls.TextBox).[Text] = 0

        DirectCast(tblInv2.FindControl("txt80CD11001"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CD11002"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CD11005"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CD11003"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CD11009"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txtD11006"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txtD11007_1"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txtD11008"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txtD11004"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txtD11013"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80CCD"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80EE"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80TTB"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80EEA"), System.Web.UI.WebControls.TextBox).[Text] = 0
        DirectCast(tblInv2.FindControl("txt80EEB"), System.Web.UI.WebControls.TextBox).[Text] = 0
        ' varalakshmi - 01/07/20
        lblMessage.Text = "Investment declaration will update with 0." & vbNewLine & "Newtax Regime Record Submitted Successfully."
    End Sub
End Class
