﻿Imports System.Data
Imports System.Data.OleDb
Imports System.IO
Imports PdfSharp.Pdf
Imports PdfSharp.Drawing
Imports MigraDoc.Rendering
Imports System.Diagnostics

Partial Class MasterPage
    Inherits System.Web.UI.MasterPage
    'Ver 3.2-E398 Start
    Public Event Print_PDF As EventHandler
    'Ver 3.2-E398 End
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            'ver 3.2-CRK Start
            OleDbConnection.ReleaseObjectPool()
            GC.Collect()
            'ver 3.2-CRK End
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If
            If Session("EmpId") = "Admin" Then
                AdminNav.Visible = True
                AdminUppMnu.Visible = True
                WebUserControl1.Visible = False
                UserMnuUpp.Visible = False
                lnkVersionDetails.Visible = True
            Else
                AdminNav.Visible = False
                AdminUppMnu.Visible = False
                WebUserControl1.Visible = True
                UserMnuUpp.Visible = True
                lnkVersionDetails.Visible = False
            End If
            If Page.IsPostBack = False Then
                ltrCompanyName.Text = Session("CoName")
                Call AddComboItems()
                'If Session("EmpId") = String.Empty Then
                '    Response.Redirect("EmpLogin.aspx")
                'End If

                imgPayLogo.ImageUrl = "~/Images/" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/Paypac.bmp"
                imgPayLogo.AlternateText = Session("CoName")
                Try
                    ltrFY.Text = Session("Period")

                Catch ex As Exception

                End Try
                ltrName.Text = Session("EmpName")
                ltrmsg.Text = Session("PageName")
            End If
            If Page.AppRelativeVirtualPath = "~/EmployeeProofSubmission.aspx" Then '.Contains("employeeproof") Then
                Call AddComboItems()
            End If

            'Call AddComboItems() 'FASTFACTS-617
            ''Ver 3.3-E509 Start-Download Form 16
            'If File.Exists(Session("strPath").ToString() & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "-Form16\" & Session("EmpId").ToString() & Mid(Session("Period"), 1, 4).ToString() & ".pdf") Then
            '    lnkDownloadForm16.Visible = True
            'End If
            ''Ver 3.3-E509 End
            AddScript()
        Catch ex As Exception
            'lblMsg.Text = ex.Message.ToString
        End Try
    End Sub
    'Public Shared Function WriteCss() As String
    '    Dim css As String = General.DefaultCSS
    '    'css = General.GetData(System.Web.HttpContext.Current.Session("StyleCon"), "select CustomizeStyle from stylesheet")
    '    'Ver 3.2-CRK Start
    '    Try
    '        css = HttpContext.Current.Session("CurCss").ToString()
    '    Catch ex As Exception
    '    End Try
    '    'Ver 3.2-CRK End
    '    Return css
    'End Function

    Private Sub AddComboItems()
        Dim myCon As New OleDbConnection(Session("myconnection"))
        Dim QueryCmd As OleDbCommand = New OleDbCommand("select distinct [Period] from [Transaction] " & _
                                                        " where EmpCode='" & Session("EmpId") & "' order by Period desc", myCon)
        Dim objReader As OleDbDataReader
        Try
            myCon.Open()
            'cmbMonth.Items.Clear() 'FASTFACTS-617
            objReader = QueryCmd.ExecuteReader()
            If objReader.HasRows Then
                While objReader.Read
                    cmbMonth.Items.Add(New ListItem(MonthName(Right(objReader(0), 2), False), MonthName(Right(objReader(0), 2), False) & "-" & Mid(objReader(0), 1, 4)))
                End While
            End If
            myCon.Close()
            If Not (Session("cMonth") Is Nothing) Then
                cmbMonth.SelectedValue = MonthName(Val(Right(Session("cMonth"), 2))) & "-" & Left(Session("cMonth"), 4)
            End If
            ltrFY.Text = Session("Period") & " Active Month:" & Session("cMonth")
        Catch ex As Exception
            'lblMsg.Text = ex.Message.ToString
        Finally
            myCon.Close()

        End Try
    End Sub
    'Protected Sub lnkHoliday_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkHoliday.Click
    '    Session("PageName") = "Holiday List"
    '    Response.Redirect("HolidayList.aspx")
    'End Sub

    'Protected Sub lnkContactUs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkContactUs.Click
    '    Session("PageName") = "Contact Us"
    '    Response.Redirect("ContactUs.aspx")
    'End Sub

    'Protected Sub lnkTaxSlab_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkTaxSlab.Click
    '    Session("PageName") = "TaxSlab"
    '    Response.Redirect("TaxSlab.aspx")
    'End Sub
    'Protected Sub lnkChngPassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkChngPassword.Click
    '    Session("PageName") = "Change Password"
    '    Response.Redirect("ChangePassword.aspx")
    'End Sub
    'Protected Sub lnkLogOut_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnklogout.Click
    '    Session.Clear()
    '    Session.Abandon()
    '    Application.Clear()
    '    Response.Redirect("Login.aspx?LogOut=True")
    'End Sub


    Protected Sub lnkPrint_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles lnkPrint.Click
        ' If "Home,PaySlip,LoanList,Leaves Details,Annual Salary Report,Reimbursement Details,Estimation Slip,Investment Declaration".Contains(Session("PageName").ToString()) Then
        If "Home,PaySlip,LoanList,Leaves Details,Annual Salary Report,Reimbursement Details,Estimation Slip,Investment Declaration,Payslip with Rate".Contains(Session("PageName").ToString()) Then
            Session("temp") = hidrpt.Value
            If hidrpt.Value = "" Then
                Alert.Show("No data found.")
                Exit Sub
            End If
            Redirect("printpreview.aspx", "_blank", "menubar=0,width=1,height=1")
        Else
            Alert.Show("Print not required.")
        End If

    End Sub
    Public Sub Redirect(ByVal url As String, ByVal target As String, ByVal windowFeatures As String)
        Dim context As HttpContext = HttpContext.Current

        If ([String].IsNullOrEmpty(target) OrElse target.Equals("_self", StringComparison.OrdinalIgnoreCase)) AndAlso [String].IsNullOrEmpty(windowFeatures) Then

            context.Response.Redirect(url)
        Else
            Dim page As Page = DirectCast(context.Handler, Page)
            If page Is Nothing Then
                Throw New InvalidOperationException("Cannot redirect to new window outside Page context.")
            End If
            url = page.ResolveClientUrl(url)

            Dim script As String
            If Not [String].IsNullOrEmpty(windowFeatures) Then
                script = "window.open(""{0}"", ""{1}"", ""{2}"");"
            Else
                script = "window.open(""{0}"", ""{1}"");"
            End If

            script = [String].Format(script, url, target, windowFeatures)
            ScriptManager.RegisterStartupScript(page, GetType(Page), "Redirect", script, True)
        End If
    End Sub

    Protected Sub lnkDownloadDoc_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDownloadDoc.Click
        Session("PageName") = "Download Document"
        Response.Redirect("DownloadDoc.aspx")
    End Sub

    'Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
    '    Dim tw As New StringWriter()
    '    Server.Execute("printpreview.aspx", tw)
    '    ClassWSThumb.GetWebSiteThumbnail(tw.ToString()).Save("C:\\sh.bmp")
    '    Dim doc As New PdfDocument()
    '    Dim oPage As New PdfPage()

    '    doc.Pages.Add(oPage)
    '    Dim xgr As XGraphics = XGraphics.FromPdfPage(oPage)
    '    Dim img As XImage = XImage.FromFile("C:\\sh.bmp")
    '    xgr.DrawImage(img, 0, 0)
    '    doc.Save("C:\\test.pdf")
    '    doc.Close()
    'End Sub
    'Ver 3.2-E398 Start
    Protected Sub imgPDF_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles imgPDF.Click
        RaiseEvent Print_PDF(Me, EventArgs.Empty)
    End Sub
    'Ver 3.2-E398 End
    'ver 3.3-E501 Start
    'Protected Sub lnkfaq_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkfaq.Click
    '    Response.Redirect("FAQ.aspx")
    'End Sub
    'ver 3.3-E501 End
    'Ver 3.3-E509 Start
    Protected Sub lnkDownloadForm16_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        'Try
        '    If File.Exists(Session("strPath").ToString() & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "-Form16\" & Session("EmpId").ToString() & Mid(Session("Period"), 1, 4).ToString() & ".pdf") Then
        '        Dim byteArray() As Byte = File.ReadAllBytes(Session("strPath").ToString() & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "-Form16\" & Session("EmpId").ToString() & Mid(Session("Period"), 1, 4).ToString() & ".pdf")
        '        HttpContext.Current.Response.ContentType = "Application/pdf"
        '        HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=Form16.pdf")
        '        HttpContext.Current.Response.AddHeader("Content-Length", byteArray.Length.ToString())
        '        HttpContext.Current.Response.ContentType = "application/octet-stream"
        '        HttpContext.Current.Response.BinaryWrite(byteArray)
        '        HttpContext.Current.Response.End()
        '    End If
        'Catch ex As Exception
        '    Alert.Show(ex.Message)
        'End Try
    End Sub
    'Ver 3.3-E509 End

    'tmp
    Protected Sub lnkCreateAdmArea_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkCreateAdmArea.Click
        Session("PageName") = "Create Area Admin"
        Response.Redirect("CreateAdmin.aspx")
    End Sub

    Protected Sub lnkResetEmail_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkResetEmail.Click
        Session("PageName") = "Re-set Password"
        Response.Redirect("Admin.aspx")
    End Sub

    Protected Sub lnkDownloadInvDetails_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDownloadInvDetails.Click
        Session("PageName") = "Download Investment Details"
        Response.Redirect("DownLoad.aspx")
    End Sub

    Protected Sub lnkLogOut_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnklogout.Click
        Session.Clear()
        Session.Abandon()
        Application.Clear()
        Response.Redirect("Login.aspx?LogOut=True")
    End Sub

    Protected Sub lnkDeActivateInvUpd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDeActivateInvUpd.Click
        Session("PageName") = "Deactivate / Activate Investment"
        Response.Redirect("DeActivateUpdate.aspx")
    End Sub
    Public Shared Function WriteCss() As String
        Dim css As String = General.DefaultCSS
        'css = General.GetData(System.Web.HttpContext.Current.Session("StyleCon"), "select CustomizeStyle from stylesheet")
        'Ver 3.2-CRK Start
        Try
            css = HttpContext.Current.Session("CurCss").ToString()
        Catch ex As Exception

        End Try
        'Ver 3.2-CRK End
        Return css
    End Function


    'Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    '    'ver 3.2-CRK Start
    '    OleDbConnection.ReleaseObjectPool()
    '    GC.Collect()
    '    ''ver 3.2-CRK End
    '    'Ver 3.2-3546 Start
    '    If Session("EmpId") = String.Empty Then
    '        Response.Redirect("EmpLogin.aspx")
    '    End If
    '    'Ver 3.2-3546 end
    '    If Session("EmpId") = "Admin" Then
    '        AdminNav.Visible = True
    '        AdminUppMnu.Visible = True
    '        WebUserControl1.Visible = False
    '        UserMnuUpp.Visible = False
    '    Else
    '        AdminNav.Visible = False
    '        AdminUppMnu.Visible = False
    '        WebUserControl1.Visible = True
    '        UserMnuUpp.Visible = True
    '    End If
    '    ltrmsg.Text = Session("PageName").ToString()
    '    ltrFY.Text = Session("Period")
    '    ltrName.Text = Session("EmpID")
    '    imgPayLogo.ImageUrl = "~/Images/" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/Paypac.bmp"
    '    imgPayLogo.AlternateText = Session("CoName")

    '    AddScript()
    'End Sub
    Private Sub AddScript()
        lnkCreateAdmArea.Attributes.Add("onmouseover", "this.className='onover'")
        lnkCreateAdmArea.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkResetEmail.Attributes.Add("onmouseover", "this.className='onover'")
        lnkEmailupdate.Attributes.Add("onmouseover", "this.className='onover'")
        lnkEmailupdate.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkResetEmail.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDownloadInvDetails.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDownloadInvDetails.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDeActivateInvUpd.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDeActivateInvUpd.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkViewQueries.Attributes.Add("onmouseover", "this.className='onover'")
        lnkViewQueries.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkdownloadcsv.Attributes.Add("onmouseover", "this.className='onover'")
        lnkdownloadcsv.Attributes.Add("onmouseout", "this.className='onleave'")
        LinkButton1.Attributes.Add("onmouseover", "this.className='onover'")
        LinkButton1.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkStyle.Attributes.Add("onmouseover", "this.className='onover'")
        lnkStyle.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkCompanyStyle.Attributes.Add("onmouseover", "this.className='onover'")
        lnkCompanyStyle.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkPageRights.Attributes.Add("onmouseover", "this.className='onover'")
        lnkPageRights.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkUDF.Attributes.Add("onmouseover", "this.className='onover'")
        lnkUDF.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkInvCom.Attributes.Add("onmouseover", "this.className='onover'")
        lnkInvCom.Attributes.Add("onmouseout", "this.className='onleave'")

        lnkDeactiveEmp.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDeactiveEmp.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkCommonMSG.Attributes.Add("onmouseover", "this.className='onover'")
        lnkCommonMSG.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDocumentMaster.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDocumentMaster.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkRoleMaster.Attributes.Add("onmouseover", "this.className='onover'")
        lnkRoleMaster.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkUpdateDB.Attributes.Add("onmouseover", "this.className='onover'")
        lnkUpdateDB.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDeactiveEmp.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDeactiveEmp.Attributes.Add("onmouseout", "this.className='onleave'")
        'Ver 3.3-E501 Start
        lnkManageFAQAdmin.Attributes.Add("onmouseover", "this.className='onover'")
        lnkManageFAQAdmin.Attributes.Add("onmouseout", "this.className='onleave'")
        'Ver 3.3-E501 End
    End Sub
    Protected Sub lnkEmailupdate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkEmailupdate.Click
        Session("PageName") = "Email Update"
        Response.Redirect("updateadminmail.aspx")
    End Sub
    Protected Sub lnkViewQueries_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkViewQueries.Click
        Session("PageName") = "View Queries"
        Response.Redirect("ViewPostQueries.aspx")
    End Sub
    Protected Sub lnkdownloadcsv_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkdownloadcsv.Click
        Session("PageName") = "Download Proofs"
        Response.Redirect("DownloadCSV.aspx")
    End Sub

    Protected Sub LinkButton1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LinkButton1.Click
        Session("PageName") = "View Proof"
        Response.Redirect("SelectEmployee.aspx")

    End Sub

    Protected Sub lnkHoliday_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkHoliday.Click
        Session("PageName") = "Holiday List"
        Response.Redirect("HolidayList.aspx")
    End Sub

    Protected Sub lnkContactUs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkContactUs.Click
        Session("PageName") = "Contact Us"
        Response.Redirect("ContactUs.aspx")
    End Sub

    Protected Sub lnkStyle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkStyle.Click
        Session("PageName") = "Employee Area Style"
        Response.Redirect("ChangeStyle.aspx")

    End Sub

    Protected Sub lnkCompanyStyle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkCompanyStyle.Click
        Session("PageName") = "Company Login Style"
        Response.Redirect("CompanyStyle.aspx")
    End Sub

    Protected Sub lnkTaxSlab_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkTaxSlab.Click
        Session("PageName") = "TaxSlab"
        Response.Redirect("TaxSlab.aspx")
    End Sub

    Protected Sub lnkPageRights_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkPageRights.Click
        Session("PageName") = "Page Rights"
        Response.Redirect("PageRights.aspx")
    End Sub

    Protected Sub lnkUDF_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkUDF.Click
        Try
            If Session("udf").ToString() = "" Then
                Alert.Show("udf.mdb is not present")
                Exit Sub
            End If
        Catch ex As Exception
            Alert.Show("udf.mdb is not present")
            Exit Sub
        End Try
        Session("PageName") = "UDF"
        Response.Redirect("UDF.aspx")
    End Sub

    Protected Sub lnkChngPassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkChngPassword.Click
        Session("PageName") = "Change Password"
        'ver 3.3-3766 Start
        'Response.Redirect("ChangeAdminPassword.aspx")
        Response.Redirect("ChangePassword.aspx")
        'ver 3.3-3766 End
    End Sub

    Protected Sub lnkInvCom_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkInvCom.Click
        Session("PageName") = "Investment Component"
        Response.Redirect("InvestmentComponent.aspx")
    End Sub
    ' ver 3.2 Start
    Protected Sub lnkDeactiveEmp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDeactiveEmp.Click
        Session("PageName") = "Deactivate / Activate Login"
        Response.Redirect("DeactivateEmployee.aspx")
    End Sub
    'Ver 3.2-E426 Start
    Protected Sub lnkUpdateDB_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkUpdateDB.Click
        Session("PageName") = "Update Database"
        Response.Redirect("UpdateDatabase.aspx")
    End Sub
    'Ver 3.2-E426 End
    'Ver 3.2-E429 Start-Remove
    Protected Sub lnkRoleMaster_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkRoleMaster.Click
        Session("PageName") = "Role For Document"
        Response.Redirect("RoleMaster.aspx")
    End Sub
    'Ver 3.2-E429 End
    'Ver 3.2-E429 Start-Temp disabled
    Protected Sub lnkDocumentMaster_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDocumentMaster.Click
        Session("PageName") = "Upload Document"
        Response.Redirect("DocumentMaster.aspx")
    End Sub
    'Ver 3.2-E429 End
    'Ver 3.2-3509/3547 Start
    Protected Sub lnkCommonMSG_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkCommonMSG.Click
        Session("PageName") = "Common Message"
        Response.Redirect("CommonMSG.aspx")
    End Sub
    'Ver 3.2-3509/3547 Start
    'ver 3.3-E501 Start
    Protected Sub lnkFAQ_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkfaq.Click
        'imgPDF.Visible = False
        Response.Redirect("FAQ.aspx")

    End Sub
    'ver 3.3-E501 End
    'tmp

    Protected Sub lnkManageFAQAdmin_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkManageFAQAdmin.Click
        Response.Redirect("FAQ.aspx")
    End Sub

   
    Protected Sub lnkAdminLogOut_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkAdminLogOut.Click
        Session.Clear()
        Session.Abandon()
        Application.Clear()
        Response.Redirect("Login.aspx?LogOut=True")
    End Sub

    Protected Sub lnkAdminChangePassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkAdminChangePassword.Click
          Session("PageName") = "Change Password"
        Response.Redirect("ChangeAdminPassword.aspx")
    End Sub

    Protected Sub lnkAdminContactUs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkAdminContactUs.Click
        Session("PageName") = "Contact Us"
        Response.Redirect("ContactUs.aspx")
    End Sub

    Protected Sub lnkAdminHolidayList_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkAdminHolidayList.Click
        Session("PageName") = "Holiday List"
        Response.Redirect("HolidayList.aspx")
    End Sub

    Protected Sub lnkAdminTaxSlap_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkAdminTaxSlap.Click
        Session("PageName") = "TaxSlab"
        Response.Redirect("TaxSlab.aspx")
    End Sub

    Protected Sub lnkVersionDetails_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkVersionDetails.Click
        Response.Redirect("WebmoduleReleaseNotes.rtf")
    End Sub
    'Ver 4.3 FASTFACTS-617 start
    Protected Sub btnPaySlipRate_Click(sender As Object, e As EventArgs) Handles btnPaySlipRate.Click
        Session("PageName") = "Payslip with Rate"
        Response.Redirect("PayslipRate.aspx") 'NewPayRate
        'Response.Redirect("NewPayRate.aspx")
    End Sub

    'Ver 4.3 FASTFACTS-617 end 
    Protected Sub lnkdownloadNewTaxRegime_Click(sender As Object, e As EventArgs) Handles lnkdownloadNewTaxRegime.Click
        Session("PageName") = "Download New Tax Regime"
        Response.Redirect("DownloadNewTaxRegime.aspx")
    End Sub
End Class

