﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing
Partial Class RoleMaster
    Inherits System.Web.UI.Page
    Dim strconn As String
    Dim strEmployeeId As String
    Dim g As General
    Dim arrdate() As String
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        ElseIf StrComp(Session("EmpId"), "Admin") <> 0 Then
            tbldtl.Visible = False
        End If
        Try
            BindData()
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
                btnAdd.Enabled = False
            End If
        End Try

        btnModify.Attributes.Add("onclick", "enbCtrl();")
        btncencel.Attributes.Add("onclick", "disCtrl();ClearCtrl();")
        
        strconn = Session("pwdConnection").ToString()
    End Sub
  
    Function Data(ByVal strQuery As String) As DataSet
        Dim ds As DataSet = New DataSet()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strQuery, Session("pwdConnection").ToString())
        da.Fill(ds)
        Return ds
    End Function
    Protected Function ExicuteDML(ByVal strQuery As String) As Integer
        Dim i As Integer = 0
        Try
            Dim con As OleDbConnection = New OleDbConnection(Session("pwdConnection").ToString())
            Dim cmd As OleDbCommand = New OleDbCommand(strQuery, con)
            con.Open()
            i = cmd.ExecuteNonQuery()
            con.Close()
        Catch ex As Exception
        End Try
        Return i
    End Function

   

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If txtRoleID.Text.Trim() = "" Or txtRoleName.Text.Trim() = "" Then
            Alert.Show("Please enter the value")
            Exit Sub
        End If
        If IsRecordExist() Then
            'ver 2.9-4 Start
            ExicuteDML("update RoleMaster set RoleName='" + txtRoleName.Text.Replace("'", "''") + "',IsActive=" & chkActive.Checked & " where RoleID='" + txtRoleID.Text + "'")
            'ver 2.9-4 end
            lblMessage.Text = "Record Update successfully."
        Else
            'ver 2.9-4 Start
            ExicuteDML("Insert Into RoleMaster (RoleID, RoleName,IsActive) Values ('" & txtRoleID.Text.Replace("'", "''") & "','" + txtRoleName.Text.Replace("'", "''") + "'," & chkActive.Checked & ")")
            'ver 2.9-4 End
            lblMessage.Text = "Record add successfully."
        End If
        BindData()
        lblMessage.ForeColor = Color.Green
    End Sub
    Sub BindData()
        Dim ds As DataSet = Data("SELECT * from RoleMaster ")
        GridView1.DataSource = ds
        GridView1.DataBind()
    End Sub
    Protected Function IsRecordExist() As Boolean
        Dim b As Boolean
        Dim con As OleDbConnection = New OleDbConnection(Session("pwdConnection").ToString())
        Dim cmd As OleDbCommand = New OleDbCommand("select * from RoleMaster where RoleID='" + txtRoleID.Text.Trim() + "'", con)
        con.Open()
        Dim rd As OleDbDataReader = cmd.ExecuteReader()
        b = rd.HasRows
        con.Close()
        Return b
    End Function

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        ExicuteDML("delete from  RoleMaster where  RoleID='" + hdID.Value + "'")
        BindData()
        lblMessage.Text = "Record delete successfully."
        lblMessage.ForeColor = Color.Green
    End Sub
    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView1.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then

            e.Row.Attributes.Add("onclick", "javascript:gvRowClick('" + e.Row.ClientID + "','#E0E0E0','" + GridView1.ClientID + "','" & e.Row.FindControl("chkActive").ClientID & "')")
        End If
    End Sub
    Private Sub ColorRow()
        Try
            For i = 0 To GridView1.Rows.Count
                If (i Mod 2 = 0) Then
                    GridView1.Rows(i).CssClass = "tblAlternetRow"
                End If
            Next
        Catch ex As Exception
        End Try
    End Sub

   
End Class
