﻿<%@ Control Language="VB" AutoEventWireup="false" CodeFile="CCF.ascx.vb" Inherits="UserControls_CCF" %>
<style type="text/css">
    .style1
    {
        width: 213px;
    }
    .lbl
    {
        font-weight: 700;
    }
</style>
<p>
    <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
            <fieldset>
                <legend><b>80CCF</b></legend>
                <asp:Panel ID="Panel1" runat="server">
                    <table>
                        <tr>
                            <td>
                                <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" OnRowCancelingEdit="GridView1_RowCancelingEdit"
                                    CellSpacing="1" OnRowDeleting="GridView1_RowDeleting" OnRowEditing="GridView1_RowEditing"
                                    OnRowUpdating="GridView1_RowUpdating" Width="707px" CellPadding="1" GridLines="None">
                                    <AlternatingRowStyle CssClass="gvAlterNetRowStyle" />
                                    <HeaderStyle CssClass="GrdHeader" HorizontalAlign="Center" />
                                    <Columns>
                                        <asp:TemplateField HeaderText="Sr. No." SortExpression="State">
                                            <ItemTemplate>
                                                <asp:Label ID="lblSrno" runat="server" Text='<%#Container.DataItemIndex + 1%>'></asp:Label>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Name Of 80CCF Holder">
                                            <ItemTemplate>
                                                <asp:Label ID="lblPolicyHolder" runat="server" Text='<%# Bind("NameofCCFHolder") %>'></asp:Label>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="RelationShip" SortExpression="qt">
                                            <ItemTemplate>
                                                <asp:Label ID="lblRelationship" runat="server" Text='<%# Bind("Relationship") %>'></asp:Label>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Date Of Payment" SortExpression="qt">
                                            <ItemTemplate>
                                                <asp:Label ID="lblDateOfPayvment" runat="server" Text='<%# Bind("DateofPayment") %>'></asp:Label>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField ItemStyle-HorizontalAlign="Right" HeaderText="Amount" SortExpression="qt">
                                            <ItemTemplate>
                                                <asp:Label ID="lblAmount" runat="server" Text='<%# Bind("Amount") %>'></asp:Label>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Proof Attach" SortExpression="qt" ItemStyle-HorizontalAlign="Center">
                                            <ItemTemplate>
                                                <asp:CheckBox ID="chkIsProofAttach" Enabled="false" runat="server" Checked='<%# Bind("IsProofAttach") %>' />
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Proof Accepted" SortExpression="qt" ItemStyle-HorizontalAlign="Center">
                                            <ItemTemplate>
                                                <asp:CheckBox ID="chkproofapproved" Enabled="false" runat="server" Checked='<%# Bind("Isproofapproved") %>' />
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Proof Rejected" SortExpression="qt" ItemStyle-HorizontalAlign="Center">
                                            <ItemTemplate>
                                                <asp:CheckBox ID="chkproofreject" Enabled="false" runat="server" Checked='<%# Bind("isproofreject") %>' />
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Reason" SortExpression="qt">
                                            <ItemTemplate>
                                                <asp:TextBox ID="txtReason" Enabled="false" runat="server" CssClass="txtbox" Text='<%# Bind("Reason") %>'
                                                    TextMode="MultiLine"></asp:TextBox>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="Sr. No." SortExpression="State" Visible="false">
                                            <ItemTemplate>
                                                <asp:Label ID="lblSr" runat="server" Text='<%#Bind("SrNo")%>'></asp:Label>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                        <asp:TemplateField HeaderText="" ShowHeader="False">
                                            <EditItemTemplate>
                                                <asp:LinkButton ID="LinkButton1" runat="server" CausesValidation="True" CommandName="Update"
                                                    ForeColor="Red" Text="Update"></asp:LinkButton>
                                                <asp:LinkButton ID="LinkButton2" runat="server" CausesValidation="False" CommandName="Cancel"
                                                    ForeColor="Red" Text="Cancel"></asp:LinkButton>
                                            </EditItemTemplate>
                                            <ItemTemplate>
                                                <asp:LinkButton ID="LinkButton3" runat="server" CausesValidation="False" CommandName="Edit"
                                                    ForeColor="Blue" Text="Edit"></asp:LinkButton>
                                            </ItemTemplate>
                                        </asp:TemplateField>
                                    </Columns>
                                    <PagerStyle BackColor="#284775" ForeColor="White" HorizontalAlign="Center" />
                                    <SelectedRowStyle BackColor="#E2DED6" Font-Bold="True" ForeColor="#333333" />
                                    <EditRowStyle BackColor="#999999" />
                                </asp:GridView>
                            </td>
                        </tr>
                        <tr>
                            <td style="font-weight: bold" align="left">
                                Total 80CCF for the year :&nbsp;
                                <asp:Label ID="txtTotalAmount" Style="text-align: right" runat="server"></asp:Label>
                            </td>
                        </tr>
                    </table>
                </asp:Panel>
            </fieldset>
            </p>
            <table style="width: 99%;">
                <tr>
                    <td class="style1">
                        <asp:Label ID="Label1" CssClass="lbl" runat="server" Text="Name Of 80CCF Holder"></asp:Label>
                    </td>
                    <td>
                        <asp:TextBox ID="txtCCFHolder" runat="server" CssClass="txtbox" Height="16px" Width="144px"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="txtCCFHolder"
                            ErrorMessage="*" ValidationGroup="ccf"></asp:RequiredFieldValidator>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator4" runat="server" ControlToValidate="txtCCFHolder"
                            ErrorMessage="Comma not allowed" ValidationExpression="[^,]+" ValidationGroup="ccf"></asp:RegularExpressionValidator>
                    </td>
                    <td rowspan="11">
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="Label2" runat="server" Text="RelationShip" Style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:DropDownList ID="ddlrelationship" runat="server" CssClass="cnDropDown">
                            <asp:ListItem>Self</asp:ListItem>
                            <asp:ListItem>Spouse</asp:ListItem>
                            <asp:ListItem>Children</asp:ListItem>
                            <asp:ListItem>Guardian</asp:ListItem>
                        </asp:DropDownList>
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <b>
                            <asp:Label ID="Label3" runat="server" Text="Date Of Payment"></asp:Label>
                            &nbsp;(dd-mm-yyyy)</b>
                    </td>
                    <td>
                        <asp:TextBox ID="txtDateOfPayvment" runat="server" CssClass="txtbox" Height="16px"
                            Width="144px"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="txtDateOfPayvment"
                            ErrorMessage="*" ValidationGroup="ccf"></asp:RequiredFieldValidator>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" ControlToValidate="txtDateOfPayvment"
                            ErrorMessage="Date Error" ValidationExpression="^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$"
                            ValidationGroup="ccf"></asp:RegularExpressionValidator>
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="Label4" runat="server" Text="Amount" Style="font-weight: 700"></asp:Label>
                        <img src="<%= Session("img")  %>" />
                    </td>
                    <td>
                        <asp:TextBox ID="txtAmount" Style="text-align: right" CssClass="txtNumbox" runat="server"
                            Height="16px" Width="144px"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator3" runat="server" ControlToValidate="txtAmount"
                            ErrorMessage="*" ValidationGroup="ccf"></asp:RequiredFieldValidator>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator3" runat="server" ControlToValidate="txtAmount"
                            ErrorMessage="Enter proper value" ValidationExpression="^[-+]?[0-9]\d{0,9}(\.\d{1,4})?%?$"
                            ValidationGroup="ccf"></asp:RegularExpressionValidator>
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="Label5" runat="server" Text="Proof Attach" Style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:CheckBox ID="chkProofAttach" runat="server" />
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="lblIsproofapproved" runat="server" Text="Proof Accepted" Visible="False"
                            Style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:CheckBox ID="chkproofapproved" runat="server" />
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="lblisproofreject" runat="server" Text="Proof Rejected" Visible="False"
                            Style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:CheckBox ID="chkproofreject" runat="server" />
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="lblreson" runat="server" Text="Reason" Visible="False" Style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:TextBox ID="txtReason" runat="server" Width="144px" Visible="False" Height="21px"
                            CssClass="txtbox"></asp:TextBox>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator5" runat="server" ControlToValidate="txtReason"
                            ErrorMessage="Comma not allowed" ValidationExpression="[^,]+" ValidationGroup="ccf"></asp:RegularExpressionValidator>
                    </td>
                </tr>
                <tr>
                    <td align="center" colspan="2">
                        <asp:UpdateProgress ID="sa" runat="server" AssociatedUpdatePanelID="UpdatePanel1">
                            <ProgressTemplate>
                                <div style="color: Red; width: 159px;">
                                    <asp:Image ID="Image1" runat="server" ImageUrl="~/IMAGES/loading.gif" />
                                    &nbsp;&nbsp;&nbsp;<b>Please Wait.. </b>
                                </div>
                            </ProgressTemplate>
                        </asp:UpdateProgress>
                    </td>
                </tr>
                <tr>
                    <td align="left" colspan="2">
                        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <asp:Button ID="btnAdd" runat="server" Text="Add" ValidationGroup="ccf" Width="66px" />
                        <asp:Button ID="btnSave" runat="server" Enabled="False" Text="Save" ValidationGroup="ccf"
                            Width="75px" />
                        <asp:Button ID="btnDelete" runat="server" Enabled="False" Text="Delete" ValidationGroup="ccf"
                            Width="60px" />
                    </td>
                </tr>
                <tr>
                    <td align="center" colspan="2">
                        <asp:Label ID="lblMessage" runat="server" Style="font-weight: 700"></asp:Label>
                    </td>
                </tr>
            </table>
            <asp:HiddenField ID="hdsrno" runat="server" />
        </ContentTemplate>
    </asp:UpdatePanel>

    <script type="text/javascript">
function validate()
{
var p;
var q;
var v=document.getElementById("<%=txtAmount.ClientID%>").value;
if(v!="")
p=parseFloat(v);
else
p=0;

var x=document.getElementById("<%=txtTotalAmount.ClientID %>").innerHTML;
if(x!="")
q=parseFloat(x);
else
q=0;
var num=p+q;
if(num>20000)
{
document.getElementById("<%=txtAmount.ClientID%>").value="0";
alert("80CCF Maximum limit is Rs. 20,000/-");
}
}
<!--
//    function chkacp()
//    {
//        if(document.getElementById("<%=chkproofreject.ClientID %>").checked==true){
//        document.getElementById("<%=chkproofreject.ClientID %>").checked=false;}
//        alert("tt");
//    }
//    function chkreg()
//    {
//        if(document.getElementById("<%=chkproofapproved.ClientID %>").checked==true){
//        document.getElementById("<%=chkproofapproved.ClientID %>").checked=false;}
//        alert("tt1");
//    }

    function panelUpdated(){
        // Ver 4.1-QC1135 start
        if (document.getElementById("<%=chkproofreject.ClientID %>") != null) {
            // Ver 4.1-QC1135 end 
            document.getElementById("<%=chkproofreject.ClientID %>").onclick =function()
            {
                if(document.getElementById("<%=chkproofapproved.ClientID %>").checked==true){
                    document.getElementById("<%=chkproofapproved.ClientID %>").checked=false;}
           
            };
        }
        // Ver 4.1-QC1135 start
        if (document.getElementById("<%=chkproofreject.ClientID %>") != null) {
            // Ver 4.1-QC1135 end 
            document.getElementById("<%=chkproofapproved.ClientID %>").onclick =function()
            {
                if(document.getElementById("<%=chkproofreject.ClientID %>").checked==true){
                    document.getElementById("<%=chkproofreject.ClientID %>").checked=false;}
          
            };
        }
    }
    
    var appInst = Sys.WebForms.PageRequestManager.getInstance();
    appInst.add_endRequest(panelUpdated);
  
    panelUpdated();
-->
    </script>

    