Imports System.Data
Imports System.Data.OleDb
Imports System.IO

Partial Class ViewPost
    Inherits System.Web.UI.Page

    Dim dsProfile As DataSet
    Dim sqlCon As OleDbConnection
    Dim sqlCmd As OleDbCommand
    Dim adpQuery As New OleDbDataAdapter
    Dim dsQuery As New DataSet

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try

            Dim strPath As String

            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If

            strPath = Server.MapPath("App_Data") & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2)

            If File.Exists(strPath & "\PostQuery.mdb") Then
                sqlCon = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & strPath & "\PostQuery.mdb;jet OLEDB:Database Password=Ffcs")
            End If
            Call FillGrid(ddlSort.SelectedItem.Value)
            ColorRow()
        Catch ex As Exception

        End Try

    End Sub

    Private Sub FillGrid(ByVal Sortstr As String)
        If Sortstr = "All" Then
            Sortstr = "Where SrNo in (SELECT max(srNo) FROM PostQueryDetails group by qryid) "
        End If
        If Sortstr = "Pending" Then
            Sortstr = "where  Replydatetime is null and Replytext is null and  SrNo in (SELECT max(srNo) FROM PostQueryDetails group by qryid)"
        End If
        If Sortstr = "AlreadyReplied" Then
            Sortstr = " where  Replydatetime<>null and Replytext<>'' and  SrNo in (SELECT max(srNo) FROM PostQueryDetails group by qryid)"
        End If
        Dim intECnt As Integer

        Dim tblRow As TableRow
        Dim tblCol As TableCell
        Dim tblHeadRow As TableHeaderRow
        Dim tblHeaderCol As TableHeaderCell

        Try
            tblHeadRow = New TableHeaderRow
            tblQueries.Rows.Add(tblHeadRow)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Sr. No."
            tblHeadRow.Cells.Add(tblHeaderCol)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Date"
            tblHeadRow.Cells.Add(tblHeaderCol)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Subject"
            tblHeadRow.Cells.Add(tblHeaderCol)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Click to Reply"
            tblHeadRow.Cells.Add(tblHeaderCol)

            adpQuery = New OleDbDataAdapter("SELECT SrNo, format([DateTime],'dd/MM/yyyy') as [Date], [Subject] ,ReplyText,ReplyDateTime FROM PostQueryDetails  " + Sortstr + " order by [DateTime] desc", sqlCon)

            adpQuery.Fill(dsQuery, "PostQuery")
            intECnt = Val(dsQuery.Tables("PostQuery").Rows.Count)

            With dsQuery.Tables("PostQuery")
                For intI As Integer = 0 To .Rows.Count - 1

                    tblRow = New TableRow
                    tblQueries.Rows.Add(tblRow)

                    tblCol = New TableCell
                    tblCol.Text = intI + 1
                    tblRow.Cells.Add(tblCol)

                    tblCol = New TableCell
                    tblCol.Text = .Rows(intI).Item("Date")
                    tblRow.Cells.Add(tblCol)

                    tblCol = New TableCell
                    tblCol.Text = .Rows(intI).Item("Subject")
                    tblRow.Cells.Add(tblCol)

                    tblCol = New TableCell
                    Dim hl As New HyperLink
                    hl.ForeColor = Drawing.Color.Blue
                    If IsDBNull(.Rows(intI).Item("ReplyText")) = False And IsDBNull(.Rows(intI).Item("ReplyDateTime")) = False Then

                        hl.Text = "Already Replied"

                    Else

                        hl.Text = "Reply "

                    End If

                    hl.NavigateUrl = "ReplyDetails.aspx?SrNo=" & .Rows(intI).Item("SrNo") & ""
                    hl.Attributes.Add("onclick", "javascript:window.open('" & "ReplyDetails.aspx?SrNo=" & .Rows(intI).Item("SrNo") & "','Reply','toolbar=no, directories=no, resizable=no, width=590, height=560'); return false")
                    hl.Target = "_Blank"
                    hl.CssClass = "link"
                    hl.Font.Bold = True
                    tblCol.Controls.Add(hl)
                    tblRow.Cells.Add(tblCol)

                Next

                'If dsQuery.Tables("PostQuery").Rows.Count > 0 Then

                'gvQueries.DataSource = dsQuery.Tables("PostQuery")
                'gvQueries.DataBind()

                'End If
            End With

            tblHeadRow.CssClass = "GrdHeader"
            lblMsg.Text = "No. of Queries : " & intECnt

        Catch ex As Exception
            '            MsgBox(ex.Message.ToString)
        End Try

    End Sub
    Private Sub ColorRow()
        Try
            For i = 1 To tblQueries.Rows.Count()
                If (i Mod 2 = 0) Then
                    tblQueries.Rows(i).CssClass = "tblAlternetRow"
                End If
            Next
        Catch ex As Exception
        End Try
    End Sub
    
End Class
