﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Collections.Generic
Partial Class WebUserControlUDF
    Inherits System.Web.UI.UserControl
    Dim lstField As New List(Of String)
    Dim dtemp As New DataTable
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Ver 3.2-3546 Start
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        End If
        'Ver 3.2-3546 End
        If Not Page.IsPostBack Then
            Session("udfmsg") = ""
        End If
        Try
            Dim dt As DataTable = General.GetDataTable(Session("udf").ToString(), "select * from UDF")
            Dim i As Integer = 0
            dtemp = General.GetDataTable(Session("udf").ToString(), "select * from udffields where empcode='" & Session("EmpId").ToString() & "'")
            CreateUI(dt)
        Catch ex As Exception

        End Try
    End Sub
    Sub CreateUI(ByVal dt As DataTable)
        'Me.Controls.Add(New LiteralControl("<div class='GrdHeader' style='height:25px;width:500px;text-align:center;'><span class='onover'>Description</span></div>"))
        Me.Controls.Add(New LiteralControl("<table border='0' cellspacing='2' cellpadding='2' style='width:550px;'><tr class='onover'><td style='width:248px;'>Description</td><td>Values</td></tr>"))
        Dim i As Integer = 0
        For i = 0 To dt.Rows.Count - 1
            Dim css As String = ""
            If i Mod 2 = 0 Then
                css = "tblAlternetRow"
            End If
            Me.Controls.Add(New LiteralControl("<tr class='" & css & "'><td>"))
            Me.Controls.Add(New LiteralControl(dt.Rows(i)(0).ToString()))
            Me.Controls.Add(New LiteralControl("</td><td>"))
            Me.Controls.Add(GetControl(dt.Rows(i)(0).ToString(), dt.Rows(i)(1).ToString()))
            Me.Controls.Add(GetValidateControl(dt.Rows(i)(0).ToString(), dt.Rows(i)(1).ToString()))
            Me.Controls.Add(New LiteralControl("</td></tr>"))
        Next
        Me.Controls.Add(New LiteralControl("</table>"))
        Dim btn As New Button
        btn.Text = "Submit"
        btn.ValidationGroup = "udf"
        Me.Controls.Add(btn)
        AddHandler btn.Click, AddressOf btn_Click
    End Sub
    Protected Sub btn_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim msg = ""
        If dtemp.Rows.Count = 0 Then
            msg = ExecuteQry(Session("udf").ToString(), GetInsertQry(lstField))
            If msg = "" Then
                Me.Controls.Add(New LiteralControl("<br/><span style='color:Red;font-weight:bold'>Record inserted successfully.</span><br/>"))
            Else
                Me.Controls.Add(New LiteralControl(msg))
            End If

        ElseIf dtemp.Rows.Count = 1 Then
            msg = ExecuteQry(Session("udf").ToString(), GetUpdateQry(lstField))
            If msg = "" Then
                Me.Controls.Add(New LiteralControl("<br/><span style='color:Red;font-weight:bold'>Record updated successfully.</span><br/>"))
            Else
                Me.Controls.Add(New LiteralControl(msg))
            End If
        Else
            Alert.Show("Multipal Record Found.Please Check Database.")
        End If

    End Sub
    Function GetControl(ByVal Name As String, ByVal Type As String) As Control
        Dim c As Control = New LiteralControl("")
        If Type = "YesNo" Then
            Dim chk As New CheckBox
            chk.ID = "chk" & Name
            Try
                chk.Checked = Convert.ToBoolean(dtemp.Rows(0)(Name))
            Catch ex As Exception
            End Try
            lstField.Add(chk.ID & ";" & Type)
            c = chk
        Else
            Dim txt As New TextBox
            txt.ID = "txt" & Name
            txt.CssClass = "txtbox"
            Try
                txt.Text = dtemp.Rows(0)(Name).ToString()
                If Type = "DateTime" Then
                    txt.Text = Convert.ToDateTime(dtemp.Rows(0)(Name).ToString()).ToString("dd/MM/yyyy")
                End If
            Catch ex As Exception
            End Try
            lstField.Add(txt.ID & ";" & Type)
            c = txt
        End If
        Return c
    End Function
    Function GetValidateControl(ByVal Name As String, ByVal Type As String) As Control
        Dim c As Control = New LiteralControl("")
        Dim rg As New RegularExpressionValidator
        rg.ID = "rg" & Name
        rg.ValidationGroup = "udf"
        If Type = "Number" Then
            'var 3.0 start
            Dim rg1 As New RequiredFieldValidator
            rg1.ControlToValidate = "txt" & Name
            rg1.ErrorMessage = "*"
            rg1.ValidationGroup = "udf"
            ' Me.Controls.Add(rg1)
            'var 3.0 End
            rg.ControlToValidate = "txt" & Name
            rg.ValidationExpression = "^[-+]?[0-9]\d{0,9}(\.\d{1,4})?%?$"
            rg.ErrorMessage = "Accept Numeric"
            c = rg
        ElseIf Type = "DateTime" Then
            'var 3.0 start
            Dim rg1 As New RequiredFieldValidator
            rg1.ControlToValidate = "txt" & Name
            rg1.ErrorMessage = "*"
            rg1.ValidationGroup = "udf"
            ' Me.Controls.Add(rg1)
            'var 3.0 End
            rg.ControlToValidate = "txt" & Name
            rg.ValidationExpression = "^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$"
            rg.ErrorMessage = "Accept Date"
            c = rg
        ElseIf Type = "Text" Then
            rg.ControlToValidate = "txt" & Name
            rg.ValidationExpression = "([a-z]|[A-Z]|[0-9]|[ ]|[-]|[_]|[@]|[$]|[%]|[&]|[=]|[+]|[-]|[(]|[)])*"
            rg.ErrorMessage = "Special characte not allow."
            c = rg
        End If
        Return c
    End Function
    Function GetInsertQry(ByVal lst As List(Of String)) As String
        Dim i As Integer = 0
        Dim strqry As String = "insert into udffields values('" & Session("EmpId").ToString() & "',#" & DateTime.Now.ToString("yyyy-MM-dd") & "#,"
        For i = 0 To lst.Count - 1
            Dim strarr() As String = lst(i).Split(";")
            If strarr(1) = "YesNo" Then
                strqry = strqry & CType(Me.FindControl(strarr(0)), CheckBox).Checked.ToString() & ","
            Else
                Dim s As String = CType(Me.FindControl(strarr(0)), TextBox).Text

                If strarr(1) = "DateTime" Then
                    If s.Trim() = "" Then
                        strqry = strqry & "null,"
                    Else
                        strqry = strqry & "#" & s & "#,"
                    End If

                ElseIf strarr(1) = "Number" Then
                    If s.Trim() = "" Then
                        strqry = strqry & "null,"
                    Else
                        strqry = strqry & s & ","
                    End If
                ElseIf strarr(1) = "Text" Then
                    strqry = strqry & "'" & s & "',"

                    End If
            End If
        Next
        strqry = strqry.Remove(strqry.Length - 1) & ")"
        Return strqry
    End Function
    Function GetUpdateQry(ByVal lst As List(Of String)) As String
        Dim i As Integer = 0
        Dim strqry As String = "Update udffields set CurDate=#" & DateTime.Now.ToString("yyyy-MM-dd") & "#,"
        Dim flds As String = ""
        For i = 0 To lst.Count - 1
            Dim strarr() As String = lst(i).Split(";")
            If strarr(1) = "YesNo" Then
                strqry = strqry & "[" & strarr(0).Substring(3) & "]=" & CType(Me.FindControl(strarr(0)), CheckBox).Checked.ToString() & ","
            Else
                Dim s As String = CType(Me.FindControl(strarr(0)), TextBox).Text

                If strarr(1) = "DateTime" Then
                    If s.Trim() = "" Then
                        strqry = strqry & "[" & strarr(0).Substring(3) & "]=null,"
                    Else
                        strqry = strqry & "[" & strarr(0).Substring(3) & "]=" & "#" & s & "#,"
                    End If
                ElseIf strarr(1) = "Number" Then
                    If s.Trim() = "" Then
                        strqry = strqry & "[" & strarr(0).Substring(3) & "]=null,"
                    Else
                        strqry = strqry & "[" & strarr(0).Substring(3) & "]=" & s & ","
                    End If

                ElseIf strarr(1) = "Text" Then
                    strqry = strqry & "[" & strarr(0).Substring(3) & "]=" & "'" & s & "',"
                End If
            End If

        Next
        strqry = strqry.Remove(strqry.Length - 1) & " where empcode='" & Session("EmpId").ToString() & "'"
        Return strqry
    End Function
    Public Function ExecuteQry(ByVal strCon As String, ByVal strQuery As String) As String
        Dim i As Int16
        Dim con As New OleDbConnection(strCon)
        Dim strmsg = ""
        Try
            Dim cmd As New OleDbCommand(strQuery, con)
            con.Open()
            i = cmd.ExecuteNonQuery()
            con.Close()
        Catch ex As Exception
            strmsg = "<br/><span style='color:Red;font-weight:bold'>" & ex.Message & ".</span><br/>"
            'ver 3.2-CRK Start
        Finally
            con.Close()
            'ver 3.2-CRK End
        End Try
        Return strmsg
    End Function
End Class
