﻿
$(document ).ready(function (){

    if($('#'+txtCustCreatedOn.id).length>0){
     
    $('#'+txtCustCreatedOn.id).datepicker({
	    changeMonth: true,
	    changeYear: true,
	    yearRange:'-200:0'
    });
    
    $('#'+txtCustCreatedOn.id).blur(function(){
       if(!isDate(this.value)) this.value = "";
    });
    }
    
    if ($("#"+txtSearch.id).length>0){
    $("#"+txtSearch.id).autocomplete("GetData.aspx",
        {
            delay: 30,
            minChars: 2,            
            onItemSelect: selectItem,            
            formatItem: formatItem,
            autoFill: true,
            mustMatch:true,
            multipleSeparator:"| ",
            extraParams:{
                  0:"SEARCH",
                  1:function () {return txtSearch.value;}

            },
            maxItemsToShow: 20
            
            //********* Set the Result Format ************            

            //            ,
            //            formatResult: function(row) 
            //                {
            //                //$("#"+hidCode.id).val(row[1]);
            //                //$("#"+TextBox1.id).val(row[1]);                
            //                return row[0];
            //                
            //                }
                

        }
    );            
    
    $("#"+txtSearch.id).result(function(event,data) { 
             $("#"+hidCode.id).val(data[1]);
             $("#"+hidBranch.id).val(data[2]);
             
    });     
    }
    
    if ($("#"+txtCustCity.id).length>0){
    $("#"+txtCustCity.id).autocomplete("GetData.aspx",
        {
        
            delay: 30,
            minChars: 1,
            onItemSelect: selectItem,
            formatItem: formatCityItem,
            autoFill: true,
            mustMatch:false,
            //multipleSeparator:"| ",
            extraParams:{
                  0:"CITY",
                  1:function () {return txtCustCity.value;}

            },
            maxItemsToShow: 20
        }
    );
    }
    
    if ($("#"+txtCustGCName.id).length>0){
            $("#"+txtCustGCName.id).blur(function(){
                
                if (txtCustGCName.value=="") return null;
                
                if (txtCustOldName.value.toLowerCase()==txtCustGCName.value.toLowerCase())
                {
                    alert("Group Company Name and Formely known as should not be same.");
                    txtCustOldName.focus();
                }
                
            });
            }
            
            if ($("#"+txtCustName.id).length>0){
            $("#"+txtCustName.id).blur(function(){
                
                if (txtCustName.value=="") return null;
                
                if (txtCustOldName.value.toLowerCase()==txtCustName.value.toLowerCase())
                {
                    alert("Name and Formely known as should not be same.");
                    txtCustOldName.focus();
                }
                
            });
            }
            
    $("#"+btnCustSave.id).click(function(){
        
        if (txtCustOldName.value=="" && txtCustGCName.value=="") return null;
        
        
        if (txtCustOldName.value.replace(/^\s+/, "").replace(/\s+$/, "").toLowerCase()==txtCustName.value.replace(/^\s+/, "").replace(/\s+$/, "").toLowerCase())
        {
            alert("Name and Formely known as should not be same.");
            txtCustOldName.focus();
        }
        else if (txtCustOldName.value.replace(/^\s+/, "").replace(/\s+$/, "").toLowerCase()==txtCustGCName.value.replace(/^\s+/, "").replace(/\s+$/, "").toLowerCase())
        {
            alert("Group Company Name and Formely known as should not be same.");
            txtCustOldName.focus();
        }
        
    });
    
    
    $("#"+txtCustBoardNo.id).blur(function(){
        
        if (ValidateTelNums(txtCustBoardNo,"-",20)==false)
        {
            alert("Please Enter Proper Board Number.");
            txtCustBoardNo.focus();
        }
        
    });
                         
    $("#"+txtCustPAN.id).blur(function(){
        var pan=/^[A-Za-z]{3}[ABCFGHJLPTabcfghjlpt]{1}[A-Za-z]{1}[0-9]{4}[A-Za-z]{1}$/; 
        
        if (txtCustPAN.value!="")
        {
            var OK = pan.exec(txtCustPAN.value);                   
            if (!OK)                   
            {   
                var tan=/^[A-Za-z]{4}[0-9]{5}[A-Za-z]{1}$/; 
                var TANOk = tan.exec(txtCustPAN.value)
                
                if (!TANOk)
                {
                    alert ("Please enter a valid PAN / TAN");
                    txtCustPAN.focus();
                }
            }
        }
    });    
    
    $("#"+txtCustName.id).blur(function(){                
        var strValue=txtCustName.value;        
        if (strValue!="")
        {
            var str=strValue.split(" ");
            //int i=0;            
            strValue="";
            for (i=0;i<str.length;i++)
            {
                str[i]=str[i].replace(/^\s+/, "").replace(/\s+$/, "");
                if (str[i].length==1)
                    if (str[i]!="&")
                        str[i]+=".";
                else if (str[i].length>1 && (str[i].substr(0,2).toUpperCase()=="MR" || str[i].substr(0,2).toUpperCase()=="MS"))
                    str[i]="";
                
                //alert(str[i]);
                
                strValue+= str[i] + " ";
            }
            //strValue=strValue.value.replace(/^\s+/, "").replace(/\s+$/, "");
            txtCustName.value=strValue.replace(/^\s+/, "").replace(/\s+$/, "");
            return strValue;
        }
        });
 
});

function findValue(li) {
    if (li == null) return aler("No match!");    
    if (!!li.extra) var sValue = li.extra[0];
    else var sValue = li.selectValue;  
    return sValue; 
}


function ValidateTelNums(ctrl,length) {

    var regEx=/^[0-9]+[-]?[0-9]+$/;
    
    var NumOk = regEx.exec(ctrl.value);
    
    return NumOk;
}

function selectItem(li) {
    $("#"+hidID.id).val(findValue(li));                 
}

function formatItem(row) {
    return row[0] + " (Code: " + row[1] + ") (Branch: " + row[2] + ")";
    
}

function formatCityItem(row) {
    return row[0]; 
    
}



