﻿Imports System.Data
Imports System.Data.OleDb
Partial Class AdminMasterPage
    Inherits System.Web.UI.MasterPage

    Protected Sub lnkCreateAdmArea_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkCreateAdmArea.Click
        Session("PageName") = "Create Area Admin"
        Response.Redirect("CreateAdmin.aspx")
    End Sub

    Protected Sub lnkResetEmail_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkResetEmail.Click
        Session("PageName") = "Re-set Password"
        Response.Redirect("Admin.aspx")
    End Sub

    Protected Sub lnkDownloadInvDetails_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDownloadInvDetails.Click
        Session("PageName") = "Download Investment Details"
        Response.Redirect("DownLoad.aspx")
    End Sub

    Protected Sub lnkLogOut_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnklogout.Click
        Session.Clear()
        Session.Abandon()
        Application.Clear()
        Response.Redirect("Login.aspx?LogOut=True")
    End Sub

    Protected Sub lnkDeActivateInvUpd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDeActivateInvUpd.Click
        Session("PageName") = "Deactivate / Activate Investment"
        Response.Redirect("DeActivateUpdate.aspx")
    End Sub
    Public Shared Function WriteCss() As String
        Dim css As String = General.DefaultCSS
        'css = General.GetData(System.Web.HttpContext.Current.Session("StyleCon"), "select CustomizeStyle from stylesheet")
        'Ver 3.2-CRK Start
        Try
            css = HttpContext.Current.Session("CurCss").ToString()
        Catch ex As Exception

        End Try
        'Ver 3.2-CRK End
        Return css
    End Function


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'ver 3.2-CRK Start
        OleDbConnection.ReleaseObjectPool()
        GC.Collect()
        ''ver 3.2-CRK End
        'Ver 3.2-3546 Start
        If Session("EmpId") = String.Empty Then
            Response.Redirect("EmpLogin.aspx")
        End If
        'Ver 3.2-3546 end
        ltrmsg.Text = Session("PageName").ToString()
        ltrFY.Text = Session("Period")
        ltrName.Text = Session("EmpID")
        imgPayLogo.ImageUrl = "~/Images/" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "/Paypac.bmp"
        imgPayLogo.AlternateText = Session("CoName")

        AddScript()
    End Sub
    Private Sub AddScript()
        lnkCreateAdmArea.Attributes.Add("onmouseover", "this.className='onover'")
        lnkCreateAdmArea.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkResetEmail.Attributes.Add("onmouseover", "this.className='onover'")
        lnkEmailupdate.Attributes.Add("onmouseover", "this.className='onover'")
        lnkEmailupdate.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkResetEmail.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDownloadInvDetails.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDownloadInvDetails.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDeActivateInvUpd.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDeActivateInvUpd.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkViewQueries.Attributes.Add("onmouseover", "this.className='onover'")
        lnkViewQueries.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkdownloadcsv.Attributes.Add("onmouseover", "this.className='onover'")
        lnkdownloadcsv.Attributes.Add("onmouseout", "this.className='onleave'")
        LinkButton1.Attributes.Add("onmouseover", "this.className='onover'")
        LinkButton1.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkStyle.Attributes.Add("onmouseover", "this.className='onover'")
        lnkStyle.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkCompanyStyle.Attributes.Add("onmouseover", "this.className='onover'")
        lnkCompanyStyle.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkPageRights.Attributes.Add("onmouseover", "this.className='onover'")
        lnkPageRights.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkUDF.Attributes.Add("onmouseover", "this.className='onover'")
        lnkUDF.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkInvCom.Attributes.Add("onmouseover", "this.className='onover'")
        lnkInvCom.Attributes.Add("onmouseout", "this.className='onleave'")

        lnkDeactiveEmp.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDeactiveEmp.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkCommonMSG.Attributes.Add("onmouseover", "this.className='onover'")
        lnkCommonMSG.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDocumentMaster.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDocumentMaster.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkRoleMaster.Attributes.Add("onmouseover", "this.className='onover'")
        lnkRoleMaster.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkUpdateDB.Attributes.Add("onmouseover", "this.className='onover'")
        lnkUpdateDB.Attributes.Add("onmouseout", "this.className='onleave'")
        lnkDeactiveEmp.Attributes.Add("onmouseover", "this.className='onover'")
        lnkDeactiveEmp.Attributes.Add("onmouseout", "this.className='onleave'")
        'Ver 3.3-E501 Start
        lnkFAQ.Attributes.Add("onmouseover", "this.className='onover'")
        lnkFAQ.Attributes.Add("onmouseout", "this.className='onleave'")
        'Ver 3.3-E501 End
    End Sub
    Protected Sub lnkEmailupdate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkEmailupdate.Click
        Session("PageName") = "Email Update"
        Response.Redirect("updateadminmail.aspx")
    End Sub
    Protected Sub lnkViewQueries_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkViewQueries.Click
        Session("PageName") = "View Queries"
        Response.Redirect("ViewPostQueries.aspx")
    End Sub
    Protected Sub lnkdownloadcsv_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkdownloadcsv.Click
        Session("PageName") = "Download Proofs"
        Response.Redirect("DownloadCSV.aspx")
    End Sub

    Protected Sub LinkButton1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LinkButton1.Click
        Session("PageName") = "View Proof"
        Response.Redirect("SelectEmployee.aspx")

    End Sub

    Protected Sub lnkHoliday_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkHoliday.Click
        Session("PageName") = "Holiday List"
        Response.Redirect("HolidayList.aspx")
    End Sub

    Protected Sub lnkContactUs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkContactUs.Click
        Session("PageName") = "Contact Us"
        Response.Redirect("ContactUs.aspx")
    End Sub

    Protected Sub lnkStyle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkStyle.Click
        Session("PageName") = "Employee Area Style"
        Response.Redirect("ChangeStyle.aspx")

    End Sub

    Protected Sub lnkCompanyStyle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkCompanyStyle.Click
        Session("PageName") = "Company Login Style"
        Response.Redirect("CompanyStyle.aspx")
    End Sub

    Protected Sub lnkTaxSlab_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkTaxSlab.Click
        Session("PageName") = "TaxSlab"
        Response.Redirect("TaxSlab.aspx")
    End Sub

    Protected Sub lnkPageRights_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkPageRights.Click
        Session("PageName") = "Page Rights"
        Response.Redirect("PageRights.aspx")
    End Sub

    Protected Sub lnkUDF_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkUDF.Click
        Try
            If Session("udf").ToString() = "" Then
                Alert.Show("udf.mdb is not present")
                Exit Sub
            End If
        Catch ex As Exception
            Alert.Show("udf.mdb is not present")
            Exit Sub
        End Try
        Session("PageName") = "UDF"
        Response.Redirect("UDF.aspx")
    End Sub

    Protected Sub lnkChngPassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkChngPassword.Click
        Session("PageName") = "Change Password"
        Response.Redirect("ChangeAdminPassword.aspx")
    End Sub

    Protected Sub lnkInvCom_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkInvCom.Click
        Session("PageName") = "Investment Component"
        Response.Redirect("InvestmentComponent.aspx")
    End Sub
    ' ver 3.2 Start
    Protected Sub lnkDeactiveEmp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDeactiveEmp.Click
        Session("PageName") = "Deactivate / Activate Login"
        Response.Redirect("DeactivateEmployee.aspx")
    End Sub
    'Ver 3.2-E426 Start
    Protected Sub lnkUpdateDB_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkUpdateDB.Click
        Session("PageName") = "Update Database"
        Response.Redirect("UpdateDatabase.aspx")
    End Sub
    'Ver 3.2-E426 End
    'Ver 3.2-E429 Start-Remove
    Protected Sub lnkRoleMaster_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkRoleMaster.Click
        Session("PageName") = "Role For Document"
        Response.Redirect("RoleMaster.aspx")
    End Sub
    'Ver 3.2-E429 End
    'Ver 3.2-E429 Start-Temp disabled
    Protected Sub lnkDocumentMaster_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkDocumentMaster.Click
        Session("PageName") = "Upload Document"
        Response.Redirect("DocumentMaster.aspx")
    End Sub
    'Ver 3.2-E429 End
    'Ver 3.2-3509/3547 Start
    Protected Sub lnkCommonMSG_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkCommonMSG.Click
        Session("PageName") = "Common Message"
        Response.Redirect("CommonMSG.aspx")
    End Sub
    'Ver 3.2-3509/3547 Start
    'ver 3.3-E501 Start
    Protected Sub lnkFAQ_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkFAQ.Click
        Response.Redirect("FAQ.aspx")
    End Sub
    'ver 3.3-E501 End
End Class

