Imports Microsoft.VisualBasic
Imports System.Data
Imports System.Data.OleDb
Imports System
Imports System.Collections.Generic

Public Class General
    Public Shared DefaultCSS As String = "body {	font-family: Verdana, Arial, Helvetica, sans-serif;	font-size: 12px;	line-height: 21px;	color: #000000;	text-decoration: none;		margin: 0px;	width :100%;	height :100%;	}.lnk{	font-family: Tahoma, Geneva, sans-serif;	font-size: 11px;		color: #397eca;	text-decoration: none;	line-height: 18px;	text-indent:30px;}.onover {		font-family: Tahoma, Geneva, sans-serif;	font-size: 11.2px;		color: #FFFFFF;	font-weight:bold;	text-decoration: none;		text-indent:30px;	background-color:#C0C0C0;}.onleave {		font-family: Tahoma, Geneva, sans-serif;	font-size: 11.2px;		color: #666666;	font-weight:bold;	text-decoration: none;		text-indent:30px;	background-color:White;	}.menulnk{	font-family: Tahoma, Geneva, sans-serif;	font-size: 11.2px;		color: #666666;	font-weight:bold;	text-decoration: none;		text-indent:30px;}.text_blue {	font-family: Tahoma, Geneva, sans-serif;	font-size: 11.2px;	font-weight: normal;	color: #1d3f65;	text-decoration: none;	}.cnDropDown{	font-family: Tahoma, Geneva, sans-serif;	font-size: 11px;		color: #666666;	font-weight:bold;	text-decoration: none;		height:22px;	border-color:#C0C0C0;}.option{	background-image:url(Button.jpg)}.tableborder{	border: thin groove Gray;	width: 524px;	height: 203px;	-moz-border-radius: 8px; border-radius: 15px;}.hdr {	font-family: Tahoma, Geneva, sans-serif;	font-size: 18px;		color: Gray;	text-decoration: none;	line-height: 30px;}.tblheader{	background-color:#C0C0C0;	color:#FFFFFF;}.tblAlternetRow{	background-color:#E0E0E0;}.gvAlterNetRowStyle{	background-color:#E0E0E0;	}.GrdHeader{	background-color:#C0C0C0;	text-align:center;	color:#FFFFFF;}.txtbox{	background-color:#ECE9D8;		font-family: Tahoma, Geneva, sans-serif;	font-size: 11px;	border-style:inset;	font-weight: normal;	color: #1d3f65;	text-decoration: none;}.txtNumbox{	background-color:#ECE9D8;	text-align:right;	border-style:inset;	font-family: Tahoma, Geneva, sans-serif;	font-size: 11px;	font-weight: normal;	color: #1d3f65;	text-decoration: none;}.hidden{	display:none;}.popupHeader{	background-color:#8080FF;}.MenuHeader{	color: #1d3f65;}a{	cursor:pointer;	}"
    Public Shared Function GetEmail(ByVal strConString As String, ByVal strEmpCode As String) As String
        Dim objCon As New OleDbConnection(strConString)
        Try
            Dim strEmail As String
            Dim cmdEmail As New OleDbCommand("select EmailId from EmpMaster where EmpCode='" & strEmpCode & "'", objCon)
            objCon.Open()
            strEmail = IIf(IsDBNull(cmdEmail.ExecuteScalar()) = True, "", cmdEmail.ExecuteScalar())
            objCon.Close()
            Return strEmail
        Catch ex As Exception
            'ver 3.2-CRK Start
            objCon.Close()
            'ver 3.2-CRK End
            Return ""
        End Try
    End Function

    Public Shared ReadOnly Property FinYear() As String()
        Get
            'Ver 3.5-REQ305 start
            ' Dim fYears(5) As String
            ' fYears(5) = "2007-2008"
            ' fYears(4) = "2008-2009"
            ' fYears(3) = "2009-2010"
            ' fYears(2) = "2010-2011"
            ' fYears(1) = "2011-2012"
            ' fYears(0) = "2012-2013"
            Dim fYears(6) As String
            fYears(6) = "2007-2008"
            fYears(5) = "2008-2009"
            fYears(4) = "2009-2010"
            fYears(3) = "2010-2011"
            fYears(2) = "2011-2012"
            fYears(1) = "2012-2013"
            fYears(0) = "2013-2014"
            'Ver 3.5-REQ305 end
            Return fYears
        End Get
    End Property


    Public Shared Function WriteToFile(ByVal strFileName As String, ByVal strTextToWrite As String) As Boolean
        Dim objWriter As System.IO.StreamWriter
        Try
            objWriter = System.IO.File.AppendText(strFileName)
            objWriter.WriteLine(strTextToWrite)
            objWriter.Flush()
            objWriter.Close()
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Shared Function GetAreaAdmin(ByVal strConString As String, ByVal strEmpCode As String) As Boolean
        Dim objPwdCon As New OleDbConnection(strConString)
        Try

            Dim cmdAdmin As New OleDbCommand("select AreaAdmin from Employee where EmpCode='" & strEmpCode & "'", objPwdCon)

            objPwdCon.Open()

            If cmdAdmin.ExecuteScalar = True Then
                Return True
            Else
                Return False
            End If
            objPwdCon.Close()

        Catch ex As Exception
            'ver 3.2-CRK Start
            objPwdCon.Close()
            'ver 3.2-CRK End
        End Try
        Return False
    End Function

    Public Shared Function GetNumsInWords(ByVal value As Decimal)
        value = System.Math.Round(value, 2)
        Dim dig1, dig2, dig3, lasttwo, threedigits As Integer
        Dim level As Integer = 0
        Dim strRetVal As String = ""
        Dim x As String = ""
        Dim ones(19) As String
        ones(0) = "zero"
        ones(1) = "one"
        ones(2) = "two"
        ones(3) = "three"
        ones(4) = "four"
        ones(5) = "five"
        ones(6) = "six"
        ones(7) = "seven"
        ones(8) = "eight"
        ones(9) = "nine"
        ones(10) = "ten"
        ones(11) = "eleven"
        ones(12) = "twelve"
        ones(13) = "thirteen"
        ones(14) = "fourteen"
        ones(15) = "fifteen"
        ones(16) = "sixteen"
        ones(17) = "seventeen"
        ones(18) = "eighteen"
        ones(19) = "nineteen"

        Dim tens(9) As String
        tens(0) = "zero"
        tens(1) = "ten"
        tens(2) = "twenty"
        tens(3) = "thirty"
        tens(4) = "forty"
        tens(5) = "fifty"
        tens(6) = "sixty"
        tens(7) = "seventy"
        tens(8) = "eighty"
        tens(9) = "ninety"

        Dim thou(4) As String
        thou(0) = ""
        thou(1) = "thousand"
        thou(2) = "lacs"
        thou(3) = "crores"
        thou(4) = "arabs"

        Dim isNegative As Boolean = False

        If value < 0 Then
            isNegative = True
            value *= -1
        End If

        If value = 0 Then Return ("zero")

        Dim s As String = ""
        Dim dec As String = ""
        If InStr(value.ToString(), ".", CompareMethod.Text) > 0 Then
            s = Mid(value.ToString(), 1, InStr(value.ToString(), ".", CompareMethod.Text) - 1)
            dec = Mid(value.ToString(".00"), InStr(value.ToString(), ".", CompareMethod.Text))
        Else
            s = value.ToString()
        End If

        While (s.Length > 0)
            ' Get the three rightmost characters
            If level = 0 Then
                If (s.Length < 3) Then
                    x = s
                Else
                    x = s.Substring(s.Length - 3, 3)
                End If
            Else
                If (s.Length < 2) Then
                    x = s
                Else
                    x = s.Substring(s.Length - 2, 2)
                End If
            End If

            ' Separate the three digits
            threedigits = CInt(x)
            lasttwo = Math.Floor(threedigits Mod 100)
            dig1 = Math.Floor(threedigits / 100)
            dig2 = Math.Floor(lasttwo / 10)
            dig3 = (threedigits Mod 10)

            ' append a "thousand" where appropriate
            If (level > 0 And dig1 + dig2 + dig3 > 0) Then
                strRetVal = thou(level) + " " + strRetVal
                strRetVal = strRetVal.Trim()
            End If

            ' check that the last two digits is not a zero
            If (lasttwo > 0) Then
                If (lasttwo < 20) Then ' if less than 20, use "ones" only
                    strRetVal = ones(lasttwo) + " " + strRetVal
                ElseIf dig3 = 0 Then
                    strRetVal = tens(dig2) + " " + strRetVal
                Else ' otherwise, use both "tens" and "ones" array
                    strRetVal = tens(dig2) + " " + ones(dig3) + " " + strRetVal
                End If
            End If

            ' if a hundreds part is there, translate it
            If (dig1 > 0) Then
                strRetVal = ones(dig1) + " hundred " + strRetVal
            End If

            If (level = 0) Then
                If (s.Length - 3) > 0 Then
                    s = s.Substring(0, s.Length - 3)
                Else
                    s = ""
                End If
            Else
                If (s.Length - 2) > 0 Then
                    s = s.Substring(0, s.Length - 2)
                Else
                    s = ""
                End If
            End If

            level += 1

        End While

        While (dec.Length > 1)
            ' Get the three rightmost characters            

            x = dec.Substring(1, dec.Length - 1)

            ' Separate the three digits
            threedigits = CInt(x)
            lasttwo = Math.Floor(threedigits Mod 100)
            dig1 = Math.Floor(threedigits / 100)
            dig2 = Math.Floor(lasttwo / 10)
            dig3 = (threedigits Mod 10)


            ' check that the last two digits is not a zero
            If (lasttwo < 20) Then ' if less than 20, use "ones" only
                strRetVal = strRetVal + " And " + ones(lasttwo) + " Paise"
            ElseIf dig3 = 0 Then
                strRetVal = strRetVal + " And " + tens(dig2) + " Paise"
            Else ' otherwise, use both "tens" and "ones" array
                strRetVal = strRetVal + " And " + tens(dig2) + " " + ones(dig3) + " Paise"
            End If

            If (dec.Length - 2) > 0 Then
                dec = dec.Substring(1, dec.Length - 2)
            Else
                dec = ""
            End If

        End While

        While (strRetVal.IndexOf("  ") > 0)
            strRetVal = strRetVal.Replace("  ", " ")
        End While

        strRetVal = strRetVal.Trim()

        If (isNegative) Then
            strRetVal = "negative " + strRetVal
        End If

        Return (strRetVal & " Only")

    End Function

    'Private Function GetPAN(ByVal strConString As String, ByVal strEmpCode As String) As String
    '    Dim objCon As New OleDbConnection(strConString)
    '    Dim dtcmd As New OleDbCommand("select [PAN] from [Details] where ECode='" & Replace(strEmpCode, "'", "") & "'", objCon)
    '    GetPAN = ""
    '    Try
    '        objCon.Open()
    '        GetPAN = dtcmd.ExecuteScalar
    '        objCon.Close()
    '    Catch ex As Exception
    '        GetPAN = ""
    '    End Try
    'End Function
    Public Shared Function ChkTblExists(ByVal strConnectionString As String, ByVal strTblName As String) As Boolean
        Try
            Dim con As New OleDb.OleDbConnection(strConnectionString)
            con.Open()
            Dim dbSchema As DataTable = con.GetOleDbSchemaTable(OleDb.OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, strTblName, "TABLE"})
            If dbSchema.Rows.Count > 0 Then
                Return True
            Else
                Return False
            End If
            con.Close()
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function
    Public Shared Function IsTblExists(ByVal strConnectionString As String, ByVal strTblName As String) As Boolean
        Try
            Dim ds As DataSet = New DataSet()
            Dim da As OleDbDataAdapter = New OleDbDataAdapter("select * from " & strTblName, strConnectionString)
            da.Fill(ds)
            If (ds.Tables(0).Rows.Count = 0) Then
                Return False
            Else
                Return True
            End If
        Catch ex As Exception
            Return False
        End Try
    End Function
    Public Shared Function DateStrings(ByVal datestr As String) As String
        datestr = datestr.Replace("-", "/")
        Dim ds() As String = datestr.Split("/")
        datestr = ds(2) + "/" + ds(1) + "/" + ds(0)
        Dim d As DateTime = New Date(Convert.ToInt32(ds(2)), Convert.ToInt32(ds(1)), Convert.ToInt32(ds(0)))
        Dim ss As String = "#" + d.Year.ToString() + "/" + d.Month.ToString() + "/" + d.Day.ToString() + "#"
        Return ss
    End Function
    Public Shared Function ExecuteDML(ByVal strCon As String, ByVal strQuery As String) As Integer
        Dim i As Int16
        'ver 3.2-CRK start
        Dim con As New OleDbConnection(strCon)
        'ver 3.2-CRK End
        Try
            Dim cmd As New OleDbCommand(strQuery, con)
            con.Open()
            i = cmd.ExecuteNonQuery()
            con.Close()
        Catch ex As Exception
            'ver 3.2-CRK start
            con.Close()
            'ver 3.2-CRK End
        End Try
        Return i
    End Function
    Public Shared Function GetData(ByVal strCon As String, ByVal strQuery As String) As String
        Dim ds As New DataTable
        Dim da As New OleDbDataAdapter(strQuery, strCon)
        da.Fill(ds)
        da.Dispose()
        Return ds.Rows(0)(0).ToString()
    End Function
    Public Shared Function GetDataTable(ByVal strCon As String, ByVal strQuery As String) As DataTable
        Dim ds As New DataTable
        Dim da As New OleDbDataAdapter(strQuery, strCon)
        da.Fill(ds)
        da.FillSchema(ds, SchemaType.Source)
        da.Dispose()
        Return ds
    End Function
    Public Shared Function CreateDBPassword(ByVal Password As String, ByVal Path As String) As Boolean
        Dim objConn As ADODB.Connection
        Dim strAlterPassword As String
        On Error GoTo CreateDBPassword_Err

        strAlterPassword = "ALTER DATABASE UDF  [Ffcs] NULL;"

        ' Open the unsecured database.
        objConn = New ADODB.Connection
        With objConn

            .Open("Provider=Microsoft.Jet.OLEDB.4.0;Data " & _
                "Source=[" & Path & "];")

            ' Execute the SQL statement to secure the database.
            .Execute(strAlterPassword)
        End With

        ' Clean up objects.
        objConn.Close()
        objConn = Nothing

        ' Return true if successful.
        CreateDBPassword = True

CreateDBPassword_Err:
        MsgBox(Err.Number & ":" & Err.Description)
        CreateDBPassword = False
    End Function
    'ver 3.2 start BC30456: 'InitializeCulture' is not a member of ...
    Public Shared Function ToTitleCase(ByVal str As String) As String
        Dim strarr() As String = str.Trim().ToLower().Split(" ")
        Dim strtem As String = ""
        Dim strorigin As String = ""
        Dim i As Integer = 0
        For i = 0 To strarr.Length - 1
            strtem = strarr(i).Trim().ToString()
            strorigin = strorigin & " " & Char.ToUpper(strtem(0)) & strtem.Substring(1)
        Next
        Return strorigin
    End Function
    'ver 3.2 end BC30456: 'InitializeCulture' is not a member of ...
    'Ver 3.2-E426 Start 
    Public Shared Function UpdateDB() As List(Of NewQuery)
        Dim qry As New NewQuery
        Dim lstqry As New List(Of NewQuery)

        '***********Query 1************
        qry.QryName = "Query 1"
        qry.QueryText = "create table DeactivateEmp (EmpCode varchar(50),IsDeactive YesNo) "
        qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        qry.DBName = "Pwd.mdb"
        lstqry.Add(qry)
        '***********End************

        ''***********Query 2************
        'qry = New NewQuery
        'qry.QryName = "Query 2"
        'qry.QueryText = "create table RoleMaster (RoleID varchar(20),RoleName varchar(200),IsActive yesno) "
        'qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        'qry.DBName = "Pwd.mdb"
        'lstqry.Add(qry)
        ''***********End************

        ''***********Query 3************
        'qry = New NewQuery
        'qry.QryName = "Query 3"
        'qry.QueryText = "create table DocumentMaster (DocID varchar(20),DocName varchar(200),DocPath varchar(200),IsActive yesno,IsRestricted yesno) "
        'qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        'qry.DBName = "Pwd.mdb"
        'lstqry.Add(qry)
        ''***********End************

        ''***********Query 4************
        'qry = New NewQuery
        'qry.QryName = "Query 4"
        'qry.QueryText = "create table DocumentRole (DocID varchar(20),RoleID varchar(20)) "
        'qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        'qry.DBName = "Pwd.mdb"
        'lstqry.Add(qry)
        ''***********End************

        '***********Query 5************


        qry = New NewQuery
        qry.QryName = "Query 2"
        qry.QueryText = "alter table  DeactivateEmp add column RoleID varchar(20)"
        qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        qry.DBName = "Pwd.mdb"
        lstqry.Add(qry)
        '***********End************


        '***********Query 6************
        qry = New NewQuery
        qry.QryName = "Query 3"
        qry.QueryText = "Create table  CommonMessage (CommonMessage varchar(255) )"
        qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        qry.DBName = "Pwd.mdb"
        lstqry.Add(qry)
        '***********End************

        '***********Query 7************
        qry = New NewQuery
        qry.QryName = "Query 4"
        qry.QueryText = "Create table  80CCG (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        '***********End************

        '***********Query 7************
        qry = New NewQuery
        qry.QryName = "Query 5"
        qry.QueryText = "alter table details add column [R11026] number"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        '***********End************
        'ver 3.3-E501 Start
        '***********Query 6************
        qry = New NewQuery
        qry.QryName = "Query 6"
        qry.QueryText = "create table FAQ (SrNo autoincrement,Quation memo,Answer memo,IsEnable yesno,priority number)"
        qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        qry.DBName = "Pwd.mdb"
        lstqry.Add(qry)
        '***********End************
        'ver 3.3-E501 End
        'Ver 3.3 Start-E456 80ccg

        '***********Query 7************
        qry = New NewQuery
        qry.QryName = "Query 7"
        qry.QueryText = "alter table details add column [D11013] number"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        '***********End************
        'Ver 3.3 End-E456 80ccg

        'Ver 3.3 Start
        '***********Query 8************
        qry = New NewQuery
        qry.QryName = "Query 8"
        qry.QueryText = "create table SMTPDetails ([FromAddress] varchar(255),[Host] varchar(255),[Port] varchar(4),[UserName] varchar(255),[Password] varchar(255),[DeliveryMethod] varchar(20),[IsSSL] yesno)"
        qry.QueryConnection = HttpContext.Current.Session("pwdConnection").ToString()
        qry.DBName = "Pwd.mdb"
        lstqry.Add(qry)
        '***********End************
        'Ver 3.3 End

        'Ver 3.3-E588 start 
        '***********Query 9************
        'Ver 3.5-REQ305 start
        'If HttpContext.Current.Session("Period") = "2013-2014" Then
        'Ver 3.07-REQ??? start
        'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Then
        'Ver 3.8-REQ580 start
        'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") = "2015-2016" Then
        If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") >= "2015-2016" Then
            'Ver 3.8-REQ580 end 
            'Ver 3.07-REQ??? end
            'Ver 3.5-REQ305 end
            qry = New NewQuery
            qry.QryName = "Query 9"
            'qry.QueryText = "alter table details add column [O11007] number,[D11015] number "
            qry.QueryText = "alter table details add column [O11007] number "
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If
        'Ver 3.07-REQ511 start
        If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Then
            'Ver 3.07-REQ511 end
            qry = New NewQuery
            qry.QryName = "Query 10"
            'qry.QueryText = "alter table details add column [O11007] number,[D11015] number "
            qry.QueryText = "alter table details add column [D11015] number "
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
            '***********End************
            'Ver 3.07-REQ511 start
        End If
        'Ver 3.07-REQ511 end
        '***********Query 10************
        qry = New NewQuery
        qry.QryName = "Query 11"
        qry.QueryText = "Create table  80TTA (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        '***********End************

        '***********Query 11************
        'Ver 3.07-REQ511 start
        ' Ver 4.0-REQ579 start
        'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Then
        'Ver 4.01-REQ723 start
        'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") = "2016-2017" Then
        If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") >= "2016-2017" Then
            'Ver 4.01-REQ723 end
            'Ver 4.0-REQ579 end 
            qry = New NewQuery
            qry.QryName = "Query 12"
            qry.QueryText = "Create table  80EE (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
            '***********End************

            'Ver 3.07-REQ511 end
        End If
        'Ver 3.3-E588 end 
        '==>Jitendra
        If HttpContext.Current.Session("Period") >= "2015-2016" Then
            qry = New NewQuery
            qry.QryName = "Query 13"
            ' qry.QueryText = "alter table details add (column [80CCDAmt1] number,column [80CCDAmt2] number ,column [80CCDAmt3] number ,column [80CCDAmt4] number ,column [80CCDAmt5] number ,column [80CCDAmt6] number ,column [80CCDAmt7] number ,column [80CCDAmt8] number ,column [80CCDAmt9] number ,column [80CCDAmt10] number ,column [80CCDAmt11] number ,column [80CCDAmt12] number)  "
            qry.QueryText = "Alter table details add   column [80CCD_1B] number "
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If
        '<==Jitendra



        ' Jayant Ver 3.9-REQ539 start

        qry = New NewQuery
        qry.QryName = "Query 14"
        qry.QueryText = "alter table details add column [IncmFromHP] number "
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)

        qry = New NewQuery
        qry.QryName = "Query 15"
        qry.QueryText = "Create table  IncomeFromHouseProperty (SrNo AUTOINCREMENT,EmpCode VARCHAR(25),FYear VARCHAR(25) ,InterestOnHLPaid Money,IncomeSelfOcc Money,RentRecieved Money,MunicipalTaxes Money,RentUnrealized Money,NetAnnualValue Money,StandardDeduction30 Money,IneterstOnHLLetout Money,IncomeLetOutHP Money,EmpInsert DATETIME,EmpUpdate DATETIME,AdminUpdate DATETIME,PRIMARY KEY (SrNo))"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        '<== Jayant Ver 3.9-REQ539 start

        '==>Jitendra 80EE started on 25/04/2016
        ' Ver 4.0-REQ579 start
        If HttpContext.Current.Session("Period") >= "2015-2016" Then
            qry = New NewQuery
            qry.QryName = "Query 16"
            qry.QueryText = "Alter table details add column [80EE] number"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If

        '  Ver 4.0-REQ579 end 
        'Ver 4.1-REQ623 start '12BB
        If HttpContext.Current.Session("Period") >= "2015-2016" Then
            qry = New NewQuery
            qry.QryName = "Query 17"
            qry.QueryText = "Alter table IncomeFromHouseProperty add column LenderName VARCHAR(50), column LenderAddress1 VARCHAR(100), column LenderAddress2 VARCHAR(100), column LenderAddress3 VARCHAR(100), column LenderPAN VARCHAR(10)"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If

        If HttpContext.Current.Session("Period") >= "2015-2016" Then
            qry = New NewQuery
            qry.QryName = "Query 18"
            qry.QueryText = "Alter table details add column LandLordName VARCHAR(50), column LandLordAddress1 VARCHAR(100), column LandLordAddress2 VARCHAR(100), column LandLordAddress3 VARCHAR(100), column LandLordPAN VARCHAR(10)"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If

        'varalakshmi - 22jun20 - start
        qry = New NewQuery
        qry.QryName = "Query 18"
        qry.QueryText = "Alter table details add column LandLordName VARCHAR(50), column LandLordAddress1 VARCHAR(100), column LandLordAddress2 VARCHAR(100), column LandLordAddress3 VARCHAR(100), column LandLordPAN VARCHAR(10)"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)

        'varalakshmi - 22jun20 - end

        qry = New NewQuery
        qry.QryName = "Query 19"
        qry.QueryText = "Create table  LandLordDetails (SrNo AUTOINCREMENT,EmpCode varchar(50),Name VARCHAR(75),Address NVARCHAR(255) ,PANNumber NVARCHAR(10),EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime,PRIMARY KEY (SrNo))"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)

        'Ver 4.1-REQ623 end  '12BB
        'Ver4.2 REQ793 start
        If HttpContext.Current.Session("Period") >= "2016-2017" Then
            qry = New NewQuery
            qry.QryName = "Query 20"
            qry.QueryText = "Create table 80CCD (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If
        'Ver4.2 REQ793 END

        'Ver 4.2-REQ806 start
        qry = New NewQuery
        qry.QryName = "Query 21"
        qry.QueryText = "Create table  80TTB (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        'Ver4.2 REQ806 END


        'Ver 4.2-REQ806 start
        If HttpContext.Current.Session("Period") >= "2018-2019" Then
            qry = New NewQuery
            qry.QryName = "Query 22"
            'qry.QueryText = "alter table details add column [O11007] number,[D11015] number "
            qry.QueryText = "alter table details add column [80TTB] number "
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If
        'Ver 4.2-REQ806 end

        'Ver 4.2-REQ806 start
        If HttpContext.Current.Session("Period") >= "2018-2019" Then
            qry = New NewQuery
            qry.QryName = "Query 23"
            'qry.QueryText = "alter table details add column [O11007] number,[D11015] number "
            qry.QueryText = "alter table details add column [LenderName] varchar (50), column LenderAddr1 varchar(20), column LenderAddr3 varchar(20), column LenderPAN varchar(20)"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If
        'Ver 4.2-REQ806 end

        'Ver 4.2-REQ806 start
        qry = New NewQuery
        qry.QryName = "Query 21"
        qry.QueryText = "Create table  80TTB (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
        qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
        qry.DBName = "InvestmentDec.mdb"
        lstqry.Add(qry)
        'Ver4.2 REQ806 END

        'FascFacts 721 start
        If HttpContext.Current.Session("Period") >= "2016-2017" Then
            qry = New NewQuery
            qry.QryName = "Query 24"
            qry.QueryText = "Create table NPS (SrNo autoincrement,EmployeeCode varchar(20),Amount Text,IsProofAttach yesno,Isproofapproved yesno,Reason memo,isproofreject yesno,EmpInsert datetime,EmpUpdate datetime,AdminUpdate datetime )"
            qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
            qry.DBName = "InvestmentDec.mdb"
            lstqry.Add(qry)
        End If
        'FascFacts 721 END

        Dim i As Integer = 0
        For i = 0 To lstqry.Count - 1
            lstqry(i).QryStatus = ExicuteDML(lstqry(i).QueryText, lstqry(i).QueryConnection)
        Next
        Try
            If Convert.ToInt32(General.GetData(HttpContext.Current.Session("pwdConnection").ToString(), "select count(commonmessage) from commonmessage ")) <= 0 Then
                General.ExecuteDML(HttpContext.Current.Session("pwdConnection").ToString(), "insert into  commonmessage values('Computer generated payslip, Hence signature not required')")
            End If
        Catch ex As Exception
        End Try

        'Ver 3.3 Start-E456 80ccg
        Try

            If Convert.ToInt32(General.GetData(HttpContext.Current.Session("invConnection").ToString(), "select count(*) from masters where saltdscode='d11013' ")) <= 0 Then
                General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "insert into  masters values('d11013','80CCG','80CCG-Rajiv Gandhi Equity Scheme','80CCG-Rajiv Gandhi Equity Scheme',0,0,true)")
            End If

            'Ver 3.3-E509 Start
            If Convert.ToInt32(General.GetData(HttpContext.Current.Session("PgRightsConn").ToString(), "select count(*) from pagerights where pagename='Form 16'")) <= 0 Then
                General.ExecuteDML(HttpContext.Current.Session("PgRightsConn").ToString(), "Insert into pagerights(pagename,allowtouser) values('Form 16',True) ")
            End If
            'Ver 3.3-E509 End
            'Ver 3.3 E588 start

            'Ver 3.5-REQ305 start
            ' If HttpContext.Current.Session("Period") = "2013-2014" Then
            'Ver 3.07-REQ??? start
            'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Then
            'Ver 3.8-REQ580 start
            'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") = "2015-2016" Then
            If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") >= "2015-2016" Then
                'Ver 3.8-REQ580 end 
                'Ver 3.07-REQ??? end
                'Ver 3.5-REQ305 end
                'Ver 3.07-REQ??? start
                'Ver 4.0-QC972 start
                ' If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Then
                'Ver 4.01-REQ723 start
                'If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") = "2016-2017" Then
                If HttpContext.Current.Session("Period") = "2013-2014" Or HttpContext.Current.Session("Period") = "2014-2015" Or HttpContext.Current.Session("Period") >= "2016-2017" Then
                    'Ver 4.01-REQ723 end
                    'Ver 4.0-QC972 end 
                    'Ver 3.07-REQ??? end
                    If Convert.ToInt32(General.GetData(HttpContext.Current.Session("invConnection").ToString(), "select count(*) from masters where saltdscode='d11015' ")) <= 0 Then
                        General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "insert into  masters values('d11015','80EE','80EE-Additional Deduction on Housing Loan Interest','80EE-Additional Deduction on Housing Loan Interest',0,0,true)")
                    End If
                    'Ver 3.07-REQ??? start
                End If
                'Ver 3.07-REQ??? end

                If Convert.ToInt32(General.GetData(HttpContext.Current.Session("invConnection").ToString(), "select count(*) from masters where saltdscode='O11007' ")) <= 0 Then
                    General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "insert into  masters values('O11007','80TTA','80TTAInterest on saving account','80TTAInterest on saving account',0,0,true)")
                Else
                    General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "delete from masters where saltdscode='O11007'")
                    General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "insert into  masters values('O11007','80TTA','80TTAInterest on saving account','80TTAInterest on saving account',0,0,true)")
                End If
            End If
            'Ver 3.3 E588 End
            'Ver 3.7-REQ519 start
            Dim sMAXsalTdsCode As String
            sMAXsalTdsCode = ""
            If HttpContext.Current.Session("Period") >= "2015-2016" Then
                If Convert.ToInt32(General.GetData(HttpContext.Current.Session("invConnection").ToString(), "select count(*) from masters where SalTdsDesc='Sukanya Samridhi Yojana' ")) <= 0 Then
                    sMAXsalTdsCode = General.GetData(HttpContext.Current.Session("invConnection").ToString(), "Select top 1 MAX(salTdsCode) from [Masters] where SalTdsCode  like 'R11%'")
                    sMAXsalTdsCode = sMAXsalTdsCode.Substring(1, sMAXsalTdsCode.Length - 1) + 1
                    General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "insert into Masters values ('" & "R" & sMAXsalTdsCode & "','Sukanya Samridhi Yojana','Sukanya Samridhi Yojana','Copy of premium paid receipt',0,0,true)")

                    qry = New NewQuery
                    qry.QryName = "Query 13"
                    qry.QueryText = "alter table details add column [" & "R" & sMAXsalTdsCode & "] number"
                    qry.QueryConnection = HttpContext.Current.Session("invConnection").ToString()
                    qry.DBName = "InvestmentDec.mdb"
                    lstqry.Add(qry)
                    General.ExecuteDML(HttpContext.Current.Session("invConnection").ToString(), "alter table details add column [" & "R" & sMAXsalTdsCode & "] number")


                End If
            End If
            'Ver 3.7-REQ519 end 
            'Ver 4.0-QC972 start
            If Convert.ToInt32(General.GetData(HttpContext.Current.Session("PgRightsConn").ToString(), "select count(*) from pagerights where pagename='Print Address on PaySlip'")) <= 0 Then
                General.ExecuteDML(HttpContext.Current.Session("PgRightsConn").ToString(), "Insert into pagerights(pagename,allowtouser) values('Print Address on PaySlip',True) ")
            End If
            'Ver 4.0-QC972 end 

        Catch ex As Exception
        End Try

        Return lstqry
    End Function
    Public Shared Function ExicuteDML(ByVal strQuery As String, ByVal strconn As String) As String
        Dim i As String = 0
        Dim con As OleDbConnection = New OleDbConnection(strconn)
        Try

            Dim cmd As OleDbCommand = New OleDbCommand(strQuery, con)
            con.Open()
            i = "Pass:" & cmd.ExecuteNonQuery().ToString()
            con.Close()
        Catch ex As Exception
            con.Close()
            i = "Fail:" & ex.Message
        End Try
        Return i
    End Function
    'Ver 3.2-E426 End 
End Class
'Ver 3.2-E426 Start 
Public Class NewQuery
    Public QueryText As String
    Public QueryConnection As String
    Private QryName1 As String
    Private QryStatus1 As String
    Private DBName1 As String
    Public Property QryName() As String
        Get
            Return QryName1
        End Get
        Set(ByVal value As String)
            QryName1 = value
        End Set
    End Property
    Public Property QryStatus() As String
        Get
            Return QryStatus1
        End Get
        Set(ByVal value As String)
            QryStatus1 = value
        End Set
    End Property
    Public Property DBName() As String
        Get
            Return DBName1
        End Get
        Set(ByVal value As String)
            DBName1 = value
        End Set
    End Property
End Class
'Ver 3.2-E426 End 