﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Collections.Generic
Imports System.Web.Services
Partial Class ApplyLeave
    Inherits System.Web.UI.Page
    Dim temp As String
    Dim LeaveList As New List(Of String)
    Private _dtMonth As DateTime
    Private _selectedDate As DateTime
    Private _specialDaySelected As Boolean = True
    Private _currentBindingMonth As Integer
    Dim tmpds As New DataSet
    Public Shared strcon As String = ""
    Public strScript As String = ""
    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        Try
            If Session("EmpId").ToString() = "Admin" Then
                Me.MasterPageFile = "MasterPage.master"
                strScript = "GetData(ldate);"
                btnAppLeave.Enabled = False
            End If
        Catch ex As Exception
        End Try
    End Sub
    Protected Sub repMonths_OnInit(ByVal sender As Object, ByVal e As EventArgs)
        If Session("EmpId").ToString() = "Admin" Then
            tmpds = GetData("select format(LeaveDate,'dd-MM-yyyy') as LeaveDate, LeaveType, IsAssing, Comment, IsPaid from appliedleave")
        Else
            tmpds = GetData("select format(LeaveDate,'dd-MM-yyyy') as LeaveDate, LeaveType, IsAssing, Comment, IsPaid from appliedleave where EmpCode='" + Session("EmpId").ToString() + "'")
        End If
        For i = 0 To tmpds.Tables(0).Rows.Count - 1
            LeaveList.Add(tmpds.Tables(0).Rows(i)(0))
        Next
        If Not DateTime.TryParse(Request.QueryString("CalDate"), _selectedDate) Then
            _specialDaySelected = False
            Dim selectedMonth As Integer, selectedYear As Integer
            Integer.TryParse(Request.QueryString("CalYear"), selectedYear)
            Integer.TryParse(Request.QueryString("CalMonth"), selectedMonth)

            If selectedYear <= 0 Then
                selectedYear = DateTime.Now.Year
            End If
            If selectedMonth <= 1 Then
                selectedMonth = 1
            ElseIf selectedMonth > 12 Then
                selectedMonth = 12
            End If

            _selectedDate = New DateTime(selectedYear, 1, 1)
        End If

        litSelectedYear.Text = _selectedDate.Year.ToString()

        repMonths.DataSource = New Integer() {1, 2, 3, 4, 5, 6, _
         7, 8, 9, 10, 11, 12}
        repMonths.DataBind()

    End Sub
    Protected Sub repMonths_OnItemDataBound(ByVal sender As Object, ByVal e As RepeaterItemEventArgs)
        If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim repDays As Repeater = DirectCast(e.Item.FindControl("repDays"), Repeater)
            Dim hylMonth As HyperLink = DirectCast(e.Item.FindControl("hylMonth"), HyperLink)
            _currentBindingMonth = CInt(e.Item.DataItem)
            _dtMonth = New DateTime(_selectedDate.Year, _currentBindingMonth, 1)

            hylMonth.Text = _dtMonth.ToString("MMM")

            If _currentBindingMonth = _selectedDate.Month Then
                hylMonth.Attributes.Add("class", "selected")
            End If

            If _dtMonth.DayOfWeek <> DayOfWeek.Monday Then
                Dim daysToSubtract As Integer = -CInt(_dtMonth.DayOfWeek)

                If _dtMonth.DayOfWeek = DayOfWeek.Sunday Then
                    daysToSubtract = -7
                End If
                ' Special case. US weeks start with sunday, thus the enum DayOfWeek.Sunday = 0.
                _dtMonth = _dtMonth.AddDays(daysToSubtract + 1)
            End If

            Dim dates As DateTime() = New DateTime(36) {}
            For i As Integer = 0 To 36
                dates(i) = _dtMonth
                _dtMonth = _dtMonth.AddDays(1)
            Next

            repDays.DataSource = dates
            repDays.DataBind()
        End If
    End Sub
    Protected Sub repDays_OnItemDataBound(ByVal sender As Object, ByVal e As RepeaterItemEventArgs)
        If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim [date] As DateTime = CType(e.Item.DataItem, DateTime)
            Dim litDay As Literal = DirectCast(e.Item.FindControl("litDay"), Literal)
            Dim tdDay As HtmlTableCell = DirectCast(e.Item.FindControl("tdDay"), HtmlTableCell)

            If [date].DayOfWeek = DayOfWeek.Saturday OrElse [date].DayOfWeek = DayOfWeek.Sunday Then
                tdDay.Attributes.Add("class", "tblAlternetRow")
            End If

            If _currentBindingMonth = [date].Month Then
                If LeaveList.Contains([date].ToString("dd-MM-yyyy")) Then
                    litDay.Text = String.Format("<span class='tblheader'><a id='{3}{2}{1}'  onclick='ShowData(this.id,""" & [date].ToString("dd-MM-yyyy") & """)' >{3}</a><span>", Request.Path, [date].Year, [date].Month, [date].Day.ToString("D2"), If((_specialDaySelected AndAlso [date].Equals(_selectedDate)), " class=""selected""", String.Empty))
                Else
                    litDay.Text = String.Format("<span><a id='{3}{2}{1}'  onclick='ShowData(this.id,""" & [date].ToString("dd-MM-yyyy") & """)' >{3}</a><span>", Request.Path, [date].Year, [date].Month, [date].Day.ToString("D2"), If((_specialDaySelected AndAlso [date].Equals(_selectedDate)), " class=""selected""", String.Empty))

                End If

            Else
                litDay.Text = String.Format("<span style='color:#dadada;'>{0}</span>", [date].Day.ToString("D2"))
            End If

            ' Clear ID's
            tdDay.ID = String.Empty

        End If
    End Sub
    Public Shared Function GetDayName(ByVal dayInWeek As Integer) As String
        Select Case dayInWeek
            Case 1
                Return "MO"
            Case 2
                Return "TU"
            Case 3
                Return "WE"
            Case 4
                Return "TH"
            Case 5
                Return "FR"
            Case 6
                Return "SA"
            Case 7
                Return "SU"
        End Select

        Return "God only made seven days in a week."
    End Function
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        End If

        If Page.IsPostBack <> True Then
            gvLeaves.DataSource = GetData("select distinct LName from leavedetails")
            gvLeaves.DataBind()
            Session("Script") = "<script>  $(function() {	" & temp & " });</script>"
            gvLeaveData.DataSource = tmpds
            gvLeaveData.DataBind()
            strcon = Session("myConnection").ToString()
        End If
        
    End Sub
    Private Function GetData(ByVal strQry As String) As DataSet
        Dim da As New OleDbDataAdapter(strQry, Session("myConnection").ToString())
        Dim ds As New DataSet()
        da.Fill(ds)
        Return ds
    End Function
    Protected Sub gvLeaves_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles gvLeaves.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            'Dim txtbox = CType(e.Row.FindControl("txtDates"), TextBox)
            'txtbox.Attributes.Add("onkeyup", "alert('')")
            temp = temp & "$('#" & e.Row.FindControl("txtDates").ClientID & "').multiDatesPicker();"
        End If

    End Sub

    Protected Sub btnAppLeave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAppLeave.Click
        Dim dt As New DataTable
        dt.Columns.Add(New DataColumn("EmpCode"))
        dt.Columns.Add(New DataColumn("LeaveDate"))
        dt.Columns.Add(New DataColumn("LeaveType"))
        dt.Columns.Add(New DataColumn("IsAssing"))
        dt.Columns.Add(New DataColumn("Comment"))
        dt.Columns.Add(New DataColumn("IsPaid"))

        For i = 0 To gvLeaves.Rows.Count - 1
            Dim txtDate = CType(gvLeaves.Rows(i).FindControl("txtDates"), TextBox)
            Dim LeaveType = CType(gvLeaves.Rows(i).FindControl("ltrLeaveType"), Literal)
            Dim chkIsPaid = CType(gvLeaves.Rows(i).FindControl("chkIsPaid"), CheckBox)
            Dim s() As String = txtDate.Text.Split(",")
            For j = 0 To s.Length - 1
                If s(j) <> "" Then
                    dt.Rows.Add(Session("EmpId").ToString(), FormatDate(s(j)), LeaveType.Text, "false", "", chkIsPaid.Checked)
                End If
            Next
            txtDate.Text = ""
        Next
        BatchInsert(dt)
        tmpds = GetData("select format(LeaveDate,'dd-MM-yyyy') as LeaveDate, LeaveType, IsAssing, Comment, IsPaid from appliedleave where EmpCode='" + Session("EmpId").ToString() + "'")
        For i = 0 To tmpds.Tables(0).Rows.Count - 1
            LeaveList.Add(tmpds.Tables(0).Rows(i)(0))
        Next
        tmpds = GetData("select format(LeaveDate,'dd-MM-yyyy') as LeaveDate, LeaveType, IsAssing, Comment, IsPaid from appliedleave where EmpCode='" + Session("EmpId").ToString() + "'")
        gvLeaveData.DataSource = tmpds
        gvLeaveData.DataBind()
        repMonths.DataSource = New Integer() {1, 2, 3, 4, 5, 6, _
        7, 8, 9, 10, 11, 12}
        repMonths.DataBind()

    End Sub
    Private Function FormatDate(ByVal strdate As String) As String
        Dim temS() = strdate.Split("/")
        Return temS(2) + "/" + temS(0) + "/" + temS(1)
    End Function
    Private Sub BatchInsert(ByVal ds As DataTable)
        For i = 0 To ds.Rows.Count - 1
            ds.Rows(i).AcceptChanges()
            ds.Rows(i).SetAdded()
        Next
        Using con As New OleDbConnection(Session("myConnection").ToString())
            con.Open()
            Dim da As New OleDbDataAdapter()
            da.InsertCommand = New OleDbCommand("insert into appliedLeave(EmpCode,LeaveDate,LeaveType,IsAssing,Comment,IsPaid) values(@EmpCode,@LeaveDate,@LeaveType,@IsAssing,@Comment,@IsPaid)", con)
            da.InsertCommand.Parameters.Add(New OleDbParameter("EmpCode", OleDbType.VarChar, 10, "EmpCode"))
            da.InsertCommand.Parameters.Add(New OleDbParameter("LeaveDate", OleDbType.Date, 10, "LeaveDate"))
            da.InsertCommand.Parameters.Add(New OleDbParameter("LeaveType", OleDbType.VarChar, 10, "LeaveType"))
            da.InsertCommand.Parameters.Add(New OleDbParameter("IsAssing", OleDbType.Boolean, 50, "IsAssing"))
            da.InsertCommand.Parameters.Add(New OleDbParameter("Comment", OleDbType.VarChar, 255, "Comment"))
            da.InsertCommand.Parameters.Add(New OleDbParameter("IsPaid", OleDbType.Boolean, 1, "IsPaid"))
            da.UpdateBatchSize = 1
            da.Update(ds)
            con.Close()
        End Using

    End Sub

    <WebMethod()> _
Public Shared Function GetEmp(ByVal leavedate As String) As String
        Dim empmarkup As New StringBuilder
        Dim strRnt As String = "[No record Found]"
        Dim con As New OleDbConnection(strcon)
        Dim cmd As New OleDbCommand("SELECT EmpMaster.EmpName FROM AppliedLeave INNER JOIN EmpMaster ON AppliedLeave.EmpCode = EmpMaster.EmpCode where format(AppliedLeave.LeaveDate,'dd-MM-yyyy')='" & leavedate & "'", con)
        con.Open()
        Dim dr As OleDbDataReader = cmd.ExecuteReader()
        If (dr.HasRows) Then
            While dr.Read()
                empmarkup.Append("<tr><td>" & dr(0).ToString() & "<td></tr>")
            End While
            strRnt = "<table>" & empmarkup.ToString() & "<table>"
        End If
        con.Close()
        Return strRnt
    End Function
End Class

