Imports System.Data
Imports System.Data.OleDb
Imports MigraDoc.Rendering
Imports System.Diagnostics

Partial Class EstimationSlip
    Inherits System.Web.UI.Page

    Dim dsProfile As New DataSet

    Dim objCon As OleDbConnection
    Dim objCmd As OleDbCommand
    Dim adp As New OleDbDataAdapter
    Dim IsRowHL As Boolean
    'Ver4.2 REQ806 start
    Dim EDUCESS_RATE As Double = 0.03
    Dim lngsurcharge As Long
    'Ver4.2 REQ806 end
    'Ver 3.2-E398 Start
    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        AddHandler Master.Print_PDF, AddressOf PrintPDF
    End Sub
    'Ver 3.2-E398 End
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("EmpId") = String.Empty Then
            Response.Redirect("EmpLogin.aspx")
        End If
        Try
            objCon = New OleDbConnection(Session("myConnection"))
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If

            lblEmpCode.Text = Session("EmpId")
            lblName.Text = Session("EmpName")
            lblFY.Text = Session("Period")
            'Ver4.2 REQ806 start
            If Session("period").ToString() >= "2018-2019" Then
                EDUCESS_RATE = 0.04
            End If
            'Ver4.2 REQ806 start
            If objCon.State <> ConnectionState.Open Then objCon.Open()
            ShowUI()
            HideColumn()
            'Dim dd As DropDownList = CType(Master.FindControl("cmbMonth"), DropDownList)
            'Dim ltmon As Literal = CType(Master.FindControl("ltrmon"), Literal)
            'ltmon.Visible = True
            'dd.Visible = True

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
            'ver 3.2-CRK Srart
        Finally
            objCon.Close()
            'ver 3.2-CRK End
        End Try
    End Sub
    Private Sub HideColumn()
        For i = 0 To tblMain.Rows.Count - 1
            Try
                tblMain.Rows(i).Cells(0).Visible = False
            Catch ex As Exception
            End Try
        Next

    End Sub

    Private Sub ShowUI()
        Try
            Dim DataTbl As DataTable = New DataTable("Estimation")
            Dim lngGrossTaxAmt, lngDedTaxAmt, lngTaxableIncome As Long
            Dim lngTaxPayable As Long
            Dim lngTaxDeducted As Long
            'Ver 4.82-2345 start
            Dim lngPreviousEmpTDS As Long
            'Ver 4.82-2345 end
            Dim DataCol As DataColumn
            Dim DtRow As DataRow = DataTbl.NewRow

            DataCol = New DataColumn("Components")

            DataTbl.Columns.Add(DataCol)

            DataCol = New DataColumn("Code")
            DataTbl.Columns.Add(DataCol)

            DataCol = New DataColumn("Amount")
            DataTbl.Columns.Add(DataCol)

            DataCol = New DataColumn("TaxFreeAmt")
            DataTbl.Columns.Add(DataCol)

            DataCol = New DataColumn("TaxableAmt")
            DataTbl.Columns.Add(DataCol)

            DataCol = New DataColumn("Total")
            DataTbl.Columns.Add(DataCol)

            dsProfile.Tables.Add(DataTbl)

            Call SetTableHeaders()

            '***************************1. Fill the Gross Salary ********************************
            '************************************************************************************
            'Ver 4.82-2343 start
            'adp = New OleDbDataAdapter("select '1.' as Num,' Gross Salary' as Components," & _
            '                                        "sum(AmtTaxable) as Total " & _
            '                                        "from [Trans] " & _
            '                                        "where (mid(Code,1,3)='S11' or mid(Code,1,3)='S12') and " & _
            '                                        "mid([Type],1,1)<>'H' and ECode='" & Session("EmpId") & "'", objCon)
            adp = New OleDbDataAdapter("select '1.' as Num,' Gross Salary' as Components," & _
                                                                "sum(AmtTaxable) as Total " & _
                                                                "from [Trans] " & _
                                                                "where (mid(Code,1,3)='S11' or mid(Code,1,3)='S12' or mid(Code,1,3)='S13') and " & _
                                                                "mid([Type],1,1)<>'H' and ECode='" & Session("EmpId") & "'", objCon)
            'Ver 4.82-2343 end
            adp.Fill(dsProfile, "Estimation")

            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                lngGrossTaxAmt = Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total"))

            dsProfile.Tables("Estimation").Rows.Clear()
            'Ver 4.82-2343 start
            'adp.SelectCommand.CommandText = "select '&nbsp;' as Num,'  ' + Desc as Components,Code," & _
            '                                        "(Amt+AmtTaxFree) as Amount," & _
            '                                        "AmtTaxFree as TaxFreeAmt," & _
            '                                        "AmtTaxable as TaxableAmt " & _
            '                                        "from [Trans] " & _
            '                                        "where (mid(Code,1,3)='S11' or mid(Code,1,3)='S12') " & _
            '                                        "and mid(Type,1,1)<>'H' and (Amt+AmtTaxFree)>0 and " & _
            '                                        "ECode='" & Session("EmpId") & "'"
            adp.SelectCommand.CommandText = "select '&nbsp;' as Num,'  ' + Desc as Components,Code," & _
                                                                "(Amt+AmtTaxFree) as Amount," & _
                                                                "AmtTaxFree as TaxFreeAmt," & _
                                                                "AmtTaxable as TaxableAmt " & _
                                                                "from [Trans] " & _
                                                                "where (mid(Code,1,3)='S11' or mid(Code,1,3)='S12' or mid(Code,1,3)='S13') " & _
                                                                "and mid(Type,1,1)<>'H' and (Amt+AmtTaxFree)>0 and " & _
                                                                "ECode='" & Session("EmpId") & "'"
            'Ver 4.82-2343 end
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), True, True)

            dsProfile.Tables("Estimation").Rows.Clear()
            'Ver 4.82-2343 start
            'adp.SelectCommand.CommandText = "select '' as Num,'Total' as Components," & _
            '                                        "sum(Amt+AmtTaxFree) as Amount," & _
            '                                        "sum(AmtTaxFree) as TaxFreeAmt," & _
            '                                        "sum(AmtTaxable) as TaxableAmt " & _
            '                                        "from [Trans] " & _
            '                                        "where (mid(Code,1,3)='S11' or mid(Code,1,3)='S12') and " & _
            '                                        "mid([Type],1,1)<>'H' and ECode='" & Session("EmpId") & "'"
            adp.SelectCommand.CommandText = "select '' as Num,'Total' as Components," & _
                                                                "sum(Amt+AmtTaxFree) as Amount," & _
                                                                "sum(AmtTaxFree) as TaxFreeAmt," & _
                                                                "sum(AmtTaxable) as TaxableAmt " & _
                                                                "from [Trans] " & _
                                                                "where (mid(Code,1,3)='S11' or mid(Code,1,3)='S12' or mid(Code,1,3)='S13') and " & _
                                                                "mid([Type],1,1)<>'H' and ECode='" & Session("EmpId") & "'"
            'Ver 4.82-2343 end
            adp.Fill(dsProfile, "Estimation")
            'dsProfile.Tables("Estimation").Rows.Add("")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, True)


            '*************************2. Fill the Deduction U/S 16 ******************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '2.' as Num,' Deduction U/S 16' as Components," & _
                                                    "sum(AmtTaxable) as Total " & _
                                                    "from [Trans] " & _
                                                    "where (mid(Code,1,3)='S17' or mid(Code,1,3)='S15') and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                lngDedTaxAmt = Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total"))
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            'Ver4.2 REQ806 start
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '' as Num,' Standard Deductions' as Components," & _
                                                    "sum(AmtTaxable) as TaxableAmt " & _
                                                    "from [Trans] " & _
                                                    "where mid(Code,1,3)='S15' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                 Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total"))
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            'Ver4.2 REQ806 end

            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '' as Num,[Desc] as Components ,Code," & _
                                                    "AmtTaxable as TaxableAmt " & _
                                                    "from [Trans] " & _
                                                    "where mid(Code,1,3)='S17' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), True, True)

            '*********3. Fill the Income chargeable under the Head Salaries (1-2) ***************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()

            DtRow = dsProfile.Tables("Estimation").NewRow
            DtRow("Num") = "4."
            DtRow("Components") = "Income chargeable under the Head Salaries "
            DtRow("Total") = lngGrossTaxAmt - lngDedTaxAmt
            dsProfile.Tables("Estimation").Rows.Add(DtRow)

            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)



            '************************4. Fill the Any Other Income Reported **********************
            '************************************************************************************

            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '4.' as Num,'Any Other Income Reported' as Components," & _
                                                    "sum(AmtTaxable) as Total " & _
                                                    "from [Trans] " & _
                                                    "where mid(Code,1,3)='O11' and " & _
                                                    "mid([Type],1,1)<>'H' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)


            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '' as Num,[Desc] as Components,Code," & _
                                                    "AmtTaxable as TaxableAmt " & _
                                                    "from [Trans] " & _
                                                    "where mid(Code,1,3)='O11' and " & _
                                                    "mid([Type],1,1)<>'H' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, True)


            '*****************5. Fill the Deduction Under Section VI-A **************************
            '************************************************************************************

            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '5.' as Num,' Deduction under Chapter VI-A' as Components ," & _
                                                    "sum(AmtTaxable) as Total " & _
                                                    "from [Trans] " & _
                                                    "where ((mid(Code,1,3)='D11' and " & _
                                                    "mid([Type],1,1)<>'H') or " & _
                                                    "Code='R11000') and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '' as Num,[Desc] as Components,Code," & _
                                                      "AmtTaxable as TaxableAmt " & _
                                                      "from [Trans] " & _
                                                      "where mid(Code,1,3)='R11' and " & _
                                                      "mid([Type],1,1)<>'H' and " & _
                                                      "AmtTaxable<>0 and " & _
                                                      "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), True, True)

            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '' as Num,[Desc] as Components,Code," & _
                                                      "AmtTaxable as TaxableAmt " & _
                                                      "from [Trans] " & _
                                                      "where mid(Code,1,3)='D11' and " & _
                                                      "mid([Type],1,1)<>'H' and " & _
                                                      "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, True)

            '**********************6. Fill the Total Income -Round Off  *************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '6.' as Num,' Total Income -Round Off' as Components," & _
                                                    "AmtTaxable as Total " & _
                                                    "from [Trans] " & _
                                                    "where Code='N00000' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            '**********************7. Fill the Tax on Total Income  *****************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '7.' as Num,' Tax on Total Income' as Components," & _
                                                    "AmtTaxable as Total " & _
                                                    "from [Trans] " & _
                                                    "where Code='T00001' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                lngTaxableIncome = Math.Round(Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total")), 0)

            '*************************8. Fill the Relief U/s 89 *********************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '8.' as Num,' Relief U/s 89' as Components," & _
                                                    "AmtTaxable as Total " & _
                                                    "from [Trans] " & _
                                                    "where Code='R14000' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                lngSurcharge = Math.Round(Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total")), 0)

            '*************************9. Fill the Surcharge *************************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '9.' as Num,' Surcharge' as Components," & _
                                                    "AmtTaxable as Total " & _
                                                    "from [Trans] " & _
                                                    "where Code='S99999' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            'lngSurcharge = TblRow.Cells.Item(intTblCol + 1).Text
            '*************************10. Fill the Educess **************************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()

            DtRow = dsProfile.Tables("Estimation").NewRow
            DtRow("Num") = "10."
            DtRow("Components") = "Educess"
            'mEduAmt = mTaxAmt - (mTaxAmt * 100 / (100 + EDUCESS_RATE_FY0809))'Taking from saltds code for estimation slip report
            DtRow("Total") = Math.Round((lngTaxableIncome + lngSurcharge) * EDUCESS_RATE, 0)
            dsProfile.Tables("Estimation").Rows.Add(DtRow)

            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            '***************************11. Fill the Tax Payable ********************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '11.'as Num,' Tax Payable' as Components," & _
                                                    "AmtTaxable as Total " & _
                                                    "from [Trans] " & _
                                                    "where Code='T00000' and " & _
                                                    "ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                lngTaxPayable = Math.Round(Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total")), 0)

            '******************12. Fill the Tax Deduction already made  *************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '12.' as Num,' Tax Deduction already made ' as Components," & _
                                                    "'TaxDedMade' as Code," & _
                                                    "Sum(TdsAmt) as Total " & _
                                                    "from Deduction " & _
                                                    "where ECode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), True, False)

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then _
                lngTaxDeducted = Math.Round(Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total")), 0)

            'Ver 4.82-2345 start
            '*************************13. Previous employer details *****************************
            '************************************************************************************
            'dsProfile.Tables("Estimation").Rows.Clear()

            'DtRow = dsProfile.Tables("Estimation").NewRow
            'DtRow("Num") = "13."
            'DtRow("Components") = "Tds deductable/Refundable"
            'DtRow("Total") = Math.Round(lngTaxPayable - lngTaxDeducted, 0)
            'dsProfile.Tables("Estimation").Rows.Add(DtRow)

            'Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            'tblMain.Rows(0).Cells(0).Text = "S.No."
            'tblMain.Rows(0).Cells(1).Text = "Particulars"

            'tblMain.Rows(0).Cells(3).HorizontalAlign = HorizontalAlign.Right
            'tblMain.Rows(0).Cells(4).HorizontalAlign = HorizontalAlign.Right
            'tblMain.Rows(0).Cells(5).HorizontalAlign = HorizontalAlign.Right
            'tblMain.Rows(0).Cells(6).HorizontalAlign = HorizontalAlign.Right
            'tblMain.Rows(0).Cells(1).HorizontalAlign = HorizontalAlign.Left
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '13.' as Num,' Previous Employer TDS ' as Components," & _
                                                   "TDS as Total " & _
                                                   "from EmpMaster " & _
                                                   "where EmpCode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            DtRow = dsProfile.Tables("Estimation").NewRow
            DtRow("Num") = "13."
            DtRow("Components") = "Previous Employer TDS"

            If dsProfile.Tables("Estimation").Rows.Count > 0 Then
                lngPreviousEmpTDS = Math.Round(Val("" & dsProfile.Tables("Estimation").Rows(dsProfile.Tables("Estimation").Rows.Count - 1).Item("Total")), 0)
            End If
            DtRow("Total") = lngTaxDeducted
            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            tblMain.Rows(0).Cells(0).Text = "S.No."
            tblMain.Rows(0).Cells(1).Text = "Particulars"


            tblMain.Rows(0).Cells(3).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(4).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(5).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(6).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(1).HorizontalAlign = HorizontalAlign.Left
            'Ver 4.82-2345 end

            '*************************14. Tds deductable/Refundable *****************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()

            DtRow = dsProfile.Tables("Estimation").NewRow
            DtRow("Num") = "14."
            DtRow("Components") = "Tds deductable/Refundable"
            DtRow("Total") = Math.Round(lngTaxPayable - lngTaxDeducted - lngPreviousEmpTDS, 0)
            dsProfile.Tables("Estimation").Rows.Add(DtRow)

            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            tblMain.Rows(0).Cells(0).Text = "S.No."
            tblMain.Rows(0).Cells(1).Text = "Particulars"

            tblMain.Rows(0).Cells(3).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(4).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(5).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(6).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(1).HorizontalAlign = HorizontalAlign.Left

            '*************************15. Income from previous employer *****************************
            '************************************************************************************
            dsProfile.Tables("Estimation").Rows.Clear()
            adp.SelectCommand.CommandText = "select '15.' as Num,' Previous Employer Income ' as Components," & _
                                                               "PrevSal as Total " & _
                                                               "from EmpMaster " & _
                                                               "where EmpCode='" & Session("EmpId") & "'"
            adp.Fill(dsProfile, "Estimation")
            DtRow = dsProfile.Tables("Estimation").NewRow
            DtRow("Num") = "15."
            DtRow("Components") = "Income from previous employer"
            DtRow = dsProfile.Tables("Estimation").NewRow
            dsProfile.Tables("Estimation").Rows.Add(DtRow)

            Call FillEstimationSlip(dsProfile.Tables("Estimation"), False, False)
            tblMain.Rows(0).Cells(0).Text = "S.No."
            tblMain.Rows(0).Cells(1).Text = "Particulars"

            tblMain.Rows(0).Cells(3).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(4).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(5).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(6).HorizontalAlign = HorizontalAlign.Right
            tblMain.Rows(0).Cells(1).HorizontalAlign = HorizontalAlign.Left

            'Ver 4.82-2345 end
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try

    End Sub

    Private Sub SetTableHeaders()
        Dim TblHRow As New TableHeaderRow
        TblHRow.CssClass = "tblheader"
        Dim TblHCell As New TableCell

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Num"
        TblHCell.Wrap = True
        TblHRow.Cells.Add(TblHCell)

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Components"
        'TblHCell.ColumnSpan = 2
        TblHRow.Cells.Add(TblHCell)

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Code"
        TblHCell.Visible = False

        TblHRow.Cells.Add(TblHCell)

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Amount<sub><img src='" & Session("img") & "'/></sub>"

        TblHRow.Cells.Add(TblHCell)

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Tax Free<sub><img src='" & Session("img") & "'/></sub>"
        TblHCell.Style("width") = "90px"
        TblHRow.Cells.Add(TblHCell)

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Taxable<sub><img src='" & Session("img") & "'/></sub>"
        TblHCell.Style("width") = "90px"
        TblHRow.Cells.Add(TblHCell)

        TblHCell = New TableHeaderCell
        TblHCell.Text = "Total<sub><img src='" & Session("img") & "'/></sub>"
        TblHCell.Style("width") = "90px"
        TblHRow.Cells.Add(TblHCell)

        tblMain.Rows.Add(TblHRow)

        tblMain.Rows.Item(0).CssClass = "GrdHeader"

    End Sub

    Private Sub FillEstimationSlip(ByVal objTblName As DataTable, ByVal blnIsHyperLnk As Boolean, ByVal blnSpace As Boolean)
        Try
            Dim TblRow As New TableRow
            Dim intI As Integer, intJ As Integer
            With objTblName
                For intI = 0 To .Rows.Count - 1
                    Dim intTblCol As Integer = 0

                    TblRow = New TableRow
                    If IsRowHL = True Then
                        TblRow.CssClass = "tblAlternetRow"
                        IsRowHL = False
                    Else
                        IsRowHL = True
                    End If
                    tblMain.Rows.Add(New TableRow)
                    tblMain.Rows.Add(TblRow)

                    If blnSpace = False Then
                        If blnIsHyperLnk = True Then
                            TblRow.Cells.Add(New TableCell)
                            TblRow.Cells.Item(0).Text = IIf(IsDBNull(.Rows(intI).Item("Num")), "", .Rows(intI).Item("Num"))
                            TblRow.Cells.Item(0).Font.Bold = True
                            TblRow.Cells.Add(New TableCell())
                            Dim hl As New HyperLink
                            hl.ForeColor = Drawing.Color.Blue
                            hl.Text = .Rows(intI).Item("Components")
                            ' hl.NavigateUrl = "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & ""
                            ' hl.Attributes.Add("onclick", "javascript:window.open('" & "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "','SalDet','toolbar=no, directories=no, resizable=no, width=590, height=560'); return false")
                            hl.Attributes.Add("onclick", "show('" & "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "');")

                            hl.Target = "_Blank"
                            hl.CssClass = "link"
                            hl.Font.Bold = True
                            TblRow.Cells.Item(1).Controls.Add(hl)
                        Else

                            TblRow.Cells.Add(New TableCell)
                            TblRow.Cells.Item(0).Text = IIf(IsDBNull(.Rows(intI).Item("Num")), "", .Rows(intI).Item("Num"))
                            TblRow.Cells.Item(0).Font.Bold = True
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(1).Text = IIf(IsDBNull(.Rows(intI).Item("Components")), "", .Rows(intI).Item("Components"))
                            TblRow.Cells.Item(0).Font.Bold = True
                            TblRow.Cells.Item(1).Font.Bold = True
                        End If
                        'TblRow.Cells.Item(0).ColumnSpan = 2
                        'TblRow.Cells.Add(New TableCell())
                        'TblRow.Cells.Item(1).Text = ""
                        intTblCol = 1
                        For intJ = 1 To .Columns.Count - 1
                            TblRow.Cells.Add(New TableCell())
                            If IsDBNull(.Rows(intI).Item(intJ)) = True Then
                                TblRow.Cells.Item(intTblCol + 1).Text = "&nbsp;"
                            Else
                                If IsNumeric(.Rows(intI).Item(intJ)) = True Then
                                    TblRow.Cells.Item(intTblCol + 1).Text = Val(.Rows(intI).Item(intJ))
                                    ' varalakshmi - 13May20 - surcharge to include in Educess - start
                                    If TblRow.Cells.Item(0).Text = "9." Then
                                        If intTblCol = 5 Then
                                            lngsurcharge = TblRow.Cells.Item(intTblCol + 1).Text
                                        End If
                                    End If
                                    ' varalakshmi - 13May20 - surcharge to include in Educess - end
                                Else
                                        TblRow.Cells.Item(intTblCol + 1).Text = .Rows(intI).Item(intJ)
                                End If
                            End If
                            TblRow.Cells.Item(intTblCol + 1).HorizontalAlign = HorizontalAlign.Right
                            intTblCol += 1
                        Next
                    Else
                        TblRow.Cells.Add(New TableCell())
                        TblRow.Cells.Item(0).Text = ""
                        'TblRow.Cells.Item(0).ColumnSpan = 0
                        If IsDBNull(.Rows(intI).Item("Code")) Then
                            If blnIsHyperLnk = True Then
                                TblRow.Cells.Add(New TableCell())
                                Dim hl As New HyperLink
                                hl.ForeColor = Drawing.Color.Blue
                                hl.Text = .Rows(intI).Item("Components")
                                'hl.NavigateUrl = ("EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "")
                                ' hl.Attributes.Add("onclick", "javascript:window.open('" & "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "','SalDet','toolbar=no, directories=no, resizable=no, width=590, height=560'); return false")
                                hl.Attributes.Add("onclick", "show('" & "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "');")

                                hl.CssClass = "link"
                                hl.Target = "_Blank"
                                TblRow.Cells.Item(1).Controls.Add(hl)
                            Else
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(1).Text = IIf(IsDBNull(.Rows(intI).Item("Components")), "", .Rows(intI).Item("Components"))
                            End If
                        ElseIf .Rows(intI).Item("Code") = "S13001" Then
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(1).Text = IIf(IsDBNull(.Rows(intI).Item("Components")), "", .Rows(intI).Item("Components"))
                        Else
                            If blnIsHyperLnk = True Then
                                TblRow.Cells.Add(New TableCell())
                                Dim hl As New HyperLink
                                hl.ForeColor = Drawing.Color.Blue
                                hl.Text = .Rows(intI).Item("Components")
                                ' hl.NavigateUrl = ("EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "")
                                'hl.Attributes.Add("onclick", "javascript:window.open('" & "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "','SalDet','toolbar=no, directories=no, resizable=no, width=590, height=560'); return false")
                                hl.Attributes.Add("onclick", "show('" & "EstDetails.aspx?Code=" & .Rows(intI).Item("Code") & "');")

                                hl.CssClass = "link"
                                hl.Target = "_Blank"
                                TblRow.Cells.Item(1).Controls.Add(hl)
                            Else
                                TblRow.Cells.Add(New TableCell())
                                TblRow.Cells.Item(1).Text = IIf(IsDBNull(.Rows(intI).Item("Components")), "", .Rows(intI).Item("Components"))
                            End If
                        End If
                        TblRow.Cells.Item(1).Font.Bold = False
                        TblRow.Cells.Item(0).Font.Bold = False
                        intTblCol = 2
                        For intJ = 1 To .Columns.Count - 1
                            TblRow.Cells.Add(New TableCell())
                            TblRow.Cells.Item(intTblCol).Text = IIf(IsDBNull(.Rows(intI).Item(intJ)), "&nbsp;", .Rows(intI).Item(intJ))
                            TblRow.Cells.Item(intTblCol).HorizontalAlign = HorizontalAlign.Right
                            intTblCol += 1
                        Next
                    End If

                    TblRow.Cells.Item(2).Visible = False
                    TblRow.Cells.Item(7).Visible = False
                    'End If
                Next intI

            End With

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try

    End Sub
    'Ver 3.2-E398 Start
    Private Sub PrintPDF()
        Try

      
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim tmpdt As New DataTable()
        Dim pdfdt As New DataTable()
        Dim da As New OleDbDataAdapter("select distinct code,desc from trans", objCon.ConnectionString)
        da.Fill(tmpdt)
        pdfdt.Columns.Add("Particulars")
        pdfdt.Columns.Add("Amount")
        pdfdt.Columns.Add("Tax Free")
        pdfdt.Columns.Add("Taxable")
        pdfdt.Columns.Add("Total")
        For i = 1 To tblMain.Rows.Count - 1
            If Not tblMain.Rows(i).Cells.Count = 0 Then
                Dim strarr() As String = {"", "", "", "", "", ""}
                strarr(0) = tblMain.Rows(i).Cells(1).Text.Replace("&nbsp;", "")
                strarr(1) = tblMain.Rows(i).Cells(2).Text.Replace("&nbsp;", "")
                If Not strarr(1).Trim() = "" Then
                    Try
                        strarr(0) = tmpdt.Select("code='" & strarr(1).Trim() & "'")(0).Item(1).ToString()
                    Catch ex As Exception
                        strarr(0) = strarr(1)
                    End Try

                End If
                strarr(2) = tblMain.Rows(i).Cells(3).Text.Replace("&nbsp;", "")
                strarr(3) = tblMain.Rows(i).Cells(4).Text.Replace("&nbsp;", "")
                strarr(4) = tblMain.Rows(i).Cells(5).Text.Replace("&nbsp;", "")
                strarr(5) = tblMain.Rows(i).Cells(6).Text.Replace("&nbsp;", "")
                pdfdt.Rows.Add(strarr(0), strarr(2), strarr(3), strarr(4), strarr(5))
            End If
        Next
        Dim dspdf As New DataSet
        dspdf.Tables.Add(pdfdt)
        Dim pdfForm As New PDFform(dspdf, "0", "8.0in")
        Dim document As MigraDoc.DocumentObjectModel.Document = pdfForm.CreateDocument()
        document.UseCmykColor = True
        Dim pdfRenderer As New PdfDocumentRenderer(True)
        pdfRenderer.Document = document
        pdfRenderer.RenderDocument()
        Dim ms As New System.IO.MemoryStream()
        pdfRenderer.Save(ms, True)
        Dim byteArray() As Byte = ms.ToArray()
        HttpContext.Current.Response.ContentType = "Application/pdf"
        HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=EstimationSlip.pdf")
        HttpContext.Current.Response.AddHeader("Content-Length", byteArray.Length.ToString())
        HttpContext.Current.Response.ContentType = "application/octet-stream"
        HttpContext.Current.Response.BinaryWrite(byteArray)
        HttpContext.Current.Response.End()
        Catch ex As Exception
            Alert.Show("No data found")
        End Try
    End Sub
    'Ver 3.2-E398 End
End Class
