﻿<%@ Page Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false"
    CodeFile="HolidayList.aspx.vb" Inherits="HolidayList" Title="Holiday List" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="ajaxToolkit" %>
<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <style type="text/css">
        .lbl
        {
            font-weight: 700;
        }
    </style>
  
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <table>
        <tr>
            <td>
                <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" 
                                    CellSpacing="1"   CellPadding="1" GridLines="None">
                                    
                    <HeaderStyle CssClass="GrdHeader" HorizontalAlign="Center" />
                    <Columns>
                        <asp:TemplateField HeaderText="Sr. No." SortExpression="State" ItemStyle-Width="40px"
                            ItemStyle-HorizontalAlign="Right">
                            <ItemTemplate>
                                <asp:Label ID="lblSrno" runat="server" Text='<%#Container.DataItemIndex + 1%>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Festival" ItemStyle-Width="300px">
                            <ItemTemplate>
                                <asp:Label ID="lblFestival" runat="server" Text='<%# Bind("festivalname") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Date" SortExpression="qt" ItemStyle-HorizontalAlign="Center"
                            ItemStyle-Width="70px">
                            <ItemTemplate>
                                <asp:Label ID="lblDate" runat="server" Text='<%# Bind("fstdate") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Day" SortExpression="qt" ItemStyle-Width="70px">
                            <ItemTemplate>
                                <asp:Label ID="lblDayname" runat="server" ItemStyle-HorizontalAlign="Right" Text='<%#  DayName(Eval("fstdate")) %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="SR" SortExpression="qt">
                            <ItemTemplate>
                                <asp:Label ID="lblDay" runat="server" Text='<%# Bind("SrNo") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
            </td>
        </tr>
    </table>
    <script type="text/javascript"src="js/jquery-latest.js"></script>
    <p></p>
    <table style="width: 99%;" id="tbldtl" runat="server">
        <tr>
            <td class="style1">
                <asp:Label ID="Label1" CssClass="lbl" runat="server" Text="Festival"></asp:Label>
            </td>
            <td>
                <asp:TextBox ID="txtFestival" runat="server" CssClass="txtbox" Height="16px" Width="144px"
                    ValidationGroup="hl"></asp:TextBox>
                <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="txtFestival"
                    ErrorMessage="*" ValidationGroup="hl"></asp:RequiredFieldValidator>
            </td>
            <td rowspan="4">
            </td>
        </tr>
        <tr>
            <td class="style1">
                <b>
                    <asp:Label ID="Label3" runat="server" Text="Date "></asp:Label>
                    &nbsp;(dd-mm-yyyy)</b>
            </td>
            <td>
                <asp:TextBox ID="txtDate" runat="server" CssClass="txtbox" Height="16px" Width="144px"
                    ValidationGroup="ccf"></asp:TextBox>
                <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="txtDate"
                    ErrorMessage="*" ValidationGroup="hl"></asp:RequiredFieldValidator>
                <asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" ControlToValidate="txtDate"
                    ErrorMessage="Date Error" ValidationExpression="^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$"
                    ValidationGroup="hl"></asp:RegularExpressionValidator>
            </td>
        </tr>
        <tr id="btnctrl" runat="server">
            <td align="center" id="allbtn" colspan="2" runat="server">
                &nbsp;<asp:Button ID="btnAdd" runat="server" Text="Add" ValidationGroup="hl" Width="66px"
                    OnClientClick="BtnAdd();return false;" />
                <asp:Button ID="btnModify" runat="server" Text="Modify" Width="62px" OnClientClick="BtnModify();return false;"
                    ValidationGroup="hl" />
                <asp:Button ID="btnSave" runat="server" Enabled="False" Text="Save" ValidationGroup="hl"
                    Width="75px" />
                <asp:Button ID="btnDelete" runat="server" Enabled="False" Text="Delete" ValidationGroup="ccf"
                    Width="60px" />
                <asp:Button ID="btncencel" runat="server" Text="Cancel" OnClientClick="BtnCancle();return false;" />
                        <asp:Button ID="btnRestore" runat="server" Text="Import" Width="54px" 
                    Visible="False" />
            </td>
        </tr>
        <tr id="trset" runat="server">
                    <td  align="left" colspan="2">
                        <strong>Please set FY for this data: </strong>&nbsp;<asp:DropDownList ID="ddltmpfy" runat="server">
                            <asp:ListItem>2011-2012</asp:ListItem>
                            <asp:ListItem>2012-2013</asp:ListItem>
                            <asp:ListItem>2013-2014</asp:ListItem>
                        </asp:DropDownList>
                        &nbsp;&nbsp;
                        <asp:Button ID="btnSet" runat="server" Text="Set" Width="50px" />
                    </td>
                </tr>
        <tr>
            <td align="center" colspan="2">
                <asp:Label ID="lblMessage" runat="server" Style="font-weight: 700"></asp:Label>
                <asp:HiddenField ID="hdSrNo" runat="server" />
            </td>
        </tr>
    </table>

    <script type="text/javascript">
   
    var previousRow;   
   
    function gvRowClick(row,color,gvClientID)
    {   
            if (previousRow == row)
                return;        
            else if (previousRow != null)     
                document.getElementById(previousRow).style.backgroundColor = "#ffffff";            
            
            try
            {
                document.getElementById(row).style.backgroundColor = color ;                            
                previousRow = row;                 
                
                var strCode = $.trim($(document.getElementById(gvClientID).rows[row].cells[1]).text());            
                var strReason =$.trim($(document.getElementById(gvClientID).rows[row].cells[2]).text()); 
                var SrNo =$.trim($(document.getElementById(gvClientID).rows[row].cells[4]).text()); 
            
                if ( strCode != null)
                {
                    document.getElementById('<%=txtFestival.ClientID%>').value = strCode;   
                    document.getElementById('<%=txtDate.ClientID%>').value = strReason;   
                    document.getElementById('<%=hdSrNo.ClientID%>').value = SrNo;

                    document.getElementById("<%= btnModify.ClientID %>").disabled = false;
                    document.getElementById("<%= btnDelete.ClientID %>").disabled = false;
                    document.getElementById("<%= btnAdd.ClientID %>").disabled = true;              
                }                
            }
            catch(err)
            {            
            }       
             
    }

    </script>

    <script type="text/javascript">
    document.onload=Load();
    function Load()
    { 
    DisableControl();      
    BtnCancle();
    document.getElementById('<%=hdSrNo.ClientID%>').value="";  
   
    }
    function DisableControl()
    {
        document.getElementById("<%= txtFestival.ClientID %>").disabled = true;
        document.getElementById("<%= txtDate.ClientID %>").disabled = true;
    }
    function EnableControl()
    {            
       document.getElementById("<%= txtFestival.ClientID %>").disabled = false;
       document.getElementById("<%= txtDate.ClientID %>").disabled = false;
    }
    function BtnAdd() {
        EnableControl();

        ClearControl();
        document.getElementById("<%= btnModify.ClientID %>").disabled = true;
        document.getElementById("<%= btnSave.ClientID %>").disabled = false;
        document.getElementById("<%= btnDelete.ClientID %>").disabled = true;
        document.getElementById("<%= btnAdd.ClientID %>").disabled = true;
    }
    function BtnModify()
    {
        document.getElementById("<%= btnModify.ClientID %>").disabled = true;
        document.getElementById("<%= btnSave.ClientID %>").disabled = false;
        document.getElementById("<%= btnDelete.ClientID %>").disabled = true;
        document.getElementById("<%= btnAdd.ClientID %>").disabled = true;
      EnableControl();
    }
    function BtnCancle()
    { 
    try{
        document.getElementById("<%= btnModify.ClientID %>").disabled = true;
        document.getElementById("<%= btnSave.ClientID %>").disabled = true;
        document.getElementById("<%= btnDelete.ClientID %>").disabled = true;
        document.getElementById("<%= btnAdd.ClientID %>").disabled = false;
     ClearControl();
      DisableControl();
    document.getElementById(previousRow).style.backgroundColor = "#ffffff";     
    previousRow=null; 
    }catch(err){}
    }
    function ClearControl()
    {
       $("[id$=txtFestival]").val("");
       $("[id$=txtDate]").val("");   
        document.getElementById('<%=hdSrNo.ClientID%>').value="";  
    }
    
   
    </script>

</asp:Content>
