﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing
Partial Class HolidayList
    Inherits System.Web.UI.Page

    Dim strconn As String
    Dim strEmployeeId As String
    Dim g As General
    Dim arrdate() As String

    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        Try
            If Session("EmpId").ToString() <> "Admin" Then
                Me.MasterPageFile = "MasterPage.master"
                'Ver 3.2-E398 Start
                Master.FindControl("imgPDF").Visible = False
                'Ver 3.2-E398 end
            End If
        Catch ex As Exception

        End Try

    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        ElseIf StrComp(Session("EmpId"), "Admin") <> 0 Then
            tbldtl.Visible = False
        End If
        trset.Visible = False
        arrdate = New String() {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}

        strconn = "Provider=Microsoft.Jet.OLEDB.4.0;data source=" & Server.MapPath(".") & "\Emails.mdb;jet OLEDB:Database Password=Ffcs"
        If Not Page.IsPostBack Then
            IsTableExist()
            If ExicuteDML("update Festival  set FY=FY where fy is null or fy=''") > 0 Then
                btnctrl.Visible = False
                trset.Visible = True
                BindData("'' or FY is null")
            Else
                BindData("'" & Session("Period") & "'")
            End If

        End If
        btnModify.Attributes.Add("onclick", "enbCtrl();")
        btncencel.Attributes.Add("onclick", "disCtrl();ClearCtrl();")
        GridView1.Columns(4).ItemStyle.CssClass = "hidden"
        GridView1.Columns(4).HeaderStyle.CssClass = "hidden"
        GridView1.Columns(4).FooterStyle.CssClass = "hidden"
        'GridView1.Columns(3).ItemStyle.CssClass = "hidden"
        ' GridView1.Columns(3).HeaderStyle.CssClass = "hidden"
        'GridView1.Columns(3).FooterStyle.CssClass = "hidden"
        If StrComp(Session("EmpId"), "Admin") <> 0 Then
            ColorRow()


        End If
    End Sub
    Private Sub IsTableExist()
        Try
            Dim ds As DataSet = New DataSet()
            Dim da As OleDbDataAdapter = New OleDbDataAdapter("select top 1 * from Festival", strconn)
            da.Fill(ds)
        Catch ex As Exception
            ExicuteDML("create table Festival (SrNo autoincrement,festivalname text(255),fstdate datetime,CompanyCode text(20) )")
        End Try
        'ver 2.9-4 Start
        Try
            ExicuteDML("alter table Festival add column FY text(10)")
        Catch ex As Exception
        End Try
        'ver 2.9-4 End
    End Sub

    Function Data(ByVal strQuery As String) As DataSet
        Dim ds As DataSet = New DataSet()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strQuery, strconn)
        da.Fill(ds)
        Return ds
    End Function
    Protected Function ExicuteDML(ByVal strQuery As String) As Integer
        'ver 3.2-CRK Start
        'Dim i As Integer = 0
        'Try
        '    Dim con As OleDbConnection = New OleDbConnection(strconn)
        '    Dim cmd As OleDbCommand = New OleDbCommand(strQuery, con)
        '    con.Open()
        '    i = cmd.ExecuteNonQuery()
        '    con.Close()
        'Catch ex As Exception
        'End Try
        'Return i
        Return General.ExecuteDML(strconn, strQuery)
        'ver 3.2-CRK End

    End Function

    Public Function DayName(ByVal dt As Object) As String
        Dim strF() As String
        strF = dt.ToString().Split("-")
        Return arrdate(DateTime.Parse(strF(2) + "/" + strF(1) + "/" + strF(0)).DayOfWeek)
    End Function

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If IsRecordExist() Then
            'ver 2.9-4 Start
            ExicuteDML("update festival set festivalname='" + txtFestival.Text.Replace("'", "''") + "', fstdate=" + g.DateStrings(txtDate.Text) + ",FY='" + Session("Period") + "' where SrNo=" + hdSrNo.Value)
            'ver 2.9-4 end
            lblMessage.Text = "Record Update successfully."
        Else
            'ver 2.9-4 Start
            ExicuteDML("Insert Into festival (festivalname, fstdate,CompanyCode,FY) Values ('" & txtFestival.Text & "'," + g.DateStrings(txtDate.Text) + ",'" + Session("CoCode") + "','" + Session("Period") + "')")
            'ver 2.9-4 End
            lblMessage.Text = "Record add successfully."
        End If
        BindData("'" & Session("Period") & "'")
        lblMessage.ForeColor = Color.Green
    End Sub
    Sub BindData(ByVal fy As String)
        Dim ds As DataSet = Data("SELECT SrNo,festivalname, format(fstdate,'dd-MM-yyyy') as fstdate,day(Festival.fstdate) as fstday FROM Festival where CompanyCode='" + Session("CoCode") + "' and  FY=" + fy + " ")
        GridView1.DataSource = ds
        GridView1.DataBind()
    End Sub
    Protected Function IsRecordExist() As Boolean
        Dim b As Boolean
        Dim con As OleDbConnection = New OleDbConnection(strconn)
        '    Dim cmd As OleDbCommand = New OleDbCommand("select * from festival where festivalname='" + txtFestival.Text + "' and fstdate=" + General.DateStrings(txtDate.Text) + "", con)
        Dim cmd As OleDbCommand = New OleDbCommand("select * from festival where SrNo=" + IIf(hdSrNo.Value = "", "null", hdSrNo.Value), con)
        Try
            con.Open()
            Dim rd As OleDbDataReader = cmd.ExecuteReader()
            b = rd.HasRows
            rd.Close()
        Catch ex As Exception
            'ver 3.2-CRK Start
        Finally
            con.Close()
            'ver 3.2-CRK end
        End Try
        Return b
    End Function

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        ExicuteDML("delete from  festival where SrNo=" + IIf(hdSrNo.Value = "", "null", hdSrNo.Value))
        BindData("'" & Session("Period") & "'")
        lblMessage.Text = "Record delete successfully."
        lblMessage.ForeColor = Color.Green
    End Sub
    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView1.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            e.Row.Attributes.Add("ID", e.Row.UniqueID.Replace("$", "_"))
            e.Row.Attributes.Add("onclick", "javascript:gvRowClick('" + e.Row.UniqueID.Replace("$", "_") + "','#E0E0E0','" + GridView1.ClientID + "')")
        End If
    End Sub
    Private Sub ColorRow()
        Try
            For i = 0 To GridView1.Rows.Count
                If (i Mod 2 = 0) Then
                    GridView1.Rows(i).CssClass = "tblAlternetRow"
                End If
            Next
        Catch ex As Exception
        End Try

    End Sub

    Private Sub ImportHoliday()
        Dim str() As String = System.IO.File.ReadAllLines(Server.MapPath(".") & "\holidaylist.txt")
        Dim i As Integer = 0
        For i = 0 To str.Length - 1
            Dim row() As String = str(i).Split(",")
            ExicuteDML("Insert Into festival (festivalname, fstdate,CompanyCode,FY) Values ('" & row(0) & "'," + General.DateStrings(row(1)) + ",'" + Session("CoCode") + "','" + Session("Period") + "')")
        Next
    End Sub
    Protected Sub btnRestore_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRestore.Click
        ImportHoliday()
        BindData("'" & Session("Period") & "'")
    End Sub
    'ver 2.9-4 Start
    Protected Sub btnSet_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSet.Click
        ExicuteDML("update festival set FY='" & ddltmpfy.SelectedValue & "' where fy is null or fy=''")
        Server.Transfer("holidaylist.aspx")
    End Sub
    'ver 2.9-4 End
End Class
