Imports System.Data
Imports System.Data.OleDb
Imports MigraDoc.Rendering
Partial Class Home
    Inherits System.Web.UI.Page

    Private dsProfile As New DataSet
    Private dr As DataRow
    Private msg, strimg1, strimg2, qry As String
    Private sqlcon As OleDbConnection
    Private strQuery As String
    Private sqlcmd As New OleDb.OleDbCommand
    Private adp As New OleDb.OleDbDataAdapter
    'Ver 3.2-E398 Start
    Private Shared tmp As Integer
    Dim dspdf As New DataSet
    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        AddHandler Master.Print_PDF, AddressOf PrintPDF
    End Sub
    'Ver 3.2-E398 End
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        sqlcon = New OleDb.OleDbConnection(Session("myconnection"))
        If Session("EmpId") = String.Empty Then
            Response.Redirect("EmpLogin.aspx")
        End If
        Call FillDetails()
        lblHeader.Text = "Welcome " + Session("EmpName")

        ''Kishor - 06-12-2019 - start to check 80EEA And 80EEB exist or not 
        Dim objCon As OleDbConnection
        objCon = New OleDbConnection(Session("invconnection"))

        Call CreateTable_80EEA_800EEB("80EEA", objCon.ConnectionString.ToString.Trim)
        Call CreateTable_80EEA_800EEB("80EEB", objCon.ConnectionString.ToString.Trim)

        Call Check_80EEA_800EEB("Details", "80EEA", objCon.ConnectionString.ToString.Trim)
        Call Check_80EEA_800EEB("Details", "80EEB", objCon.ConnectionString.ToString.Trim)

        '''Kishor - 06-12-2019 - to check 80EEA And 80EEB exist or not


        '' added by kishor -22-03-2020 - start to check TaxNewRegime exist or not 
        Call CreateTable_TaxNewRegime("TaxNewRegime", objCon.ConnectionString.ToString.Trim)
        '' added by kishor -22-03-2020 - start to check TaxNewRegime exist or not


    End Sub

    '===kishor===='

    Private Sub CreateTable_TaxNewRegime(ByVal tblName As String, ByVal cnnStr As String)
        Dim con As New OleDb.OleDbConnection(cnnStr)
        con.Open()

        'Get database schema
        Dim dbSchema As DataTable = con.GetOleDbSchemaTable(OleDb.OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, tblName, "TABLE"})

        con.Close()

        ' If the table exists, the count = 1
        If dbSchema.Rows.Count = 0 Then
            ' e.g. create a table
            Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] (SrNo AUTOINCREMENT,[EmployeeCode] TEXT(20),[EmpInsert] datetime)", con)
            con.Open()
            cmd.ExecuteNonQuery()
            con.Close()
        End If
    End Sub

    Private Sub Check_80EEA_800EEB(ByVal tblName As String, ByVal fldName As String, ByVal cnnStr As String)
        Try
            ' Open connection to the database
            Dim dbConn As New OleDbConnection(cnnStr)
            dbConn.Open()
            Dim dbTbl As New DataTable
            Dim DoesFieldExist As Boolean

            ' Get the table definition loaded in a table adapter
            Dim strSql As String = "Select TOP 1 * from " & tblName
            Dim dbAdapater As New OleDbDataAdapter(strSql, dbConn)
            dbAdapater.Fill(dbTbl)

            ' Get the index of the field name
            Dim i As Integer = dbTbl.Columns.IndexOf(fldName)

            If i = -1 Then
                'Field is missing
                DoesFieldExist = False

                'to add missing field
                Dim intRecordsAffected As Integer
                adp = New OleDbDataAdapter("ALTER TABLE Details ADD COLUMN " & fldName & " TEXT(255)", dbConn)
                If sqlcon.State = ConnectionState.Closed Then
                    sqlcon.Open()
                End If
                intRecordsAffected = adp.SelectCommand.ExecuteNonQuery()
                sqlcon.Close()

            Else
                'Field is there
                DoesFieldExist = True
                Exit Sub
            End If
        Catch ex As Exception
            ''lblMessage.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub CreateTable_80EEA_800EEB(ByVal tblName As String, ByVal cnnStr As String)
        Dim con As New OleDb.OleDbConnection(cnnStr)
        con.Open()

        'Get database schema
        Dim dbSchema As DataTable = con.GetOleDbSchemaTable(OleDb.OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, tblName, "TABLE"})

        con.Close()

        ' If the table exists, the count = 1
        If dbSchema.Rows.Count = 0 Then
            ' e.g. create a table
            ' Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] ([Field1] TEXT(10), [Field2] TEXT(10))", con)
            Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] (SrNo AUTOINCREMENT,[EmployeeCode] TEXT(20),[Amount] TEXT(100),[IsProofAttach] YesNo,[Isproofapproved] YesNo,[Reason] TEXT(150),[isproofreject] YesNo,[EmpInsert] datetime,[EmpUpdate] datetime,[AdminUpdate] DateTime)", con)
            'Dim cmd As New OleDb.OleDbCommand("CREATE TABLE [" + tblName + "] ([EmployeeCode] TEXT(20),[Amount] TEXT(100),[IsProofAttach] YesNo)", con)
            con.Open()
            cmd.ExecuteNonQuery()
            con.Close()
        End If
    End Sub
    '====kishor==='


    Private Sub FillDetails()
        Try
            adp = New OleDbDataAdapter("select * FROM EmpMaster where EmpCode='" & Session("EmpId") & "'", sqlcon)
            adp.Fill(dsProfile, "EmpMaster")
            ' Call FillHome(dsProfile.Tables("EmpMaster"))
            FillEmp(dsProfile.Tables(0).Rows(0))
            FillUserDefineField()
        Catch ex As Exception
            '--lblMsg.Text = "Error - " & ex.Message.ToString
        End Try
    End Sub
    Function GetDate(ByVal dt As String) As String
        Dim rtn As String = dt
        Try
            rtn = Convert.ToDateTime(dt).ToString("dd/MM/yyyy")
        Catch ex As Exception
        End Try
        Return rtn
    End Function
    Private Sub FillEmp(ByVal dr As DataRow)
        dspdf = New DataSet()
        ltrEmpCode.Text = dr("EmpCode").ToString()
        ltrEmpName.Text = dr("EmpName").ToString()
        ltrAccNum.Text = dr("SBAccNo").ToString()
        ltrBank.Text = dr("Bank").ToString()
        ltrBirthDay.Text = GetDate(dr("DateOfBirth").ToString())
        ltrBranch.Text = dr("Branch").ToString()
        ltrcategory.Text = dr("Category").ToString()
        ltrCost_center.Text = dr("CostCenter").ToString()
        ltrDateofConfirm.Text = GetDate(dr("ConfirmDate").ToString())
        ltrDepartmnt.Text = dr("Department").ToString()
        ltrDesig.Text = dr("Designation").ToString()
        '==>Jitendra
        '  ltrEmpAdd.Text = dr("Add1").ToString()
        ltrEmpAdd.Text = dr("Add1").ToString() & " " & dr("Add2").ToString() & " " & dr("Add3").ToString() & " " & dr("City").ToString() & " " & dr("Pin").ToString() & " " & dr("State").ToString()
        '<==Jitendra
        ltrESIC.Text = dr("ESICAccNo").ToString()
        ltrFHname.Text = dr("FHName").ToString()
        ltrGender.Text = dr("Sex").ToString()
        ltrGrade.Text = dr("Grade").ToString()
        ltrIFSCMICR.Text = dr("IFSCCode").ToString()
        ltrJoinDate.Text = GetDate(dr("DateOfJoin").ToString())
        ltrPan.Text = dr("PAN").ToString()
        ltrPFacc.Text = IIf(dr("PFPrefix").ToString().Trim().EndsWith("/"), dr("PFPrefix").ToString() & dr("PFAccNo").ToString(), dr("PFPrefix").ToString() & "/" & dr("PFAccNo").ToString())
        ltrSection.Text = dr("Section").ToString()
        ltrEmail.Text = dr("EmailId").ToString()
        'Ver 3.2-E398 Start
        Dim dt As New DataTable()
        dt.Columns.Add("F1")
        dt.Columns.Add("V1")
        dt.Columns.Add("F2")
        dt.Columns.Add("V2")
        dt.Rows.Add("Employee Code", dr("EmpCode").ToString(), "Branch", dr("Branch").ToString())
        dt.Rows.Add("Employee Name", dr("EmpName").ToString(), "Department", dr("Department").ToString())
        dt.Rows.Add("Father / Husband Name", dr("FHName").ToString(), "Designation", dr("Designation").ToString())
        dt.Rows.Add("Gender", dr("Sex").ToString(), "Grade", dr("Grade").ToString())
        dt.Rows.Add("Employee Address", dr("Add1").ToString(), "Cost_Center", dr("CostCenter").ToString())
        dt.Rows.Add("Employee PAN", dr("PAN").ToString(), "Category", "")
        dt.Rows.Add("Date of Birth", GetDate(dr("DateOfBirth").ToString()), "Section", "")
        dt.Rows.Add("Email Id", dr("EmailId").ToString(), "", "")
        dt.Rows.Add("Date of Joining", GetDate(dr("DateOfJoin").ToString()), "PF Account Number", IIf(dr("PFPrefix").ToString().Trim().EndsWith("/"), dr("PFPrefix").ToString() & dr("PFAccNo").ToString(), dr("PFPrefix").ToString() & "/" & dr("PFAccNo").ToString()))
        dt.Rows.Add("Date of Confirmation", GetDate(dr("ConfirmDate").ToString()), "ESIC Account Number", dr("ESICAccNo").ToString())
        dt.Rows.Add("", "", "", "")
        dt.Rows.Add("Employee Bank Name & Branch", dr("Bank").ToString(), "", "")
        dt.Rows.Add("Employee Bank Account Number", dr("SBAccNo").ToString(), "", "")
        dt.Rows.Add("Employee IFSC/MICR Code", dr("IFSCCode").ToString(), "", "")
        dspdf.Tables.Add(dt)
        'Ver 3.2-E398 End
    End Sub
    'Private Sub FillHome(ByVal objTblName As DataTable)
    '    Dim tblRow As TableRow
    '    Dim tblCol As TableCell

    '    With tblMain
    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Employee Code"
    '        tblCol.Width = Unit.Pixel(150)
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True

    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)
    '        tblRow.CssClass = "gvAlterNetRowStyle"

    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("EmpCode").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    " & objTblName.Rows(objTblName.Rows.Count - 1).Item("EmpCode")
    '            tblCol.Width = Unit.Pixel(300)
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Employee Name"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)

    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("EmpName").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    " & objTblName.Rows(objTblName.Rows.Count - 1).Item("EmpName")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Email Id"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)
    '        tblRow.CssClass = "gvAlterNetRowStyle"
    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("EmailId").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;     " & objTblName.Rows(objTblName.Rows.Count - 1).Item("EmailId")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Date of Joining"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)

    '        tblCol = New TableCell

    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("DateOfJoin").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;     " & Format(CDate(objTblName.Rows(objTblName.Rows.Count - 1).Item("DateOfJoin").ToString), "dd/MM/yyyy")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Date of Leaving"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)
    '        tblRow.CssClass = "gvAlterNetRowStyle"
    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("DateOfLeaving").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;     " & Format(CDate(objTblName.Rows(objTblName.Rows.Count - 1).Item("DateOfLeaving").ToString), "dd/MM/yyyy")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Branch"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)

    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("Branch") = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;     " & objTblName.Rows(objTblName.Rows.Count - 1).Item("Branch")
    '        End If

    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Department"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)
    '        tblRow.CssClass = "gvAlterNetRowStyle"
    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("Department").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    " & objTblName.Rows(objTblName.Rows.Count - 1).Item("Department")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Designation"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)

    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("Designation").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;     " & objTblName.Rows(objTblName.Rows.Count - 1).Item("Designation")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)


    '        tblCol = New TableCell
    '        tblCol.Text = "Grade"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)
    '        tblRow.CssClass = "gvAlterNetRowStyle"
    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("Grade").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; " & objTblName.Rows(objTblName.Rows.Count - 1).Item("Grade")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Cost Center"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)

    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("CostCenter").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   " & objTblName.Rows(objTblName.Rows.Count - 1).Item("CostCenter")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)


    '        tblCol = New TableCell
    '        tblCol.Text = "Category"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)
    '        tblRow.CssClass = "gvAlterNetRowStyle"
    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("Category").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   " & objTblName.Rows(objTblName.Rows.Count - 1).Item("Category")
    '        End If
    '        tblRow.Cells.Add(tblCol)

    '        tblRow = New TableRow
    '        .Rows.Add(tblRow)

    '        tblCol = New TableCell
    '        tblCol.Text = "Section"
    '        'Ver 2.2-1 start
    '        tblCol.Font.Bold = True
    '        'Ver 2.2-1 end
    '        tblRow.Cells.Add(tblCol)

    '        tblCol = New TableCell
    '        If objTblName.Rows(objTblName.Rows.Count - 1).Item("Section").ToString = "" Then
    '            tblCol.Text = ":"
    '        Else
    '            tblCol.Text = ":&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    " & objTblName.Rows(objTblName.Rows.Count - 1).Item("Section")
    '        End If
    '        tblRow.Cells.Add(tblCol)
    '    End With
    'End Sub
    Private Sub FillUserDefineField()
        Dim tmpdt As DataTable = New DataTable()
        tmpdt.Columns.Add("Field Name")
        tmpdt.Columns.Add("Value")
        Dim tmpdt1 As DataTable = New DataTable()
        tmpdt1.Columns.Add("Field Name")
        tmpdt1.Columns.Add("Value")
        ' tmpdt.Columns.Add("GrdID")
        Dim mstdt As DataTable = New DataTable()
        Dim dt As DataTable = New DataTable()
        adp = New OleDbDataAdapter("select * FROM udfvalues where EmpCode='" & Session("EmpId").ToString() & "'", sqlcon)
        adp.Fill(mstdt)
        adp = New OleDbDataAdapter("select name,FieldName FROM udfmaster ", sqlcon)
        adp.Fill(dt)
        For i = 0 To dt.Rows.Count - 1
            If mstdt.Rows(0)(dt.Rows(i)("FieldName").ToString()).ToString() <> "" Then
                If (i Mod 2) = 0 Then
                    tmpdt.Rows.Add(dt.Rows(i)("name").ToString(), mstdt.Rows(0)(dt.Rows(i)("FieldName").ToString()).ToString())
                Else
                    tmpdt1.Rows.Add(dt.Rows(i)("name").ToString(), mstdt.Rows(0)(dt.Rows(i)("FieldName").ToString()).ToString())

                End If

            End If
        Next
        'Ver 3.2-E398 Start
        dspdf.Tables.Add(tmpdt)
        dspdf.Tables.Add(tmpdt1)
        'Ver 3.2-E398 End
        gvmain.DataSource = tmpdt
        gvmain.DataBind()
        grdLeft.DataSource = tmpdt1
        grdLeft.DataBind()
    End Sub
    Function GetData(ByVal dr() As DataRow) As DataTable
        Dim dtmp As New DataTable()
        Dim i As Integer
        For i = 0 To dr.Length - 1
            dtmp.Rows.Add(dr(i))
        Next
        Return dtmp
    End Function
    Function GetAltrnet() As Integer
        If tmp = 0 Then
            tmp = 1
        Else
            tmp = 0
        End If
        Return tmp
    End Function
    'Ver 3.2-E398 Start
    Private Sub PrintPDF()
        FillDetails()
        Dim pdfForm As New PDFform(dspdf, "0", "8.0in")
        Dim document As MigraDoc.DocumentObjectModel.Document = pdfForm.CreateDocument()
        document.UseCmykColor = True
        Dim pdfRenderer As New PdfDocumentRenderer(True)
        pdfRenderer.Document = document
        pdfRenderer.RenderDocument()

        Dim ms As New System.IO.MemoryStream()
        pdfRenderer.Save(ms, True)
        Dim byteArray() As Byte = ms.ToArray()
        HttpContext.Current.Response.ContentType = "Application/pdf"
        HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=" & Session("PageName") & ".pdf")
        HttpContext.Current.Response.AddHeader("Content-Length", byteArray.Length.ToString())
        HttpContext.Current.Response.ContentType = "application/octet-stream"
        HttpContext.Current.Response.BinaryWrite(byteArray)
        HttpContext.Current.Response.End()
    End Sub
    'Ver 3.2-E398 End
End Class
