Imports System.Data
Imports System.Data.OleDb

Partial Class Reimbursement
    Inherits System.Web.UI.Page

    Dim objCon As OleDbConnection
    Dim adp As New OleDbDataAdapter
    Dim dsProfile As New DataSet
    Dim strPeriod As String
    Dim dd As DropDownList = New DropDownList()
    Dim dspdf As New DataSet
    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        AddHandler Master.Print_PDF, AddressOf PrintPDF
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("EmpId") = String.Empty Then
                Response.Redirect("EmpLogin.aspx")
            End If
            objCon = New OleDbConnection(Session("myconnection"))

            strPeriod = Session("cMonth")

            lblEmpCode.Text = Session("EmpId")
            lblName.Text = Session("EmpName")
            lblFY.Text = Session("Period")
            dd = CType(Master.FindControl("cmbMonth"), DropDownList)
            dd.Visible = True
            Dim ltmon As Literal = CType(Master.FindControl("ltrmon"), Literal)
            ltmon.Visible = True
            AddHandler dd.SelectedIndexChanged, AddressOf PageRefresh
            Call FillReimbursement()
            gdReimb.HeaderRow.Cells(0).HorizontalAlign = HorizontalAlign.Left
            gdReimb.HeaderRow.Cells(0).Width = Unit.Pixel(200)
            gdReimb.HeaderRow.Cells(1).Width = Unit.Pixel(100)
            gdReimb.HeaderRow.Cells(2).Width = Unit.Pixel(100)
            gdReimb.HeaderRow.Cells(3).Width = Unit.Pixel(100)
            gdReimb.HeaderRow.Cells(4).Width = Unit.Pixel(100)

        Catch ex As Exception

        End Try
    End Sub

    Private Sub FillReimbursement()
        Try
            Dim DataTbl As New DataTable
            Dim intI As Integer
            Dim dataCol As DataColumn
            Dim strCode As String

            adp = New OleDbDataAdapter("select distinct a.Code, b.Desc, a.Amount,a.Taxable from ReimPayment a " & _
                                                    " inner join ReimProcess b on a.Code=b.Code where " & _
                                                    " a.EmpCode='" & Session("EmpId") & "' and a.Month='" & strPeriod & "' ", objCon)
            adp.Fill(dsProfile, "ReimPay")

            If dsProfile.Tables("ReimPay").Rows.Count > 0 Then

                dataCol = New DataColumn("Earnings")
                DataTbl.Columns.Add(dataCol)
                'Ver 5.13-QC276 start
                dataCol = New DataColumn("Previous Year Closing Balance")
                DataTbl.Columns.Add(dataCol)
                'Ver 5.13-QC276 end
                dataCol = New DataColumn("Opening Balance")
                DataTbl.Columns.Add(dataCol)
                dataCol = New DataColumn("Claimed")
                DataTbl.Columns.Add(dataCol)
                dataCol = New DataColumn("Paid for Month")
                DataTbl.Columns.Add(dataCol)
                dataCol = New DataColumn("Closing Balance")
                DataTbl.Columns.Add(dataCol)

                For intI = 0 To dsProfile.Tables("ReimPay").Rows.Count - 1
                    Dim DataRow1 As DataRow = DataTbl.NewRow

                    DataRow1("Earnings") = dsProfile.Tables("ReimPay").Rows(intI).Item("Desc")
                 

                    DataRow1("Paid for Month") = Val(dsProfile.Tables("ReimPay").Rows(intI).Item("Amount"))
                    '--DataRow1("Taxable") = Val(dsProfile.Tables("ReimPay").Rows(intI).Item("Taxable"))
                    strCode = dsProfile.Tables("ReimPay").Rows(intI).Item("Code")

                    adp = New OleDbDataAdapter("select sum(Amount) as SAmt from ReimPayment where " & _
                                " EmpCode='" & Session("EmpId") & "' and val(Month) < " & Val(strPeriod) & " " & _
                                " and Code='" & strCode & "'", objCon)

                    adp.Fill(dsProfile, "ReimSum1")
                    'MsgBox(dsProfile.Tables("ReimSum1").Rows(0).Item("SAmt"))

                    adp = New OleDbDataAdapter("select " & MonthAdd(Right(strPeriod, 2)) & " as TotAmt from ReimProcess where " & _
                                " EmpCode='" & Session("EmpId") & "' and " & _
                                " Code='" & strCode & "'", objCon)
                    adp.Fill(dsProfile, "ReimSum2")


                    'Ver 5.13-QC276 start
                    adp = New OleDbDataAdapter("select Amount as ClosingAmt from ReimClosing where " & _
                              " EmpCode='" & Session("EmpId") & "'  and Code='" & strCode & "'", objCon)

                    adp.Fill(dsProfile, "ReimClosing")
                    If dsProfile.Tables("ReimClosing").Rows.Count > 0 Then
                        DataRow1("Previous Year Closing Balance") = Val(dsProfile.Tables("ReimClosing").Rows(0).Item("ClosingAmt").ToString)
                    End If
                    'Ver 5.13-QC276 end


                    If dsProfile.Tables("ReimSum1").Rows.Count > 0 Then
                        If Not dsProfile.Tables("ReimSum1").Rows(0).Item("SAmt") Is String.Empty Then
                            DataRow1("Claimed") = Val(dsProfile.Tables("ReimSum1").Rows(0).Item("SAmt").ToString)
                        Else
                            DataRow1("Claimed") = 0
                        End If
                    End If
                    If dsProfile.Tables("ReimSum2").Rows.Count > 0 Then
                        DataRow1("Opening Balance") = Val(dsProfile.Tables("ReimSum2").Rows(0).Item("TotAmt").ToString)
                    End If
                    'Ver 5.13-QC276 start
                    'DataRow1("Closing Balance") = Val("" & DataRow1("Opening Balance").ToString) - Val(dsProfile.Tables("ReimPay").Rows(intI).Item("Amount")) - Val("" & DataRow1("Claimed").ToString)
                    DataRow1("Closing Balance") = (Val("" & DataRow1("Previous Year Closing Balance").ToString) + Val("" & DataRow1("Opening Balance").ToString)) - Val(dsProfile.Tables("ReimPay").Rows(intI).Item("Amount")) - Val("" & DataRow1("Claimed").ToString)
                    'Ver 5.13-QC276 end
                    DataTbl.Rows.Add(DataRow1)
                    dsProfile.Tables("ReimSum1").Rows.Clear()
                    dsProfile.Tables("ReimSum2").Rows.Clear()
                    'Ver 5.13-QC276 start
                    dsProfile.Tables("ReimClosing").Rows.Clear()
                    'Ver 5.13-QC276 end

                Next intI
                dspdf.Tables.Add(DataTbl)
                gdReimb.DataSource = DataTbl
                gdReimb.DataBind()

                For intI = 0 To gdReimb.Rows.Count - 1
                    gdReimb.Rows(intI).Cells(0).HorizontalAlign = HorizontalAlign.Left
                Next

                gdReimb.Visible = True
            Else
                CType(Master.FindControl("hidrpt"), HiddenField).Value = ""
            End If

        Catch ex As Exception
            'lblMsg.Text = "Error - " & ex.Message.ToString
        End Try

    End Sub

    Function MonthAdd(ByVal intM As Integer) As String
        Dim iMonth As Integer

        MonthAdd = ""

        If intM > 3 Then
            For iMonth = 4 To intM
                If MonthAdd = "" Then
                    MonthAdd = "IIf(IsNull(" & MonthName(iMonth, True) & "), 0, " & MonthName(iMonth, True) & ")"
                Else
                    MonthAdd = MonthAdd & "+" & "IIf(IsNull(" & MonthName(iMonth, True) & "), 0, " & MonthName(iMonth, True) & ")"
                End If
            Next
        Else
            For iMonth = 4 To 12
                If MonthAdd = "" Then
                    MonthAdd = "IIf(IsNull(" & MonthName(iMonth, True) & "), 0, " & MonthName(iMonth, True) & ")"
                Else
                    MonthAdd = MonthAdd & "+" & "IIf(IsNull(" & MonthName(iMonth, True) & "), 0, " & MonthName(iMonth, True) & ")"
                End If
            Next
            For intM = 1 To intM
                MonthAdd = MonthAdd & "+" & "IIf(IsNull(" & MonthName(intM, True) & "), 0, " & MonthName(intM, True) & ")"
            Next
        End If
    End Function
    Private Sub PageRefresh()
        Session("CMonth") = Format(CDate(dd.SelectedItem.Value), "yyyyMM")
        
        Server.Transfer("Reimbursement.aspx")
    End Sub
    Private Sub PrintPDF()
        'FillReimbursement()
        Try
            Dim pdfForm As New PDFform(dspdf, "0", "11.0in")
            'Dim pdfForm As New PDFform(dsProfile, "0", "8.5in")
            Dim document As MigraDoc.DocumentObjectModel.Document = pdfForm.CreateDocument()

            document.UseCmykColor = True
            Dim pdfRenderer As New MigraDoc.Rendering.PdfDocumentRenderer(True)
            pdfRenderer.Document = document
            pdfRenderer.RenderDocument()
            Dim ms As New System.IO.MemoryStream()
            pdfRenderer.Save(ms, True)
            Dim byteArray() As Byte = ms.ToArray()
            HttpContext.Current.Response.ContentType = "Application/pdf"
            HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment; filename=ReimbursementDetails.pdf")
            HttpContext.Current.Response.AddHeader("Content-Length", byteArray.Length.ToString())
            HttpContext.Current.Response.ContentType = "application/octet-stream"
            HttpContext.Current.Response.BinaryWrite(byteArray)
            HttpContext.Current.Response.End()
        Catch ex As Exception
            Alert.Show("No data found")
        End Try
    End Sub
End Class
