Imports System.Data.OleDb
Imports System.Data
Imports System.IO

Partial Class ReplyDetails
    Inherits System.Web.UI.Page

    Dim objCon As OleDbConnection
    Dim objConPay As OleDbConnection
    Dim strSrNo As String
    Dim strEmpCode As String
    Dim strEmpName As String

    Dim strReplyText As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try
            If Session("CoCode") = String.Empty Then
                Response.Redirect("Login.aspx")
            End If
            Dim strPath As String
            strPath = Server.MapPath("App_Data") & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2)

            If File.Exists(strPath & "\PostQuery.mdb") Then
                objCon = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & strPath & "\PostQuery.mdb;jet OLEDB:Database Password=Ffcs")
            End If

            If File.Exists(strPath & "\Paypac.mdb") Then
                objConPay = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & strPath & "\Paypac.mdb;jet OLEDB:Database Password=Ffcs")
            End If

            objCon.Open()
            objConPay.Open()

            strSrNo = Request.QueryString("SrNo")

            strEmpCode = Session("EmpId")
            strEmpName = Session("EmpName")
            
            Call EmployeeDetails()
            Call FillDtls()

        Catch ex As Exception
            'ver 3.2-CRK start
        Finally
            objCon.Close()
            objConPay.Close()
            'ver 3.2-CRK End
        End Try

    End Sub

    Private Sub EmployeeDetails()
        Try

            Dim strEmpCd As String
            Dim dsPay As New DataSet
            Dim objCmd As New OleDbCommand("Select [EmpCode] From PostQueryDetails where SrNo =" & strSrNo & "", objCon)

            strEmpCd = objCmd.ExecuteScalar

            Dim adp As New OleDbDataAdapter("select 'Employee Code' as Fld1, ':' as col, EmpCode as Fld2, 'Joining Date' as Fld3, ': ' + format(DateOfJoin,'dd/MM/yyyy') as col2  from EmpMaster where EmpCode='" & strEmpCd & "'", objConPay)
            adp.Fill(dsPay, "EmpMaster")
            adp = New OleDbDataAdapter("select 'Employee Name' as Fld1, ':' as col, EmpName as Fld2, 'Email Address' as Fld3, ': ' + EmailId as col2 from EmpMaster where EmpCode='" & strEmpCd & "'", objConPay)
            adp.Fill(dsPay, "EmpMaster")

            gvReplies.DataSource = dsPay.Tables("EmpMaster")
            gvReplies.DataBind()
            gvReplies.HeaderRow.CssClass = "GrdHeader"

        Catch ex As Exception

        End Try
    End Sub

    Private Sub FillDtls()

        
        Dim strPath As String
        strPath = Server.MapPath("App_Data") & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2)
        Dim dt As DataTable = General.GetDataTable("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & strPath & "\PostQuery.mdb;jet OLEDB:Database Password=Ffcs", "Select [Description], format([DateTime],'dd/MM/yyyy') as [DateTime1], [ReplyText], format([ReplyDateTime],'dd/MM/yyyy') as [ReplyDateTime1],EmailId,Subject,QryID,SrNo  From PostQueryDetails where QryID=(select QryID from PostQueryDetails where SrNo =" & strSrNo & ") order by SrNo ")
        Dim sb1 As New StringBuilder()
      
        sb1.Append("<table style='width:100%' class='text_blue'>")
        Dim i As Integer = 0
        For i = dt.Rows.Count - 1 To 0 Step -1
          
            If IsDBNull(dt.Rows(i)("ReplyText")) = False And IsDBNull(dt.Rows(i)("ReplyDateTime1")) = False Then
                sb1.Append("  <tr><td><b>Replied On :</b>" & dt.Rows(i)("ReplyDateTime1") & "</td></tr><tr><td><b>Reply :</b> " & dt.Rows(i)("ReplyText") & "</td></tr><tr><td><hr style='border-style:dotted;border-color:Black;'  /></td></tr>")
                If i = dt.Rows.Count - 1 Then
                    btnSubmit.Visible = False
                    ltr.Visible = False
                    txtReply.Visible = False
                End If


            End If
            sb1.Append("<tr><td><b>" & "Query On : </b>" & dt.Rows(i)("DateTime1") & "</td></tr><tr><td><b>Query :</b> " & dt.Rows(i)("Description") & "</td></tr>")
            sb1.Append("<tr><td><hr style='border-style:double;height:3px;border-color:Black;' /></td></tr>")
        Next
        sb1.Append("</table>")
        Literal1.Text = sb1.ToString()

    End Sub
    Public Shared Function WriteCss() As String
        Dim css As String = ""
        css = General.GetData(System.Web.HttpContext.Current.Session("StyleCon"), "select CustomizeStyle from stylesheet")
        Return css
    End Function
    Protected Sub btnSubmit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSubmit.Click

        Dim oleDbCMD As New OleDbCommand

        Try

            'If Trim(txtReply.Text) = "" Then
            '    lblMsg.Text = "Enter the reply and try again!"

            '    Exit Sub
            'End If

            '--strReplyText = txtReply.Value
            'Ver 3.0 Start
            'oleDbCMD.CommandText = "update PostQueryDetails set ReplyText='" & strReplyText & vbNewLine & txtReply.Text & _
            '                    "', ReplyDateTime=#" & Month(Today) & "/" & Day(Today) & "/" & Year(Today) & " " & Now.ToLongTimeString & "# where SrNo=" & Val(strSrNo) & ""

            oleDbCMD.CommandText = "update PostQueryDetails set ReplyText='" & txtReply.Text().Replace("'", "''") & _
                            "', ReplyDateTime=#" & Month(Today) & "/" & Day(Today) & "/" & Year(Today) & " " & Now.ToLongTimeString & "# where SrNo=" & Val(strSrNo) & ""
            'Ver 3.0 End
            oleDbCMD.Connection = objCon
            'Ver 3.2-3604 Start  Problem:The 'objCon.Open()' code is commmented.
            'objCon.Open() 

            If objCon.State = ConnectionState.Closed Then
                objCon.Open()
            End If
            'Ver 3.2-3604 End

            oleDbCMD.ExecuteScalar()
            objCon.Close()
            btnSubmit.Visible = False
            ltr.Visible = False
            txtReply.Visible = False
            lblMsg.Text = "Reply sent successfully"

        Catch ex As Exception
            objCon.Close()
        End Try

    End Sub

End Class
