﻿<%@ Page Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false"
    CodeFile="RoleMaster.aspx.vb" Inherits="RoleMaster" Title="RoleMaster" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="ajaxToolkit" %>
<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <style type="text/css">
        .lbl
        {
            font-weight: 700;
        }
    </style>
  
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <table>
        <tr>
            <td>
                <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" 
                                    CellSpacing="1"   CellPadding="1" GridLines="None">
                    <PagerStyle BackColor="#284775" ForeColor="White" HorizontalAlign="Center" />
                                    <SelectedRowStyle BackColor="#E2DED6" Font-Bold="True" ForeColor="#333333" />
                                    <HeaderStyle CssClass="GrdHeader" />
                                    <AlternatingRowStyle CssClass="gvAlterNetRowStyle" />
                    <Columns>
                        <asp:TemplateField HeaderText="Sr. No." SortExpression="State" ItemStyle-Width="40px"
                            ItemStyle-HorizontalAlign="Right">
                            <ItemTemplate>
                                <asp:Label ID="lblSrno" runat="server" Text='<%#Container.DataItemIndex + 1%>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="RoleID" ItemStyle-Width="300px">
                            <ItemTemplate>
                                <asp:Label ID="lblFestival" runat="server" Text='<%# Bind("RoleID") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="RoleName" SortExpression="qt" ItemStyle-HorizontalAlign="Center"
                            ItemStyle-Width="70px">
                            <ItemTemplate>
                                <asp:Label ID="lblDate" runat="server" Text='<%# Bind("RoleName") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                     <asp:TemplateField HeaderText="Is Active" SortExpression="qt" ItemStyle-HorizontalAlign="Center"
                            ItemStyle-Width="70px">
                            <ItemTemplate>
                                <asp:CheckBox ID="chkActive" runat="server" Checked='<%# Bind("IsActive") %>' />
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
            </td>
        </tr>
    </table>
    <script type="text/javascript"src="js/jquery-latest.js"></script>
    <p></p>
    <table style="width: 99%;" id="tbldtl" runat="server">
        <tr>
            <td class="style1">
                <asp:Label ID="Label1" CssClass="lbl" runat="server" Text="RoleID"></asp:Label>
            </td>
            <td>
                <asp:TextBox ID="txtRoleID" runat="server" CssClass="txtbox" Height="16px" Width="144px"
                    ValidationGroup="hl"></asp:TextBox>
                <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="txtRoleID"
                    ErrorMessage="*" ValidationGroup="hl"></asp:RequiredFieldValidator>
            </td>
            <td rowspan="4">
            </td>
        </tr>
        <tr>
            <td class="style1">
                <strong>RoleName</strong></td>
            <td>
                <asp:TextBox ID="txtRoleName" runat="server" CssClass="txtbox" Height="16px" Width="144px"
                    ValidationGroup="ccf"></asp:TextBox>
                <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="txtRoleName"
                    ErrorMessage="*" ValidationGroup="hl"></asp:RequiredFieldValidator>
            </td>
        </tr>
        <tr>
            <td class="style1">
                <strong>Is Active</strong></td>
            <td>
                <asp:CheckBox ID="chkActive" runat="server" />
            </td>
        </tr>
        <tr id="btnctrl" runat="server">
            <td align="center" id="allbtn" colspan="2" runat="server">
                &nbsp;<asp:Button ID="btnAdd" runat="server" Text="Add" ValidationGroup="hl" Width="66px"
                    OnClientClick="BtnAdd();return false;" />
                <asp:Button ID="btnModify" runat="server" Text="Modify" Width="62px" OnClientClick="BtnModify();return false;"
                    ValidationGroup="hl" />
                <asp:Button ID="btnSave" runat="server" Enabled="False" Text="Save" ValidationGroup="hl"
                    Width="75px" />
                <asp:Button ID="btnDelete" runat="server" Enabled="False" Text="Delete" ValidationGroup="ccf"
                    Width="60px" />
                <asp:Button ID="btncencel" runat="server" Text="Cancel" OnClientClick="BtnCancle();return false;" />
            </td>
        </tr>
        <tr>
            <td align="center" colspan="2">
                <asp:Label ID="lblMessage" runat="server" Style="font-weight: 700"></asp:Label>
            </td>
        </tr>
    </table>
    <asp:HiddenField ID="hdID" runat="server" />
    <script type="text/javascript">
   
    var previousRow;   
   
    function gvRowClick(row,color,gvClientID,chkid) {

        
            if (previousRow == row)
                return;        
            else if (previousRow != null)     
                document.getElementById(previousRow).style.backgroundColor = "#ffffff";            
            
            try
            {
                document.getElementById(row).style.backgroundColor = color ;                            
                previousRow = row;                 
                
                var strCode = $.trim($(document.getElementById(gvClientID).rows[row].cells[1]).text());
                var strReason = $.trim($(document.getElementById(gvClientID).rows[row].cells[2]).text());
                var chk = document.getElementById(chkid).checked;
              
                if ( strCode != null) {

                    
                    document.getElementById('<%=hdID.ClientID%>').value = strCode;
                    document.getElementById('<%=txtRoleID.ClientID%>').value = strCode;
                    document.getElementById('<%=txtRoleName.ClientID%>').value = strReason;
                    document.getElementById('<%=chkActive.ClientID%>').checked = chk;  

                    document.getElementById("<%= btnModify.ClientID %>").disabled = false;
                    document.getElementById("<%= btnDelete.ClientID %>").disabled = false;
                    document.getElementById("<%= btnAdd.ClientID %>").disabled = true;              
                }                
            }
            catch(err)
            {            
            }       
             
    }

    </script>

    <script type="text/javascript">
    document.onload=Load();
    function Load()
    { 
    DisableControl();      
    BtnCancle();
     
   
    }
    function DisableControl()
    {
        document.getElementById("<%= txtRoleID.ClientID %>").disabled = true;
        document.getElementById("<%= txtRoleName.ClientID %>").disabled = true;
    }
    function EnableControl()
    {
        document.getElementById("<%= txtRoleID.ClientID %>").disabled = false;
        document.getElementById("<%= txtRoleName.ClientID %>").disabled = false;
    }
    function BtnAdd() {
        EnableControl();

        ClearControl();
        document.getElementById("<%= btnModify.ClientID %>").disabled = true;
        document.getElementById("<%= btnSave.ClientID %>").disabled = false;
        document.getElementById("<%= btnDelete.ClientID %>").disabled = true;
        document.getElementById("<%= btnAdd.ClientID %>").disabled = true;
    }
    function BtnModify()
    {
        document.getElementById("<%= btnModify.ClientID %>").disabled = true;
        document.getElementById("<%= btnSave.ClientID %>").disabled = false;
        document.getElementById("<%= btnDelete.ClientID %>").disabled = true;
        document.getElementById("<%= btnAdd.ClientID %>").disabled = true;
        EnableControl();

    }
    function BtnCancle()
    { 
    try{
        document.getElementById("<%= btnModify.ClientID %>").disabled = true;
        document.getElementById("<%= btnSave.ClientID %>").disabled = true;
        document.getElementById("<%= btnDelete.ClientID %>").disabled = true;
        document.getElementById("<%= btnAdd.ClientID %>").disabled = false;
     ClearControl();
      DisableControl();
    document.getElementById(previousRow).style.backgroundColor = "#ffffff";     
    previousRow=null; 
    }catch(err){}
    }
    function ClearControl()
    {
        $("[id$=txtRoleID]").val("");
        $("[id$=txtRoleName]").val("");   
        
    }
    
   
    </script>

</asp:Content>
