﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing
Imports System.Collections.Generic

Partial Class TaxSlab
    Inherits System.Web.UI.Page

    Dim strconn As String
    Dim strEmployeeId As String
    Dim g As General

    Private Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        Try
            If Session("EmpId").ToString() <> "Admin" Then
                Me.MasterPageFile = "MasterPage.master"
                'Ver 3.2-E398 Start
                Master.FindControl("imgPDF").Visible = False
                'Ver 3.2-E398 end
            End If
        Catch ex As Exception
        End Try
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        ElseIf StrComp(Session("EmpId"), "Admin") <> 0 Then
            tbldtl.Visible = False
        End If
        trset.Visible = False
        strconn = "Provider=Microsoft.Jet.OLEDB.4.0;data source=" & Server.MapPath(".") & "\Emails.mdb;jet OLEDB:Database Password=Ffcs"


        btnModify.Attributes.Add("onclick", "enbCtrl();")
        btncencel.Attributes.Add("onclick", "disCtrl();ClearCtrl();")
        GridView1.Columns(4).ItemStyle.CssClass = "hidden"
        GridView1.Columns(4).HeaderStyle.CssClass = "hidden"
        GridView1.Columns(4).FooterStyle.CssClass = "hidden"
        GridView1.Columns(5).ItemStyle.CssClass = "hidden"
        GridView1.Columns(5).HeaderStyle.CssClass = "hidden"
        GridView1.Columns(5).FooterStyle.CssClass = "hidden"
        GridView1.Columns(0).ItemStyle.CssClass = "hidden"
        GridView1.Columns(0).HeaderStyle.CssClass = "hidden"
        GridView1.Columns(0).FooterStyle.CssClass = "hidden"
        If Not Page.IsPostBack Then
            IsTableExist()
            If ExicuteDML("update taxslab set FY=FY where fy is null or fy=''") > 0 Then
                btnctrl.Visible = False
                trset.Visible = True
                BindData("'' or FY is null")
            Else
                BindData("'" & Session("Period") & "'")
            End If

        End If

        If StrComp(Session("EmpId"), "Admin") <> 0 Then
            ColorRow()
            GridView1.Columns(5).ItemStyle.CssClass = "hidden"
            GridView1.Columns(5).HeaderStyle.CssClass = "hidden"
            GridView1.Columns(5).FooterStyle.CssClass = "hidden"
        End If
    End Sub
    Function Data(ByVal strQuery As String) As DataSet
        Dim ds As DataSet = New DataSet()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strQuery, strconn)
        da.Fill(ds)
        Return ds
    End Function
    Protected Function ExicuteDML(ByVal strQuery As String) As Integer
        'ver 3.2-CRK Start
        'Dim i As Integer = 0
        'Try
        '    Dim con As OleDbConnection = New OleDbConnection(strconn)
        '    Dim cmd As OleDbCommand = New OleDbCommand(strQuery, con)
        '    con.Open()
        '    i = cmd.ExecuteNonQuery()
        '    con.Close()
        'Catch ex As Exception
        'End Try
        'Return i

        Return General.ExecuteDML(strconn, strQuery)
        'ver 3.2-CRK End
    End Function
    Private Sub IsTableExist()
        Try
            Dim ds As DataSet = New DataSet()
            Dim da As OleDbDataAdapter = New OleDbDataAdapter("select top 1 * from TaxSlab", strconn)
            da.Fill(ds)
        Catch ex As Exception
            ExicuteDML("create table TaxSlab ( SrNo autoincrement,Category text(100),Slab text(100),Rate text(20),Ord number )")
        End Try
        'ver 2.9-3 Start
        Try
            ExicuteDML("alter table TaxSlab add column FY text(10)")
        Catch ex As Exception
        End Try
        'ver 2.9-3 End
    End Sub
    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If IsRecordExist() Then
            ExicuteDML("update TaxSlab set Category='" + txtCategory.Text.Replace("'", "''") + "',Slab='" + txtSlab.Text.Replace("'", "''") + "',Rate='" + txtRate.Text + "',Ord=" + txtOrder.Text + ",FY='" + Session("Period") + "' where SrNo=" + hdSrNo.Value)
            lblMessage.Text = "Record Update successfully."
        Else
            ExicuteDML("Insert Into TaxSlab (Category, Slab,Rate,Ord,FY) Values ('" & txtCategory.Text & "','" + txtSlab.Text.Replace("'", "''") + "','" + txtRate.Text + "'," + txtOrder.Text + ",'" + Session("Period").ToString() + "')")
            lblMessage.Text = "Record add successfully."
        End If
        BindData("'" & Session("Period") & "'")
        lblMessage.ForeColor = Color.Green
    End Sub
    Sub BindData(ByVal fy As String)
        'ver 2.9-3 Start
        ' Dim ds As DataSet = Data("SELECT SrNo,Category,Category as cat, Slab,Rate,Ord from TaxSlab order by Ord")
        Dim ds As DataSet = Data("SELECT SrNo,Category,Category as cat, Slab,Rate,Ord from TaxSlab where FY=" + fy + " order by Ord")

        'ver 2.9-3 End
        Dim temstr As String = ""
        Try
            For i = 0 To ds.Tables(0).Rows.Count - 1
                If temstr = ds.Tables(0).Rows(i)(1).ToString() Then
                    ds.Tables(0).Rows(i)(1) = ""
                Else
                    temstr = ds.Tables(0).Rows(i)(1).ToString()
                End If
            Next
        Catch ex As Exception
        End Try

        GridView1.DataSource = ds
        GridView1.DataBind()

    End Sub
    Protected Function IsRecordExist() As Boolean
        Dim b As Boolean
        Dim con As OleDbConnection = New OleDbConnection(strconn)
        Dim cmd As OleDbCommand = New OleDbCommand("select * from TaxSlab where SrNo=" + IIf(hdSrNo.Value = "", "null", hdSrNo.Value), con)
        Try
            con.Open()
            Dim rd As OleDbDataReader = cmd.ExecuteReader()
            b = rd.HasRows
            rd.Close()
        Catch ex As Exception
            'ver 3.2-CRK Start
        Finally
            con.Close()
            'ver 3.2-CRK end
        End Try
        Return b
    End Function

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        ExicuteDML("delete from  TaxSlab where SrNo=" + IIf(hdSrNo.Value = "", "null", hdSrNo.Value))
        BindData("'" & Session("Period") & "'")
        lblMessage.Text = "Record delete successfully."
        lblMessage.ForeColor = Color.Green
    End Sub
    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView1.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            e.Row.Attributes.Add("ID", e.Row.UniqueID.Replace("$", "_"))
            e.Row.Attributes.Add("onclick", "javascript:gvRowClick('" + e.Row.UniqueID.Replace("$", "_") + "','#E0E0E0','" + GridView1.ClientID + "')")

        End If
    End Sub
    Private Sub ColorRow()
        Try

            For i = 0 To GridView1.Rows.Count
                If (i Mod 2 = 0) Then
                    GridView1.Rows(i).CssClass = "tblAlternetRow"
                End If
            Next
        Catch ex As Exception
        End Try

    End Sub
    Private Sub AddSlab()
        Dim str() As String = System.IO.File.ReadAllLines(Server.MapPath(".") & "\Tax-Slab.txt")
        Dim i As Integer = 0
        For i = 0 To str.Length - 1
            Dim row() As String = str(i).Split(",")
            ExicuteDML("Insert Into TaxSlab (Category, Slab,Rate,Ord,FY) Values ('" & row(0) & "','" + row(1).Replace("'", "''") + "','" + row(2) + "'," + row(3) + ",'" + Session("Period") + "')")
        Next
    End Sub
    Protected Sub btnRestore_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRestore.Click
        AddSlab()
        BindData("'" & Session("Period") & "'")
    End Sub
    'ver 2.9-3 Start
    Protected Sub btnSet_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSet.Click
        ExicuteDML("update taxslab set FY='" & ddltmpfy.SelectedValue & "' where fy is null or fy=''")
        Server.Transfer("TaxSlab.aspx")
    End Sub
    Public Function GetCtrlID(ByVal id As String) As String

        Return FindControlIterative(Me.Controls(0), "btnAdd").ClientID
    End Function
    Private Shared Function FindControlIterative(ByVal root As Control, ByVal id As String) As Control
        Dim ctl As Control = root
        Dim ctls As New LinkedList(Of Control)()


        While ctl IsNot Nothing
            If ctl.ID = id Then
                Return ctl
            End If
            For Each child As Control In ctl.Controls
                If child.ID = id Then
                    Return child
                End If
                If child.HasControls() Then
                    ctls.AddLast(child)
                End If
            Next
            ctl = ctls.First.Value
            ctls.Remove(ctl)
        End While
        Return Nothing
    End Function
    'ver 2.9-3 End

    Protected Sub GridView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView1.SelectedIndexChanged

    End Sub
End Class
