﻿Imports System.Data
Imports System.Data.OleDb
Partial Class UDF
    Inherits System.Web.UI.Page
    Shared strdeletecol As String = ""
    Protected Sub BtnAddColumn_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BtnAddColumn.Click
        ExecuteQry(Session("udf").ToString(), "alter table UDFFields add column [" & txtColumnName.Text.Trim().Replace(" ", "_") & "] " & DDLDataType.SelectedValue)
        If lblmsg.Text = "" Then
            ExecuteQry(Session("udf").ToString(), "insert into UDF(Colname,DataType) values ('" & txtColumnName.Text.Trim().Replace(" ", "_") & "','" & DDLDataType.SelectedValue & "')")
            If lblmsg.Text = "" Then
                BindGrid()
                lblmsg.Text = lblmsg.Text & "Record Updated."
            End If
        End If


    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        End If

        If Not Page.IsPostBack Then
            If Not General.IsTblExists(Session("udf").ToString(), "UDFFields") Then
                ExecuteQry(Session("udf").ToString(), "Create table UDFFields (empcode varchar(10),CurDate DateTime)")
                lblmsg.Text = ""
            End If
            BindGrid()

        End If
    End Sub
    Sub BindGrid()
        Dim da As New OleDbDataAdapter("select Colname,DataType from UDF", Session("udf").ToString())
        Dim dt As New DataTable
        da.Fill(dt)
        gvUDF.DataSource = dt
        gvUDF.DataBind()
    End Sub
    Protected Sub GridView1_RowEditing(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewEditEventArgs) Handles gvUDF.RowEditing
        strdeletecol = CType(gvUDF.Rows(e.NewEditIndex).FindControl("lblColname"), Label).Text
        gvUDF.Rows(e.NewEditIndex).BackColor = Drawing.Color.Gray
        gvUDF.Enabled = False
        btnDelete.Visible = True
        btnCancle.Visible = True
        BtnAddColumn.Visible = False
        btnDownload.Visible = False
        lblmsg.Text = ""
    End Sub

    Protected Sub btnCancle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancle.Click
        gvUDF.Enabled = True
        btnDelete.Visible = False
        btnCancle.Visible = False
        BtnAddColumn.Visible = True
        btnDownload.Visible = True
        BindGrid()
        lblmsg.Text = ""
    End Sub

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        gvUDF.Enabled = True
        btnDelete.Visible = False
        btnCancle.Visible = False
        BtnAddColumn.Visible = True
        btnDownload.Visible = True
        ExecuteQry(Session("udf").ToString(), "alter table udffields drop column [" & strdeletecol & "]")
        If lblmsg.Text = "" Then
            ExecuteQry(Session("udf").ToString(), "delete from udf where Colname='" & strdeletecol & "'")
            If lblmsg.Text = "" Then
                BindGrid()
                lblmsg.Text = lblmsg.Text & "Record Deleted."
            End If
        End If
    End Sub

    Protected Sub btnDownload_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDownload.Click
        Dim dt As DataTable = General.GetDataTable(Session("udf").ToString(), "select * from UDFfields")
        Dim sb As New StringBuilder()
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim c As Integer = 0
        For j = 0 To dt.Columns.Count - 1
            sb.Append("," & dt.Columns(j).ColumnName)
        Next
        sb = sb.Remove(0, 1)
        sb.AppendLine("")
        For i = 0 To dt.Rows.Count - 1
            Dim sbrow As New StringBuilder()
            For j = 0 To dt.Columns.Count - 1
                If Not dt.Rows(i)(j).ToString() = "" Then
                    If dt.Columns(j).DataType.ToString() = "System.DateTime" Then
                        sbrow.Append("," & Convert.ToDateTime(dt.Rows(i)(j).ToString()).ToString("dd/MM/yyyy"))
                    Else
                        sbrow.Append("," & dt.Rows(i)(j).ToString())
                    End If
                Else
                    sbrow.Append(",null")
                End If
            Next
            sb.AppendLine(sbrow.ToString().Substring(1))
        Next
        Response.ContentType = "text/Plain"
        Response.AddHeader("content-disposition", "attachment; filename=download.csv")
        Response.Write(Replace(sb.ToString, """", ""))
        Response.End()
    End Sub
    Public Sub ExecuteQry(ByVal strCon As String, ByVal strQuery As String)
        lblmsg.Text = ""
        Dim con As New OleDbConnection(strCon)
        Dim i As Int16
        Try
            Dim cmd As New OleDbCommand(strQuery, con)
            con.Open()
            i = cmd.ExecuteNonQuery()
            con.Close()
        Catch ex As Exception
            'ver 3.2-CRK start
            con.Close()
            lblmsg.Text = ex.Message
            'ver 3.2-CRK end
        End Try
    End Sub
End Class
