Imports System.IO
Imports System.Web.Mail
Imports System.Data.OleDb
Imports System.Data

Imports SendMail
Imports General

Partial Class UploadFile
    Inherits System.Web.UI.Page

    Private fileOK As Boolean = False
    Private FileSize As Double
    Private msg, strimg1, qry, Isactive As String
    Dim objMail As OleDbConnection
    Dim adp As New OleDbDataAdapter

    Protected Sub btnUpload_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUpload.Click
        Dim objReader As OleDbDataReader
        If Browsefile.HasFile Then
            Dim fileExtension As String = System.IO.Path.GetExtension(Browsefile.FileName).ToLower()
            FileSize = Browsefile.PostedFile.ContentLength
            Dim allowedExtensions As String() = {".zip"}
            For i As Integer = 0 To allowedExtensions.Length - 1
                If fileExtension = allowedExtensions(i) Then
                    fileOK = True
                End If
            Next

            If fileOK = True Then
                uploadFile(Browsefile)
                'UploadFile1(Browsefile.FileName)
                Dim StrTxt As String = txtDescription.Text.Trim
                'Dim sb As New StringBuilder
                'sb = sb.Append("Hello Administrator,<br /><br />" &
                '            StrTxt &
                '            "The uploaded file is " & Browsefile.FileName &
                '            "<br /><br />Regards<br />" & Session("EmpName"))
                Dim strsql As String = "Hello Administrator,"
                strsql &= vbCrLf & "<br /><br />"
                If StrTxt <> String.Empty Then strsql &= vbCrLf & StrTxt
                strsql &= vbCrLf & "<br />"
                strsql &= vbCrLf & "The uploaded file is " & Browsefile.FileName
                strsql &= vbCrLf & "<br /><br />"
                strsql &= vbCrLf & "Regards"
                strsql &= vbCrLf & "<br />"
                strsql &= vbCrLf & Session("EmpName")
                '--Connecting to the Emails.mdb
                objMail = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & Server.MapPath(".") & "\Emails.mdb;jet OLEDB:Database Password=Ffcs")
                objMail.Open()

                adp = New OleDbDataAdapter("select * from Emails where CompanyCode='" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "'", objMail)
                objReader = adp.SelectCommand.ExecuteReader()

                If objReader.HasRows Then objReader.Read()
                If objReader.HasRows Then
                    Call Mailer(objReader("AdminEmail"), objReader("AdminEmail"), "Upload Details", strsql, "localhost")
                    If funSendMail() = True Then
                    Else
                        lblMsg.Text = "Error while sending mail."
                    End If
                Else
                    lblMsg.Text = "Admin Email Id Not Found!"
                    Exit Sub
                End If
                objMail.Close()
                objMail = Nothing
                '--On 22/12/2008 Starts
                '--Call WriteToFile1("U")
                '--22/12/2008 End
                lblSuccess.Text = (Session("EmpName") & " you have uploaded " & Browsefile.FileName & " file " & "<hr>")
            Else
                lblIMG.Visible = True
                lblIMG.Text = "Invalid File Format"
                Exit Sub
            End If
        End If
    End Sub

    Private Sub uploadFile(ByVal zipfile As FileUpload)
        Dim sSavePath As String
        ' Check file size (mustnt be 0) 
        Dim myFile As HttpPostedFile = zipfile.PostedFile
        Dim nFileLen As Integer = myFile.ContentLength
        If nFileLen = 0 Then
            'lblmsg.Text = "There wasn't any file uploaded."
            Return
        End If
        Dim myData As Byte() = New Byte(nFileLen - 1) {}
        myFile.InputStream.Read(myData, 0, nFileLen)

        ' Make sure a duplicate file doesnt exist. If it does, keep on appending an incremental numeric until it is unique 
        Dim sFilename As String = System.IO.Path.GetFileName(myFile.FileName)
        Dim file_append As Integer = 0
        sSavePath = Server.MapPath("App_Data\" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "\" & Session("EmpId") & "\Upload\" & sFilename)

        Dim mainDir As New DirectoryInfo(Server.MapPath("App_Data\" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "\" & UCase(Session("EmpId")) & "\Upload\"))
        If mainDir.Exists = False Then
            mainDir.Create()
        End If

        'sSavePath = "C:\etds0708\" & sFilename
        Dim newFile As New System.IO.FileStream(sSavePath, System.IO.FileMode.Create)
        newFile.Write(myData, 0, myData.Length)
        newFile.Close()
    End Sub

    Private Sub UploadFile1(ByVal strFileName As String)
        Try
            Dim testPath As String

            testPath = Server.MapPath("App_Data\" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "\" & Session("EmpId") & "\Upload\") ' & strFileName)
            If Not File.Exists(testPath) Then
                'File.Create(testPath)
            End If
            Dim objFileInfo As FileInfo
            Dim strPhysicalPath As String = Path.GetFullPath(testPath)
            If Not System.IO.File.Exists(strPhysicalPath) _
             Then Exit Sub
            objFileInfo = New System.IO.FileInfo(strFileName)

            objFileInfo.CopyTo(strPhysicalPath, True)

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Sub WriteToFile1(ByVal strAction As String)
        Dim strPath As String
        Dim NewContent As String

        NewContent = "" 'Default Value
        strPath = System.Configuration.ConfigurationManager.AppSettings("FilePath") & "/LogUpload.txt"

        If strAction = "U" Then
            NewContent = "Uploaded On " & vbTab & Format(Now, "dd/MM/yyyy") & vbTab & Format(Now, "hh:mm:ss tt")
        ElseIf strAction = "A" Then
            NewContent = "Upload Failed On " & vbTab & Format(Now, "dd/MM/yyyy") & vbTab & Format(Now, "hh:mm:ss tt")
        End If
        If WriteToFile(strPath, NewContent) = False Then
            lblMsg.Text = "Error while writing the log file."
        End If
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("CoCode") = String.Empty Then
            Response.Redirect("Login.aspx")
        End If
        'Ver 3.2-E398 Start
        Master.FindControl("imgPDF").Visible = False
        'Ver 3.2-E398 end
        Try
            lblEmpCode.Text = Session("EmpId")
            lblName.Text = Session("EmpName")
            lblFY.Text = Session("Period")
        Catch ex As Exception

        End Try
    End Sub
End Class
