﻿<%@ Control Language="VB" AutoEventWireup="false" CodeFile="80CCG.ascx.vb" Inherits="UserControls_80CCG" %>
<style type="text/css">
    .style1
    {
        width: 213px;
    }
    .lbl
    {        font-weight: 700;
    }
</style>
<p>
    &nbsp;<asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
        <strong>80 CCG</strong>
            <table style="width: 99%;">
                <tr>
                    <td class="style1">
                        <asp:Label ID="Label4" runat="server" Text="Amount" style="font-weight: 700"></asp:Label>
                        <img src="<%= Session("img")  %>" /></td>
                    <td>
                        <asp:TextBox ID="txtAmount" Style="text-align: right" runat="server" 
                            CssClass="txtNumbox" Height="17px" Width="143px"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator3" runat="server" ControlToValidate="txtAmount"
                            ErrorMessage="*" ValidationGroup="CCG"></asp:RequiredFieldValidator>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator3" runat="server" ControlToValidate="txtAmount"
                            ErrorMessage="Enter proper value" ValidationExpression="^[-+]?[0-9]\d{0,9}(\.\d{1,4})?%?$"
                            ValidationGroup="CCG"></asp:RegularExpressionValidator>                        
                        (Maximum of 25000/- will be taken for deduction.)&nbsp;&nbsp;&nbsp;</td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="Label5" runat="server" Text="Proof Attach" 
                            style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:CheckBox ID="chkProofAttach" runat="server" />
                    </td>
                </tr>
                <tr >
                    <td class="style1">
                        <asp:Label ID="lblIsproofapproved" runat="server" Text="Proof Accepted" 
                            style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:CheckBox ID="chkproofapproved" runat="server"  />
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="lblisproofreject" runat="server" Text="Proof Rejected" 
                            style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:CheckBox ID="chkproofreject" runat="server"   />
                    </td>
                </tr>
                <tr>
                    <td class="style1">
                        <asp:Label ID="lblreson" runat="server" Text="Reason" Visible="False" 
                            style="font-weight: 700"></asp:Label>
                    </td>
                    <td>
                        <asp:TextBox ID="txtReason" runat="server" Width="144px" Visible="False" 
                            CssClass="txtbox" Height="16px"></asp:TextBox>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator5" runat="server" ControlToValidate="txtReason"
                            ErrorMessage="Comma not allowed" ValidationExpression="[^,]+" ValidationGroup="CCG"></asp:RegularExpressionValidator>
                    </td>
                </tr>
                <tr>
                    <td align="center" colspan="2">
                        <asp:UpdateProgress ID="sa" runat="server" AssociatedUpdatePanelID="UpdatePanel1">
                            <ProgressTemplate>
                                <div style="color: Red">
                                    <asp:Image ID="Image1" runat="server" ImageUrl="~/IMAGES/loading.gif" />
                                    &nbsp;&nbsp;&nbsp;<b>Please Wait.. </b>
                                </div>
                            </ProgressTemplate>
                        </asp:UpdateProgress>
                    </td>
                </tr>
                <tr>
                    <td align="left" colspan="2">
                     
                       &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;<asp:Button ID="btnAdd" runat="server" Text="Add" ValidationGroup="CCG" Width="66px" />
                        <%--Ver4.2 REQ793 start--%>
                        <asp:Button ID="btnEdit" runat="server" Text="EDIT" ValidationGroup="CCG" Width="66px" />
                        <%--Ver4.2 REQ793 End--%>
                        <asp:Button ID="btnSave" runat="server" Enabled="False" Text="Save" ValidationGroup="CCG"
                            Width="75px" />
                        <asp:Button ID="btnDelete" runat="server" Enabled="False" Text="Delete" ValidationGroup="CCG"
                            Width="60px" />
                    </td>
                </tr>
                <tr>
                    <td align="center" colspan="2">
                        <asp:Label ID="lblMessage" runat="server" Style="font-weight: 700"></asp:Label>
                    </td>
                </tr>
            </table>
            <asp:HiddenField ID="hdsrno" runat="server" />
        </ContentTemplate>
    </asp:UpdatePanel>

    <script type="text/javascript">

        function panelUpdated() {
            // Ver 4.1-QC1135 start
            if (document.getElementById("<%=chkproofreject.ClientID %>") != null) {
                // Ver 4.1-QC1135 end 
                document.getElementById("<%=chkproofreject.ClientID %>").onclick = function () {
                    if (document.getElementById("<%=chkproofapproved.ClientID %>").checked == true) {
                        document.getElementById("<%=chkproofapproved.ClientID %>").checked = false;
                    }

                };
            }
            // Ver 4.1-QC1135 start
            if (document.getElementById("<%=chkproofreject.ClientID %>") != null) {
                // Ver 4.1-QC1135 end 
                document.getElementById("<%=chkproofapproved.ClientID %>").onclick = function () {
                    if (document.getElementById("<%=chkproofreject.ClientID %>").checked == true) {
                        document.getElementById("<%=chkproofreject.ClientID %>").checked = false;
                    }

                };
            }
        }

        var appInst = Sys.WebForms.PageRequestManager.getInstance();
        appInst.add_endRequest(panelUpdated);

        panelUpdated();
    </script>
