﻿'Ver4.2 REQ806 start
Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing
Partial Class UserControls_80EEA
    Inherits System.Web.UI.UserControl
    Dim strconn As String
    Dim strEmployeeId As String

    Protected Function ExecuteDML(ByVal strQuery As String) As Integer
        Return General.ExecuteDML(strconn, strQuery)
    End Function

    Function Data(ByVal strQuery As String) As DataSet
        Dim ds As DataSet = New DataSet()
        Dim da As OleDbDataAdapter = New OleDbDataAdapter(strQuery, strconn)
        da.Fill(ds)
        Return ds
    End Function

    Sub UpdateDateTime(ByVal category As String)
        Dim i = ExecuteDML("update categoryLOG set Lastmodify=#" + DateTime.Now.ToString() + "# where category='" + category + "'")
        If (i = 0) Then
            ExecuteDML("insert into categoryLOG(category) values ('80EEA')")
            ExecuteDML("update categoryLOG set Lastmodify=#" + DateTime.Now.ToString() + " # where category ='" + category + "'")

        End If
    End Sub

    Protected Sub btnAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAdd.Click

        If btnAdd.Text = "Add" Then
            If Convert.ToDouble(txtAmount.Text) <> 0.0 Then
                ExecuteDML("Insert Into 80EEA (EmployeeCode,Amount,IsProofAttach,Isproofapproved,Reason,isproofreject,EmpInsert) Values ('" & strEmployeeId & "'," & txtAmount.Text & "," & chkProofAttach.Checked.ToString() & "," & chkproofapproved.Checked.ToString() & ",''," & chkproofreject.Checked.ToString() & ",#" + Date.Now.ToString() + "#)")
                ShowData()
                UpdateDateTime("80EEA")
                lblMessage.Text = "Record add successfully."
                lblMessage.ForeColor = Color.Green
            Else
                lblMessage.Text = "Amount can not be zero"
                lblMessage.ForeColor = Color.Red
            End If
        Else
            EnableDisable(True)
            btnAdd.Enabled = False
            btnSave.Enabled = True
            btnDelete.Enabled = True

        End If
    End Sub
    Sub ShowData()
        If UpdatePanel1.Visible = True Then
            Dim dsCCG As New DataSet
            dsCCG = Data("Select * from 80EEA where EmployeeCode ='" & strEmployeeId & "'")
            If dsCCG.Tables(0).Rows.Count > 0 Then
                btnEdit.Enabled = True
                btnAdd.Enabled = False
                EnableDisable(False)
                txtAmount.Text = dsCCG.Tables(0).Rows(0)("Amount")
                txtReason.Text = dsCCG.Tables(0).Rows(0)("Reason")
                hdsrno.Value = dsCCG.Tables(0).Rows(0)("SrNo")
                If dsCCG.Tables(0).Rows(0)("IsProofAttach") = True Then
                    chkProofAttach.Checked = True
                End If
                If dsCCG.Tables(0).Rows(0)("Isproofapproved") = True Then
                    chkproofapproved.Checked = True
                End If
                If dsCCG.Tables(0).Rows(0)("isproofreject") = True Then
                    chkproofreject.Checked = True
                End If
            Else
                EnableDisable(True)
                btnAdd.Enabled = True
                btnEdit.Enabled = False
            End If
            dsCCG.Dispose()

        End If
    End Sub
    Sub EnableDisable(ByVal blnFlag As Boolean)
        txtAmount.Enabled = blnFlag
        txtReason.Enabled = blnFlag

        If Session("EmpId").ToString().Equals("Admin") Then
            chkproofapproved.Enabled = blnFlag
            chkproofreject.Enabled = blnFlag
            btnDelete.Enabled = False
        Else
            chkProofAttach.Enabled = blnFlag
        End If
    End Sub

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If Convert.ToDouble(txtAmount.Text) <> 0.0 Then
            If Session("EmpId").ToString().Equals("Admin") Then
                ExecuteDML("update 80EEA set   Amount=" + txtAmount.Text + ", IsProofAttach=" + chkProofAttach.Checked.ToString() + ",Isproofapproved=" + chkproofapproved.Checked.ToString() + ",Reason='" + txtReason.Text.Replace("'", "''") + "',isproofreject=" + chkproofreject.Checked.ToString() + ",AdminUpdate=#" + DateTime.Now.ToString() + "# where srno=" + hdsrno.Value + " and EmployeeCode='" + strEmployeeId + "'")
            Else
                ExecuteDML("update 80EEA set  Amount=" + txtAmount.Text + ", IsProofAttach=" + chkProofAttach.Checked.ToString() + ",Isproofapproved=" + chkproofapproved.Checked.ToString() + ",Reason='" + txtReason.Text.Replace("'", "''") + "',isproofreject=" + chkproofreject.Checked.ToString() + ",EmpUpdate=#" + DateTime.Now.ToString() + "# where srno=" + hdsrno.Value + " and EmployeeCode='" + strEmployeeId + "'")
                btnAdd.Enabled = True
            End If

            UpdateDateTime("80EEA")
            lblMessage.Text = "Record Update successfully."
            lblMessage.ForeColor = Color.Green
        Else
            lblMessage.Text = "Amount can not be zero"
            lblMessage.ForeColor = Color.Red
        End If
        btnSave.Enabled = False
        btnDelete.Enabled = False

        ClearControls()
        ShowData()
    End Sub
    Sub ClearControls()
        txtAmount.Text = ""
        chkProofAttach.Checked = False
        txtReason.Text = ""
    End Sub

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        ExecuteDML("delete from  80EEA where SrNo=" + hdsrno.Value + " and EmployeeCode='" + strEmployeeId + "'")
        btnSave.Enabled = False
        btnDelete.Enabled = False
        btnEdit.Enabled = False
        btnAdd.Enabled = True
        UpdateDateTime("80EEA")
        lblMessage.Text = "Record delete successfully."
        lblMessage.ForeColor = Color.Green
        ClearControls()
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        strconn = Session("invConnection").ToString()

        If Session("EmpId").ToString().Equals("Admin") Then
            chkProofAttach.Enabled = False
            strEmployeeId = Session("SelectedEmpId").ToString()
            lblIsproofapproved.Visible = True
            lblisproofreject.Visible = True
            lblreson.Visible = True
            txtReason.Visible = True
            chkproofapproved.Visible = True
            chkproofreject.Visible = True

        Else

            strEmployeeId = Session("EmpId").ToString()
            lblIsproofapproved.Visible = True
            lblisproofreject.Visible = True
            lblreson.Visible = False
            txtReason.Visible = False
            chkproofapproved.Enabled = False
            chkproofreject.Enabled = False

        End If

        Dim dscd As New DataSet
        dscd = Data("Select * from 80EEA where EmployeeCode ='" & strEmployeeId & "'")
        If dscd.Tables(0).Rows.Count > 0 Then
            btnAdd.Enabled = False
            btnEdit.Enabled = True
        Else
            btnAdd.Enabled = True
            btnEdit.Enabled = False
        End If

        If Not Page.IsPostBack Then
            Try
                ShowData()
            Catch ex As Exception
                If ex.Message.Contains("cannot find the input table") Then
                    If Not Session("EmpId").ToString().ToLower() = "admin" Then
                        lblMessage.Text = "This option is not active.Please contact administrator."
                    Else
                        lblMessage.Text = "Please update database."
                    End If

                    btnAdd.Enabled = False
                End If
            End Try

        End If
    End Sub
    Protected Sub btnEdit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnEdit.Click
        btnEdit.Enabled = False
        btnAdd.Enabled = False
        btnSave.Enabled = True
        btnDelete.Enabled = True
    End Sub

    Private Sub btnSave_Load(sender As Object, e As EventArgs) Handles btnSave.Load

    End Sub
End Class
'Ver4.2 REQ806 end