Imports System.Data
Imports System.Data.OleDb
Imports System.IO

Partial Class ViewQueries
    Inherits System.Web.UI.Page

    Dim dsProfile As DataSet
    Dim sqlCon As OleDbConnection
    Dim sqlCmd As OleDbCommand
    Dim adpQuery As New OleDbDataAdapter
    Dim dsQuery As New DataSet

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Dim strPath As String
            If Me.IsPostBack = False Then
                If Session("EmpId") = String.Empty Then
                    Response.Redirect("EmpLogin.aspx")
                End If
                'Ver 3.2-E398 Start
                Master.FindControl("imgPDF").Visible = False
                Master.FindControl("lnkPrint").Visible = False
                'Ver 3.2-E398 end
                strPath = Server.MapPath("App_Data") & "\" & Session("CoCode") & Mid(Session("Period"), 3, 2)

                If File.Exists(strPath & "\PostQuery.mdb") Then
                    sqlCon = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & strPath & "\PostQuery.mdb;jet OLEDB:Database Password=Ffcs")
                End If

                lblEmpCode.Text = Session("EmpId")
                lblName.Text = Session("EmpName")
                lblFY.Text = Session("Period")

                Call FillGrid()
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub FillGrid()

        Dim intECnt As Integer

        Dim tblRow As TableRow
        Dim tblCol As TableCell
        Dim tblHeadRow As TableHeaderRow
        Dim tblHeaderCol As TableHeaderCell

        Try
            tblHeadRow = New TableHeaderRow
            tblQueries.Rows.Add(tblHeadRow)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Sr. No."
            tblHeadRow.Cells.Add(tblHeaderCol)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Date"
            tblHeadRow.Cells.Add(tblHeaderCol)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Subject"
            tblHeadRow.Cells.Add(tblHeaderCol)

            tblHeaderCol = New TableHeaderCell
            tblHeaderCol.Text = "Click for Details"
            tblHeadRow.Cells.Add(tblHeaderCol)

            adpQuery = New OleDbDataAdapter("SELECT SrNo, format([DateTime],'dd/MM/yyyy') as [Date], [Subject] as [Subject],ReplyText,format(ReplyDateTime,'dd/MM/yyyy') as ReplyDateTime FROM PostQueryDetails" & _
                                            " WHERE Empcode='" & Session("EmpId") & "' and SrNo in (SELECT max(srNo) FROM PostQueryDetails group by qryid)  order by [DateTime] desc", sqlCon)

            adpQuery.Fill(dsQuery, "PostQuery")
            intECnt = Val(dsQuery.Tables("PostQuery").Rows.Count)

            With dsQuery.Tables("PostQuery")
                For intI As Integer = 0 To .Rows.Count - 1

                    tblRow = New TableRow
                    tblQueries.Rows.Add(tblRow)

                    tblCol = New TableCell
                    tblCol.Text = intI + 1
                    tblRow.Cells.Add(tblCol)
                    tblCol.HorizontalAlign = HorizontalAlign.Center

                    tblCol = New TableCell
                    tblCol.Text = .Rows(intI).Item("Date")
                    tblRow.Cells.Add(tblCol)
                    tblCol.HorizontalAlign = HorizontalAlign.Center

                    tblCol = New TableCell
                    tblCol.Text = .Rows(intI).Item("Subject")
                    tblRow.Cells.Add(tblCol)

                    tblCol = New TableCell
                    Dim hl As New HyperLink
                    hl.ForeColor = Drawing.Color.Blue

                    If IsDBNull(.Rows(intI).Item("ReplyText")) = False And IsDBNull(.Rows(intI).Item("ReplyDateTime")) = False Then

                        hl.Text = "View Reply"
                        
                    Else

                        hl.Text = "Not yet Replied "

                    End If

                    hl.NavigateUrl = "QueryDetails.aspx?SrNo=" & .Rows(intI).Item("SrNo") & ""
                    hl.Attributes.Add("onclick", "javascript:window.open('" & "QueryDetails.aspx?SrNo=" & .Rows(intI).Item("SrNo") & "','DetailedQuery','toolbar=no, directories=no, resizable=no, width=590, height=560'); return false")
                    hl.Target = "_Blank"
                    hl.CssClass = "link"
                    hl.Font.Bold = True
                    tblCol.Controls.Add(hl)
                    tblCol.HorizontalAlign = HorizontalAlign.Center
                    tblRow.Cells.Add(tblCol)

                Next

                'If dsQuery.Tables("PostQuery").Rows.Count > 0 Then

                'gvQueries.DataSource = dsQuery.Tables("PostQuery")
                'gvQueries.DataBind()

                'End If
            End With

            tblHeadRow.CssClass = "GrdHeader"
            lblMsg.Text = "No. of Queries from you. " & intECnt

        Catch ex As Exception
            '            MsgBox(ex.Message.ToString)
        End Try

    End Sub
End Class
